
package FourierPackage;

import java.awt.Toolkit;
import java.util.Hashtable;
import javax.swing.JDialog;
import javax.swing.JLabel;


/** Hauptteil des Programms mit Benutzeroberflaeche
 * @author Matthias Klingler
 */
public class Fourier extends javax.swing.JPanel {

    private boolean automatic=false;
    private int T=10;
    private Hashtable<Integer, JLabel> labelTableX = new Hashtable<Integer, JLabel>();
    private Hashtable<Integer, JLabel> labelTableY = new Hashtable<Integer, JLabel>();
    private Hashtable<Integer, JLabel> labelTableAmp = new Hashtable<Integer, JLabel>();
    private Hashtable<Integer, JLabel> labelTableA = new Hashtable<Integer, JLabel>();
    private Hashtable<Integer, JLabel> labelTableT = new Hashtable<Integer, JLabel>();


    /** Creates new form FourierPanel */
    public Fourier() {
        initComponents();
        rechteckMain1.setXminmax(-10, 10);
        rechteckMain1.setDynamic(false);
        rechteckMain1.setPanelSize(rechteckMain1.getSize().height-1, rechteckMain1.getSize().width-1);

        rechteckMain2.setType(1);
        rechteckMain2.setLabelW(true);
        rechteckMain3.setType(2);
        rechteckMain3.setLabelW(true);

        if(automatic) {

            rechteckMain2.setDynamic(true);
            rechteckMain2.setXYminmax(-1, 10, -5, 5);
            rechteckMain2.setPanelSize(rechteckMain2.getSize().height-1, rechteckMain2.getSize().width-1);

            rechteckMain3.setDynamic(true);
            rechteckMain3.setXYminmax(-1, 10, -5, 5);
            rechteckMain3.setPanelSize(rechteckMain3.getSize().height-1, rechteckMain3.getSize().width-1);
        } else {
            rechteckMain2.setDynamic(false);
            rechteckMain2.setXminmax(-1, 10);
            rechteckMain2.setPanelSize(rechteckMain2.getSize().height-1, rechteckMain2.getSize().width-1);

            rechteckMain3.setDynamic(false);
            rechteckMain3.setXminmax(-1, 10);
            rechteckMain3.setPanelSize(rechteckMain3.getSize().height-1, rechteckMain3.getSize().width-1);
        }

        SliderT.setValue(40);
        SliderAmp.setValue(20);
        SliderN.setValue(3);
        SliderA.setVisible(false);

        TField.setText("4.0");
        AmpField.setText("2.0");
        NField.setText("3");
        AField.setText("0.0");
        AField.setVisible(false);

        setSliderOffXLabels(-50,0,50);
        setSliderOffYLabels(-50,0,50);
        setSliderAmpLabels(0,50,100);
        setSliderALabels(0,5,10);
        setSliderTLabels(10,50,90);
        BasicButton.setSelected(true);
        rechteckMain1.setBasic(BasicButton.isSelected());
        anLabel.setVisible(false);
        bnLabel.setVisible(false);
    }



    private void setSliderOffXLabels(int min,int mid, int max) {
        labelTableX.clear();
        labelTableX.put( min , new JLabel(String.valueOf(min/10.0)));
        labelTableX.put( mid , new JLabel(String.valueOf(mid/10.0)));
        labelTableX.put( max , new JLabel(String.valueOf(max/10.0)));
        SliderOffX.setMaximum(max);
        SliderOffX.setMinimum(min);
        SliderOffX.setValue(mid);
        XField.setText(String.valueOf(mid/10.0));
        SliderOffX.setLabelTable( labelTableX );
    }
    private void setSliderOffYLabels(int min,int mid, int max) {
        labelTableY.clear();
        labelTableY.put( min , new JLabel(String.valueOf(min/10.0)));
        labelTableY.put( mid , new JLabel(String.valueOf(mid/10.0)));
        labelTableY.put( max , new JLabel(String.valueOf(max/10.0)));
        SliderOffY.setMaximum(max);
        SliderOffY.setMinimum(min);
        SliderOffY.setValue(mid);
        YField.setText(String.valueOf(mid/10.0));
        SliderOffY.setLabelTable( labelTableY );
    }
    private void setSliderAmpLabels(int min,int mid, int max) {
        labelTableAmp.clear();
        labelTableAmp.put( min , new JLabel(String.valueOf(min/10.0)));
        labelTableAmp.put( mid , new JLabel(String.valueOf(mid/10.0)));
        labelTableAmp.put( max , new JLabel(String.valueOf(max/10.0)));
        SliderAmp.setMaximum(max);
        SliderAmp.setMinimum(min);
        SliderAmp.setLabelTable( labelTableAmp );
    }
    private void setSliderALabels(int min,int mid, int max) {
        labelTableA.clear();
        labelTableA.put( min , new JLabel(String.valueOf(min/10.0)));
        labelTableA.put( mid , new JLabel(String.valueOf(mid/10.0)));
        labelTableA.put( max , new JLabel(String.valueOf(max/10.0)));
        SliderA.setMaximum(max);
        SliderA.setMinimum(min);
        SliderA.setValue(min);
        XField.setText(String.valueOf(min/10.0));
        SliderA.setLabelTable( labelTableA );
    }
    private void setSliderTLabels(int min,int mid, int max) {
        labelTableT.clear();
        labelTableT.put( min , new JLabel(String.valueOf(min/10.0)));
        labelTableT.put( mid , new JLabel(String.valueOf(mid/10.0)));
        labelTableT.put( max , new JLabel(String.valueOf(max/10.0)));
        SliderT.setLabelTable( labelTableT );
    }


    /**
     * Wird vom Appletstarter aus aufgerufen und führt die
     * entsprechende Aktion aus
     * @param evt Event
     */
    public void ItemRectPush(java.awt.event.ActionEvent evt) {
        jTabbedPane1.setSelectedIndex(0);
    }

    /**
     * Wird vom Appletstarter aus aufgerufen und führt die
     * entsprechende Aktion aus
     * @param evt Event
     */
    public void ItemTrianPush(java.awt.event.ActionEvent evt) {
        jTabbedPane1.setSelectedIndex(1);
    }

    /**
     * Wird vom Appletstarter aus aufgerufen und führt die
     * entsprechende Aktion aus
     * @param evt Event
     */
    public void ItemSawPush(java.awt.event.ActionEvent evt) {
        jTabbedPane1.setSelectedIndex(2);
    }

    /**
     * Wird vom Appletstarter aus aufgerufen und führt die
     * entsprechende Aktion aus
     * @param evt Event
     */
    public void ItemSinPush(java.awt.event.ActionEvent evt) {
        jTabbedPane1.setSelectedIndex(3);
    }

    /**
     * Wird vom Appletstarter aus aufgerufen und führt die
     * entsprechende Aktion aus
     * @param evt Event
     */
    public void ItemParaPush(java.awt.event.ActionEvent evt) {
        jTabbedPane1.setSelectedIndex(4);
    }

    /**
     * Wird vom Appletstarter aus aufgerufen und führt die
     * entsprechende Aktion aus
     * @param evt Event
     */
    public void ItemRectImpPush(java.awt.event.ActionEvent evt) {
        jTabbedPane1.setSelectedIndex(5);
    }

    /**
     * Wird vom Appletstarter aus aufgerufen und führt die
     * entsprechende Aktion aus
     * @param evt Event
     */
    public void ItemSinImpPush(java.awt.event.ActionEvent evt) {
        jTabbedPane1.setSelectedIndex(6);
    }

    /**
     * Wird vom Appletstarter aus aufgerufen und führt die
     * entsprechende Aktion aus
     * @param evt Event
     */
    public void helpItemPush(java.awt.event.ActionEvent evt,java.awt.Frame parent) {
        JDialog help = new Help(parent, true);
        help.setVisible(true);
    }

    /**
     * Wird vom Appletstarter aus aufgerufen und führt die
     * entsprechende Aktion aus
     * @param evt Event
     */
    public void aboutItemPush(java.awt.event.ActionEvent evt,java.awt.Frame parent) {
        JDialog information = new Info(parent, true);
        information.setVisible(true);
    }




    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel1 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        jPanel5 = new javax.swing.JPanel();
        jPanel10 = new javax.swing.JPanel();
        jPanel11 = new javax.swing.JPanel();
        jSeparator1 = new javax.swing.JSeparator();
        SliderN = new javax.swing.JSlider();
        jLabel2 = new javax.swing.JLabel();
        SliderOffX = new javax.swing.JSlider();
        jLabel1 = new javax.swing.JLabel();
        SliderAmp = new javax.swing.JSlider();
        jLabel6 = new javax.swing.JLabel();
        jSeparator5 = new javax.swing.JSeparator();
        SliderMinX = new javax.swing.JSlider();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        SliderOffY = new javax.swing.JSlider();
        jLabel5 = new javax.swing.JLabel();
        jPanel6 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jPanel7 = new javax.swing.JPanel();
        rechteckMain1 = new FourierPackage.RechteckMain();
        AmpPhaButton = new javax.swing.JRadioButton();
        SinCosButton = new javax.swing.JRadioButton();
        jPanel8 = new javax.swing.JPanel();
        rechteckMain2 = new FourierPackage.RechteckMain();
        jPanel9 = new javax.swing.JPanel();
        rechteckMain3 = new FourierPackage.RechteckMain();
        jSeparator2 = new javax.swing.JSeparator();
        leftLabel = new javax.swing.JLabel();
        rightLabel = new javax.swing.JLabel();
        checkAnpass = new javax.swing.JCheckBox();
        FormelLabel = new javax.swing.JLabel();
        anLabel = new javax.swing.JLabel();
        bnLabel = new javax.swing.JLabel();
        SliderMaxX = new javax.swing.JSlider();
        SliderT = new javax.swing.JSlider();
        jLabel7 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        SliderA = new javax.swing.JSlider();
        BasicButton = new javax.swing.JRadioButton();
        XField = new javax.swing.JTextField();
        YField = new javax.swing.JTextField();
        NField = new javax.swing.JTextField();
        AmpField = new javax.swing.JTextField();
        TField = new javax.swing.JTextField();
        AField = new javax.swing.JTextField();

        jTabbedPane1.setTabLayoutPolicy(javax.swing.JTabbedPane.SCROLL_TAB_LAYOUT);
        jTabbedPane1.setToolTipText("");
        jTabbedPane1.setFont(new java.awt.Font("Tahoma", 0, 10));
        jTabbedPane1.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jTabbedPane1StateChanged(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 550, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        jTabbedPane1.addTab("Rechteck", jPanel1);

        jPanel2.setBackground(new java.awt.Color(255, 255, 255));

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 550, Short.MAX_VALUE)
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        jTabbedPane1.addTab("Dreieck", jPanel2);

        jPanel3.setBackground(new java.awt.Color(255, 255, 255));

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 550, Short.MAX_VALUE)
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        jTabbedPane1.addTab("Sägezahn", jPanel3);

        jPanel4.setBackground(new java.awt.Color(255, 255, 255));

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 550, Short.MAX_VALUE)
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        jTabbedPane1.addTab("Rechteckimpuls", jPanel4);

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 550, Short.MAX_VALUE)
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        jTabbedPane1.addTab("Parabel", jPanel5);

        javax.swing.GroupLayout jPanel10Layout = new javax.swing.GroupLayout(jPanel10);
        jPanel10.setLayout(jPanel10Layout);
        jPanel10Layout.setHorizontalGroup(
            jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 550, Short.MAX_VALUE)
        );
        jPanel10Layout.setVerticalGroup(
            jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        jTabbedPane1.addTab("Sinus 2-Weggleichr.", jPanel10);

        javax.swing.GroupLayout jPanel11Layout = new javax.swing.GroupLayout(jPanel11);
        jPanel11.setLayout(jPanel11Layout);
        jPanel11Layout.setHorizontalGroup(
            jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 550, Short.MAX_VALUE)
        );
        jPanel11Layout.setVerticalGroup(
            jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        jTabbedPane1.addTab("Sinus 1-Weggleichr.", jPanel11);

        jSeparator1.setOrientation(javax.swing.SwingConstants.VERTICAL);

        SliderN.setMajorTickSpacing(5);
        SliderN.setMaximum(15);
        SliderN.setMinorTickSpacing(1);
        SliderN.setPaintLabels(true);
        SliderN.setPaintTicks(true);
        SliderN.setSnapToTicks(true);
        SliderN.setToolTipText("Anzahl der harmonischen Schwingungen");
        SliderN.setValue(0);
        SliderN.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                SliderNStateChanged(evt);
            }
        });

        jLabel2.setText(" Anzahl n");

        SliderOffX.setMajorTickSpacing(10);
        SliderOffX.setMaximum(50);
        SliderOffX.setMinimum(-50);
        SliderOffX.setMinorTickSpacing(1);
        SliderOffX.setPaintLabels(true);
        SliderOffX.setPaintTicks(true);
        SliderOffX.setSnapToTicks(true);
        SliderOffX.setToolTipText("Verschieben der ganzen Funktion nach links oder rechts");
        SliderOffX.setValue(0);
        SliderOffX.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                SliderOffXStateChanged(evt);
            }
        });

        jLabel1.setText(" t - Verschiebung");

        SliderAmp.setMajorTickSpacing(10);
        SliderAmp.setMinorTickSpacing(1);
        SliderAmp.setPaintLabels(true);
        SliderAmp.setPaintTicks(true);
        SliderAmp.setSnapToTicks(true);
        SliderAmp.setToolTipText("Einstellen der Amplitude");
        SliderAmp.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                SliderAmpStateChanged(evt);
            }
        });

        jLabel6.setText(" Amplitude");

        SliderMinX.setMajorTickSpacing(5);
        SliderMinX.setMaximum(0);
        SliderMinX.setMinimum(-15);
        SliderMinX.setMinorTickSpacing(1);
        SliderMinX.setPaintLabels(true);
        SliderMinX.setPaintTicks(true);
        SliderMinX.setSnapToTicks(true);
        SliderMinX.setToolTipText("Ändert Minimalwert der t-Achse");
        SliderMinX.setValue(-10);
        SliderMinX.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                SliderMinXStateChanged(evt);
            }
        });

        jLabel8.setText(" t-Achse");

        jLabel9.setFont(new java.awt.Font("Tahoma", 1, 14));
        jLabel9.setText("Koordinatensystem:");

        jLabel10.setFont(new java.awt.Font("Tahoma", 1, 14));
        jLabel10.setText("Funktion:");

        SliderOffY.setMajorTickSpacing(10);
        SliderOffY.setMaximum(50);
        SliderOffY.setMinimum(-50);
        SliderOffY.setMinorTickSpacing(1);
        SliderOffY.setPaintLabels(true);
        SliderOffY.setPaintTicks(true);
        SliderOffY.setSnapToTicks(true);
        SliderOffY.setToolTipText("Verschieben der ganzen Funktion nach oben oder unten");
        SliderOffY.setValue(0);
        SliderOffY.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                SliderOffYStateChanged(evt);
            }
        });

        jLabel5.setText(" Y - Verschiebung");

        jLabel3.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel3.setText("Fourier-Reihe (ohne Verschiebung) :");

        jPanel7.setBackground(new java.awt.Color(255, 255, 255));
        jPanel7.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(java.awt.event.ComponentEvent evt) {
                jPanel7ComponentResized(evt);
            }
        });

        rechteckMain1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                rechteckMain1MousePressed(evt);
            }
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                rechteckMain1MouseReleased(evt);
            }
        });

        javax.swing.GroupLayout jPanel7Layout = new javax.swing.GroupLayout(jPanel7);
        jPanel7.setLayout(jPanel7Layout);
        jPanel7Layout.setHorizontalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel7Layout.createSequentialGroup()
                      .addContainerGap()
                      .addComponent(rechteckMain1, javax.swing.GroupLayout.DEFAULT_SIZE, 515, Short.MAX_VALUE)
                      .addContainerGap())
        );
        jPanel7Layout.setVerticalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel7Layout.createSequentialGroup()
                      .addContainerGap()
                      .addComponent(rechteckMain1, javax.swing.GroupLayout.DEFAULT_SIZE, 185, Short.MAX_VALUE)
                      .addContainerGap())
        );

        AmpPhaButton.setSelected(true);
        AmpPhaButton.setText("Betrag & Phase");
        AmpPhaButton.setToolTipText("Zeigt Betrag und Phase an");
        AmpPhaButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AmpPhaButtonActionPerformed(evt);
            }
        });

        SinCosButton.setText("Sinus & Cosinus");
        SinCosButton.setToolTipText("Zeigt Sinus- und Cosinusanteil an");
        SinCosButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                SinCosButtonActionPerformed(evt);
            }
        });

        jPanel8.setBackground(new java.awt.Color(255, 255, 255));
        jPanel8.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(java.awt.event.ComponentEvent evt) {
                jPanel8ComponentResized(evt);
            }
        });

        rechteckMain2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                rechteckMain2MousePressed(evt);
            }
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                rechteckMain2MouseReleased(evt);
            }
        });

        javax.swing.GroupLayout jPanel8Layout = new javax.swing.GroupLayout(jPanel8);
        jPanel8.setLayout(jPanel8Layout);
        jPanel8Layout.setHorizontalGroup(
            jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel8Layout.createSequentialGroup()
                      .addContainerGap()
                      .addComponent(rechteckMain2, javax.swing.GroupLayout.DEFAULT_SIZE, 245, Short.MAX_VALUE)
                      .addContainerGap())
        );
        jPanel8Layout.setVerticalGroup(
            jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel8Layout.createSequentialGroup()
                      .addContainerGap()
                      .addComponent(rechteckMain2, javax.swing.GroupLayout.DEFAULT_SIZE, 180, Short.MAX_VALUE)
                      .addContainerGap())
        );

        jPanel9.setBackground(new java.awt.Color(255, 255, 255));
        jPanel9.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(java.awt.event.ComponentEvent evt) {
                jPanel9ComponentResized(evt);
            }
        });

        rechteckMain3.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                rechteckMain3MousePressed(evt);
            }
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                rechteckMain3MouseReleased(evt);
            }
        });

        javax.swing.GroupLayout jPanel9Layout = new javax.swing.GroupLayout(jPanel9);
        jPanel9.setLayout(jPanel9Layout);
        jPanel9Layout.setHorizontalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel9Layout.createSequentialGroup()
                      .addContainerGap()
                      .addComponent(rechteckMain3, javax.swing.GroupLayout.DEFAULT_SIZE, 244, Short.MAX_VALUE)
                      .addContainerGap())
        );
        jPanel9Layout.setVerticalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel9Layout.createSequentialGroup()
                      .addContainerGap()
                      .addComponent(rechteckMain3, javax.swing.GroupLayout.DEFAULT_SIZE, 180, Short.MAX_VALUE)
                      .addContainerGap())
        );

        leftLabel.setFont(new java.awt.Font("Tahoma", 1, 11));
        leftLabel.setText("Betrag");

        rightLabel.setFont(new java.awt.Font("Tahoma", 1, 11));
        rightLabel.setText("Phase");

        checkAnpass.setText("Grafik anpassen");
        checkAnpass.setToolTipText("Passt automatisch die y-Achse an");
        checkAnpass.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                checkAnpassActionPerformed(evt);
            }
        });

        //FormelLabel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/RechteckFormel.gif"))); // NOI18N
		try{
			FormelLabel.setIcon(new javax.swing.ImageIcon(javax.imageio.ImageIO.read(Fourier.class.getResourceAsStream("/images/RechteckFormel.gif"))));
			anLabel.setIcon(new javax.swing.ImageIcon(javax.imageio.ImageIO.read(Fourier.class.getResourceAsStream("/images/an3.jpg")))); // NOI18N
			bnLabel.setIcon(new javax.swing.ImageIcon(javax.imageio.ImageIO.read(Fourier.class.getResourceAsStream("/images/bn3.jpg")))); // NOI18N
			
		}catch(java.io.IOException IOE){
		}

        //anLabel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/an3.jpg"))); // NOI18N

        //bnLabel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/bn3.jpg"))); // NOI18N

        javax.swing.GroupLayout jPanel6Layout = new javax.swing.GroupLayout(jPanel6);
        jPanel6.setLayout(jPanel6Layout);
        jPanel6Layout.setHorizontalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                      .addContainerGap()
                      .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                .addComponent(jPanel7, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(jSeparator2, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 535, Short.MAX_VALUE)
                                .addComponent(FormelLabel)
                                .addComponent(jLabel3)
                                .addGroup(jPanel6Layout.createSequentialGroup()
                                          .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                  .addGroup(jPanel6Layout.createSequentialGroup()
                                                          .addComponent(leftLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 88, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                          .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                          .addComponent(anLabel))
                                                  .addGroup(jPanel6Layout.createSequentialGroup()
                                                          .addComponent(AmpPhaButton)
                                                          .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                          .addComponent(SinCosButton))
                                                  .addComponent(jPanel8, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                          .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                          .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                                  .addComponent(jPanel9, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                                  .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel6Layout.createSequentialGroup()
                                                          .addComponent(rightLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 69, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                          .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                          .addComponent(bnLabel))
                                                  .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel6Layout.createSequentialGroup()
                                                          .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 161, Short.MAX_VALUE)
                                                          .addComponent(checkAnpass)))))
                      .addContainerGap())
        );
        jPanel6Layout.setVerticalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                      .addContainerGap()
                      .addComponent(jLabel3)
                      .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                      .addComponent(FormelLabel)
                      .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                      .addComponent(jPanel7, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                      .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                      .addComponent(jSeparator2, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                      .addGap(6, 6, 6)
                      .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                .addGroup(jPanel6Layout.createSequentialGroup()
                                          .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                                  .addComponent(AmpPhaButton)
                                                  .addComponent(checkAnpass, javax.swing.GroupLayout.PREFERRED_SIZE, 15, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                  .addComponent(SinCosButton))
                                          .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                          .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                                  .addComponent(leftLabel)
                                                  .addComponent(anLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 15, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                .addComponent(bnLabel)
                                .addComponent(rightLabel))
                      .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                      .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                .addComponent(jPanel9, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(jPanel8, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                      .addContainerGap())
        );

        SliderMaxX.setMajorTickSpacing(5);
        SliderMaxX.setMaximum(15);
        SliderMaxX.setMinorTickSpacing(1);
        SliderMaxX.setPaintLabels(true);
        SliderMaxX.setPaintTicks(true);
        SliderMaxX.setSnapToTicks(true);
        SliderMaxX.setToolTipText("Ändert Maximalwert der t-Achse");
        SliderMaxX.setValue(10);
        SliderMaxX.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                SliderMaxXStateChanged(evt);
            }
        });

        SliderT.setMajorTickSpacing(10);
        SliderT.setMaximum(90);
        SliderT.setMinimum(10);
        SliderT.setMinorTickSpacing(1);
        SliderT.setPaintLabels(true);
        SliderT.setPaintTicks(true);
        SliderT.setSnapToTicks(true);
        SliderT.setToolTipText("Einstellen der Periodendauer T");
        SliderT.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                SliderTStateChanged(evt);
            }
        });

        jLabel7.setText(" Periodendauer");

        jLabel11.setText(" Abstand a");

        SliderA.setMajorTickSpacing(5);
        SliderA.setMaximum(10);
        SliderA.setMinorTickSpacing(1);
        SliderA.setPaintLabels(true);
        SliderA.setPaintTicks(true);
        SliderA.setSnapToTicks(true);
        SliderA.setToolTipText("Einstellen der Pausen zwischen den Impulsen");
        SliderA.setValue(0);
        SliderA.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                SliderAStateChanged(evt);
            }
        });

        BasicButton.setText("Originalfunktion");
        BasicButton.setToolTipText("Zeigt die Originalfunktion der Fourierentwicklung an");
        BasicButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BasicButtonActionPerformed(evt);
            }
        });

        XField.setBackground(new java.awt.Color(224, 223, 227));
        XField.setEditable(false);
        XField.setForeground(new java.awt.Color(102, 102, 102));
        XField.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        XField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                XFieldActionPerformed(evt);
            }
        });

        YField.setBackground(new java.awt.Color(224, 223, 227));
        YField.setEditable(false);
        YField.setForeground(new java.awt.Color(102, 102, 102));
        YField.setHorizontalAlignment(javax.swing.JTextField.RIGHT);

        NField.setBackground(new java.awt.Color(224, 223, 227));
        NField.setEditable(false);
        NField.setForeground(new java.awt.Color(102, 102, 102));
        NField.setHorizontalAlignment(javax.swing.JTextField.RIGHT);

        AmpField.setBackground(new java.awt.Color(224, 223, 227));
        AmpField.setEditable(false);
        AmpField.setForeground(new java.awt.Color(102, 102, 102));
        AmpField.setHorizontalAlignment(javax.swing.JTextField.RIGHT);

        TField.setBackground(new java.awt.Color(224, 223, 227));
        TField.setEditable(false);
        TField.setForeground(new java.awt.Color(102, 102, 102));
        TField.setHorizontalAlignment(javax.swing.JTextField.RIGHT);

        AField.setBackground(new java.awt.Color(224, 223, 227));
        AField.setEditable(false);
        AField.setForeground(new java.awt.Color(102, 102, 102));
        AField.setHorizontalAlignment(javax.swing.JTextField.RIGHT);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 729, Short.MAX_VALUE)
            .addGroup(layout.createSequentialGroup()
                      .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                .addGroup(layout.createSequentialGroup()
                                          .addContainerGap()
                                          .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                  .addComponent(jLabel9)
                                                  .addGroup(layout.createSequentialGroup()
                                                          .addComponent(SliderMinX, javax.swing.GroupLayout.DEFAULT_SIZE, 67, Short.MAX_VALUE)
                                                          .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                          .addComponent(SliderMaxX, javax.swing.GroupLayout.DEFAULT_SIZE, 67, Short.MAX_VALUE))
                                                  .addComponent(jLabel10)
                                                  .addComponent(jSeparator5, javax.swing.GroupLayout.DEFAULT_SIZE, 140, Short.MAX_VALUE)
                                                  .addComponent(BasicButton)
                                                  .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                                          .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, 89, Short.MAX_VALUE)
                                                          .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                          .addComponent(XField, javax.swing.GroupLayout.PREFERRED_SIZE, 47, javax.swing.GroupLayout.PREFERRED_SIZE))))
                                .addGroup(layout.createSequentialGroup()
                                          .addGap(10, 10, 10)
                                          .addComponent(jLabel5)
                                          .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 10, Short.MAX_VALUE)
                                          .addComponent(YField, javax.swing.GroupLayout.PREFERRED_SIZE, 47, javax.swing.GroupLayout.PREFERRED_SIZE)
                                          .addGap(0, 0, 0))
                                .addGroup(layout.createSequentialGroup()
                                          .addGap(10, 10, 10)
                                          .addComponent(jLabel2)
                                          .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 49, Short.MAX_VALUE)
                                          .addComponent(NField, javax.swing.GroupLayout.PREFERRED_SIZE, 47, javax.swing.GroupLayout.PREFERRED_SIZE)
                                          .addGap(0, 0, 0))
                                .addGroup(layout.createSequentialGroup()
                                          .addGap(10, 10, 10)
                                          .addComponent(jLabel6)
                                          .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 43, Short.MAX_VALUE)
                                          .addComponent(AmpField, javax.swing.GroupLayout.PREFERRED_SIZE, 47, javax.swing.GroupLayout.PREFERRED_SIZE)
                                          .addGap(0, 0, 0))
                                .addGroup(layout.createSequentialGroup()
                                          .addContainerGap()
                                          .addComponent(jLabel7)
                                          .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 20, Short.MAX_VALUE)
                                          .addComponent(TField, javax.swing.GroupLayout.PREFERRED_SIZE, 47, javax.swing.GroupLayout.PREFERRED_SIZE)
                                          .addGap(0, 0, 0))
                                .addGroup(layout.createSequentialGroup()
                                          .addGap(10, 10, 10)
                                          .addComponent(jLabel11)
                                          .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 41, Short.MAX_VALUE)
                                          .addComponent(AField, javax.swing.GroupLayout.PREFERRED_SIZE, 47, javax.swing.GroupLayout.PREFERRED_SIZE)
                                          .addGap(0, 0, 0))
                                .addComponent(SliderA, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 150, Short.MAX_VALUE)
                                .addComponent(SliderT, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 150, Short.MAX_VALUE)
                                .addComponent(SliderAmp, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 150, Short.MAX_VALUE)
                                .addComponent(SliderN, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 150, Short.MAX_VALUE)
                                .addComponent(SliderOffY, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 150, Short.MAX_VALUE)
                                .addComponent(SliderOffX, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 150, Short.MAX_VALUE)
                                .addGroup(layout.createSequentialGroup()
                                          .addContainerGap()
                                          .addComponent(jLabel8, javax.swing.GroupLayout.PREFERRED_SIZE, 52, javax.swing.GroupLayout.PREFERRED_SIZE)))
                      .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                      .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                      .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                      .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 555, Short.MAX_VALUE)
                                .addComponent(jPanel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                      .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 622, Short.MAX_VALUE)
            .addGroup(layout.createSequentialGroup()
                      .addContainerGap()
                      .addComponent(jLabel9)
                      .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                      .addComponent(jLabel8)
                      .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                      .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                .addComponent(SliderMaxX, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(SliderMinX, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                      .addGap(7, 7, 7)
                      .addComponent(BasicButton)
                      .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                      .addComponent(jSeparator5, javax.swing.GroupLayout.PREFERRED_SIZE, 11, javax.swing.GroupLayout.PREFERRED_SIZE)
                      .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                      .addComponent(jLabel10)
                      .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                      .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                .addComponent(jLabel1)
                                .addComponent(XField, javax.swing.GroupLayout.PREFERRED_SIZE, 15, javax.swing.GroupLayout.PREFERRED_SIZE))
                      .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                      .addComponent(SliderOffX, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                      .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                      .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                .addComponent(jLabel5)
                                .addComponent(YField, javax.swing.GroupLayout.PREFERRED_SIZE, 15, javax.swing.GroupLayout.PREFERRED_SIZE))
                      .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                      .addComponent(SliderOffY, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                      .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                      .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                .addComponent(jLabel2)
                                .addComponent(NField, javax.swing.GroupLayout.PREFERRED_SIZE, 15, javax.swing.GroupLayout.PREFERRED_SIZE))
                      .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                      .addComponent(SliderN, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                      .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                      .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                .addComponent(jLabel6)
                                .addComponent(AmpField, javax.swing.GroupLayout.PREFERRED_SIZE, 15, javax.swing.GroupLayout.PREFERRED_SIZE))
                      .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                      .addComponent(SliderAmp, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                      .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                      .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                .addComponent(jLabel7)
                                .addComponent(TField, javax.swing.GroupLayout.PREFERRED_SIZE, 15, javax.swing.GroupLayout.PREFERRED_SIZE))
                      .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                      .addComponent(SliderT, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                      .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                      .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                .addComponent(jLabel11)
                                .addComponent(AField, javax.swing.GroupLayout.PREFERRED_SIZE, 15, javax.swing.GroupLayout.PREFERRED_SIZE))
                      .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                      .addComponent(SliderA, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                      .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
            .addGroup(layout.createSequentialGroup()
                      .addContainerGap()
                      .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 16, javax.swing.GroupLayout.PREFERRED_SIZE)
                      .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                      .addComponent(jPanel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
            .addComponent(jSeparator1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 622, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents

    private void jTabbedPane1StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jTabbedPane1StateChanged
        int state=jTabbedPane1.getSelectedIndex();



        if(state==3)
            state=5;
        else if(state==5)
            state=3;

        double amp = SliderAmp.getValue();
        double temp = 0;

        rechteckMain1.setFunction(state);
        rechteckMain2.setFunction(state);
        rechteckMain3.setFunction(state);


        rechteckMain1.repaint();
        rechteckMain2.repaint();
        rechteckMain3.repaint();

        // <editor-fold defaultstate="collapsed" desc="Set Cases">
        switch(state) {
        case 0:
			try{
				FormelLabel.setIcon(new javax.swing.ImageIcon(javax.imageio.ImageIO.read(Fourier.class.getResourceAsStream("/images/RechteckFormel.gif"))));
			}catch(java.io.IOException IOE){
			}
            setSliderOffYLabels(-50,0,50);
            SliderA.setVisible(false);
            jLabel11.setVisible(false);
            AField.setVisible(false);
            break;
        case 1:
			try{
				FormelLabel.setIcon(new javax.swing.ImageIcon(javax.imageio.ImageIO.read(Fourier.class.getResourceAsStream("/images/DreieckFormel.gif"))));
			}catch(java.io.IOException IOE){
			}
            //FormelLabel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/DreieckFormel.gif")));
            setSliderOffYLabels(-50,0,50);
            SliderA.setVisible(false);
            jLabel11.setVisible(false);
            AField.setVisible(false);
            break;
        case 2:
			try{
				FormelLabel.setIcon(new javax.swing.ImageIcon(javax.imageio.ImageIO.read(Fourier.class.getResourceAsStream("/images/SaegezahnFormel.gif"))));
			}catch(java.io.IOException IOE){
			}
            //FormelLabel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/SaegezahnFormel.gif")));
            setSliderOffYLabels(-50,0,50);
            SliderA.setVisible(false);
            jLabel11.setVisible(false);
            AField.setVisible(false);
            break;
        case 3:
			try{
				FormelLabel.setIcon(new javax.swing.ImageIcon(javax.imageio.ImageIO.read(Fourier.class.getResourceAsStream("/images/SinusFormel.gif"))));
			}catch(java.io.IOException IOE){
			}
            //FormelLabel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/SinusFormel.gif")));
            temp=(2*(amp/10)/Math.PI);
            setSliderOffYLabels((int)(10*temp-50),(int)(10*temp),(int)(10*temp+50));
            SliderA.setVisible(false);
            jLabel11.setVisible(false);
            AField.setVisible(false);
            break;
        case 4:
			try{
				FormelLabel.setIcon(new javax.swing.ImageIcon(javax.imageio.ImageIO.read(Fourier.class.getResourceAsStream("/images/ParabelFormel.gif"))));
			}catch(java.io.IOException IOE){
			}
            //FormelLabel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/ParabelFormel.gif")));
            temp=((amp/10.0)/3.0);
            setSliderOffYLabels((int)(10*temp-50),(int)(10*temp),(int)(10*temp+50));
            SliderA.setVisible(false);
            jLabel11.setVisible(false);
            AField.setVisible(false);
            break;
        case 5:
			try{
				FormelLabel.setIcon(new javax.swing.ImageIcon(javax.imageio.ImageIO.read(Fourier.class.getResourceAsStream("/images/RechteckImpFormel.gif"))));
			}catch(java.io.IOException IOE){
			}
            //FormelLabel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/RechteckImpFormel.gif")));
            setSliderOffYLabels(-50,0,50);
            SliderA.setVisible(true);
            jLabel11.setVisible(true);
            AField.setVisible(true);
            break;
        default:
			try{
				FormelLabel.setIcon(new javax.swing.ImageIcon(javax.imageio.ImageIO.read(Fourier.class.getResourceAsStream("/images/SinusImpFormel.gif"))));
			}catch(java.io.IOException IOE){
			}
            //FormelLabel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/SinusImpFormel.gif")));
            temp=((amp/10.0)/(Math.PI));
            setSliderOffYLabels((int)(10*temp-50),(int)(10*temp),(int)(10*temp+50));
            SliderA.setVisible(false);
            jLabel11.setVisible(false);
            AField.setVisible(false);
            break;
        }

        // </editor-fold>
    }//GEN-LAST:event_jTabbedPane1StateChanged

    private void SliderNStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_SliderNStateChanged
        rechteckMain1.setAmount(SliderN.getValue());
        rechteckMain1.repaint();
        rechteckMain2.setAmount(SliderN.getValue());
        rechteckMain2.repaint();
        rechteckMain3.setAmount(SliderN.getValue());
        rechteckMain3.repaint();
        NField.setText(String.valueOf(SliderN.getValue()));

        rechteckMain2.setXminmax(-2*Math.PI/(T/10.0), (SliderN.getValue()+2)*2*Math.PI/(T/10.0));
        rechteckMain2.setPanelSize(rechteckMain2.getSize().height-1, rechteckMain2.getSize().width-1);

        if(AmpPhaButton.isSelected())
            rechteckMain3.setXminmax(-3*Math.PI/(T/10.0), (SliderN.getValue()+2)*2*Math.PI/(T/10.0));
        else
            rechteckMain3.setXminmax(-2*Math.PI/(T/10.0), (SliderN.getValue()+2)*2*Math.PI/(T/10.0));
        rechteckMain3.setPanelSize(rechteckMain3.getSize().height-1, rechteckMain3.getSize().width-1);
    }//GEN-LAST:event_SliderNStateChanged

    private void SliderOffXStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_SliderOffXStateChanged
        rechteckMain1.setXoffset(SliderOffX.getValue());
        rechteckMain1.repaint();
        rechteckMain2.setXoffset(SliderOffX.getValue());
        rechteckMain2.repaint();
        rechteckMain3.setXoffset(SliderOffX.getValue());
        rechteckMain3.repaint();
        XField.setText(String.valueOf(SliderOffX.getValue()/10.0));
    }//GEN-LAST:event_SliderOffXStateChanged

    private void SliderAmpStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_SliderAmpStateChanged
        double amp=SliderAmp.getValue();
        rechteckMain1.setAmplitude(amp);
        rechteckMain1.repaint();
        rechteckMain2.setAmplitude(amp);
        rechteckMain2.repaint();
        rechteckMain3.setAmplitude(amp);
        rechteckMain3.repaint();
        AmpField.setText(String.valueOf(SliderAmp.getValue()/10.0));
        double temp=0;

        // <editor-fold defaultstate="collapsed" desc="Set Cases">
        switch(jTabbedPane1.getSelectedIndex()) {
        case 0:
            try{
				FormelLabel.setIcon(new javax.swing.ImageIcon(javax.imageio.ImageIO.read(Fourier.class.getResourceAsStream("/images/RechteckFormel.gif"))));
			}catch(java.io.IOException IOE){
			}
            setSliderOffYLabels(-50,0,50);
            break;
        case 1:
            try{
				FormelLabel.setIcon(new javax.swing.ImageIcon(javax.imageio.ImageIO.read(Fourier.class.getResourceAsStream("/images/DreieckFormel.gif"))));
			}catch(java.io.IOException IOE){
			}
            setSliderOffYLabels(-50,0,50);
            break;
        case 2:
            try{
				FormelLabel.setIcon(new javax.swing.ImageIcon(javax.imageio.ImageIO.read(Fourier.class.getResourceAsStream("/images/SaegezahnFormel.gif"))));
			}catch(java.io.IOException IOE){
			}
            setSliderOffYLabels(-50,0,50);
            break;
        case 5:                                                             //3
            try{
				FormelLabel.setIcon(new javax.swing.ImageIcon(javax.imageio.ImageIO.read(Fourier.class.getResourceAsStream("/images/SinusFormel.gif"))));
			}catch(java.io.IOException IOE){
			}
            temp=(2*(amp/10.0)/Math.PI);
            setSliderOffYLabels((int)(10*temp-50),(int)(10*temp),(int)(10*temp+50));
            break;
        case 4:
            try{
				FormelLabel.setIcon(new javax.swing.ImageIcon(javax.imageio.ImageIO.read(Fourier.class.getResourceAsStream("/images/ParabelFormel.gif"))));
			}catch(java.io.IOException IOE){
			}
            temp=((amp/10.0)/3.0);
            setSliderOffYLabels((int)(10*temp-50),(int)(10*temp),(int)(10*temp+50));
            break;
        case 3:                                                             //5
            try{
				FormelLabel.setIcon(new javax.swing.ImageIcon(javax.imageio.ImageIO.read(Fourier.class.getResourceAsStream("/images/RechteckImpFormel.gif"))));
			}catch(java.io.IOException IOE){
			}
            setSliderOffYLabels(-50,0,50);
            break;
        case 6:
            try{
				FormelLabel.setIcon(new javax.swing.ImageIcon(javax.imageio.ImageIO.read(Fourier.class.getResourceAsStream("/images/SinusImpFormel.gif"))));
			}catch(java.io.IOException IOE){
			}
            temp=((amp/10.0)/(Math.PI));
            setSliderOffYLabels((int)(10*temp-50),(int)(10*temp),(int)(10*temp+50));
            break;
        }


        // </editor-fold>
    }//GEN-LAST:event_SliderAmpStateChanged

    private void SliderMinXStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_SliderMinXStateChanged
        rechteckMain1.setXmin(SliderMinX.getValue());
        rechteckMain1.setPanelSize(rechteckMain1.getSize().height-1, rechteckMain1.getSize().width-1);
        rechteckMain1.repaint();
    }//GEN-LAST:event_SliderMinXStateChanged

    private void SliderOffYStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_SliderOffYStateChanged
        rechteckMain1.setYoffset(SliderOffY.getValue());
        rechteckMain1.repaint();
        rechteckMain2.setYoffset(SliderOffY.getValue());
        rechteckMain2.repaint();
        rechteckMain3.setYoffset(SliderOffY.getValue());
        rechteckMain3.repaint();
        YField.setText(String.valueOf(SliderOffY.getValue()/10.0));
    }//GEN-LAST:event_SliderOffYStateChanged

    private void rechteckMain1MousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_rechteckMain1MousePressed

    }//GEN-LAST:event_rechteckMain1MousePressed

    private void rechteckMain1MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_rechteckMain1MouseReleased

    }//GEN-LAST:event_rechteckMain1MouseReleased

    private void jPanel7ComponentResized(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_jPanel7ComponentResized
        rechteckMain1.setPanelSize(rechteckMain1.getSize().height-1, rechteckMain1.getSize().width-1);
        rechteckMain1.repaint();
    }//GEN-LAST:event_jPanel7ComponentResized

    private void AmpPhaButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_AmpPhaButtonActionPerformed
        if(AmpPhaButton.isSelected()) {
            SinCosButton.setSelected(false);
            leftLabel.setText("Betrag");
            rechteckMain2.setType(1);
            rightLabel.setText("Phase");
            rechteckMain3.setType(2);
            rechteckMain2.repaint();
            rechteckMain3.repaint();
            anLabel.setVisible(false);
            bnLabel.setVisible(false);
        } else
            AmpPhaButton.setSelected(true);
    }//GEN-LAST:event_AmpPhaButtonActionPerformed

    private void SinCosButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_SinCosButtonActionPerformed
        if(SinCosButton.isSelected()) {
            AmpPhaButton.setSelected(false);
            leftLabel.setText("Cosinus-Anteil");
            rechteckMain2.setType(3);
            rightLabel.setText("Sinus-Anteil");
            rechteckMain3.setType(4);
            rechteckMain2.repaint();
            rechteckMain3.repaint();
            anLabel.setVisible(true);
            bnLabel.setVisible(true);
        } else
            SinCosButton.setSelected(true);
    }//GEN-LAST:event_SinCosButtonActionPerformed

    private void rechteckMain2MousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_rechteckMain2MousePressed

    }//GEN-LAST:event_rechteckMain2MousePressed

    private void rechteckMain2MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_rechteckMain2MouseReleased

    }//GEN-LAST:event_rechteckMain2MouseReleased

    private void jPanel8ComponentResized(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_jPanel8ComponentResized
        rechteckMain2.setPanelSize(rechteckMain2.getSize().height-1, rechteckMain2.getSize().width-1);
        rechteckMain2.repaint();
    }//GEN-LAST:event_jPanel8ComponentResized

    private void rechteckMain3MousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_rechteckMain3MousePressed

    }//GEN-LAST:event_rechteckMain3MousePressed

    private void rechteckMain3MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_rechteckMain3MouseReleased

    }//GEN-LAST:event_rechteckMain3MouseReleased

    private void jPanel9ComponentResized(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_jPanel9ComponentResized
        rechteckMain3.setPanelSize(rechteckMain3.getSize().height-1, rechteckMain3.getSize().width-1);
        rechteckMain3.repaint();
    }//GEN-LAST:event_jPanel9ComponentResized

    private void checkAnpassActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_checkAnpassActionPerformed
        automatic=checkAnpass.isSelected();

        rechteckMain2.setDynamic(automatic);
        if(!automatic) {
            rechteckMain2.setPanelSize(rechteckMain2.getSize().height-1, rechteckMain2.getSize().width-1);
        }
        rechteckMain2.repaint();
        rechteckMain2.repaint();

        rechteckMain3.setDynamic(automatic);
        if(!automatic) {
            rechteckMain3.setPanelSize(rechteckMain3.getSize().height-1, rechteckMain3.getSize().width-1);
        }
        rechteckMain3.repaint();
        rechteckMain3.repaint();
    }//GEN-LAST:event_checkAnpassActionPerformed

    private void SliderMaxXStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_SliderMaxXStateChanged
        rechteckMain1.setXmax(SliderMaxX.getValue());
        rechteckMain1.setPanelSize(rechteckMain1.getSize().height-1, rechteckMain1.getSize().width-1);
        rechteckMain1.repaint();
    }//GEN-LAST:event_SliderMaxXStateChanged

    private void SliderTStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_SliderTStateChanged
        T=SliderT.getValue();
        rechteckMain1.setT(T);
        rechteckMain1.setA(SliderA.getValue());
        rechteckMain2.setT(T);
        rechteckMain2.setA(SliderA.getValue());
        rechteckMain3.setT(T);
        rechteckMain3.setA(SliderA.getValue());
        TField.setText(String.valueOf(SliderT.getValue()/10.0));



        rechteckMain2.setXminmax(-2*Math.PI/(T/10.0), (SliderN.getValue()+2)*2*Math.PI/(T/10.0));
        rechteckMain2.setPanelSize(rechteckMain2.getSize().height-1, rechteckMain2.getSize().width-1);

        if(AmpPhaButton.isSelected())
            rechteckMain3.setXminmax(-3*Math.PI/(T/10.0), (SliderN.getValue()+2)*2*Math.PI/(T/10.0));
        else
            rechteckMain3.setXminmax(-2*Math.PI/(T/10.0), (SliderN.getValue()+2)*2*Math.PI/(T/10.0));
        rechteckMain3.setPanelSize(rechteckMain3.getSize().height-1, rechteckMain3.getSize().width-1);



        rechteckMain1.repaint();
        rechteckMain2.repaint();
        rechteckMain3.repaint();
    }//GEN-LAST:event_SliderTStateChanged

    private void SliderAStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_SliderAStateChanged
        rechteckMain1.setA(SliderA.getValue());
        rechteckMain2.setA(SliderA.getValue());
        rechteckMain3.setA(SliderA.getValue());
        rechteckMain1.repaint();
        rechteckMain2.repaint();
        rechteckMain3.repaint();
        AField.setText(String.valueOf(SliderA.getValue()/10.0));
    }//GEN-LAST:event_SliderAStateChanged

    private void BasicButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BasicButtonActionPerformed
        rechteckMain1.setBasic(BasicButton.isSelected());
        rechteckMain1.repaint();
    }//GEN-LAST:event_BasicButtonActionPerformed

    private void XFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_XFieldActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_XFieldActionPerformed


    public static void main(String args[]) {
        Fourier fr = new Fourier();
//        fr.setDefaultCloseOperation(Fourier.EXIT_ON_CLOSE);
        fr.setVisible(true);
//        fr.setTitle("Fourierentwicklung");
        fr.setLocation(((Toolkit.getDefaultToolkit().getScreenSize().width-fr.getSize().width) / 2),((Toolkit.getDefaultToolkit().getScreenSize().height-fr.getSize().height) / 2));
    }



    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField AField;
    private javax.swing.JTextField AmpField;
    private javax.swing.JRadioButton AmpPhaButton;
    private javax.swing.JRadioButton BasicButton;
    private javax.swing.JLabel FormelLabel;
    private javax.swing.JTextField NField;
    private javax.swing.JRadioButton SinCosButton;
    private javax.swing.JSlider SliderA;
    private javax.swing.JSlider SliderAmp;
    private javax.swing.JSlider SliderMaxX;
    private javax.swing.JSlider SliderMinX;
    private javax.swing.JSlider SliderN;
    private javax.swing.JSlider SliderOffX;
    private javax.swing.JSlider SliderOffY;
    private javax.swing.JSlider SliderT;
    private javax.swing.JTextField TField;
    private javax.swing.JTextField XField;
    private javax.swing.JTextField YField;
    private javax.swing.JLabel anLabel;
    private javax.swing.JLabel bnLabel;
    private javax.swing.JCheckBox checkAnpass;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel11;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JSeparator jSeparator5;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JLabel leftLabel;
    private FourierPackage.RechteckMain rechteckMain1;
    private FourierPackage.RechteckMain rechteckMain2;
    private FourierPackage.RechteckMain rechteckMain3;
    private javax.swing.JLabel rightLabel;
    // End of variables declaration//GEN-END:variables

}
