
package FourierPackage;

import java.awt.Color;
import java.awt.Font;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JApplet;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.SwingConstants;

/**
 * StartApplet stellt den Einstiegspunkt
 * für ein Java Applet zur Verfügung
 *
 * @author Matthias Klingler
 */

public class StartApplet extends JApplet {

    private static final long serialVersionUID = 1L;
    private Fourier Fourierframe;
    private JButton buttonStart;
    private JMenuBar menuBar;
    private JMenu menu1, menu2, menu3;
    private JMenuItem ItemEnd,ItemRect,ItemTrian,ItemSaw,ItemSin,ItemPara,ItemRectImp,ItemSinImp,helpItem,aboutItem;
    private javax.swing.JSeparator jSeparator4;
    private JApplet applet = null;;
    private Color bgcolor;
    private Adapter adapter = new Adapter();


    /** Entspricht der Main-Funktion
    * - Wird beim Applet immer als erstes aufgerufen
    */
    @Override
    public void init() {
        // Referenz für weitere Aktionen
        jSeparator4 = new javax.swing.JSeparator();
        ItemEnd = new javax.swing.JMenuItem();
        ItemRect = new javax.swing.JMenuItem();
        ItemTrian = new javax.swing.JMenuItem();
        ItemSaw = new javax.swing.JMenuItem();
        ItemSin = new javax.swing.JMenuItem();
        ItemPara = new javax.swing.JMenuItem();
        ItemRectImp = new javax.swing.JMenuItem();
        ItemSinImp = new javax.swing.JMenuItem();
        helpItem = new javax.swing.JMenuItem();
        aboutItem = new javax.swing.JMenuItem();
        menu1 = new javax.swing.JMenu();
        menu2 = new javax.swing.JMenu();
        menu3 = new javax.swing.JMenu();


        applet = this;
        bgcolor = new Color(235,238,247);
        getContentPane().setLayout(null);
        getContentPane().setBackground(bgcolor);

        //buttonStart = new JButton("", new javax.swing.ImageIcon(getClass().getResource("/StartButton.gif")));
		
		try{
			buttonStart = new JButton("", new javax.swing.ImageIcon(javax.imageio.ImageIO.read(StartApplet.class.getResourceAsStream("/images/StartButton.gif"))));
		}catch(java.io.IOException IOE){
		}
		
        buttonStart.setBackground(bgcolor);
        buttonStart.setFont(new Font("Sans Serif", Font.BOLD, 14));
        buttonStart.setHorizontalAlignment(SwingConstants.LEFT);
        buttonStart.setIconTextGap(20);
        buttonStart.addActionListener(adapter);
        buttonStart.setBounds(20,20,315,130);
        buttonStart.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseEntered(MouseEvent evt) {
                setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
            }

            @Override
            public void mouseExited(MouseEvent evt) {
                setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
            }
        });
        getContentPane().add(buttonStart);
    }

    /**
     * Nachdem die init()-Methode durchlaufen wurde,
     * wird diese Methode ausgeführt.
     */
    @Override
    public void start() {
    }

    /**
     * Diese Methode wird ausgeführt, falls das
     * Applet beendet wird.
     */
    @Override
    public void stop() {
    }

    class Adapter extends WindowAdapter implements ActionListener {
        @Override
        public void windowClosing(WindowEvent evt) {
        }

        public void actionPerformed(ActionEvent evt) {
            //Start-Button wurde geklickt.
            if (evt.getSource() == buttonStart) {

                final JFrame Hauptfenster = new JFrame("Fourierentwicklung");
                Hauptfenster.setSize(1080, 750);

                Fourierframe = new Fourier();
                Hauptfenster.add(Fourierframe);
                Hauptfenster.setLocation(((Toolkit.getDefaultToolkit().getScreenSize().width-Hauptfenster.getSize().width) / 2),((Toolkit.getDefaultToolkit().getScreenSize().height-Hauptfenster.getSize().height) / 2));


                menuBar = new JMenuBar();
                Hauptfenster.setJMenuBar(menuBar);

                menu1 = new JMenu("Menü");
                menu1.setText("Datei");

                ItemEnd.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_Q, java.awt.event.InputEvent.CTRL_MASK));
                ItemEnd.setText("Beenden");
                ItemEnd.addActionListener(new java.awt.event.ActionListener() {
                    public void actionPerformed(java.awt.event.ActionEvent evt) {
                        Hauptfenster.dispose();
                    }
                });
                menu1.add(ItemEnd);

                menuBar.add(menu1);

                menu2.setText("Funktion");

                ItemRect.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_1, java.awt.event.InputEvent.CTRL_MASK));
                ItemRect.setFont(new java.awt.Font("Tahoma", 1, 13)); // NOI18N
                //ItemRect.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Rectangle.jpg"))); // NOI18N
				try{
					ItemRect.setIcon(new javax.swing.ImageIcon(javax.imageio.ImageIO.read(Fourier.class.getResourceAsStream("/images/Rectangle.jpg"))));
				}catch(java.io.IOException IOE){
				}
                ItemRect.setText("Rechteck");
                ItemRect.addActionListener(new java.awt.event.ActionListener() {
                    public void actionPerformed(java.awt.event.ActionEvent evt) {
                        Fourierframe.ItemRectPush(evt);
                    }
                });
                menu2.add(ItemRect);

                ItemTrian.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_2, java.awt.event.InputEvent.CTRL_MASK));
                ItemTrian.setFont(new java.awt.Font("Tahoma", 1, 13)); // NOI18N
                //ItemTrian.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Triangle.jpg"))); // NOI18N
				try{
					ItemTrian.setIcon(new javax.swing.ImageIcon(javax.imageio.ImageIO.read(Fourier.class.getResourceAsStream("/images/Triangle.jpg"))));
				}catch(java.io.IOException IOE){
				}
                ItemTrian.setText("Dreieck");
                ItemTrian.addActionListener(new java.awt.event.ActionListener() {
                    public void actionPerformed(java.awt.event.ActionEvent evt) {
                        Fourierframe.ItemTrianPush(evt);
                    }
                });
                menu2.add(ItemTrian);

                ItemSaw.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_3, java.awt.event.InputEvent.CTRL_MASK));
                ItemSaw.setFont(new java.awt.Font("Tahoma", 1, 13)); // NOI18N
                //ItemSaw.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Sawtooth.jpg"))); // NOI18N
				try{
					ItemSaw.setIcon(new javax.swing.ImageIcon(javax.imageio.ImageIO.read(Fourier.class.getResourceAsStream("/images/Sawtooth.jpg"))));
				}catch(java.io.IOException IOE){
				}
                ItemSaw.setText("Sägezahn");
                ItemSaw.addActionListener(new java.awt.event.ActionListener() {
                    public void actionPerformed(java.awt.event.ActionEvent evt) {
                        Fourierframe.ItemSawPush(evt);
                    }
                });
                menu2.add(ItemSaw);

                ItemSin.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_4, java.awt.event.InputEvent.CTRL_MASK));
                ItemSin.setFont(new java.awt.Font("Tahoma", 1, 13)); // NOI18N
                //ItemSin.setIcon(new javax.swing.ImageIcon(getClass().getResource("/RectangleImp.jpg"))); // NOI18N
				try{
					ItemSin.setIcon(new javax.swing.ImageIcon(javax.imageio.ImageIO.read(Fourier.class.getResourceAsStream("/images/RectangleImp.jpg"))));
				}catch(java.io.IOException IOE){
				}
                ItemSin.setText("Rechteckimpuls");
                ItemSin.addActionListener(new java.awt.event.ActionListener() {
                    public void actionPerformed(java.awt.event.ActionEvent evt) {
                        Fourierframe.ItemSinPush(evt);
                    }
                });
                menu2.add(ItemSin);

                ItemPara.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_5, java.awt.event.InputEvent.CTRL_MASK));
                ItemPara.setFont(new java.awt.Font("Tahoma", 1, 13)); // NOI18N
                //ItemPara.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Parabel.jpg"))); // NOI18N
				try{
					ItemPara.setIcon(new javax.swing.ImageIcon(javax.imageio.ImageIO.read(Fourier.class.getResourceAsStream("/images/Parabel.jpg"))));
				}catch(java.io.IOException IOE){
				}
                ItemPara.setText("Parabel");
                ItemPara.addActionListener(new java.awt.event.ActionListener() {
                    public void actionPerformed(java.awt.event.ActionEvent evt) {
                        Fourierframe.ItemParaPush(evt);
                    }
                });
                menu2.add(ItemPara);

                ItemRectImp.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_6, java.awt.event.InputEvent.CTRL_MASK));
                ItemRectImp.setFont(new java.awt.Font("Tahoma", 1, 13)); // NOI18N
                //ItemRectImp.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Sinus.jpg"))); // NOI18N
				try{
					ItemRectImp.setIcon(new javax.swing.ImageIcon(javax.imageio.ImageIO.read(Fourier.class.getResourceAsStream("/images/Sinus.jpg"))));
				}catch(java.io.IOException IOE){
				}
                ItemRectImp.setText("Sinusimpuls (Zweiweggleichrichtung)");
                ItemRectImp.addActionListener(new java.awt.event.ActionListener() {
                    public void actionPerformed(java.awt.event.ActionEvent evt) {
                        Fourierframe.ItemRectImpPush(evt);
                    }
                });
                menu2.add(ItemRectImp);

                ItemSinImp.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_7, java.awt.event.InputEvent.CTRL_MASK));
                ItemSinImp.setFont(new java.awt.Font("Tahoma", 1, 13)); // NOI18N
                //ItemSinImp.setIcon(new javax.swing.ImageIcon(getClass().getResource("/SinusImp.jpg"))); // NOI18N
				try{
					ItemSinImp.setIcon(new javax.swing.ImageIcon(javax.imageio.ImageIO.read(Fourier.class.getResourceAsStream("/images/SinusImp.jpg"))));
				}catch(java.io.IOException IOE){
				}
                ItemSinImp.setText("Sinusimpuls (Einweggleichrichtung)");
                ItemSinImp.addActionListener(new java.awt.event.ActionListener() {
                    public void actionPerformed(java.awt.event.ActionEvent evt) {
                        Fourierframe.ItemSinImpPush(evt);
                    }
                });
                menu2.add(ItemSinImp);

                menuBar.add(menu2);

                menu3.setText("Hilfe");

                helpItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_H, java.awt.event.InputEvent.CTRL_MASK));
                helpItem.setText("Hilfe");
                helpItem.addActionListener(new java.awt.event.ActionListener() {
                    public void actionPerformed(java.awt.event.ActionEvent evt) {
                        Fourierframe.helpItemPush(evt,Hauptfenster);
                    }
                });
                menu3.add(helpItem);
                menu3.add(jSeparator4);

                aboutItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_I, java.awt.event.InputEvent.CTRL_MASK));
                aboutItem.setText("Über...");
                aboutItem.addActionListener(new java.awt.event.ActionListener() {
                    public void actionPerformed(java.awt.event.ActionEvent evt) {
                        Fourierframe.aboutItemPush(evt,Hauptfenster);
                    }
                });
                menu3.add(aboutItem);

                menuBar.add(menu3);

                Hauptfenster.setVisible(true);

            }
        }
    }
}
