
package source;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.DecimalFormat;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.JTextField;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
 * Die Klasse ParameterEingabe verwaltet die
 * Ein- und Ausgabewerte der Logarithmus-naturalis-Funktion
 *
 * @author Horst Lauinger  31.10.2007
 */

public class ParameterEingabeLNFunktion {
    // Legt die Genauigkeit fest
    private double Genauigkeit = 100;

    // Formatierung der Anzeigen
    DecimalFormat df2 = new DecimalFormat( "0.00" );
    DecimalFormat df4 = new DecimalFormat( "0.0000" );

    // Referenzen auf die Zeichenbereiche
    private ZeichenbereichLNFunk Zeichenbereich1 = null;
    private ZeichenbereichLNFunk Zeichenbereich2 = null;

    // Bereich der in ParameterEingabe verwaltet wird
    private JPanel innerContent = null;

    // Gruppe von Elementen erstellen:
    // Beschriftung, Eingabefeld & Scrollbalken fr ParameterA
    // Beschriftung, Eingabefeld & Scrollbalken fr ParameterB
    // Beschriftung, Eingabefeld & Scrollbalken fr ParameterC
    // Beschriftung, Eingabefeld & Scrollbalken fr Abgriff

    // Labels
    private JLabel LB_ParameterA_Wert = null;
    private JLabel LB_ParameterB_Wert = null;
    private JLabel LB_ParameterC_Wert = null;
    private JLabel LB_Abgriff = null;
    private JLabel Logo = null;

    // Textfelder
    private JTextField TF_ParameterA_Wert= null;
    private JTextField TF_ParameterB_Wert = null;
    private JTextField TF_ParameterC_Wert = null;
    private JTextField TF_Abgriff = null;

    // Slider (Scrollbalken)
    private JSlider sl_ParameterA_Wert = null;
    private JSlider sl_ParameterB_Wert = null;
    private JSlider sl_ParameterC_Wert = null;
    private JSlider sl_Abgriff = null;

    // Interne Variablen
    private double ParameterA_Wert = 1;
    private double ParameterB_Wert = 1;
    private double ParameterC_Wert = 0;
    private double Abgriff_Wert = 1;

    /**
     * Konstruktor erzeugt die Eingabefelder
     */
    public ParameterEingabeLNFunktion () {
        String Beschriftung;
        // wir legen alle Elemente auf ein Panel
        innerContent = new JPanel();
        // wir verwenden keinen Layoutmanager
        innerContent.setLayout(null);

        // Erzeugung der Text-Eingabefelder, mit dem jeweiligen Wert und
        // lassen maximal 10 Zeichen zu
        Beschriftung = df2.format(ParameterA_Wert);
        TF_ParameterA_Wert = new JTextField(Beschriftung,10);

        Beschriftung = df2.format(ParameterB_Wert);
        TF_ParameterB_Wert = new JTextField(Beschriftung,10);

        Beschriftung = df2.format(ParameterC_Wert);
        TF_ParameterC_Wert = new JTextField(Beschriftung,10);

        Beschriftung = df2.format(Abgriff_Wert);
        TF_Abgriff = new JTextField(Beschriftung,10);

        // wir erzeugen die Berschriftungslabels
        LB_ParameterA_Wert = new JLabel("Parameter a:");
        LB_ParameterB_Wert = new JLabel("Parameter b:");
        LB_ParameterC_Wert = new JLabel("Parameter c:");
        LB_Abgriff = new JLabel("x-Wert:");
        Logo = new JLabel("");

        // Erzeugung der Schieberegler --> JSlider (min, max, value)
        sl_ParameterA_Wert = new JSlider(-500,500,(int)(Genauigkeit * ParameterA_Wert));
        sl_ParameterB_Wert = new JSlider(-500, 500, (int) (Genauigkeit * ParameterB_Wert));
        sl_ParameterC_Wert = new JSlider(-500, 500, (int) (Genauigkeit * ParameterC_Wert));
        sl_Abgriff = new JSlider(-398, 398,(int)(Genauigkeit*Abgriff_Wert));

        // Positionierung der Elemente
        int left = 5;
        int width = 120;
        int height = 21;
        int abstand = 26;
        int top = 7 - abstand;

        // Elementbegrenzungen setzen
        LB_ParameterA_Wert.setBounds(left,top+=abstand,width,height);
        TF_ParameterA_Wert.setBounds(left,top+=abstand/1.5,width,height);
        sl_ParameterA_Wert.setBounds(left,top+=abstand,width,(int)(height));

        top+=abstand*0.1;
        LB_ParameterB_Wert.setBounds(left,top+=abstand,width,height);
        TF_ParameterB_Wert.setBounds(left,top+=abstand/1.5,width,height);
        sl_ParameterB_Wert.setBounds(left,top+=abstand,width,(int)(height));

        top+=abstand*0.1;
        LB_ParameterC_Wert.setBounds(left,top+=abstand,width,height);
        TF_ParameterC_Wert.setBounds(left,top+=abstand/1.5,width,height);
        sl_ParameterC_Wert.setBounds(left,top+=abstand,width,(int)(height));

        top+=abstand*0.3;
        LB_Abgriff.setBounds(left,top+=abstand,width,height);
        TF_Abgriff.setBounds(left,top+=abstand/1.5,width,height);
        sl_Abgriff.setBounds(left,top+=abstand,width,(int)(height));

        top+=abstand*0.4;
        if (Ableitung.getIconLogo() != null)
            Logo.setIcon(Ableitung.getIconLogo());
        Logo.setBounds(left,top+=abstand,120,108);

        /**
         * Reaktion auf die nderung der Eingabefelder
         */
        TF_ParameterA_Wert.addActionListener
        (
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (!TF_ParameterA_Wert.hasFocus())
                    return;
                eingabewerteEinlesen();
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        sl_ParameterA_Wert.addChangeListener
        (
        new ChangeListener() {
            public void stateChanged(ChangeEvent  e) {
                if (!sl_ParameterA_Wert.hasFocus())
                    return;
                String Beschriftung1;
                ParameterA_Wert = sl_ParameterA_Wert.getValue()/Genauigkeit;
                Beschriftung1 = df2.format(ParameterA_Wert);
                TF_ParameterA_Wert.setText(Beschriftung1);
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        TF_ParameterB_Wert.addActionListener
        (
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (!TF_ParameterB_Wert.hasFocus())
                    return;
                eingabewerteEinlesen();
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        sl_ParameterB_Wert.addChangeListener
        (
        new ChangeListener() {
            public void stateChanged(ChangeEvent  e) {
                if (!sl_ParameterB_Wert.hasFocus())
                    return;
                String Beschriftung1;
                ParameterB_Wert = sl_ParameterB_Wert.getValue()/Genauigkeit;
                Beschriftung1 = df2.format(ParameterB_Wert);
                TF_ParameterB_Wert.setText(Beschriftung1);
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        TF_ParameterC_Wert.addActionListener
        (
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (!TF_ParameterC_Wert.hasFocus())
                    return;
                eingabewerteEinlesen();
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        sl_ParameterC_Wert.addChangeListener
        (
        new ChangeListener() {
            public void stateChanged(ChangeEvent  e) {
                if (!sl_ParameterC_Wert.hasFocus())
                    return;
                String Beschriftung1;
                ParameterC_Wert = sl_ParameterC_Wert.getValue()/Genauigkeit;
                Beschriftung1 = df2.format(ParameterC_Wert);
                TF_ParameterC_Wert.setText(Beschriftung1);
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        TF_Abgriff.addActionListener
        (
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (!TF_Abgriff.hasFocus())
                    return;
                eingabewerteEinlesen();
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        sl_Abgriff.addChangeListener
        (
        new ChangeListener() {
            public void stateChanged(ChangeEvent  e) {
                if (!sl_Abgriff.hasFocus())
                    return;
                String Beschriftung1;
                Abgriff_Wert = sl_Abgriff.getValue()/Genauigkeit;
                Beschriftung1 = df2.format(Abgriff_Wert);
                TF_Abgriff.setText(Beschriftung1);
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        // Gre des Eingabebereichs zulassen
        innerContent.setPreferredSize(new Dimension(left*2+width,20));

        // Widgets auf dem Panel plazieren
        innerContent.add(LB_ParameterA_Wert);
        innerContent.add(TF_ParameterA_Wert);
        innerContent.add(sl_ParameterA_Wert);

        innerContent.add(LB_ParameterB_Wert);
        innerContent.add(TF_ParameterB_Wert);
        innerContent.add(sl_ParameterB_Wert);

        innerContent.add(LB_ParameterC_Wert);
        innerContent.add(TF_ParameterC_Wert);
        innerContent.add(sl_ParameterC_Wert);

        innerContent.add(LB_Abgriff);
        innerContent.add(TF_Abgriff);
        innerContent.add(sl_Abgriff);

        innerContent.add(Logo);
    }

    /**
     * Methode delete dient dazu eine Eingabe aus dem Speicher aufzulsen
     *
     * @param Fenster	Fenster auf dem die Elemente plaziert sind
     */
    public void delete(JFrame Fenster) {
        // Eingabefelder freigeben
        innerContent.remove(LB_ParameterA_Wert);
        innerContent.remove(TF_ParameterA_Wert);
        innerContent.remove(sl_ParameterA_Wert);

        innerContent.remove(LB_ParameterB_Wert);
        innerContent.remove(TF_ParameterB_Wert);
        innerContent.remove(sl_ParameterB_Wert);

        innerContent.remove(LB_ParameterC_Wert);
        innerContent.remove(TF_ParameterC_Wert);
        innerContent.remove(sl_ParameterC_Wert);

        innerContent.remove(LB_Abgriff);
        innerContent.remove(TF_Abgriff);
        innerContent.remove(sl_Abgriff);

        innerContent.remove(Logo);

        // Referenzen lschen
        LB_ParameterA_Wert = null;
        LB_ParameterB_Wert = null;
        LB_ParameterC_Wert = null;
        LB_Abgriff = null;
        Logo = null;

        TF_ParameterA_Wert = null;
        TF_ParameterB_Wert = null;
        TF_ParameterC_Wert = null;
        TF_Abgriff = null;

        sl_ParameterA_Wert = null;
        sl_ParameterB_Wert = null;
        sl_ParameterC_Wert = null;
        sl_Abgriff = null;

        // selbst auflsen
        Fenster.getContentPane().remove(innerContent);
        innerContent = null;
        Zeichenbereich1 = null;
        Zeichenbereich2 = null;
    }

    /**
     * setzt den ParameterA Wert von aussen
     *
     * @param wert	Neuer ParameterA Wert
     */
    public void setParameterA_Wert(double wert) {
        ParameterA_Wert = wert;
        String Beschriftung = df4.format(ParameterA_Wert);
        TF_ParameterA_Wert.setText(Beschriftung);
        sl_ParameterA_Wert.setValue( (int) (ParameterA_Wert*Genauigkeit) );
    }

    /**
     * setzt den ParameterB Wert von aussen
     *
     * @param wert	Neuer ParameterB Wert
     */
    public void setParameterB_Wert(int wert) {
        ParameterB_Wert = wert;
        String Beschriftung = df4.format(ParameterB_Wert);
        TF_ParameterB_Wert.setText(Beschriftung);
        sl_ParameterB_Wert.setValue( (int) (ParameterB_Wert * Genauigkeit) );
    }

    /**
     * setzt den ParameterC Wert von aussen
     *
     * @param wert	Neuer ParameterC Wert
     */
    public void setParameterC_Wert(int wert) {
        ParameterC_Wert = wert;
        String Beschriftung = df4.format(ParameterC_Wert);
        TF_ParameterC_Wert.setText(Beschriftung);
        sl_ParameterC_Wert.setValue( (int) (ParameterC_Wert*Genauigkeit) );
    }

    /**
     * liefert den ParameterA Wert
     *
     * @return derzeitiger ParameterA Wert
     */
    public double getParameterA_Wert() {
        return ParameterA_Wert;
    }

    /**
     * liefert den ParameterB Wert
     *
     * @return derzeitige ParameterB
     */
    public double getParameterB_Wert() {
        return ParameterB_Wert;
    }

    /**
     * liefert den ParameterC Wert
     *
     * @return derzeitigen ParameterC
     */
    public double getParameterC_Wert() {
        return ParameterC_Wert;
    }

    /**
     * setzt die Zeichenbereiche
     *
     * @param z	Zeichenbereich
     */
    public void setZeichenbereich(ZeichenbereichLNFunk z) {
        if (Zeichenbereich1==null)
            Zeichenbereich1=z;
        else
            Zeichenbereich2=z;
    }

    /**
     * liefert den Abgriff
     *
     * @return derzeitiger Abgriff
     */
    public double getAbgriff() {
        return	Abgriff_Wert;
    }

    /**
     * setzt den Abgriff
     *
     * @param w	Neuer Abgriff
     */
    public void setAbgriff(double w) {
        // Abfangen unzulssiger Werte
        Abgriff_Wert = w ;
        if (Abgriff_Wert > -3.98 && Abgriff_Wert < 3.98) {
            sl_Abgriff.setValue( (int)(Genauigkeit*Abgriff_Wert) );
            String Beschriftung1;
            Beschriftung1 = df2.format(Abgriff_Wert);
            TF_Abgriff.setText(Beschriftung1);
        } else if (Abgriff_Wert > 3.98) {
            sl_Abgriff.setValue( (int)(Genauigkeit*3.98) );
            String Beschriftung1;
            Beschriftung1 = df2.format(3.98);
            TF_Abgriff.setText(Beschriftung1);
            Abgriff_Wert = 3.98;
        } else {
            sl_Abgriff.setValue( (int)(Genauigkeit*-3.98) );
            String Beschriftung1;
            Beschriftung1 = df2.format(-3.98);
            TF_Abgriff.setText(Beschriftung1);
            Abgriff_Wert = -3.98;
        }
        if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
        if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
    }

    /**
     * fgt die Eingabeleiste auf einem Fenster ein
     *
     * @param Fenster	Fenster auf dem die Leiste eingefgt werden soll
     */
    public void addToFrame(JFrame Fenster) {
        Fenster.getContentPane().add(innerContent, BorderLayout.WEST);
    }

    /**
     * bernimmt alle Werte bei der Texteingabe
     */
    private void eingabewerteEinlesen() {
        // ParameterA
        {
            String Hilf = TF_ParameterA_Wert.getText();
            ParameterA_Wert = Double.parseDouble(Hilf.replace(',','.'));
            // ungltige Werte nicht zulassen
            if (ParameterA_Wert < -5 ) {
                ParameterA_Wert = -5;
                TF_ParameterA_Wert.setText("-5,00");
            }
            if (ParameterA_Wert > 5 ) {
                ParameterA_Wert = 5;
                TF_ParameterA_Wert.setText("5,00");
            }
            sl_ParameterA_Wert.setValue( (int)(Genauigkeit*ParameterA_Wert) );
        }

        // ParameterB
        {
            String Hilf = TF_ParameterB_Wert.getText();
            ParameterB_Wert = Double.parseDouble(Hilf.replace(',','.'));
            // ungltige Werte nicht zulassen
            if (ParameterB_Wert < -5 ) {
                ParameterB_Wert = -5;
                TF_ParameterB_Wert.setText("-5,00");
            }
            if (ParameterB_Wert > 5 ) {
                ParameterB_Wert = 5;
                TF_ParameterB_Wert.setText("5,00");
            }
            sl_ParameterB_Wert.setValue( (int) (Genauigkeit*ParameterB_Wert) );
        }

        // ParameterC
        {
            String Hilf = TF_ParameterC_Wert.getText();
            ParameterC_Wert = Double.parseDouble(Hilf.replace(',','.'));
            // ungltige Werte nicht zulassen
            if (ParameterC_Wert < -5 ) {
                ParameterC_Wert = -5;
                TF_ParameterC_Wert.setText("-5,00");
            }
            if (ParameterC_Wert > 5 ) {
                ParameterC_Wert = 5;
                TF_ParameterC_Wert.setText("5,00");
            }
            sl_ParameterC_Wert.setValue( (int) (Genauigkeit * ParameterC_Wert) );
        }

        // Abgriff
        {
            String Hilf = TF_Abgriff.getText();
            Abgriff_Wert = Double.parseDouble(Hilf.replace(',','.'));
            // ungltige Werte nicht zulassen
            if (Abgriff_Wert < -3.98 ) {
                Abgriff_Wert = -3.98;
                TF_Abgriff.setText("-3,98");
            }
            if (Abgriff_Wert > 3.98 ) {
                Abgriff_Wert = 3.98;
                TF_Abgriff.setText("3,98");
            }
            sl_Abgriff.setValue( (int) (Genauigkeit * Abgriff_Wert) );
        }
    }
}
