
package source;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.text.DecimalFormat;

import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.JTextField;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
 * Die Klasse ParameterEingabe verwaltet die Ein- und Ausgabewerte der
 * Polynomfunktion
 *
 * @author Horst Lauinger  31.10.2007
 */

public class ParameterEingabePolynom {
    // Legt die Genauigkeit fest
    private double Genauigkeit = 100;

    // Formatierung der Anzeigen
    DecimalFormat df2 = new DecimalFormat( "0.00" );
    DecimalFormat df4 = new DecimalFormat( "0.0000" );

    // Referenzen auf die Zeichenbereiche
    private ZeichenbereichPolynom Zeichenbereich1 = null;
    private ZeichenbereichPolynom Zeichenbereich2 = null;

    // Bereich der in ParameterEingabe verwaltet wird
    private JPanel innerContent = null;

    // Gruppe von Elementen erstellen:
    // Beschriftung, Eingabefeld & Scrollbalken fr Koeffizient a
    // Beschriftung, Eingabefeld & Scrollbalken fr Koeffizeint b
    // Beschriftung, Eingabefeld & Scrollbalken fr Koeffizient c
    // Beschriftung, Eingabefeld & Scrollbalken fr Koeffizeint d
    // Beschriftung, Eingabefeld & Scrollbalken fr Koeffizient e
    // Beschriftung, Eingabefeld & Scrollbalken fr Abgriff
    // Beschriftung & ComboBox fr Gradauswahl

    // Labels
    private JLabel LB_Koeffa_Wert = null;
    private JLabel LB_Koeffb_Wert = null;
    private JLabel LB_Koeffc_Wert = null;
    private JLabel LB_Koeffd_Wert = null;
    private JLabel LB_Koeffe_Wert = null;
    private JLabel LB_Abgriff = null;
    private JLabel LB_Grad = null;
    private JLabel Logo = null;

    // Textfelder
    private JTextField TF_Koeffa_Wert = null;
    private JTextField TF_Koeffb_Wert = null;
    private JTextField TF_Koeffc_Wert = null;
    private JTextField TF_Koeffd_Wert = null;
    private JTextField TF_Koeffe_Wert = null;
    private JTextField TF_Abgriff = null;

    // Slider (Scrollbalken)
    private JSlider sl_Koeffa_Wert = null;
    private JSlider sl_Koeffb_Wert = null;
    private JSlider sl_Koeffc_Wert = null;
    private JSlider sl_Koeffd_Wert = null;
    private JSlider sl_Koeffe_Wert = null;
    private JSlider sl_Abgriff = null;

    // Gradauswahl
    private JComboBox CB_Grad = null;
    private String[] CB_GradWahl = {"Grad 2 (Parabel)", "Grad 3", "Grad 4"};

    // Interne Variablen
    private double Koeffa_Wert = 0;
    private double Koeffb_Wert = 0;
    private double Koeffc_Wert = 1;
    private double Koeffd_Wert = 0;
    private double Koeffe_Wert = 0;
    private double Abgriff_Wert = 1;

    /**
     * Konstruktor erzeugt die Eingabefelder
     */
    public ParameterEingabePolynom () {
        String Beschriftung;
        // wir legen alle Elemente auf ein Panel
        innerContent = new JPanel();
        // wir verwenden keinen Layoutmanager
        innerContent.setLayout(null);

        // Erzeugung der Text-Eingabefelder, mit dem jeweiligen Wert und
        // lassen maximal 10 Zeichen zu
        Beschriftung = df2.format(Koeffa_Wert);
        TF_Koeffa_Wert = new JTextField(Beschriftung,10);

        Beschriftung = df2.format(Koeffb_Wert);
        TF_Koeffb_Wert = new JTextField(Beschriftung,10);

        Beschriftung = df2.format(Koeffc_Wert);
        TF_Koeffc_Wert = new JTextField(Beschriftung,10);

        Beschriftung = df2.format(Koeffd_Wert);
        TF_Koeffd_Wert = new JTextField(Beschriftung,10);

        Beschriftung = df2.format(Koeffe_Wert);
        TF_Koeffe_Wert = new JTextField(Beschriftung,10);

        Beschriftung = df2.format(Abgriff_Wert);
        TF_Abgriff = new JTextField(Beschriftung,10);

        // wir erzeugen die Berschriftungslabels
        LB_Koeffa_Wert = new JLabel("Keoffizient a:");
        LB_Koeffb_Wert = new JLabel("Keoffizient b:");
        LB_Koeffc_Wert = new JLabel("Keoffizient c:");
        LB_Koeffd_Wert = new JLabel("Keoffizient d:");
        LB_Koeffe_Wert = new JLabel("Keoffizient e:");
        LB_Grad = new JLabel("Gradauswahl:");
        LB_Abgriff = new JLabel("x-Wert:");
        Logo = new JLabel ("");

        // ComboBox erzeugen
        CB_Grad = new JComboBox(CB_GradWahl);
        CB_Grad.setMaximumRowCount(3);
        CB_Grad.setSelectedIndex(0);

        // Erzeugung der Schieberegler --> JSlider (min, max, value)
        sl_Koeffa_Wert = new JSlider( -500, 500, (int)(Genauigkeit * Koeffa_Wert));
        sl_Koeffb_Wert = new JSlider( -500, 500, (int) (Genauigkeit * Koeffb_Wert));
        sl_Koeffc_Wert = new JSlider( -500, 500, (int) (Genauigkeit * Koeffc_Wert));
        sl_Koeffd_Wert = new JSlider( -500, 500, (int) (Genauigkeit * Koeffd_Wert));
        sl_Koeffe_Wert = new JSlider( -500, 500, (int) (Genauigkeit * Koeffe_Wert));
        sl_Abgriff = new JSlider( -398, 398, (int)(Genauigkeit*Abgriff_Wert));

        // Positionierung der Elemente
        int left = 5;
        int width = 120;
        int height = 21;
        int abstand = 26;
        int top = 7 - abstand;

        // Elementbegrenzungen setzen
        LB_Grad.setBounds(left,top+=abstand,width,height);
        CB_Grad.setBounds(left,top+=abstand/1.5,width,height);

        top+=abstand*0.5;
        LB_Koeffa_Wert.setBounds(left,top+=abstand,width,height);
        TF_Koeffa_Wert.setBounds(left,top+=abstand/1.5,width,height);
        sl_Koeffa_Wert.setBounds(left,top+=abstand,width,(int)(height));

        top+=abstand*0.1;
        LB_Koeffb_Wert.setBounds(left,top+=abstand,width,height);
        TF_Koeffb_Wert.setBounds(left,top+=abstand/1.5,width,height);
        sl_Koeffb_Wert.setBounds(left,top+=abstand,width,(int)(height));

        top+=abstand*0.1;
        LB_Koeffc_Wert.setBounds(left,top+=abstand,width,height);
        TF_Koeffc_Wert.setBounds(left,top+=abstand/1.5,width,height);
        sl_Koeffc_Wert.setBounds(left,top+=abstand,width,(int)(height));

        top+=abstand*0.1;
        LB_Koeffd_Wert.setBounds(left,top+=abstand,width,height);
        TF_Koeffd_Wert.setBounds(left,top+=abstand/1.5,width,height);
        sl_Koeffd_Wert.setBounds(left,top+=abstand,width,(int)(height));

        top+=abstand*0.1;
        LB_Koeffe_Wert.setBounds(left,top+=abstand,width,height);
        TF_Koeffe_Wert.setBounds(left,top+=abstand/1.5,width,height);
        sl_Koeffe_Wert.setBounds(left,top+=abstand,width,(int)(height));

        top+=abstand*0.3;
        LB_Abgriff.setBounds(left,top+=abstand,width,height);
        TF_Abgriff.setBounds(left,top+=abstand/1.5,width,height);
        sl_Abgriff.setBounds(left,top+=abstand,width,(int)(height));

        top+=abstand*0.4;
        if (Ableitung.getIconLogo() != null)
            Logo.setIcon(Ableitung.getIconLogo());
        Logo.setBounds(left,top+=abstand,120,108);

        /**
         * Reaktion auf die nderung der Eingabefelder
         */
        TF_Koeffa_Wert.addActionListener
        (
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (!TF_Koeffa_Wert.hasFocus())
                    return;
                eingabewerteEinlesen();
                if (Zeichenbereich1 != null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2 != null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        sl_Koeffa_Wert.addChangeListener
        (
        new ChangeListener() {
            public void stateChanged(ChangeEvent  e) {
                if (!sl_Koeffa_Wert.hasFocus())
                    return;
                String Beschriftung1;
                Koeffa_Wert = sl_Koeffa_Wert.getValue()/Genauigkeit;
                Beschriftung1 = df2.format(Koeffa_Wert);
                TF_Koeffa_Wert.setText(Beschriftung1);
                if (Zeichenbereich1 != null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2 != null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        TF_Koeffb_Wert.addActionListener
        (
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (!TF_Koeffb_Wert.hasFocus())
                    return;
                eingabewerteEinlesen();
                if (Zeichenbereich1 != null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2 != null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        sl_Koeffb_Wert.addChangeListener
        (
        new ChangeListener() {
            public void stateChanged(ChangeEvent  e) {
                if (!sl_Koeffb_Wert.hasFocus())
                    return;
                String Beschriftung1;
                Koeffb_Wert = sl_Koeffb_Wert.getValue()/Genauigkeit;
                Beschriftung1 = df2.format(Koeffb_Wert);
                TF_Koeffb_Wert.setText(Beschriftung1);
                if (Zeichenbereich1 != null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2 != null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        TF_Koeffc_Wert.addActionListener
        (
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (!TF_Koeffc_Wert.hasFocus())
                    return;
                eingabewerteEinlesen();
                if (Zeichenbereich1 != null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2 != null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        sl_Koeffc_Wert.addChangeListener
        (
        new ChangeListener() {
            public void stateChanged(ChangeEvent  e) {
                if (!sl_Koeffc_Wert.hasFocus())
                    return;
                String Beschriftung1;
                Koeffc_Wert = sl_Koeffc_Wert.getValue()/Genauigkeit;
                Beschriftung1 = df2.format(Koeffc_Wert);
                TF_Koeffc_Wert.setText(Beschriftung1);
                if (Zeichenbereich1 != null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2 != null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        TF_Koeffd_Wert.addActionListener
        (
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (!TF_Koeffd_Wert.hasFocus() || getGrad() <= 0 )
                    return;
                eingabewerteEinlesen();
                if (Zeichenbereich1 != null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2 != null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        sl_Koeffd_Wert.addChangeListener
        (
        new ChangeListener() {
            public void stateChanged(ChangeEvent  e) {
                if (!sl_Koeffd_Wert.hasFocus() || getGrad() <=0 )
                    return;
                String Beschriftung1;
                Koeffd_Wert = sl_Koeffd_Wert.getValue()/Genauigkeit;
                Beschriftung1 = df2.format(Koeffd_Wert);
                TF_Koeffd_Wert.setText(Beschriftung1);
                if (Zeichenbereich1 != null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2 != null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        TF_Koeffe_Wert.addActionListener
        (
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (!TF_Koeffe_Wert.hasFocus() || getGrad() <= 1 )
                    return;
                eingabewerteEinlesen();
                if (Zeichenbereich1 != null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2 != null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        sl_Koeffe_Wert.addChangeListener
        (
        new ChangeListener() {
            public void stateChanged(ChangeEvent  e) {
                if (!sl_Koeffe_Wert.hasFocus() || getGrad() <= 1 )
                    return;
                String Beschriftung1;
                Koeffe_Wert = sl_Koeffe_Wert.getValue()/Genauigkeit;
                Beschriftung1 = df2.format(Koeffe_Wert);
                TF_Koeffe_Wert.setText(Beschriftung1);
                if (Zeichenbereich1 != null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2 != null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        TF_Abgriff.addActionListener
        (
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (!TF_Abgriff.hasFocus())
                    return;
                eingabewerteEinlesen();
                if (Zeichenbereich1 != null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2 != null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        sl_Abgriff.addChangeListener
        (
        new ChangeListener() {
            public void stateChanged(ChangeEvent  e) {
                if (!sl_Abgriff.hasFocus())
                    return;
                String Beschriftung1;
                Abgriff_Wert = sl_Abgriff.getValue()/Genauigkeit;
                Beschriftung1 = df2.format(Abgriff_Wert);
                TF_Abgriff.setText(Beschriftung1);
                if (Zeichenbereich1 != null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2 != null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        CB_Grad.addItemListener
        (
        new ItemListener() {
            public void itemStateChanged(ItemEvent e) {
                // nur bei nderung der Sekektion reagieren
                if (ItemEvent.SELECTED == e.getStateChange()) {
                    setKoeffa_Wert (0);
                    setKoeffb_Wert (0);
                    setKoeffc_Wert (1);
                    innerContent.remove(LB_Koeffd_Wert);
                    innerContent.remove(TF_Koeffd_Wert);
                    innerContent.remove(sl_Koeffd_Wert);
                    innerContent.remove(LB_Koeffe_Wert);
                    innerContent.remove(TF_Koeffe_Wert);
                    innerContent.remove(sl_Koeffe_Wert);

                    if (getGrad() >0) {
                        setKoeffc_Wert (0);
                        setKoeffd_Wert (1);
                        innerContent.add(LB_Koeffd_Wert);
                        innerContent.add(TF_Koeffd_Wert);
                        innerContent.add(sl_Koeffd_Wert);
                        innerContent.remove(LB_Koeffe_Wert);
                        innerContent.remove(TF_Koeffe_Wert);
                        innerContent.remove(sl_Koeffe_Wert);
                    }
                    if (getGrad() >1) {
                        setKoeffc_Wert (0);
                        setKoeffd_Wert (0);
                        setKoeffe_Wert (1);
                        innerContent.add(LB_Koeffd_Wert);
                        innerContent.add(TF_Koeffd_Wert);
                        innerContent.add(sl_Koeffd_Wert);
                        innerContent.add(LB_Koeffe_Wert);
                        innerContent.add(TF_Koeffe_Wert);
                        innerContent.add(sl_Koeffe_Wert);
                    }
                    setAbgriff (1);
                    if (Zeichenbereich1 != null) Zeichenbereich1.Dorepaint();
                    if (Zeichenbereich2 != null) Zeichenbereich2.Dorepaint();
                }
            }
        }
        );

        // Gre des Eingabebereichs zulassen
        innerContent.setPreferredSize(new Dimension(left*2+width,20));

        // Widgets auf dem Panel plazieren
        innerContent.add(LB_Grad);
        innerContent.add(CB_Grad);

        innerContent.add(LB_Koeffa_Wert);
        innerContent.add(TF_Koeffa_Wert);
        innerContent.add(sl_Koeffa_Wert);

        innerContent.add(LB_Koeffb_Wert);
        innerContent.add(TF_Koeffb_Wert);
        innerContent.add(sl_Koeffb_Wert);

        innerContent.add(LB_Koeffc_Wert);
        innerContent.add(TF_Koeffc_Wert);
        innerContent.add(sl_Koeffc_Wert);

        innerContent.add(LB_Abgriff);
        innerContent.add(TF_Abgriff);
        innerContent.add(sl_Abgriff);

        innerContent.add(Logo);
    }

    /**
     * Methode delete dient dazu eine Eingabe aus dem Speicher aufzulsen
     *
     * @param Fenster	Fenster auf dem die Elemente plaziert sind
     */
    public void delete(JFrame Fenster) {
        // Eingabefelder freigeben
        innerContent.remove(LB_Koeffa_Wert);
        innerContent.remove(TF_Koeffa_Wert);
        innerContent.remove(sl_Koeffa_Wert);

        innerContent.remove(LB_Koeffb_Wert);
        innerContent.remove(TF_Koeffb_Wert);
        innerContent.remove(sl_Koeffb_Wert);

        innerContent.remove(LB_Koeffc_Wert);
        innerContent.remove(TF_Koeffc_Wert);
        innerContent.remove(sl_Koeffc_Wert);

        innerContent.remove(LB_Koeffd_Wert);
        innerContent.remove(TF_Koeffd_Wert);
        innerContent.remove(sl_Koeffd_Wert);

        innerContent.remove(LB_Koeffe_Wert);
        innerContent.remove(TF_Koeffe_Wert);
        innerContent.remove(sl_Koeffe_Wert);

        innerContent.remove(LB_Abgriff);
        innerContent.remove(TF_Abgriff);
        innerContent.remove(sl_Abgriff);

        innerContent.remove(LB_Grad);
        innerContent.remove(CB_Grad);

        innerContent.remove(Logo);

        // Referenzen lschen
        LB_Koeffa_Wert = null;
        LB_Koeffb_Wert = null;
        LB_Koeffc_Wert = null;
        LB_Koeffd_Wert = null;
        LB_Koeffe_Wert = null;
        LB_Abgriff = null;
        Logo = null;

        TF_Koeffa_Wert = null;
        TF_Koeffb_Wert = null;
        TF_Koeffc_Wert = null;
        TF_Koeffd_Wert = null;
        TF_Koeffe_Wert = null;
        TF_Abgriff = null;

        sl_Koeffa_Wert = null;
        sl_Koeffb_Wert = null;
        sl_Koeffc_Wert = null;
        sl_Koeffd_Wert = null;
        sl_Koeffe_Wert = null;
        sl_Abgriff = null;

        // selbst auflsen
        Fenster.getContentPane().remove(innerContent);
        innerContent = null;
        Zeichenbereich1 = null;
        Zeichenbereich2 = null;
    }

    /**
     * setzt den Wert des Polynomkoeffizienten a von aussen
     *
     * @param wert	Neuer Polynomkoeffizient a Wert
     */
    public void setKoeffa_Wert(double wert) {
        Koeffa_Wert = wert;
        String Beschriftung = df2.format(Koeffa_Wert);
        TF_Koeffa_Wert.setText(Beschriftung);
        sl_Koeffa_Wert.setValue( (int) (Koeffa_Wert*Genauigkeit) );
    }

    /**
     * setzt den Wert des Polynomkoeffizienten b von aussen
     *
     * @param wert	Neuer Polynomkoeffizient b Wert
     */
    public void setKoeffb_Wert(int wert) {
        Koeffb_Wert = wert;
        String Beschriftung = df2.format(Koeffb_Wert);
        TF_Koeffb_Wert.setText(Beschriftung);
        sl_Koeffb_Wert.setValue( (int) (Koeffb_Wert * Genauigkeit) );
    }

    /**
     * setzt den Wert von Polynomkoeffizienten c von aussen
     *
     * @param wert	Neuer Polynomkoeffizient c Wert
     */
    public void setKoeffc_Wert(int wert) {
        Koeffc_Wert = wert;
        String Beschriftung = df2.format(Koeffc_Wert);
        TF_Koeffc_Wert.setText(Beschriftung);
        sl_Koeffc_Wert.setValue( (int) (Koeffc_Wert*Genauigkeit) );
    }

    /**
     * setzt den Wert von Polynomkoeffizienten d von aussen
     *
     * @param wert	Neuer Polynomkoeffizient d Wert
     */
    public void setKoeffd_Wert(int wert) {
        Koeffd_Wert = wert;
        String Beschriftung = df2.format(Koeffd_Wert);
        TF_Koeffd_Wert.setText(Beschriftung);
        sl_Koeffd_Wert.setValue( (int) (Koeffd_Wert*Genauigkeit) );
    }

    /**
     * setzt den Wert von Polynomkoeffizienten e von aussen
     *
     * @param wert	Neuer Polynomkoeffizient e Wert
     */
    public void setKoeffe_Wert(int wert) {
        Koeffe_Wert = wert;
        String Beschriftung = df2.format(Koeffe_Wert);
        TF_Koeffe_Wert.setText(Beschriftung);
        sl_Koeffe_Wert.setValue( (int) (Koeffe_Wert*Genauigkeit) );
    }

    /**
     * liefert den Polynomkoeffizienten a Wert
     *
     * @return derzeitiger Polynomkoeffizient a
     */
    public double getKoeffa_Wert() {
        return Koeffa_Wert;
    }

    /**
     * liefert den Polynomkoeffizienten b Wert
     *
     * @return derzeitiger Polynomkoeffizient b
     */
    public double getKoeffb_Wert() {
        return Koeffb_Wert;
    }

    /**
     * liefert den Polynomkoeffizienten c Wert
     *
     * @return derzeitiger Polynomkoeffizient c
     */
    public double getKoeffc_Wert() {
        return Koeffc_Wert;
    }

    /**
     * liefert den Polynomkoeffizienten d Wert
     *
     * @return derzeitiger Polynomkoeffizient d
     */
    public double getKoeffd_Wert() {
        return Koeffd_Wert;
    }

    /**
     * liefert den Polynomkoeffizienten e Wert
     *
     * @return derzeitiger Polynomkoeffizient e
     */
    public double getKoeffe_Wert() {
        return Koeffe_Wert;
    }

    /**
     * setzt die Zeichenbereiche
     *
     * @param z	Zeichenbereich
     */
    public void setZeichenbereich(ZeichenbereichPolynom z) {
        if (Zeichenbereich1==null)
            Zeichenbereich1=z;
        else
            Zeichenbereich2=z;
    }

    /**
     * liefert den Abgriff
     *
     * @return derzeitiger Abgriff
     */
    public double getAbgriff() {
        return	Abgriff_Wert;
    }

    /**
     * setzt den Abgriff
     *
     * @param w	Neuer Abgriff
     */
    public void setAbgriff(double w) {
        // Abfangen unzulssiger Werte
        Abgriff_Wert = w;
        if (Abgriff_Wert > -3.98 && Abgriff_Wert < 3.98) {
            sl_Abgriff.setValue( (int)(Genauigkeit*Abgriff_Wert) );
            String Beschriftung1;
            Beschriftung1 = df2.format(Abgriff_Wert); //  / 100d
            TF_Abgriff.setText(Beschriftung1);
        } else if (Abgriff_Wert > 3.98) {
            sl_Abgriff.setValue( (int)(Genauigkeit*3.98) );
            String Beschriftung1;
            Beschriftung1 = df2.format(3.98); //  / 100d
            TF_Abgriff.setText(Beschriftung1);
            Abgriff_Wert = 3.98;
        } else {
            sl_Abgriff.setValue( (int)(Genauigkeit*-3.98) );
            String Beschriftung1;
            Beschriftung1 = df2.format(-3.98); //  / 100d
            TF_Abgriff.setText(Beschriftung1);
            Abgriff_Wert = -3.98;
        }
        if (Zeichenbereich1 != null) Zeichenbereich1.Dorepaint();
        if (Zeichenbereich2 != null) Zeichenbereich2.Dorepaint();
    }

    /**
     * liefert den Grad der Polynomfunktion
     *
     * @return Grad der Polynomfunktion
     */
    public int getGrad() {
        return CB_Grad.getSelectedIndex();
    }

    /**
     * fgt die Eingabeleiste auf einem Fenster ein
     *
     * @param Fenster	Fenster auf dem die Leiste eingefgt werden soll
     */
    public void addToFrame(JFrame Fenster) {
        Fenster.getContentPane().add(innerContent, BorderLayout.WEST);
    }

    /**
     * bernimmt alle Werte bei der Texteingabe
     */
    private void eingabewerteEinlesen() {
        // Koeffizient a
        {
            String Hilf = TF_Koeffa_Wert.getText();
            Koeffa_Wert = Double.parseDouble(Hilf.replace(',','.'));
            // ungltige Werte nicht zulassen
            if (Koeffa_Wert > 5 ) {
                Koeffa_Wert = 5;
                TF_Koeffa_Wert.setText("5,00");
            }
            if (Koeffa_Wert < -5 ) {
                Koeffa_Wert = -5;
                TF_Koeffa_Wert.setText("-5,00");
            }
            sl_Koeffa_Wert.setValue( (int)(Genauigkeit*Koeffa_Wert) );
        }

        // Koeffizient b
        {
            String Hilf = TF_Koeffb_Wert.getText();
            Koeffb_Wert = Double.parseDouble(Hilf.replace(',','.'));
            // ungltige Werte nicht zulassen
            if (Koeffb_Wert > 5 ) {
                Koeffb_Wert = 5;
                TF_Koeffb_Wert.setText("5,00");
            }
            if (Koeffb_Wert < -5 ) {
                Koeffb_Wert = -5;
                TF_Koeffb_Wert.setText("-5,00");
            }
            sl_Koeffb_Wert.setValue( (int) (Genauigkeit*Koeffb_Wert) );
        }

        // Koeffizient c
        {
            String Hilf = TF_Koeffc_Wert.getText();
            Koeffc_Wert = Double.parseDouble(Hilf.replace(',','.'));
            // ungltige Werte nicht zulassen
            if (Koeffc_Wert > 5 ) {
                Koeffc_Wert = 5;
                TF_Koeffc_Wert.setText("5,00");
            }
            if (Koeffc_Wert < -5 ) {
                Koeffc_Wert = -5;
                TF_Koeffc_Wert.setText("-5,00");
            }
            sl_Koeffc_Wert.setValue( (int) (Genauigkeit * Koeffc_Wert) );
        }

        // Koeffizient d
        {
            String Hilf = TF_Koeffd_Wert.getText();
            Koeffd_Wert = Double.parseDouble(Hilf.replace(',','.'));
            // ungltige Werte nicht zulassen
            if (Koeffd_Wert > 5 ) {
                Koeffd_Wert = 5;
                TF_Koeffd_Wert.setText("5,00");
            }
            if (Koeffd_Wert < -5 ) {
                Koeffd_Wert = -5;
                TF_Koeffd_Wert.setText("-5,00");
            }
            sl_Koeffd_Wert.setValue( (int) (Genauigkeit * Koeffd_Wert) );
        }

        // Koeffizient e
        {
            String Hilf = TF_Koeffe_Wert.getText();
            Koeffe_Wert = Double.parseDouble(Hilf.replace(',','.'));
            // ungltige Werte nicht zulassen
            if (Koeffe_Wert > 5 ) {
                Koeffe_Wert = 5;
                TF_Koeffe_Wert.setText("5,00");
            }
            if (Koeffe_Wert < -5 ) {
                Koeffe_Wert = -5;
                TF_Koeffe_Wert.setText("-5,00");
            }
            sl_Koeffe_Wert.setValue( (int) (Genauigkeit * Koeffe_Wert) );
        }

        //	Abgriff
        {
            String Hilf = TF_Abgriff.getText();
            Abgriff_Wert = Double.parseDouble(Hilf.replace(',','.'));
            // ungltige Werte nicht zulassen
            if (Abgriff_Wert < -3.98 ) {
                Abgriff_Wert = -3.98;
                TF_Abgriff.setText("-3,98");
            }
            if (Abgriff_Wert > 3.98 ) {
                Abgriff_Wert = 3.98;
                TF_Abgriff.setText("3,98");
            }
            sl_Abgriff.setValue( (int) (Genauigkeit * Abgriff_Wert) );
        }
    }
}
