
package source;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JToolBar;

/**
 * Klasse Toolbar
 * Stellt die Button-Leiste zur Verfgung
 * Whlt Aufgrund der Buttons eine entsprechende Funktion
 * @author Horst Lauinger   31.10.2007
 */

public class Toolbar {
    /**
     * Toolbar
     */
    private JToolBar toolBar = null;

    /**
     * die verschiedenen Buttons
     */
    private JButton BT_close = null;
    private JButton BT_Sinus = null;
    private JButton BT_Cosinus = null;
    private JButton BT_SinusH = null;
    private JButton BT_CosinusH = null;
    private JButton BT_Polynom = null;
    private JButton BT_EFunk = null;
    private JButton BT_LNFunk = null;

    /**
     * In diesem Panel liegen die Buttons
     */
    private JPanel panel = null;

    /**
     * Referenz auf das bergeordnete Hauptfenster
     */
    private JFrame Hauptfenster = null;
    private JPanel HauptFensterMitte = null;

    /**
     * Referenzen auf die verschiedenen Eingabebereiche
     */
    private ParameterEingabeSinus parameterEingabeS  = null;
    private ParameterEingabeCosinus parameterEingabeC  = null;
    private ParameterEingabeSinusH parameterEingabeSH  = null;
    private ParameterEingabeCosinusH parameterEingabeCH  = null;
    private ParameterEingabePolynom parameterEingabeP  = null;
    private ParameterEingabeEFunktion parameterEingabeE  = null;
    private ParameterEingabeLNFunktion parameterEingabeLN  = null;

    /**
     * Referenzen auf die verschiedenen Zeichenbereiche
     */
    private ZeichenbereichSinus ZeichenbereichS1=null;
    private ZeichenbereichSinus ZeichenbereichS2=null;
    private ZeichenbereichCosinus ZeichenbereichC1=null;
    private ZeichenbereichCosinus ZeichenbereichC2=null;
    private ZeichenbereichSinusH ZeichenbereichSH1=null;
    private ZeichenbereichSinusH ZeichenbereichSH2=null;
    private ZeichenbereichCosinusH ZeichenbereichCH1=null;
    private ZeichenbereichCosinusH ZeichenbereichCH2=null;
    private ZeichenbereichPolynom ZeichenbereichP1=null;
    private ZeichenbereichPolynom ZeichenbereichP2=null;
    private ZeichenbereichEFunk ZeichenbereichE1=null;
    private ZeichenbereichEFunk ZeichenbereichE2=null;
    private ZeichenbereichLNFunk ZeichenbereichL1=null;
    private ZeichenbereichLNFunk ZeichenbereichL2=null;

    /**
     * Konstruktor
     * erzeugt die Toolbar
     *
     * @param HF 		Fenster auf dem die Toolbar eingefgt werden soll
     * @param IsApplet 	true falls Anwendung als Applet luft
     */
    public Toolbar ( final JFrame HF  , final boolean IsApplet  ) {
        // Referenz intern sichern
        Hauptfenster = HF;

        // In den verschiedenen Regionen des Hauptfensters Panels ablegen
        HauptFensterMitte = new JPanel();
        Hauptfenster.getContentPane().add(HauptFensterMitte,BorderLayout.CENTER );

        // Layout Manager fr dien Mittelteil
        BoxLayout boxLayout =  new BoxLayout(HauptFensterMitte, BoxLayout.Y_AXIS);
        HauptFensterMitte.setLayout(boxLayout);

        // Buttons erzeugen
        BT_close = new JButton("Close");
        // Standardsymbole sind nicht gedrckt
        BT_Sinus = new JButton(Ableitung.getsymbolUnPressedLogo(0));
        BT_Cosinus = new JButton(Ableitung.getsymbolUnPressedLogo(1));
        BT_SinusH = new JButton(Ableitung.getsymbolUnPressedLogo(2));
        BT_CosinusH = new JButton(Ableitung.getsymbolUnPressedLogo(3));
        BT_Polynom = new JButton(Ableitung.getsymbolUnPressedLogo(4));
        BT_EFunk = new JButton(Ableitung.getsymbolUnPressedLogo(5));
        BT_LNFunk = new JButton(Ableitung.getsymbolUnPressedLogo(6));

        // Tool Tips
        BT_close.setToolTipText("Close");
        BT_Sinus.setToolTipText("Sinus-Funktion");
        BT_Cosinus.setToolTipText("Cosinus-Funktion");
        BT_SinusH.setToolTipText("Sinus-hyperbolicus-Funktion");
        BT_CosinusH.setToolTipText("Cosinus-hyperbolicus-Funktion");
        BT_Polynom.setToolTipText("Polynome");
        BT_EFunk.setToolTipText("Exponential-Funktion");
        BT_LNFunk.setToolTipText("Logarithmus-Naturalis-Funktion");

        // Aktionen der Buttons
        BT_close.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (!IsApplet)
                    System.exit(0);
                else
                    Hauptfenster.setVisible(false);
            }
        }
        );

        BT_Sinus.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                panel.setVisible( false );
                remouveVerteilungen();
                addSinus();
                panel.setVisible( true );
            }
        }
        );

        BT_Cosinus.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                panel.setVisible( false );
                remouveVerteilungen();
                addCosinus();
                panel.setVisible( true );
            }
        }
        );
        BT_SinusH.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                panel.setVisible( false );
                remouveVerteilungen();
                addSinusH();
                panel.setVisible( true );
            }
        }
        );
        BT_CosinusH.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                panel.setVisible( false );
                remouveVerteilungen();
                addCosinusH();
                panel.setVisible( true );
            }
        }
        );
        BT_Polynom.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                panel.setVisible( false );
                remouveVerteilungen();
                addPolynom();
                panel.setVisible( true );
            }
        }
        );
        BT_EFunk.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                panel.setVisible( false );
                remouveVerteilungen();
                addEFunk();
                panel.setVisible( true );
            }
        }
        );
        BT_LNFunk.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                panel.setVisible( false );
                remouveVerteilungen();
                addLNFunk();
                panel.setVisible( true );
            }
        }
        );

        // ToolBar selbst erzeugen
        toolBar = new JToolBar();

        // Buttons auf die ToolBar legen
        //toolBar.add(BT_close);
        toolBar.add(BT_Sinus);
        toolBar.add(BT_Cosinus);
        toolBar.add(BT_SinusH);
        toolBar.add(BT_CosinusH);
        toolBar.add(BT_Polynom);
        toolBar.add(BT_EFunk);
        toolBar.add(BT_LNFunk);
    }

    /**
     * Setzt die gewnschte Darstellungsart auf der Toolbar
     *
     * @param nr der Funktion
     */
    public void setFunktionsart(int nr) {
        panel.setVisible( false );
        // bisherige Verteilungen entfernen
        remouveVerteilungen();
        // neue auswhlen
        switch (nr) {
        case 1:
            addCosinus();
            break;
        case 2:
            addSinusH();
            break;
        case 3:
            addCosinusH();
            break;
        case 4:
            addPolynom();
            break;
        case 5:
            addEFunk();
            break;
        case 6:
            addLNFunk();
            break;

        default:
            addSinus();
            break;
        }
        panel.setVisible( true );
    }

    /**
     * frgt die Toolbar zum Fenster hinzu
     */
    public void addToFrame() {
        // Panel im Norden des Hauptfensters fr die Buttonleiste plazieren
        panel = new JPanel();
        Hauptfenster.getContentPane().add(panel, BorderLayout.NORTH);

        // Layout bestimmen
        BoxLayout boxLayout =  new BoxLayout(panel, BoxLayout.X_AXIS);
        panel.setLayout(boxLayout);

        // Panel hinzufgen
        panel.add(toolBar);

        // standardmig Sinusfunktion laden
        addSinus();
    }

    /**
     * Veranlasst ein Neuzeichnen der Zeichenbereiche
     */
    public void doRepaint() {
        if ( ZeichenbereichS1 != null ) ZeichenbereichS1.Dorepaint();
        if ( ZeichenbereichS2 != null ) ZeichenbereichS2.Dorepaint();
        if ( ZeichenbereichC1 != null ) ZeichenbereichC1.Dorepaint();
        if ( ZeichenbereichC2 != null ) ZeichenbereichC2.Dorepaint();
        if ( ZeichenbereichSH1 != null ) ZeichenbereichSH1.Dorepaint();
        if ( ZeichenbereichSH2 != null ) ZeichenbereichSH2.Dorepaint();
        if ( ZeichenbereichCH1 != null ) ZeichenbereichCH1.Dorepaint();
        if ( ZeichenbereichCH2 != null ) ZeichenbereichCH2.Dorepaint();
        if ( ZeichenbereichP1 != null ) ZeichenbereichP1.Dorepaint();
        if ( ZeichenbereichP2 != null ) ZeichenbereichP2.Dorepaint();
        if ( ZeichenbereichE1 != null ) ZeichenbereichE1.Dorepaint();
        if ( ZeichenbereichE2 != null ) ZeichenbereichE2.Dorepaint();
        if ( ZeichenbereichL1 != null ) ZeichenbereichL1.Dorepaint();
        if ( ZeichenbereichL2 != null ) ZeichenbereichL2.Dorepaint();
    }

    /**
     * entfernt alle Zeichenbereiche vom Fenster
     */
    private void remouveVerteilungen() {
        if (ZeichenbereichS1 != null) HauptFensterMitte.remove(ZeichenbereichS1);
        if (ZeichenbereichS2 != null) HauptFensterMitte.remove(ZeichenbereichS2);
        if (ZeichenbereichC1 != null) HauptFensterMitte.remove(ZeichenbereichC1);
        if (ZeichenbereichC2 != null) HauptFensterMitte.remove(ZeichenbereichC2);
        if (ZeichenbereichSH1 != null) HauptFensterMitte.remove(ZeichenbereichSH1);
        if (ZeichenbereichSH2 != null) HauptFensterMitte.remove(ZeichenbereichSH2);
        if (ZeichenbereichCH1 != null) HauptFensterMitte.remove(ZeichenbereichCH1);
        if (ZeichenbereichCH2 != null) HauptFensterMitte.remove(ZeichenbereichCH2);
        if (ZeichenbereichP1 != null) HauptFensterMitte.remove(ZeichenbereichP1);
        if (ZeichenbereichP2 != null) HauptFensterMitte.remove(ZeichenbereichP2);
        if (ZeichenbereichE1 != null) HauptFensterMitte.remove(ZeichenbereichE1);
        if (ZeichenbereichE2 != null) HauptFensterMitte.remove(ZeichenbereichE2);
        if (ZeichenbereichL1 != null) HauptFensterMitte.remove(ZeichenbereichL1);
        if (ZeichenbereichL2 != null) HauptFensterMitte.remove(ZeichenbereichL2);

        if (ZeichenbereichS1 != null) ZeichenbereichS1.delete();
        if (ZeichenbereichS2 != null) ZeichenbereichS2.delete();
        if (ZeichenbereichC1 != null) ZeichenbereichC1.delete();
        if (ZeichenbereichC2 != null) ZeichenbereichC2.delete();
        if (ZeichenbereichSH1 != null) ZeichenbereichSH1.delete();
        if (ZeichenbereichSH2 != null) ZeichenbereichSH2.delete();
        if (ZeichenbereichCH1 != null) ZeichenbereichCH1.delete();
        if (ZeichenbereichCH2 != null) ZeichenbereichCH2.delete();
        if (ZeichenbereichP1 != null) ZeichenbereichP1.delete();
        if (ZeichenbereichP2 != null) ZeichenbereichP2.delete();
        if (ZeichenbereichE1 != null) ZeichenbereichE1.delete();
        if (ZeichenbereichE2 != null) ZeichenbereichE2.delete();
        if (ZeichenbereichL1 != null) ZeichenbereichL1.delete();
        if (ZeichenbereichL2 != null) ZeichenbereichL2.delete();

        if (parameterEingabeS != null) parameterEingabeS.delete(Hauptfenster);
        if (parameterEingabeC != null) parameterEingabeC.delete(Hauptfenster);
        if (parameterEingabeSH != null) parameterEingabeSH.delete(Hauptfenster);
        if (parameterEingabeCH != null) parameterEingabeCH.delete(Hauptfenster);
        if (parameterEingabeP != null) parameterEingabeP.delete(Hauptfenster);
        if (parameterEingabeE != null) parameterEingabeE.delete(Hauptfenster);
        if (parameterEingabeLN != null) parameterEingabeLN.delete(Hauptfenster);

        ZeichenbereichS1 	= null;
        ZeichenbereichS2 	= null;
        ZeichenbereichC1 	= null;
        ZeichenbereichC2 	= null;
        ZeichenbereichSH1 	= null;
        ZeichenbereichSH2 	= null;
        ZeichenbereichCH1 	= null;
        ZeichenbereichCH2 	= null;
        ZeichenbereichP1 	= null;
        ZeichenbereichP2 	= null;
        ZeichenbereichE1 	= null;
        ZeichenbereichE2 	= null;
        ZeichenbereichL1 	= null;
        ZeichenbereichL2 	= null;

        parameterEingabeS	= null;
        parameterEingabeC	= null;
        parameterEingabeSH	= null;
        parameterEingabeCH	= null;
        parameterEingabeP	= null;
        parameterEingabeE	= null;
        parameterEingabeLN	= null;
    }

    /**
     * fgt die Ein- und Ausgabebereiche fr Sinusfunktion dem Fenster hinzu
     */
    private void addSinus() {
        BT_Sinus.setIcon(Ableitung.getsymbolPressedLogo(0));
        BT_Cosinus.setIcon(Ableitung.getsymbolUnPressedLogo(1));
        BT_SinusH.setIcon(Ableitung.getsymbolUnPressedLogo(2));
        BT_CosinusH.setIcon(Ableitung.getsymbolUnPressedLogo(3));
        BT_Polynom.setIcon(Ableitung.getsymbolUnPressedLogo(4));
        BT_EFunk.setIcon(Ableitung.getsymbolUnPressedLogo(5));
        BT_LNFunk.setIcon(Ableitung.getsymbolUnPressedLogo(6));

        ZeichenbereichS1=null;
        ZeichenbereichS2=null;
        parameterEingabeS=null;

        // Eingabe anfgen
        parameterEingabeS = new ParameterEingabeSinus();
        parameterEingabeS.addToFrame(Hauptfenster);

        ZeichenbereichS1 = new ZeichenbereichSinus(parameterEingabeS, false);
        ZeichenbereichS2 = new ZeichenbereichSinus(parameterEingabeS, true);

        HauptFensterMitte.add(ZeichenbereichS1);
        HauptFensterMitte.add(ZeichenbereichS2);

        // Men aktualisieren
        Ableitung.setMenueFunktionsart(0);
    }

    /**
     * fgt die Ein- und Ausgabebereiche fr Cosinusfunktion dem Fenster hinzu
     */
    private void addCosinus() {
        BT_Sinus.setIcon(Ableitung.getsymbolUnPressedLogo(0));
        BT_Cosinus.setIcon(Ableitung.getsymbolPressedLogo(1));
        BT_SinusH.setIcon(Ableitung.getsymbolUnPressedLogo(2));
        BT_CosinusH.setIcon(Ableitung.getsymbolUnPressedLogo(3));
        BT_Polynom.setIcon(Ableitung.getsymbolUnPressedLogo(4));
        BT_EFunk.setIcon(Ableitung.getsymbolUnPressedLogo(5));
        BT_LNFunk.setIcon(Ableitung.getsymbolUnPressedLogo(6));

        ZeichenbereichC1=null;
        ZeichenbereichC2=null;
        parameterEingabeC=null;

        // Eingabe anfgen
        parameterEingabeC = new ParameterEingabeCosinus();
        parameterEingabeC.addToFrame(Hauptfenster);

        ZeichenbereichC1 = new ZeichenbereichCosinus(parameterEingabeC, false);
        ZeichenbereichC2 = new ZeichenbereichCosinus(parameterEingabeC, true);

        HauptFensterMitte.add(ZeichenbereichC1);
        HauptFensterMitte.add(ZeichenbereichC2);

        // Men aktualisieren
        Ableitung.setMenueFunktionsart(1);
    }

    /**
     * fgt die Ein- und Ausgabebereiche fr Sinus-hyperbolicus-Funktion dem Fenster hinzu
     */
    private void addSinusH() {
        BT_Sinus.setIcon(Ableitung.getsymbolUnPressedLogo(0));
        BT_Cosinus.setIcon(Ableitung.getsymbolUnPressedLogo(1));
        BT_SinusH.setIcon(Ableitung.getsymbolPressedLogo(2));
        BT_CosinusH.setIcon(Ableitung.getsymbolUnPressedLogo(3));
        BT_Polynom.setIcon(Ableitung.getsymbolUnPressedLogo(4));
        BT_EFunk.setIcon(Ableitung.getsymbolUnPressedLogo(5));
        BT_LNFunk.setIcon(Ableitung.getsymbolUnPressedLogo(6));

        ZeichenbereichSH1=null;
        ZeichenbereichSH2=null;
        parameterEingabeSH=null;

        // Eingabe anfgen
        parameterEingabeSH = new ParameterEingabeSinusH();
        parameterEingabeSH.addToFrame(Hauptfenster);

        ZeichenbereichSH1 = new ZeichenbereichSinusH(parameterEingabeSH, false);
        ZeichenbereichSH2 = new ZeichenbereichSinusH(parameterEingabeSH, true);

        HauptFensterMitte.add(ZeichenbereichSH1);
        HauptFensterMitte.add(ZeichenbereichSH2);

        // Men aktualisieren
        Ableitung.setMenueFunktionsart(2);
    }

    /**
     * fgt die Ein- und Ausgabebereiche fr Cosinus-hyperbolicus-Funktion dem Fenster hinzu
     */
    private void addCosinusH() {
        BT_Sinus.setIcon(Ableitung.getsymbolUnPressedLogo(0));
        BT_Cosinus.setIcon(Ableitung.getsymbolUnPressedLogo(1));
        BT_SinusH.setIcon(Ableitung.getsymbolUnPressedLogo(2));
        BT_CosinusH.setIcon(Ableitung.getsymbolPressedLogo(3));
        BT_Polynom.setIcon(Ableitung.getsymbolUnPressedLogo(4));
        BT_EFunk.setIcon(Ableitung.getsymbolUnPressedLogo(5));
        BT_LNFunk.setIcon(Ableitung.getsymbolUnPressedLogo(6));

        ZeichenbereichCH1=null;
        ZeichenbereichCH2=null;
        parameterEingabeCH=null;

        // Eingabe anfgen
        parameterEingabeCH = new ParameterEingabeCosinusH();
        parameterEingabeCH.addToFrame(Hauptfenster);

        ZeichenbereichCH1 = new ZeichenbereichCosinusH(parameterEingabeCH, false);
        ZeichenbereichCH2 = new ZeichenbereichCosinusH(parameterEingabeCH, true);

        HauptFensterMitte.add(ZeichenbereichCH1);
        HauptFensterMitte.add(ZeichenbereichCH2);

        // Men aktualisieren
        Ableitung.setMenueFunktionsart(3);
    }

    /**
     * fgt die Ein- und Ausgabebereiche fr Polynomfunktionen dem Fenster hinzu
     */
    private void addPolynom() {
        BT_Sinus.setIcon(Ableitung.getsymbolUnPressedLogo(0));
        BT_Cosinus.setIcon(Ableitung.getsymbolUnPressedLogo(1));
        BT_SinusH.setIcon(Ableitung.getsymbolUnPressedLogo(2));
        BT_CosinusH.setIcon(Ableitung.getsymbolUnPressedLogo(3));
        BT_Polynom.setIcon(Ableitung.getsymbolPressedLogo(4));
        BT_EFunk.setIcon(Ableitung.getsymbolUnPressedLogo(5));
        BT_LNFunk.setIcon(Ableitung.getsymbolUnPressedLogo(6));

        ZeichenbereichP1=null;
        ZeichenbereichP2=null;
        parameterEingabeP=null;

        // Eingabe anfgen
        parameterEingabeP = new ParameterEingabePolynom();
        parameterEingabeP.addToFrame(Hauptfenster);

        ZeichenbereichP1 = new ZeichenbereichPolynom(parameterEingabeP, false);
        ZeichenbereichP2 = new ZeichenbereichPolynom(parameterEingabeP, true);

        HauptFensterMitte.add(ZeichenbereichP1);
        HauptFensterMitte.add(ZeichenbereichP2);

        // Men aktualisieren
        Ableitung.setMenueFunktionsart(4);
    }

    /**
     * fgt die Ein- und Ausgabebereiche fr E-Funktion dem Fenster hinzu
     */
    private void addEFunk() {
        BT_Sinus.setIcon(Ableitung.getsymbolUnPressedLogo(0));
        BT_Cosinus.setIcon(Ableitung.getsymbolUnPressedLogo(1));
        BT_SinusH.setIcon(Ableitung.getsymbolUnPressedLogo(2));
        BT_CosinusH.setIcon(Ableitung.getsymbolUnPressedLogo(3));
        BT_Polynom.setIcon(Ableitung.getsymbolUnPressedLogo(4));
        BT_EFunk.setIcon(Ableitung.getsymbolPressedLogo(5));
        BT_LNFunk.setIcon(Ableitung.getsymbolUnPressedLogo(6));

        ZeichenbereichE1=null;
        ZeichenbereichE2=null;
        parameterEingabeE = null;
        // Eingabe anfgen
        parameterEingabeE = new ParameterEingabeEFunktion();
        parameterEingabeE.addToFrame(Hauptfenster);

        ZeichenbereichE1 = new ZeichenbereichEFunk(parameterEingabeE, false);
        ZeichenbereichE2 = new ZeichenbereichEFunk(parameterEingabeE, true);

        HauptFensterMitte.add(ZeichenbereichE1);
        HauptFensterMitte.add(ZeichenbereichE2);

        // Men aktualisieren
        Ableitung.setMenueFunktionsart(5);
    }

    /**
     * fgt die Ein- und Ausgabebereiche fr LN-Funktion dem Fenster hinzu
     */
    private void addLNFunk() {
        BT_Sinus.setIcon(Ableitung.getsymbolUnPressedLogo(0));
        BT_Cosinus.setIcon(Ableitung.getsymbolUnPressedLogo(1));
        BT_SinusH.setIcon(Ableitung.getsymbolUnPressedLogo(2));
        BT_CosinusH.setIcon(Ableitung.getsymbolUnPressedLogo(3));
        BT_Polynom.setIcon(Ableitung.getsymbolUnPressedLogo(4));
        BT_EFunk.setIcon(Ableitung.getsymbolUnPressedLogo(5));
        BT_LNFunk.setIcon(Ableitung.getsymbolPressedLogo(6));

        ZeichenbereichL1=null;
        ZeichenbereichL2=null;

        parameterEingabeLN = null;
        // Eingabe anfgen
        parameterEingabeLN = new ParameterEingabeLNFunktion();
        parameterEingabeLN.addToFrame(Hauptfenster);

        ZeichenbereichL1 = new ZeichenbereichLNFunk(parameterEingabeLN, false);
        ZeichenbereichL2 = new ZeichenbereichLNFunk(parameterEingabeLN, true);

        HauptFensterMitte.add(ZeichenbereichL1);
        HauptFensterMitte.add(ZeichenbereichL2);
        // Men aktualisieren
        Ableitung.setMenueFunktionsart(6);
    }

}
