
package source;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.SystemColor;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;

/**
 * Die Klasse <b>AboutDlg</b> erzeugt ein Info-Dialogfeld.
 * <p>
 * Dieses Dialogfeld dient lediglich dem Zweck dem Anwender eine kurze Information
 * ber dieses Applet zu geben.
 * </p>
 * @author Sergej Khltau 29.04.2008
 */

public class AboutDlg extends JFrame {
    /**
     * automatisch generierte UID
     */
    private static final long serialVersionUID = 1L;

    /**
     * Dialogfenster "Info"
     */
    private JDialog Aboutdlg;

    /**
     * Eventhandler fr GUI-Elemente
     */
    private Adapter adapter = new Adapter();

    /**
     * Flag welches kennzeichnet ob Dialogfenster im Vordergrund bleiben soll.
     */
    private boolean closing = false;

    /**
     * Schriftart Dialog, Pitch 12, Standard
     */
    private Font f_big =  new Font("Dialog", Font.PLAIN, 12);
    private Font f_fatt = new Font ("Dialog", Font.BOLD, 12);

    /**
     * Dialogfenster wird erzeugt
     */
    public AboutDlg() {
        Aboutdlg = new JDialog (this,"Info", false);
        //Layout des Dialogfeldes wird auf "Null-Layout" festegelegt.
        Aboutdlg.getContentPane().setLayout(null);
        Aboutdlg.getContentPane().setBackground(SystemColor.control);
    }

    /**
     * Es wird das Dialogfenster "Info" in der Bildschirmmitte geffnet.
     *
     * Es werden folgende Widget-Elemente erzeugt, initialisiert und platziert:
     * <ul>
     * 	<li>CanvasLogo: Auf diesem Canvas wird Logo gezeichnet, welches dem Dialogfeld hinzugefgt wird.</li>
     * 	<li>4 Labels: = 4 Zeilen des Dialogfeldes, auf welchen die Informationen ausgegeben werden.</li>
     * 	<li>Button "schlieen": Mit Hilfe dieses Buttons kann das Dialogfenster geschlossen werden.</li>
     * </ul>
     * <br>
     * Nachdem alle GUI-Elemente erzeugt und initialisert wurden, wird das Dialogfenster in der
     * Bildschirmmitte geffnet.
     *
     */
    public void showInfoDlg() {
        //Platz fr Logo
        JLabel labelIcon = new JLabel();
        labelIcon.setBounds(12,30,120,94);
        Aboutdlg.getContentPane().add(labelIcon);

        //Logo welches hinzugefgt werden soll, wird aus der Klasse Integral
        //geholt.
        if (Ableitung.getIconLogo() != null)
            labelIcon.setIcon(Ableitung.getIconLogo());

        //4 Labels um die Informationen darzustellen
        JLabel labelZeile1 = new JLabel();
        JLabel labelZeile2 = new JLabel();
        JLabel labelZeile3 = new JLabel();
        JLabel labelZeile4 = new JLabel();

        labelZeile1.setText(" Grundfunktionen und ihre Integrale");
        labelZeile1.setFont(f_fatt);
        labelZeile1.setBounds(135,40,320,15);
        Aboutdlg.getContentPane().add(labelZeile1);

        labelZeile2.setText(" Studienarbeit - Sergej Khltau");
        labelZeile2.setFont(f_big);
        labelZeile2.setBounds(135,75,320,15);
        Aboutdlg.getContentPane().add(labelZeile2);

        labelZeile3.setText(" Elektronik und Informationstechnik");
        labelZeile3.setFont(f_big);
        labelZeile3.setBounds(135,90,320,15);
        Aboutdlg.getContentPane().add(labelZeile3);

        labelZeile4.setText(" HTW Aalen - SS 2008");
        labelZeile4.setFont(f_big);
        labelZeile4.setBounds(135,105,320,15);
        Aboutdlg.getContentPane().add(labelZeile4);

        // Schlieen-Button erzeugen
        JButton buttonClose = new JButton ();
        buttonClose.setText("Schlieen");
        buttonClose.setMnemonic(KeyEvent.VK_S);
        buttonClose.setBackground(SystemColor.control);
        buttonClose.setFont(f_big);
        buttonClose.addActionListener(adapter);
        buttonClose.setBounds(135,150,100,25);
        buttonClose.setToolTipText("<html>Klicken Sie hier,<br>um das Dialogfenster zu schlieen.</html>");
        Aboutdlg.getContentPane().add(buttonClose);

        //Dialog in Bildschirmmitte positionieren
        Aboutdlg.setSize(370,230);
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Aboutdlg.setLocation( (screenSize.width-Aboutdlg.getSize().width)/2,
                              (screenSize.height-Aboutdlg.getSize().height)/2);
        Aboutdlg.setVisible(true);

        // Minimale Gre des Dialogfensters festlegen
        Aboutdlg. setMinimumSize(new java.awt.Dimension(370, 230));

        Aboutdlg.addWindowListener(new DialogListener());
        Aboutdlg.repaint();
    }

    /**
     * Adapterklasse: Eventhandler fr Button "schlieen".
     */
    class Adapter implements ActionListener {

        /**
         * Methode wird aufgerufen, falls mit der Maus auf Button
         * "Schlieen" geklickt wurde.
         */
        public void actionPerformed(ActionEvent e) {
            if (closing = true)
                Aboutdlg.setVisible(false);
        }
    }

    /**
     *  Die Klasse <b>DialogListener</b> setzt das Dialogfenster
     *  wieder in den Vordergrund, falls es minimiert oder
     * 	von einem anderen Task berdeckt werden sollte und
     *  nicht geschlossen werden soll.
     */
    class DialogListener extends WindowAdapter {

        /**
         * Methode wird aufgerufen, falls das Dialogfenster den Focus verloren hat.
         */
        public void windowDeactivated(WindowEvent e) {
            if (!closing)
                Aboutdlg.setVisible(true);
        }
    }
}
