
package source;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.text.DecimalFormat;

import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.JTextField;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
 * Die Klasse ParameterEingabe verwaltet die Ein- und Ausgabewerte der
 * Polynomfunktion
 *
 * @author Sergej Khltau  28.06.2008
 */

public class ParameterEingabePolynom {
    // Legt die Genauigkeit fest
    private double Genauigkeit = 100;

    // Formatierung der Anzeigen
    DecimalFormat df2 = new DecimalFormat( "0.00" );
    DecimalFormat df4 = new DecimalFormat( "0.0000" );

    // Referenzen auf die Zeichenbereiche
    private ZeichenbereichPolynom Zeichenbereich1 = null;
    private ZeichenbereichPolynom Zeichenbereich2 = null;

    // Bereich der in ParameterEingabe verwaltet wird
    private JPanel innerContent = null;

    // Gruppe von Elementen erstellen:
    // Beschriftung, Eingabefeld & Scrollbalken fr Koeffizient a
    // Beschriftung, Eingabefeld & Scrollbalken fr Koeffizeint b
    // Beschriftung, Eingabefeld & Scrollbalken fr Koeffizient c
    // Beschriftung, Eingabefeld & Scrollbalken fr Koeffizeint d

    // Beschriftung, Eingabefeld & Scrollbalken fr Obergrenze
    // Beschriftung, Eingabefeld & Scrollbalken fr Untergrenze
    // Beschriftung & ComboBox fr Gradauswahl

    // Labels
    private JLabel LB_Koeffa_Wert = null;
    private JLabel LB_Koeffb_Wert = null;
    private JLabel LB_Koeffc_Wert = null;
    private JLabel LB_Koeffd_Wert = null;

    private JLabel LB_Untergrenze = null;
    private JLabel LB_Obergrenze = null;
    private JLabel LB_Grad = null;
    private JLabel Logo = null;

    // Textfelder
    private JTextField TF_Koeffa_Wert = null;
    private JTextField TF_Koeffb_Wert = null;
    private JTextField TF_Koeffc_Wert = null;
    private JTextField TF_Koeffd_Wert = null;

    private JTextField TF_Untergrenze = null;
    private JTextField TF_Obergrenze = null;

    // Slider (Scrollbalken)
    private JSlider sl_Koeffa_Wert = null;
    private JSlider sl_Koeffb_Wert = null;
    private JSlider sl_Koeffc_Wert = null;
    private JSlider sl_Koeffd_Wert = null;

    private JSlider sl_Untergrenze = null;
    private JSlider sl_Obergrenze = null;

    // Gradauswahl
    private JComboBox CB_Grad = null;
    private String[] CB_GradWahl = {"Grad 1 (Gerade)", "Grad 2 (Parabel)", "Grad 3"};

    // Interne Variablen
    private double Koeffa_Wert = 1;
    private double Koeffb_Wert = 1;
    private double Koeffc_Wert = 1;
    private double Koeffd_Wert = 1;

    private double Untergrenze_Wert = -1;
    private double Obergrenze_Wert = 1;

    /**
     * Konstruktor erzeugt die Eingabefelder
     */
    public ParameterEingabePolynom () {
        String Beschriftung;
        // wir legen alle Elemente auf ein Panel
        innerContent = new JPanel();
        // wir verwenden keinen Layoutmanager
        innerContent.setLayout(null);

        // Erzeugung der Text-Eingabefelder, mit dem jeweiligen Wert und
        // lassen maximal 10 Zeichen zu
        Beschriftung = df2.format(Koeffa_Wert);
        TF_Koeffa_Wert = new JTextField(Beschriftung,10);

        Beschriftung = df2.format(Koeffb_Wert);
        TF_Koeffb_Wert = new JTextField(Beschriftung,10);

        Beschriftung = df2.format(Koeffc_Wert);
        TF_Koeffc_Wert = new JTextField(Beschriftung,10);

        Beschriftung = df2.format(Koeffd_Wert);
        TF_Koeffd_Wert = new JTextField(Beschriftung,10);



        Beschriftung = df2.format(Untergrenze_Wert);
        TF_Untergrenze = new JTextField(Beschriftung,10);

        Beschriftung = df2.format(Obergrenze_Wert);
        TF_Obergrenze = new JTextField(Beschriftung,10);


        // wir erzeugen die Berschriftungslabels
        LB_Koeffa_Wert = new JLabel("Keoffizient A:");
        LB_Koeffb_Wert = new JLabel("Keoffizient B:");
        LB_Koeffc_Wert = new JLabel("Keoffizient C:");
        LB_Koeffd_Wert = new JLabel("Keoffizient D:");

        LB_Grad = new JLabel("Gradauswahl:");
        LB_Untergrenze = new JLabel("Untergrenze a:");
        LB_Obergrenze = new JLabel("Obergrenze b:");
        Logo = new JLabel ("");

        // ComboBox erzeugen
        CB_Grad = new JComboBox(CB_GradWahl);
        CB_Grad.setMaximumRowCount(3);
        CB_Grad.setSelectedIndex(0);

        // Erzeugung der Schieberegler --> JSlider (min, max, value)
        sl_Koeffa_Wert = new JSlider( -300, 300, (int)(Genauigkeit * Koeffa_Wert));
        sl_Koeffb_Wert = new JSlider( -500, 500, (int) (Genauigkeit * Koeffb_Wert));
        sl_Koeffc_Wert = new JSlider( -500, 500, (int) (Genauigkeit * Koeffc_Wert));
        sl_Koeffd_Wert = new JSlider( -500, 500, (int) (Genauigkeit * Koeffd_Wert));

        sl_Untergrenze = new JSlider(-398, 398, (int) (Genauigkeit * Untergrenze_Wert));
        sl_Obergrenze = new JSlider(-398, 398,(int)(Genauigkeit* Obergrenze_Wert));

        // Positionierung der Elemente
        int left = 5;
        int width = 120;
        int height = 21;
        int abstand = 26;
        int top = 7 - abstand;

        // Elementbegrenzungen setzen
        LB_Grad.setBounds(left,top+=abstand,width,height);
        CB_Grad.setBounds(left,top+=abstand/1.5,width,height);

        top+=abstand*0.5;
        LB_Koeffa_Wert.setBounds(left,top+=abstand,width,height);
        TF_Koeffa_Wert.setBounds(left,top+=abstand/1.5,width,height);
        sl_Koeffa_Wert.setBounds(left,top+=abstand,width,(int)(height));

        top+=abstand*0.1;
        LB_Koeffb_Wert.setBounds(left,top+=abstand,width,height);
        TF_Koeffb_Wert.setBounds(left,top+=abstand/1.5,width,height);
        sl_Koeffb_Wert.setBounds(left,top+=abstand,width,(int)(height));

        top+=abstand*0.1;
        LB_Koeffc_Wert.setBounds(left,top+=abstand,width,height);
        TF_Koeffc_Wert.setBounds(left,top+=abstand/1.5,width,height);
        sl_Koeffc_Wert.setBounds(left,top+=abstand,width,(int)(height));

        top+=abstand*0.1;
        LB_Koeffd_Wert.setBounds(left,top+=abstand,width,height);
        TF_Koeffd_Wert.setBounds(left,top+=abstand/1.5,width,height);
        sl_Koeffd_Wert.setBounds(left,top+=abstand,width,(int)(height));



        top+=abstand*0.1;
        LB_Untergrenze.setBounds(left,top+=abstand,width,height);
        TF_Untergrenze.setBounds(left,top+=abstand/1.5,width,height);
        sl_Untergrenze.setBounds(left,top+=abstand,width,(int)(height));

        top+=abstand*0.1;
        LB_Obergrenze.setBounds(left,top+=abstand,width,height);
        TF_Obergrenze.setBounds(left,top+=abstand/1.5,width,height);
        sl_Obergrenze.setBounds(left,top+=abstand,width,(int)(height));

        top+=abstand*0.3;
        if (Ableitung.getIconLogo() != null)
            Logo.setIcon(Ableitung.getIconLogo());
        Logo.setBounds(left,top+=abstand,120,108);

        /**
         * Reaktion auf die nderung der Eingabefelder
         */
        TF_Koeffa_Wert.addActionListener
        (
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (!TF_Koeffa_Wert.hasFocus())
                    return;
                eingabewerteEinlesen();
                if (Zeichenbereich1 != null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2 != null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        sl_Koeffa_Wert.addChangeListener
        (
        new ChangeListener() {
            public void stateChanged(ChangeEvent  e) {
                if (!sl_Koeffa_Wert.hasFocus())
                    return;
                String Beschriftung1;
                Koeffa_Wert = sl_Koeffa_Wert.getValue()/Genauigkeit;
                Beschriftung1 = df2.format(Koeffa_Wert);
                TF_Koeffa_Wert.setText(Beschriftung1);
                if (Zeichenbereich1 != null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2 != null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        TF_Koeffb_Wert.addActionListener
        (
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (!TF_Koeffb_Wert.hasFocus())
                    return;
                eingabewerteEinlesen();
                if (Zeichenbereich1 != null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2 != null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        sl_Koeffb_Wert.addChangeListener
        (
        new ChangeListener() {
            public void stateChanged(ChangeEvent  e) {
                if (!sl_Koeffb_Wert.hasFocus())
                    return;
                String Beschriftung1;
                Koeffb_Wert = sl_Koeffb_Wert.getValue()/Genauigkeit;
                Beschriftung1 = df2.format(Koeffb_Wert);
                TF_Koeffb_Wert.setText(Beschriftung1);
                if (Zeichenbereich1 != null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2 != null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        TF_Koeffc_Wert.addActionListener
        (
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (!TF_Koeffc_Wert.hasFocus()  )
                    return;
                eingabewerteEinlesen();
                if (Zeichenbereich1 != null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2 != null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        sl_Koeffc_Wert.addChangeListener
        (
        new ChangeListener() {
            public void stateChanged(ChangeEvent  e) {
                if (!sl_Koeffc_Wert.hasFocus()  )
                    return;
                String Beschriftung1;
                Koeffc_Wert = sl_Koeffc_Wert.getValue()/Genauigkeit;
                Beschriftung1 = df2.format(Koeffc_Wert);
                TF_Koeffc_Wert.setText(Beschriftung1);
                if (Zeichenbereich1 != null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2 != null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        TF_Koeffd_Wert.addActionListener
        (
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (!TF_Koeffd_Wert.hasFocus() || getGrad() <= 0 )
                    return;
                eingabewerteEinlesen();
                if (Zeichenbereich1 != null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2 != null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        sl_Koeffd_Wert.addChangeListener
        (
        new ChangeListener() {
            public void stateChanged(ChangeEvent  e) {
                if (!sl_Koeffd_Wert.hasFocus() || getGrad() <=0 )
                    return;
                String Beschriftung1;
                Koeffd_Wert = sl_Koeffd_Wert.getValue()/Genauigkeit;
                Beschriftung1 = df2.format(Koeffd_Wert);
                TF_Koeffd_Wert.setText(Beschriftung1);
                if (Zeichenbereich1 != null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2 != null) Zeichenbereich2.Dorepaint();
            }
        }
        );



        TF_Untergrenze.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (!TF_Untergrenze.hasFocus()) return;
                eingabewerteEinlesen();
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        sl_Untergrenze.addChangeListener(
        new ChangeListener() {
            public void stateChanged(ChangeEvent  e) {
                if (!sl_Untergrenze.hasFocus()) return;
                String Beschriftung1;
                Untergrenze_Wert = sl_Untergrenze.getValue()/Genauigkeit;
                Beschriftung1 = df2.format(Untergrenze_Wert);
                TF_Untergrenze.setText(Beschriftung1);
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        TF_Obergrenze.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (!TF_Obergrenze.hasFocus()) return;
                eingabewerteEinlesen();
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        sl_Obergrenze.addChangeListener(
        new ChangeListener() {
            public void stateChanged(ChangeEvent  e) {
                if (!sl_Obergrenze.hasFocus()) return;
                String Beschriftung2;
                Obergrenze_Wert = sl_Obergrenze.getValue()/Genauigkeit;
                Beschriftung2 = df2.format(Obergrenze_Wert);
                TF_Obergrenze.setText(Beschriftung2);
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        CB_Grad.addItemListener
        (
        new ItemListener() {
            public void itemStateChanged(ItemEvent e) {
                // nur bei nderung der Sekektion reagieren
                if (ItemEvent.SELECTED == e.getStateChange()) {
                    if (getGrad()==0) {

                        setKoeffa_Wert (0);
                        setKoeffb_Wert (1);

                        innerContent.add(LB_Koeffb_Wert);
                        innerContent.add(TF_Koeffb_Wert);
                        innerContent.add(sl_Koeffb_Wert);
                        innerContent.remove(LB_Koeffc_Wert);
                        innerContent.remove(TF_Koeffc_Wert);
                        innerContent.remove(sl_Koeffc_Wert);
                        innerContent.remove(LB_Koeffd_Wert);
                        innerContent.remove(TF_Koeffd_Wert);
                        innerContent.remove(sl_Koeffd_Wert);
                    }

                    if (getGrad() ==1) {
                        setKoeffa_Wert (0);
                        setKoeffb_Wert (0);
                        setKoeffc_Wert (1);

                        innerContent.add(LB_Koeffc_Wert);
                        innerContent.add(TF_Koeffc_Wert);
                        innerContent.add(sl_Koeffc_Wert);
                        innerContent.remove(LB_Koeffd_Wert);
                        innerContent.remove(TF_Koeffd_Wert);
                        innerContent.remove(sl_Koeffd_Wert);

                    }
                    if (getGrad() ==2) {
                        setKoeffa_Wert (0);
                        setKoeffb_Wert (0);
                        setKoeffc_Wert (0);
                        setKoeffd_Wert (1);

                        innerContent.add(LB_Koeffc_Wert);
                        innerContent.add(TF_Koeffc_Wert);
                        innerContent.add(sl_Koeffc_Wert);
                        innerContent.add(LB_Koeffd_Wert);
                        innerContent.add(TF_Koeffd_Wert);
                        innerContent.add(sl_Koeffd_Wert);

                    }
                    setUntergrenze (-1);
                    setObergrenze (1);
                    if (Zeichenbereich1 != null) Zeichenbereich1.Dorepaint();
                    if (Zeichenbereich2 != null) Zeichenbereich2.Dorepaint();
                }
            }
        }
        );

        // Gre des Eingabebereichs zulassen
        innerContent.setPreferredSize(new Dimension(left*2+width,20));

        // Widgets auf dem Panel plazieren
        innerContent.add(LB_Grad);
        innerContent.add(CB_Grad);

        innerContent.add(LB_Koeffa_Wert);
        innerContent.add(TF_Koeffa_Wert);
        innerContent.add(sl_Koeffa_Wert);

        innerContent.add(LB_Koeffb_Wert);
        innerContent.add(TF_Koeffb_Wert);
        innerContent.add(sl_Koeffb_Wert);



        innerContent.add(LB_Untergrenze);
        innerContent.add(TF_Untergrenze);
        innerContent.add(sl_Untergrenze);

        innerContent.add(LB_Obergrenze);
        innerContent.add(TF_Obergrenze);
        innerContent.add(sl_Obergrenze);

        innerContent.add(Logo);
    }

    /**
     * Methode delete dient dazu eine Eingabe aus dem Speicher aufzulsen
     *
     * @param Fenster	Fenster auf dem die Elemente plaziert sind
     */
    public void delete(JFrame Fenster) {
        // Eingabefelder freigeben
        innerContent.remove(LB_Koeffa_Wert);
        innerContent.remove(TF_Koeffa_Wert);
        innerContent.remove(sl_Koeffa_Wert);

        innerContent.remove(LB_Koeffb_Wert);
        innerContent.remove(TF_Koeffb_Wert);
        innerContent.remove(sl_Koeffb_Wert);

        innerContent.remove(LB_Koeffc_Wert);
        innerContent.remove(TF_Koeffc_Wert);
        innerContent.remove(sl_Koeffc_Wert);

        innerContent.remove(LB_Koeffd_Wert);
        innerContent.remove(TF_Koeffd_Wert);
        innerContent.remove(sl_Koeffd_Wert);



        innerContent.remove(LB_Untergrenze);
        innerContent.remove(TF_Untergrenze);
        innerContent.remove(sl_Untergrenze);

        innerContent.remove(LB_Obergrenze);
        innerContent.remove(TF_Obergrenze);
        innerContent.remove(sl_Obergrenze);

        innerContent.remove(LB_Grad);
        innerContent.remove(CB_Grad);

        innerContent.remove(Logo);

        // Referenzen lschen
        LB_Koeffa_Wert = null;
        LB_Koeffb_Wert = null;
        LB_Koeffc_Wert = null;
        LB_Koeffd_Wert = null;

        LB_Untergrenze = null;
        LB_Obergrenze = null;
        Logo = null;

        TF_Koeffa_Wert = null;
        TF_Koeffb_Wert = null;
        TF_Koeffc_Wert = null;
        TF_Koeffd_Wert = null;

        TF_Untergrenze = null;
        TF_Obergrenze = null;

        sl_Koeffa_Wert = null;
        sl_Koeffb_Wert = null;
        sl_Koeffc_Wert = null;
        sl_Koeffd_Wert = null;

        sl_Untergrenze = null;
        sl_Obergrenze = null;

        // selbst auflsen
        Fenster.getContentPane().remove(innerContent);
        innerContent = null;
        Zeichenbereich1 = null;
        Zeichenbereich2 = null;
    }

    /**
     * setzt den Wert des Polynomkoeffizienten a von aussen
     *
     * @param wert	Neuer Polynomkoeffizient a Wert
     */
    public void setKoeffa_Wert(double wert) {
        Koeffa_Wert = wert;
        String Beschriftung = df2.format(Koeffa_Wert);
        TF_Koeffa_Wert.setText(Beschriftung);
        sl_Koeffa_Wert.setValue( (int) (Koeffa_Wert*Genauigkeit) );
    }

    /**
     * setzt den Wert des Polynomkoeffizienten b von aussen
     *
     * @param wert	Neuer Polynomkoeffizient b Wert
     */
    public void setKoeffb_Wert(int wert) {
        Koeffb_Wert = wert;
        String Beschriftung = df2.format(Koeffb_Wert);
        TF_Koeffb_Wert.setText(Beschriftung);
        sl_Koeffb_Wert.setValue( (int) (Koeffb_Wert * Genauigkeit) );
    }

    /**
     * setzt den Wert von Polynomkoeffizienten c von aussen
     *
     * @param wert	Neuer Polynomkoeffizient c Wert
     */
    public void setKoeffc_Wert(int wert) {
        Koeffc_Wert = wert;
        String Beschriftung = df2.format(Koeffc_Wert);
        TF_Koeffc_Wert.setText(Beschriftung);
        sl_Koeffc_Wert.setValue( (int) (Koeffc_Wert*Genauigkeit) );
    }

    /**
     * setzt den Wert von Polynomkoeffizienten d von aussen
     *
     * @param wert	Neuer Polynomkoeffizient d Wert
     */
    public void setKoeffd_Wert(int wert) {
        Koeffd_Wert = wert;
        String Beschriftung = df2.format(Koeffd_Wert);
        TF_Koeffd_Wert.setText(Beschriftung);
        sl_Koeffd_Wert.setValue( (int) (Koeffd_Wert*Genauigkeit) );
    }



    /**
     * setzt den Untergrenze-Wert
     *
     * @param x	Neue Untergrenze
     */
    public void setUntergrenze(double x) {
        // Abfangen der unzulssigen Werte
        Untergrenze_Wert = x;
        if (Untergrenze_Wert > -3.98 && Untergrenze_Wert < 3.98) {
            sl_Untergrenze.setValue( (int)(Genauigkeit*Untergrenze_Wert) );
            String Beschriftung1;
            Beschriftung1 = df2.format(Untergrenze_Wert);
            TF_Untergrenze.setText(Beschriftung1);
        } else if (Untergrenze_Wert > 3.98) {
            sl_Untergrenze.setValue( (int)(Genauigkeit*3.98) );
            String Beschriftung1;
            Beschriftung1 = df2.format(3.98);
            TF_Untergrenze.setText(Beschriftung1);
            Untergrenze_Wert = 3.98;
        } else {
            sl_Untergrenze.setValue( (int)(Genauigkeit*-3.98) );
            String Beschriftung1;
            Beschriftung1 = df2.format(-3.98);
            TF_Untergrenze.setText(Beschriftung1);
            Untergrenze_Wert = -3.98;
        }
        if (Zeichenbereich1 != null) Zeichenbereich1.Dorepaint();
        if (Zeichenbereich2 != null) Zeichenbereich2.Dorepaint();
    }

    /**
     * liefert den Polynomkoeffizienten a Wert
     *
     * @return derzeitiger Polynomkoeffizient a
     */
    public double getKoeffa_Wert() {
        return Koeffa_Wert;
    }

    /**
     * liefert den Polynomkoeffizienten b Wert
     *
     * @return derzeitiger Polynomkoeffizient b
     */
    public double getKoeffb_Wert() {
        return Koeffb_Wert;
    }

    /**
     * liefert den Polynomkoeffizienten c Wert
     *
     * @return derzeitiger Polynomkoeffizient c
     */
    public double getKoeffc_Wert() {
        return Koeffc_Wert;
    }

    /**
     * liefert den Polynomkoeffizienten d Wert
     *
     * @return derzeitiger Polynomkoeffizient d
     */
    public double getKoeffd_Wert() {
        return Koeffd_Wert;
    }



    /**
     * liefert den Wert des Untergrenze_Wertes
     *
     * @return derzeitiger Untergrenze_Wert
     */
    public double getUntergrenze() {
        return Untergrenze_Wert;
    }

    /**
     * setzt die Zeichenbereiche
     *
     * @param z	Zeichenbereich
     */
    public void setZeichenbereich(ZeichenbereichPolynom z) {
        if (Zeichenbereich1==null)
            Zeichenbereich1=z;
        else
            Zeichenbereich2=z;
    }

    /**
     * liefert den Obergrenze-Wert
     *
     * @return derzeitiger Abgriff
     */
    public double getObergrenze() {
        return	Obergrenze_Wert;
    }

    /**
     * setzt den Obergrenze-Wert
     *
     * @param x	Neue Obergrenze
     */
    public void setObergrenze(double x) {
        // Abfangen der unzulssigen Werte
        Obergrenze_Wert = x;
        if (Obergrenze_Wert > -3.98 && Obergrenze_Wert < 3.98) {
            sl_Obergrenze.setValue( (int)(Genauigkeit*Obergrenze_Wert) );
            String Beschriftung1;
            Beschriftung1 = df2.format(Obergrenze_Wert);
            TF_Obergrenze.setText(Beschriftung1);
        } else if (Obergrenze_Wert > 3.98) {
            sl_Obergrenze.setValue( (int)(Genauigkeit*3.98) );
            String Beschriftung1;
            Beschriftung1 = df2.format(3.98);
            TF_Obergrenze.setText(Beschriftung1);
            Obergrenze_Wert = 3.98;
        } else {
            sl_Obergrenze.setValue( (int)(Genauigkeit*-3.98) );
            String Beschriftung1;
            Beschriftung1 = df2.format(-3.98);
            TF_Obergrenze.setText(Beschriftung1);
            Obergrenze_Wert = -3.98;
        }
        if (Zeichenbereich1 != null) Zeichenbereich1.Dorepaint();
        if (Zeichenbereich2 != null) Zeichenbereich2.Dorepaint();
    }

    /**
     * liefert den Grad der Polynomfunktion
     *
     * @return Grad der Polynomfunktion
     */
    public int getGrad() {
        return CB_Grad.getSelectedIndex();
    }

    /**
     * fgt die Eingabeleiste auf einem Fenster ein
     *
     * @param Fenster	Fenster auf dem die Leiste eingefgt werden soll
     */
    public void addToFrame(JFrame Fenster) {
        Fenster.getContentPane().add(innerContent, BorderLayout.WEST);
    }

    /**
     * bernimmt alle Werte bei der Texteingabe
     */
    private void eingabewerteEinlesen() {
        // Koeffizient a
        {
            String Hilf = TF_Koeffa_Wert.getText();
            Koeffa_Wert = Double.parseDouble(Hilf.replace(',','.'));
            // ungltige Werte nicht zulassen
            if (Koeffa_Wert > 3 ) {
                Koeffa_Wert = 3;
                TF_Koeffa_Wert.setText("3,00");
            }
            if (Koeffa_Wert < -3 ) {
                Koeffa_Wert = -3;
                TF_Koeffa_Wert.setText("-3,00");
            }
            sl_Koeffa_Wert.setValue( (int)(Genauigkeit*Koeffa_Wert) );
        }

        // Koeffizient b
        {
            String Hilf = TF_Koeffb_Wert.getText();
            Koeffb_Wert = Double.parseDouble(Hilf.replace(',','.'));
            // ungltige Werte nicht zulassen
            if (Koeffb_Wert > 5 ) {
                Koeffb_Wert = 5;
                TF_Koeffb_Wert.setText("5,00");
            }
            if (Koeffb_Wert < -5 ) {
                Koeffb_Wert = -5;
                TF_Koeffb_Wert.setText("-5,00");
            }
            sl_Koeffb_Wert.setValue( (int) (Genauigkeit*Koeffb_Wert) );
        }

        // Koeffizient c
        {
            String Hilf = TF_Koeffc_Wert.getText();
            Koeffc_Wert = Double.parseDouble(Hilf.replace(',','.'));
            // ungltige Werte nicht zulassen
            if (Koeffc_Wert > 5 ) {
                Koeffc_Wert = 5;
                TF_Koeffc_Wert.setText("5,00");
            }
            if (Koeffc_Wert < -5 ) {
                Koeffc_Wert = -5;
                TF_Koeffc_Wert.setText("-5,00");
            }
            sl_Koeffc_Wert.setValue( (int) (Genauigkeit * Koeffc_Wert) );
        }

        // Koeffizient d
        {
            String Hilf = TF_Koeffd_Wert.getText();
            Koeffd_Wert = Double.parseDouble(Hilf.replace(',','.'));
            // ungltige Werte nicht zulassen
            if (Koeffd_Wert > 5 ) {
                Koeffd_Wert = 5;
                TF_Koeffd_Wert.setText("5,00");
            }
            if (Koeffd_Wert < -5 ) {
                Koeffd_Wert = -5;
                TF_Koeffd_Wert.setText("-5,00");
            }
            sl_Koeffd_Wert.setValue( (int) (Genauigkeit * Koeffd_Wert) );
        }



        // Obergrenze
        {
            String Hilf = TF_Obergrenze.getText();
            Obergrenze_Wert = Double.parseDouble(Hilf.replace(',','.'));
            // ungltige Werte nicht zulassen
            if (Obergrenze_Wert < -3.98 ) {
                Obergrenze_Wert = -3.98;
                TF_Obergrenze.setText("-3,98");
            }
            if (Obergrenze_Wert > 3.98 ) {
                Obergrenze_Wert = 3.98;
                TF_Obergrenze.setText("3,98");
            }
            sl_Obergrenze.setValue( (int) (Genauigkeit * Obergrenze_Wert) );
        }

        // Untergrenze
        {
            String Hilf = TF_Untergrenze.getText();
            Untergrenze_Wert = Double.parseDouble(Hilf.replace(',','.'));
            // ungltige Werte nicht zulassen
            if (Untergrenze_Wert < -3.98 ) {
                Untergrenze_Wert = -3.98;
                TF_Untergrenze.setText("-3,98");
            }
            if (Untergrenze_Wert > 3.98 ) {
                Untergrenze_Wert = 3.98;
                TF_Untergrenze.setText("3,98");
            }
            sl_Untergrenze.setValue( (int) (Genauigkeit * Untergrenze_Wert) );
        }
    }
}

