
package source;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.DecimalFormat;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.JTextField;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
 * Die Klasse ParameterEingabe verwaltet die
 * Ein- und Ausgabewerte der Sinus-hyperbolicus-Funktion
 *
 * @author Sergej Khltau  19.06.2008
 */

public class ParameterEingabeSinusH {
    // Legt die Genauigkeit fest
    private double Genauigkeit = 100;

    // Formatierung der Anzeigen
    DecimalFormat df2 = new DecimalFormat( "0.00" );
    DecimalFormat df4 = new DecimalFormat( "0.0000" );

    // Referenzen auf die Zeichenbereiche
    private ZeichenbereichSinusH Zeichenbereich1 = null;
    private ZeichenbereichSinusH Zeichenbereich2 = null;

    // Bereich der in ParameterEingabe verwaltet wird
    private JPanel innerContent = null;

    // Gruppe von Elementen erstellen:
    // Beschriftung, Eingabefeld & Scrollbalken fr ParameterA
    // Beschriftung, Eingabefeld & Scrollbalken fr ParameterB
    // Beschriftung, Eingabefeld & Scrollbalken fr ParameterC
    // Beschriftung, Eingabefeld & Scrollbalken fr Abgriff

    // Labels
    private JLabel LB_ParameterA_Wert = null;
    private JLabel LB_ParameterB_Wert = null;
    private JLabel LB_ParameterC_Wert = null;
    private JLabel LB_Untergrenze = null;
    private JLabel LB_Obergrenze = null;
    private JLabel Logo = null;

    // Textfelder
    private JTextField TF_ParameterA_Wert= null;
    private JTextField TF_ParameterB_Wert = null;
    private JTextField TF_ParameterC_Wert = null;
    private JTextField TF_Untergrenze = null;
    private JTextField TF_Obergrenze = null;

    // Slider (Scrollbalken)
    private JSlider sl_ParameterA_Wert = null;
    private JSlider sl_ParameterB_Wert = null;
    private JSlider sl_ParameterC_Wert = null;
    private JSlider sl_Untergrenze = null;
    private JSlider sl_Obergrenze = null;

    // Interne Variablen
    private double ParameterA_Wert = 1;
    private double ParameterB_Wert = 1;
    private double ParameterC_Wert = 0;
    private double Untergrenze_Wert = -1;
    private double Obergrenze_Wert = 1;

    /**
     * Konstruktor erzeugt die Eingabefelder
     */
    public ParameterEingabeSinusH () {
        String Beschriftung;
        // wir legen alle Elemente auf ein Panel
        innerContent = new JPanel();
        // wir verwenden keinen Layoutmanager
        innerContent.setLayout(null);

        // Erzeugung der Text-Eingabefelder, mit dem jeweiligen Wert und
        // lassen maximal 10 Zeichen zu
        Beschriftung = df2.format(ParameterA_Wert);
        TF_ParameterA_Wert = new JTextField(Beschriftung,10);

        Beschriftung = df2.format(ParameterB_Wert);
        TF_ParameterB_Wert = new JTextField(Beschriftung,10);

        Beschriftung = df2.format(ParameterC_Wert);
        TF_ParameterC_Wert = new JTextField(Beschriftung,10);

        Beschriftung = df2.format(Untergrenze_Wert);
        TF_Untergrenze = new JTextField(Beschriftung,10);

        Beschriftung = df2.format(Obergrenze_Wert);
        TF_Obergrenze = new JTextField(Beschriftung,10);

        // wir erzeugen die Berschriftungslabels
        LB_ParameterA_Wert = new JLabel("Parameter A:");
        LB_ParameterB_Wert = new JLabel("Parameter B:");
        LB_ParameterC_Wert = new JLabel("Parameter C:");
        LB_Untergrenze = new JLabel("Untergrenze a:");
        LB_Obergrenze = new JLabel("Obergrenze b:");
        Logo = new JLabel("");

        // Erzeugung der Schieberegler --> JSlider (min, max, value)
        sl_ParameterA_Wert = new JSlider(-250, 250, (int)(Genauigkeit * ParameterA_Wert));
        sl_ParameterB_Wert = new JSlider(-250, 250, (int) (Genauigkeit * ParameterB_Wert));
        sl_ParameterC_Wert = new JSlider(-300, 300, (int) (Genauigkeit * ParameterC_Wert));
        sl_Untergrenze = new JSlider(-398, 398, (int) (Genauigkeit * Untergrenze_Wert));
        sl_Obergrenze = new JSlider(-398, 398,(int)(Genauigkeit* Obergrenze_Wert));

        // Positionierung der Elemente
        int left = 5;
        int width = 120;
        int height = 21;
        int abstand = 26;
        int top = 7 - abstand;

        // Elementbegrenzungen setzen
        LB_ParameterA_Wert.setBounds(left,top+=abstand,width,height);
        TF_ParameterA_Wert.setBounds(left,top+=abstand/1.5,width,height);
        sl_ParameterA_Wert.setBounds(left,top+=abstand,width,(int)(height));

        top+=abstand*0.1;
        LB_ParameterB_Wert.setBounds(left,top+=abstand,width,height);
        TF_ParameterB_Wert.setBounds(left,top+=abstand/1.5,width,height);
        sl_ParameterB_Wert.setBounds(left,top+=abstand,width,(int)(height));

        top+=abstand*0.1;
        LB_ParameterC_Wert.setBounds(left,top+=abstand,width,height);
        TF_ParameterC_Wert.setBounds(left,top+=abstand/1.5,width,height);
        sl_ParameterC_Wert.setBounds(left,top+=abstand,width,(int)(height));

        top+=abstand*0.1;
        LB_Untergrenze.setBounds(left,top+=abstand,width,height);
        TF_Untergrenze.setBounds(left,top+=abstand/1.5,width,height);
        sl_Untergrenze.setBounds(left,top+=abstand,width,(int)(height));

        top+=abstand*0.1;
        LB_Obergrenze.setBounds(left,top+=abstand,width,height);
        TF_Obergrenze.setBounds(left,top+=abstand/1.5,width,height);
        sl_Obergrenze.setBounds(left,top+=abstand,width,(int)(height));

        top+=abstand*0.4;
        if (Ableitung.getIconLogo() != null)
            Logo.setIcon(Ableitung.getIconLogo());
        Logo.setBounds(left,top+=abstand,120,108);

        /**
         * Reaktion auf die nderung der Eingabefelder
         */
        TF_ParameterA_Wert.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (!TF_ParameterA_Wert.hasFocus()) return;
                eingabewerteEinlesen();
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        sl_ParameterA_Wert.addChangeListener(
        new ChangeListener() {
            public void stateChanged(ChangeEvent  e) {
                if (!sl_ParameterA_Wert.hasFocus()) return;
                String Beschriftung1;
                ParameterA_Wert = sl_ParameterA_Wert.getValue()/Genauigkeit;
                Beschriftung1 = df2.format(ParameterA_Wert);
                TF_ParameterA_Wert.setText(Beschriftung1);
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        TF_ParameterB_Wert.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (!TF_ParameterB_Wert.hasFocus()) return;
                eingabewerteEinlesen();
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        sl_ParameterB_Wert.addChangeListener(
        new ChangeListener() {
            public void stateChanged(ChangeEvent  e) {
                if (!sl_ParameterB_Wert.hasFocus()) return;
                String Beschriftung1;
                ParameterB_Wert = sl_ParameterB_Wert.getValue()/Genauigkeit;
                Beschriftung1 = df2.format(ParameterB_Wert);
                TF_ParameterB_Wert.setText(Beschriftung1);
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        TF_ParameterC_Wert.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (!TF_ParameterC_Wert.hasFocus()) return;
                eingabewerteEinlesen();
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        sl_ParameterC_Wert.addChangeListener(
        new ChangeListener() {
            public void stateChanged(ChangeEvent  e) {
                if (!sl_ParameterC_Wert.hasFocus()) return;
                String Beschriftung1;
                ParameterC_Wert = sl_ParameterC_Wert.getValue()/Genauigkeit;
                Beschriftung1 = df2.format(ParameterC_Wert);
                TF_ParameterC_Wert.setText(Beschriftung1);
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        TF_Untergrenze.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (!TF_Untergrenze.hasFocus()) return;
                eingabewerteEinlesen();
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        sl_Untergrenze.addChangeListener(
        new ChangeListener() {
            public void stateChanged(ChangeEvent  e) {
                if (!sl_Untergrenze.hasFocus()) return;
                String Beschriftung1;
                Untergrenze_Wert = sl_Untergrenze.getValue()/Genauigkeit;
                Beschriftung1 = df2.format(Untergrenze_Wert);
                TF_Untergrenze.setText(Beschriftung1);
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        TF_Obergrenze.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (!TF_Obergrenze.hasFocus()) return;
                eingabewerteEinlesen();
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        sl_Obergrenze.addChangeListener(
        new ChangeListener() {
            public void stateChanged(ChangeEvent  e) {
                if (!sl_Obergrenze.hasFocus()) return;
                String Beschriftung2;
                Obergrenze_Wert = sl_Obergrenze.getValue()/Genauigkeit;
                Beschriftung2 = df2.format(Obergrenze_Wert);
                TF_Obergrenze.setText(Beschriftung2);
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        // Gre des Eingabebereichs zulassen
        innerContent.setPreferredSize(new Dimension(left*2+width,20));

        // Widgets auf dem Panel plazieren
        innerContent.add(LB_ParameterA_Wert);
        innerContent.add(TF_ParameterA_Wert);
        innerContent.add(sl_ParameterA_Wert);

        innerContent.add(LB_ParameterB_Wert);
        innerContent.add(TF_ParameterB_Wert);
        innerContent.add(sl_ParameterB_Wert);

        innerContent.add(LB_ParameterC_Wert);
        innerContent.add(TF_ParameterC_Wert);
        innerContent.add(sl_ParameterC_Wert);

        innerContent.add(LB_Untergrenze);
        innerContent.add(TF_Untergrenze);
        innerContent.add(sl_Untergrenze);

        innerContent.add(LB_Obergrenze);
        innerContent.add(TF_Obergrenze);
        innerContent.add(sl_Obergrenze);

        innerContent.add(Logo);
    }

    /**
     * Methode delete dient dazu eine Eingabe aus dem Speicher aufzulsen
     *
     * @param Fenster	Fenster auf dem die Elemente plaziert sind
     */
    public void delete(JFrame Fenster) {
        // Eingabefelder freigeben
        innerContent.remove(LB_ParameterA_Wert);
        innerContent.remove(TF_ParameterA_Wert);
        innerContent.remove(sl_ParameterA_Wert);

        innerContent.remove(LB_ParameterB_Wert);
        innerContent.remove(TF_ParameterB_Wert);
        innerContent.remove(sl_ParameterB_Wert);

        innerContent.remove(LB_ParameterC_Wert);
        innerContent.remove(TF_ParameterC_Wert);
        innerContent.remove(sl_ParameterC_Wert);

        innerContent.remove(LB_Untergrenze);
        innerContent.remove(TF_Untergrenze);
        innerContent.remove(sl_Untergrenze);

        innerContent.remove(LB_Obergrenze);
        innerContent.remove(TF_Obergrenze);
        innerContent.remove(sl_Obergrenze);

        innerContent.remove(Logo);

        // Referenzen lschen
        LB_ParameterA_Wert = null;
        LB_ParameterB_Wert = null;
        LB_ParameterC_Wert = null;
        LB_Untergrenze = null;
        LB_Obergrenze = null;
        innerContent.remove(Logo);

        TF_ParameterA_Wert = null;
        TF_ParameterB_Wert = null;
        TF_ParameterC_Wert = null;
        TF_Untergrenze = null;
        TF_Obergrenze = null;

        sl_ParameterA_Wert = null;
        sl_ParameterB_Wert = null;
        sl_ParameterC_Wert = null;
        sl_Untergrenze = null;
        sl_Obergrenze = null;

        // selbst auflsen
        Fenster.getContentPane().remove(innerContent);
        innerContent = null;
        Zeichenbereich1 = null;
        Zeichenbereich2 = null;
    }

    /**
     * setzt den ParameterA-Wert von aussen
     *
     * @param wert	Neuer ParameterA-Wert
     */
    public void setParameterA_Wert(double wert) {
        ParameterA_Wert = wert;
        String Beschriftung = df2.format(ParameterA_Wert);
        TF_ParameterA_Wert.setText(Beschriftung);
        sl_ParameterA_Wert.setValue( (int) (ParameterA_Wert*Genauigkeit) );
    }

    /**
     * setzt den ParameterB-Wert von aussen
     *
     * @param wert	Neuer ParameterB-Wert
     */
    public void setParameterB_Wert(int wert) {
        ParameterB_Wert = wert;
        String Beschriftung = df2.format(ParameterB_Wert);
        TF_ParameterB_Wert.setText(Beschriftung);
        sl_ParameterB_Wert.setValue( (int) (ParameterB_Wert * Genauigkeit) );
    }

    /**
     * setzt den ParameterC-Wert von aussen
     *
     * @param wert	Neuer ParameterC-Wert
     */
    public void setParameterC_Wert(int wert) {
        ParameterC_Wert = wert;
        String Beschriftung = df2.format(ParameterC_Wert);
        TF_ParameterC_Wert.setText(Beschriftung);
        sl_ParameterC_Wert.setValue( (int) (ParameterC_Wert*Genauigkeit) );
    }

    /**
     * setzt den Untergrenze-Wert
     *
     * @param x	Neue Untergrenze
     */
    public void setUntergrenze(double x) {
        // Abfangen der unzulssigen Werte
        Untergrenze_Wert = x;
        if (Untergrenze_Wert > -3.98 && Untergrenze_Wert < 3.98) {
            sl_Untergrenze.setValue( (int)(Genauigkeit*Untergrenze_Wert) );
            String Beschriftung1;
            Beschriftung1 = df2.format(Untergrenze_Wert);
            TF_Untergrenze.setText(Beschriftung1);
        } else if (Untergrenze_Wert > 3.98) {
            sl_Untergrenze.setValue( (int)(Genauigkeit*3.98) );
            String Beschriftung1;
            Beschriftung1 = df2.format(3.98);
            TF_Untergrenze.setText(Beschriftung1);
            Untergrenze_Wert = 3.98;
        } else {
            sl_Untergrenze.setValue( (int)(Genauigkeit*-3.98) );
            String Beschriftung1;
            Beschriftung1 = df2.format(-3.98);
            TF_Untergrenze.setText(Beschriftung1);
            Untergrenze_Wert = -3.98;
        }
        if (Zeichenbereich1 != null) Zeichenbereich1.Dorepaint();
        if (Zeichenbereich2 != null) Zeichenbereich2.Dorepaint();
    }

    /**
     * liefert den Wert des ParameterA
     *
     * @return derzeitiger ParameterA
     */
    public double getParameterA_Wert() {
        return ParameterA_Wert ;
    }

    /**
     * liefert den Wert des ParameterB
     *
     * @return derzeitiger ParameterB
     */
    public double getParameterB_Wert() {
        return ParameterB_Wert;
    }

    /**
     * liefert den Wert des ParameterC
     *
     * @return derzeitiger ParameterC
     */
    public double getParameterC_Wert() {
        return ParameterC_Wert;
    }

    /**
     * liefert den Wert des Untergrenze_Wertes
     *
     * @return derzeitiger Untergrenze_Wert
     */
    public double getUntergrenze() {
        return Untergrenze_Wert;
    }

    /**
     * setzt die Zeichenbereiche
     *
     * @param z	Zeichenbereich
     */
    public void setZeichenbereich(ZeichenbereichSinusH z) {
        if (Zeichenbereich1==null)
            Zeichenbereich1=z;
        else
            Zeichenbereich2=z;
    }

    /**
     * liefert den Obergrenze-Wert
     *
     * @return derzeitiger Abgriff
     */
    public double getObergrenze() {
        return	Obergrenze_Wert;
    }

    /**
     * setzt den Obergrenze-Wert
     *
     * @param x	Neue Obergrenze
     */
    public void setObergrenze(double x) {
        // Abfangen der unzulssigen Werte
        Obergrenze_Wert = x;
        if (Obergrenze_Wert > -3.98 && Obergrenze_Wert < 3.98) {
            sl_Obergrenze.setValue( (int)(Genauigkeit*Obergrenze_Wert) );
            String Beschriftung1;
            Beschriftung1 = df2.format(Obergrenze_Wert);
            TF_Obergrenze.setText(Beschriftung1);
        } else if (Obergrenze_Wert > 3.98) {
            sl_Obergrenze.setValue( (int)(Genauigkeit*3.98) );
            String Beschriftung1;
            Beschriftung1 = df2.format(3.98);
            TF_Obergrenze.setText(Beschriftung1);
            Obergrenze_Wert = 3.98;
        } else {
            sl_Obergrenze.setValue( (int)(Genauigkeit*-3.98) );
            String Beschriftung1;
            Beschriftung1 = df2.format(-3.98);
            TF_Obergrenze.setText(Beschriftung1);
            Obergrenze_Wert = -3.98;
        }
        if (Zeichenbereich1 != null) Zeichenbereich1.Dorepaint();
        if (Zeichenbereich2 != null) Zeichenbereich2.Dorepaint();
    }

    /**
     * fgt die Eingabeleiste auf einem Fenster ein
     *
     * @param Fenster	Fenster auf dem die Leiste eingefgt werden soll
     */
    public void addToFrame(JFrame Fenster) {
        Fenster.getContentPane().add(innerContent, BorderLayout.WEST);
    }

    /**
     * bernimmt alle Werte bei der Texteingabe
     */
    private void eingabewerteEinlesen() {
        // ParameterA
        {
            String Hilf = TF_ParameterA_Wert.getText();
            ParameterA_Wert = Double.parseDouble(Hilf.replace(',','.'));
            // ungltige Werte nicht zulassen
            if (ParameterA_Wert < -2.5 ) {
                ParameterA_Wert = 2.50;
                TF_ParameterA_Wert.setText("-2,50");
            }
            if (ParameterA_Wert > 2.5 ) {
                ParameterA_Wert = 2.50;
                TF_ParameterA_Wert.setText("2,50");
            }
            sl_ParameterA_Wert.setValue( (int)(Genauigkeit*ParameterA_Wert) );
        }

        // ParameterB
        {
            String Hilf = TF_ParameterB_Wert.getText();
            ParameterB_Wert = Double.parseDouble(Hilf.replace(',','.'));
            // ungltige Werte nicht zulassen
            if (ParameterB_Wert < -2.5 ) {
                ParameterB_Wert = -2.5;
                TF_ParameterB_Wert.setText("-2,50");
            }
            if (ParameterB_Wert > 2.5 ) {
                ParameterB_Wert = 2.50;
                TF_ParameterB_Wert.setText("2,50");
            }
            sl_ParameterB_Wert.setValue( (int) (Genauigkeit*ParameterB_Wert) );
        }

        // ParameterC
        {
            String Hilf = TF_ParameterC_Wert.getText();
            ParameterC_Wert = Double.parseDouble(Hilf.replace(',','.'));
            // ungltige Werte nicht zulassen
            if (ParameterC_Wert < -3 ) {
                ParameterC_Wert = -3;
                TF_ParameterC_Wert.setText("-3,00");
            }
            if (ParameterC_Wert > 3 ) {
                ParameterC_Wert = 3;
                TF_ParameterC_Wert.setText("3,00");
            }
            sl_ParameterC_Wert.setValue( (int) (Genauigkeit * ParameterC_Wert) );
        }

        // Obergrenze
        {
            String Hilf = TF_Obergrenze.getText();
            Obergrenze_Wert = Double.parseDouble(Hilf.replace(',','.'));
            // ungltige Werte nicht zulassen
            if (Obergrenze_Wert < -3.98 ) {
                Obergrenze_Wert = -3.98;
                TF_Obergrenze.setText("-3,98");
            }
            if (Obergrenze_Wert > 3.98 ) {
                Obergrenze_Wert = 3.98;
                TF_Obergrenze.setText("3,98");
            }
            sl_Obergrenze.setValue( (int) (Genauigkeit * Obergrenze_Wert) );
        }

        // Untergrenze
        {
            String Hilf = TF_Untergrenze.getText();
            Untergrenze_Wert = Double.parseDouble(Hilf.replace(',','.'));
            // ungltige Werte nicht zulassen
            if (Untergrenze_Wert < -3.98 ) {
                Untergrenze_Wert = -3.98;
                TF_Untergrenze.setText("-3,98");
            }
            if (Untergrenze_Wert > 3.98 ) {
                Untergrenze_Wert = 3.98;
                TF_Untergrenze.setText("3,98");
            }
            sl_Untergrenze.setValue( (int) (Genauigkeit * Untergrenze_Wert) );
        }
    }
}