package Parmeterdarstellung;


import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.InputEvent;
import java.net.MalformedURLException;
import java.net.URL;

import javax.swing.JApplet;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.KeyStroke;

/**
 * Die Klasse Fenstermenue erzeugt ein Men.
 * Verschiedene Menpunkte werden eingetragen.
 * @author Pascal Klipstein 15/11/2007
 */


public class Menuleiste {
    // die Unterpunkte im Men
    private JCheckBoxMenuItem item_s, item_c, item_p;

    /**
     * Referenz auf das Applet
     */
    private JApplet applet = null;



    /**
     *
     * Der Konstruktor
     * bergabe Fenster in der das Men plaziert werden soll, und Appleteigenschaft j/n
     *
     * @param Fenster 	Fenster zu dem das Men hinzugefgt werden soll
     * @param IsApplet	Ist die Anwendung ein Applet
     */
    public Menuleiste( final JFrame Fenster, final boolean IsApplet,  JApplet a) {
        // Die Menleiste
        JMenuBar mbar;
        // Die Hauptpunkte
        JMenu menuDatei, menuFunktionen, menuHilfe;
        // Die unterpunkte konstruieren die Menzeile
        JMenuItem item;

        // Referenz fr Aplet laden
        applet = a;

        // Hauptmen einrichten
        mbar = new JMenuBar();
        menuDatei = Menuleiste.addMenuBarItem( mbar, "_Datei" );
        menuFunktionen = Menuleiste.addMenuBarItem( mbar, "_Funktionen" );
        menuHilfe = Menuleiste.addMenuBarItem( mbar, "?" );


        // Eintrge fr Datei
        item = Menuleiste.addMenuItem( menuDatei, "_Beenden", 'B' );
        item.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e ) {
                if (!IsApplet)
                    System.exit(0);
                else
                    Fenster.setVisible(false);
            }
        }
        );


        // Eintrge fr Verteilungsfunktionen
        item_s = Menuleiste.addMenuItem1( menuFunktionen, "_x= a cos (bt) | y= sin (ct)", '1' );
        item_s.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e ) {
                item_s.setState(true);
                item_c.setState(false);
                item_p.setState(false);
                Parameter.setToolbarFunktionsart(0);
            }
        }
        );
        item_c = Menuleiste.addMenuItem1( menuFunktionen, "_x= at | y= b cos (ct+d)", '2' );
        item_c.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e ) {
                item_s.setState(false);
                item_c.setState(true);
                item_p.setState(false);
                Parameter.setToolbarFunktionsart(1);
            }
        }
        );
        item_p = Menuleiste.addMenuItem1( menuFunktionen, "_x= at | y= ct + dt ", '3' );
        item_p.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e ) {
                item_s.setState(false);
                item_c.setState(false);
                item_p.setState(true);
                Parameter.setToolbarFunktionsart(2);
            }
        }
        );

        /**			if (IsApplet)
        				{
        				// HTML - Anleitung
        				item = Menuleiste.addMenuItem( menuHilfe, "_HTML-Hilfe", 'H' );
        				item.addActionListener(
        					    		new ActionListener()
        					    			{
        					          		public void actionPerformed( ActionEvent e )
        					          		{
        								try
        									{
        									URL page = new URL(applet.getCodeBase(),"./anleitung.htm");
        									applet.getAppletContext().showDocument(page, "_blank");
        									}
        								catch (MalformedURLException evt)
        									{
        									evt.printStackTrace();
        									}
        					          		}
        					        	}
        						);
        				}

        */
        // Eintrge fr Hilfe
        Menuleiste.addMenuItem( menuHilfe, "ber dieses Applet", actionShowAbout );


        // Men abschlieen
        Fenster.setJMenuBar( mbar );

        item_s.setState(true);
    }



    /**
     * Setzt die gewnschte Darstellungsart im Men
     *
     * @param nr der Funktion
     */
    public void setFunktionsart(int nr) {
        item_s.setState(false);
        item_c.setState(false);
        item_p.setState(false);

        switch (nr) {
        case 0:
            item_s.setState(true);
            break;
        case 1:
            item_c.setState(true);
            break;
        case 2:
            item_p.setState(true);
            break;
        }
    }


    // event Handler fr die Ereignisse

    //fr "ber..."
    ActionListener actionShowAbout = new ActionListener() {
        public void actionPerformed( ActionEvent e ) {
            AboutDlg aboutdlg = new AboutDlg();
            aboutdlg.showInfoDlg();
        }
    };



    // und fr den Rest
    ActionListener actionProcCmd = new ActionListener() {
        public void actionPerformed( ActionEvent e ) {
        }
    };


//	Ab hier folgen vorgefertigte Funktionen die Metoden fr Meneintrge zur verfgung stellen


    /**
     * Add an element to the menubar.
     *
     * @param    menuBar             a  JMenuBar
     * @param    s                   a  String
     *
     * @return   added JMenu
     *
     */
    public static JMenu addMenuBarItem( JMenuBar menuBar, String s ) {
        JMenu menu;

        if ( s.indexOf("_") > -1 ) {
            int pos = s.indexOf("_");
            char c = s.charAt( pos+1 );
            StringBuffer sb = new StringBuffer(s).delete(pos,pos+1);
            menu =  new JMenu( sb.toString() );
            menu.setMnemonic( c );
        } else
            menu = new JMenu( s );

        menuBar.add( menu );
        return menu;
    }


    private static JMenuItem processMnemonic( String s ) {
        if ( s.indexOf("_") > -1 ) {
            int pos = s.indexOf("_");
            char c = s.charAt( pos+1 );
            StringBuffer sb = new StringBuffer(s).delete(pos,pos+1);
            return new JMenuItem( sb.toString(), c );
        } else
            return new JMenuItem( s );
    }

    /**
      * Insert a JMenuItem to a given JMenu.
      *
      * @param    m                   a  JMenu
      * @param    s                   a  String
      * @param    keyChar             a  char
      * @param    al                  an ActionListener
      *
      * @return   a JMenuItem
      */
    public static JMenuItem addMenuItem( JMenu m, String s, char keyChar,
                                         ActionListener al ) {
        if ( s.startsWith("-") ) {
            m.addSeparator();
            return null;
        }

        JMenuItem menuItem = processMnemonic( s );

        m.add( menuItem  );

        if ( keyChar != 0 )
            menuItem.setAccelerator(
                KeyStroke.getKeyStroke(keyChar, InputEvent.CTRL_MASK) );

        if ( al != null )
            menuItem.addActionListener( al );

        return menuItem;
    }

    private static JCheckBoxMenuItem processMnemonic1( String s ) {
        if ( s.indexOf("_") > -1 ) {
            int pos = s.indexOf("_");
            StringBuffer sb = new StringBuffer(s).delete(pos,pos+1);
            //  return new JCheckBoxMenuItem( sb.toString(), c );
            return new JCheckBoxMenuItem( sb.toString());
        } else
            return new JCheckBoxMenuItem( s );
    }

    /**
     * Insert a JMenuItem to a given JMenu.
     *
     * @param    m                   a  JMenu
     * @param    s                   a  String
     * @param    keyChar             a  char
     * @param    al                  an ActionListener
     *
     * @return   a JCheckBoxMenuItem
     */
    public static JCheckBoxMenuItem addMenuItem1( JMenu m, String s, char keyChar,
            ActionListener al ) {
        if ( s.startsWith("-") ) {
            m.addSeparator();
            return null;
        }

        JCheckBoxMenuItem menuItem = processMnemonic1( s );

        m.add( menuItem  );

        if ( keyChar != 0 )
            menuItem.setAccelerator(
                KeyStroke.getKeyStroke(keyChar, InputEvent.CTRL_MASK) );

        if ( al != null )
            menuItem.addActionListener( al );

        return menuItem;
    }



    public static JMenuItem addMenuItem( JMenu m, String s, char c ) {
        return addMenuItem( m, s, c, null );
    }

    public static JCheckBoxMenuItem addMenuItem1( JMenu m, String s, char c ) {
        return addMenuItem1( m, s, c, null );
    }



    public static JMenuItem addMenuItem( JMenu m, String s ) {
        return addMenuItem( m, s, (char)0, null );
    }

    public static JMenuItem addMenuItem( JMenu m, String s,
                                         ActionListener al ) {
        return addMenuItem( m, s, (char)0, al );
    }
}




