package Parmeterdarstellung;

import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;

import javax.swing.ImageIcon;
import javax.swing.JApplet;
import javax.swing.JFrame;
import javax.swing.UIManager;

import javax.imageio.ImageIO;
import java.io.IOException;

/**
 * Klasse Parameter
 * Enthlt Einstiegspunkt fr das Java-Programm
 * Erzeugt das Hauptfenster
 * @author Pascal Klipstein 15/11/2007
 */


public class Parameter extends javax.swing.JFrame {

    /**
     *
     */
    private static final long serialVersionUID = 1L;

    /**
     * Hauptfenster
     */
    private static JFrame Hauptfenster;

    /**
     * Thread welcher das Fenster nach festgelegter Zeit neu zeichnet
     */
    private static RepaintThread thread;

    /**
     * legt fest ob Applet oder nicht
     */
    private static boolean IsApplet = true;

    /**
     * Zeiger auf Logos
     */
    private static ImageIcon iconLogo = null;
    private static ImageIcon symbolPressedLogo[];
    private static ImageIcon symbolUnPressedLogo[];

    /**
     * Iconleiste
     */
    private static Toolbar toolbar  = null;

    /**
     * Men
     */
    private static Menuleiste Menuleiste = null;

    /**
     * Standart Fenstergre
     */
    private static final int groesseHauptfenster_X = 830;


    /**
     * Referenz auf das Applet
     */
    private static JApplet applet = null;

    //---------------------------------------------------------------------------


    /**
     * leifert Zeiger auf Logo
     */
    public static ImageIcon getIconLogo() {
        return iconLogo;
    }

    /**
     * leifert Zeiger auf gedrcktes Symbol
     */
    public static ImageIcon getsymbolPressedLogo(int nr) {
        return symbolPressedLogo[nr];
    }

    /**
     * leifert Zeiger auf nicht gedrcktes Symbol
     */
    public static ImageIcon getsymbolUnPressedLogo(int nr) {
        return symbolUnPressedLogo[nr];
    }


    /**
     * Einsprungspunkt fr java Programme
     *
     * @param args Argumente (werden nicht bercksichtigt)
     */
    public static void main( String args[] ) {
        // kein Applet
        IsApplet = false;

        // Icon Arrays anlegen
        symbolPressedLogo = new ImageIcon[4];
        symbolUnPressedLogo = new ImageIcon[4];
		
		try{
			symbolPressedLogo[0] = new ImageIcon(ImageIO.read(Parameter.class.getResourceAsStream("/images/formel1_klein_aktiv.gif")));
			symbolUnPressedLogo[0] = new ImageIcon(ImageIO.read(Parameter.class.getResourceAsStream("/images/formel1_klein_aktiv.gif")));
			symbolPressedLogo[1] = new ImageIcon(ImageIO.read(Parameter.class.getResourceAsStream("/images/formel2_klein_aktiv.gif")));
			symbolUnPressedLogo[1] = new ImageIcon(ImageIO.read(Parameter.class.getResourceAsStream("/images/formel2_klein_aktiv.gif")));
			symbolPressedLogo[2] = new ImageIcon(ImageIO.read(Parameter.class.getResourceAsStream("/images/formel3_klein_aktiv.gif")));
			symbolUnPressedLogo[2] = new ImageIcon(ImageIO.read(Parameter.class.getResourceAsStream("/images/formel3_klein_aktiv.gif")));


			// iconLogo laden
			iconLogo = new ImageIcon(ImageIO.read(Parameter.class.getResourceAsStream("/images/logo_1.png")));

			// Icons laden
			symbolPressedLogo[0] = new ImageIcon(ImageIO.read(Parameter.class.getResourceAsStream("/images/formel1_klein_aktiv.gif")));
			symbolUnPressedLogo[0] = new ImageIcon(ImageIO.read(Parameter.class.getResourceAsStream("/images/formel1_klein_inaktiv.gif")));
			symbolPressedLogo[1] = new ImageIcon(ImageIO.read(Parameter.class.getResourceAsStream("/images/formel2_klein_aktiv.gif")));
			symbolUnPressedLogo[1] = new ImageIcon(ImageIO.read(Parameter.class.getResourceAsStream("/images/formel2_klein_inaktiv.gif")));
			symbolPressedLogo[2] = new ImageIcon(ImageIO.read(Parameter.class.getResourceAsStream("/images/formel3_klein_aktiv.gif")));
			symbolUnPressedLogo[2] = new ImageIcon(ImageIO.read(Parameter.class.getResourceAsStream("/images/formel3_klein_inaktiv.gif")));
		}catch(IOException IOE){
		}

        // starten
        Haupt_Programm();
    }



    /**
     * Einsprungspunkt fr javaApplets
     *
     * @param a Referenz des Applets
     */
    public void main1(JApplet a) {
        // Logo kommt vom Applet

        iconLogo = StartApplet.getIconLogo();
        symbolPressedLogo = StartApplet.getsymbolPressedLogo();
        symbolUnPressedLogo = StartApplet.getsymbolUnPressedLogo();


        // Icon Arrays anlegen
        symbolPressedLogo = new ImageIcon[5];
        symbolUnPressedLogo = new ImageIcon[5];


        try{
			symbolPressedLogo[0] = new ImageIcon(ImageIO.read(Parameter.class.getResourceAsStream("/images/formel1_klein_aktiv.gif")));
			symbolUnPressedLogo[0] = new ImageIcon(ImageIO.read(Parameter.class.getResourceAsStream("/images/formel1_klein_aktiv.gif")));
			symbolPressedLogo[1] = new ImageIcon(ImageIO.read(Parameter.class.getResourceAsStream("/images/formel2_klein_aktiv.gif")));
			symbolUnPressedLogo[1] = new ImageIcon(ImageIO.read(Parameter.class.getResourceAsStream("/images/formel2_klein_aktiv.gif")));
			symbolPressedLogo[2] = new ImageIcon(ImageIO.read(Parameter.class.getResourceAsStream("/images/formel3_klein_aktiv.gif")));
			symbolUnPressedLogo[2] = new ImageIcon(ImageIO.read(Parameter.class.getResourceAsStream("/images/formel3_klein_aktiv.gif")));


			// iconLogo laden
			iconLogo = new ImageIcon(ImageIO.read(Parameter.class.getResourceAsStream("/images/logo_1.png")));

			// Icons laden
			symbolPressedLogo[0] = new ImageIcon(ImageIO.read(Parameter.class.getResourceAsStream("/images/formel1_klein_aktiv.gif")));
			symbolUnPressedLogo[0] = new ImageIcon(ImageIO.read(Parameter.class.getResourceAsStream("/images/formel1_klein_inaktiv.gif")));
			symbolPressedLogo[1] = new ImageIcon(ImageIO.read(Parameter.class.getResourceAsStream("/images/formel2_klein_aktiv.gif")));
			symbolUnPressedLogo[1] = new ImageIcon(ImageIO.read(Parameter.class.getResourceAsStream("/images/formel2_klein_inaktiv.gif")));
			symbolPressedLogo[2] = new ImageIcon(ImageIO.read(Parameter.class.getResourceAsStream("/images/formel3_klein_aktiv.gif")));
			symbolUnPressedLogo[2] = new ImageIcon(ImageIO.read(Parameter.class.getResourceAsStream("/images/formel3_klein_inaktiv.gif")));
		}catch(IOException IOE){
		}

        applet = a;

        // starten
        Haupt_Programm();

    }


    /**
     * eigentlicher Einsprungspunkt fr's Programm
     */
    private static void Haupt_Programm(  ) {

        // Look & Feel einstellen
        try {
            UIManager.setLookAndFeel( UIManager.getCrossPlatformLookAndFeelClassName() );
            UIManager.setLookAndFeel( "javax.swing.plaf.metal.MetalLookAndFeel" );
            UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
//			    UIManager.setLookAndFeel( "com.l2fprod.gui.plaf.skin.SkinLookAndFeel" );
            UIManager.setLookAndFeel( UIManager.getSystemLookAndFeelClassName() );
        } catch ( Exception e ) {
            e.printStackTrace();
        }

        // Hauptfenster erzeugen
        Hauptfenster = new JFrame( "Parameterdarstellung von Kurven" );

        // Java Programme sofort beenden
        if (!IsApplet) Hauptfenster.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );

        // Tool Bar erzeugen und zum Fenster hinzufgen
        toolbar = new Toolbar(Hauptfenster, IsApplet);
        toolbar.addToFrame();

        //Menu erzeugen
        Menuleiste = new Menuleiste(Hauptfenster, IsApplet, applet);

        // Gre vom Hauptfenster festlegen
        Hauptfenster.setSize( groesseHauptfenster_X  , groesseHauptfenster_X *3/4);

        // Minimale Gre des Hauptfensters festlegen
        Hauptfenster.setMinimumSize(new java.awt.Dimension(403, 257));

        // Hauptfenster in Bildschirmmitte positionieren
        Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
        int xPos = dim.width/2 - Hauptfenster.getWidth()/2;
        int yPos = dim.height/2 - Hauptfenster.getHeight()/2;
        Hauptfenster.setLocation(xPos, yPos);

        // bei Grennderung neu zeichnen
        Hauptfenster.addComponentListener(
            new ComponentAdapter()

        {
            public void componentResized( ComponentEvent event ) {
                if ( event.getID() == 	ComponentEvent.COMPONENT_RESIZED ) {
                    if (toolbar != null ) toolbar.doRepaint();
                }
            }
        }
        );


        // repaint Thread erzeugen und starten
        thread= new RepaintThread();
        thread.start();

        // Hauptfenster anzeigen
        Hauptfenster.setVisible( true );
    }


    /**
     * Setzt die gewnschte Darstellungsart auf der Toolbar
     *
     * @param nr Nummer der Funktion
     */
    public static void setToolbarFunktionsart(int nr) {
        if (toolbar != null) toolbar.setFunktionsart(nr);
    }

    /**
     * Setzt die gewnschte Darstellungsart im Men
     *
     * @param nr Nummer der Funktion
     */
    public static void setMenueFunktionsart(int nr) {
        if (Menuleiste != null) Menuleiste.setFunktionsart(nr);
    }





    //*************** T H R E A D ************************************************
    static class RepaintThread extends Thread { //extends javax.swing.JFrame
        public void run () {

            while (!isInterrupted()) {
                if (toolbar != null ) toolbar.doRepaint();

                try {
                    //Prozess schlft fr 5s.
                    Thread.sleep(60000);
                    if (Hauptfenster.isVisible() == false) {
                        thread.interrupt();
                    }

                } catch(InterruptedException e) {
                    thread.interrupt();
                }
            }
        }
    }
}




