
package Parmeterdarstellung;


import java.awt.BorderLayout;
import java.awt.Checkbox;
import java.awt.CheckboxGroup;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
//	import java.awt.event.ItemEvent;
//	import java.awt.event.ItemListener;
import java.text.DecimalFormat;

import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.JTextField;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
 * Die Klasse ParameterEingabe verwaltet die Ein- und Ausgabewerte der
 * 3. Funktion
 *
 * @author Pascal Klipstein 15/11/2007
 */


public class ParameterEingabe_Funktion3 {
    // Legt die Genauigkeit fest
    private double Genauigkeit = 100;

    // Formatierung der Anzeigen
    DecimalFormat df2 = new DecimalFormat( "0.00" );
    DecimalFormat df4 = new DecimalFormat( "0.0000" );


    // Referenzen auf die Zeichenbereiche
    private Zeichenbereich_Funktion3 Zeichenbereich1 = null;
    private Zeichenbereich_Funktion3 Zeichenbereich2 = null;

    // Bereich der in ParameterEingabe verwaltet wird
    private JPanel innerContent = null;

    // Gruppe von Elementen erstellen:
    // Beschriftung, Eingabefeld & Scrollbalken fr df1
    // Beschriftung, Eingabefeld & Scrollbalken fr df2
    // Beschriftung, Eingabefeld & Scrollbalken fr t
    // Beschriftung, Eingabefeld & Scrollbalken fr Abgriff
    // Beschriftung & ComboBox fr Grenzenauswahl
    // RadioButtons fr Grenzenauswahl

    // Labels
    private JLabel LB_VariableA_Wert = null;
    private JLabel LB_VariableB_Wert = null;
    private JLabel LB_VariableC_Wert = null;
    private JLabel LB_Abgriff = null;
    private JLabel LB_Hyperbol = null;

    // Textfelder
    private JTextField TF_VariableA_Wert= null;
    private JTextField TF_VariableB_Wert = null;
    private JTextField TF_VariableC_Wert = null;
    private JTextField TF_Abgriff = null;

    // Slider (Scrollbalken)
    private JSlider sl_VariableA_Wert = null;
    private JSlider sl_VariableB_Wert = null;
    private JSlider sl_VariableC_Wert = null;
    private JSlider sl_Abgriff = null;

    // Grenzenauswahl
    private JComboBox CB_Hyperbol = null;
    private String[] CB_HyperbolWahl = {"trigonometrisch", "hyperbolisch"};

    // Check Boxen
    private CheckboxGroup group = new CheckboxGroup();
    private Checkbox CB_Skalierung_auto = null;
//		private Checkbox CB_Skalierung_fix = null;

    // befindet sich die Grafik bei Drag & Drop?
//		private boolean IsDragging = false;

    // Interne Variablen
    private double VariableA_Wert = 1;
    private double VariableB_Wert = 1;
    private double VariableC_Wert = -1;
    private double Abgriff_Wert = 1;
//		private double Abgriff_Wert_Intern = 1;
    private double YFaktor = 1;


    /**
     * Konstruktor erzeugt die Eingabefelder
     */
    public ParameterEingabe_Funktion3 () {
        String Beschriftung;

        // wir legen alle Elemente auf ein Panel
        innerContent = new JPanel();

        // wir verwenden keinen Layoutmanager
        innerContent.setLayout(null);

        // Erzeugung der Text-Eingabefelder, mit dem jeweiligen Wert und
        // lassen maximal 10 Zeichen zu
        Beschriftung = df2.format(VariableA_Wert);
        TF_VariableA_Wert = new JTextField(Beschriftung,10);

        Beschriftung = df2.format(VariableB_Wert);
        TF_VariableB_Wert = new JTextField(Beschriftung,10);

        Beschriftung = df2.format(VariableC_Wert);
        TF_VariableC_Wert = new JTextField(Beschriftung,10);

        Beschriftung = df2.format(Abgriff_Wert);
        TF_Abgriff = new JTextField(Beschriftung,10);

        // wir erzeugen die Berschriftungslabels
        LB_VariableA_Wert = new JLabel("Koeffizient a:");
        LB_VariableB_Wert = new JLabel("Koeffizient b:");
        LB_VariableC_Wert = new JLabel("Koeffizient c:");
        LB_Hyperbol = new JLabel("Art:");
        LB_Abgriff = new JLabel("t-Wert:");


        // ComboBox erzeugen
        CB_Hyperbol = new JComboBox(CB_HyperbolWahl);
        CB_Hyperbol.setMaximumRowCount(3);

        // Erzeugung der Schieberegler --> JSlider (min, max, value)
        sl_VariableA_Wert = new JSlider(-250,250,(int)(Genauigkeit * VariableA_Wert));
        sl_VariableB_Wert = new JSlider(-500, 500, (int) (Genauigkeit * VariableB_Wert));
        sl_VariableC_Wert = new JSlider(-300, 300, (int) (Genauigkeit * VariableC_Wert));
        sl_Abgriff = new JSlider(-390,390,(int)(Genauigkeit*Abgriff_Wert));


        // Erzeugung der Check Boxen fr die Skalierungsart
        CB_Skalierung_auto = new Checkbox("auto Skalierung", group, true);
//			CB_Skalierung_fix = new Checkbox("fixe Skalierung", group, false);

        // Positionierung der Elemente
        int left = 5;
        int width = 120;
        int height = 21;
        int abstand = 26;
        int top = 7 - abstand;

        // Elementbegrenzungen setzen
        LB_VariableA_Wert.setBounds(left,top+=abstand,width,height);
        TF_VariableA_Wert.setBounds(left,top+=abstand/1.5,width,height);
        sl_VariableA_Wert.setBounds(left,top+=abstand,width,(int)(height));

        top+=abstand*0.1;

        LB_VariableB_Wert.setBounds(left,top+=abstand,width,height);
        TF_VariableB_Wert.setBounds(left,top+=abstand/1.5,width,height);
        sl_VariableB_Wert.setBounds(left,top+=abstand,width,(int)(height));

        top+=abstand*0.1;

        LB_VariableC_Wert.setBounds(left,top+=abstand,width,height);
        TF_VariableC_Wert.setBounds(left,top+=abstand/1.5,width,height);
        sl_VariableC_Wert.setBounds(left,top+=abstand,width,(int)(height));

//			top+=abstand*0.7;
        CB_Skalierung_auto.setBounds(left,top+=2*abstand/3,width,height);
//			CB_Skalierung_fix.setBounds(left,top+=2*abstand/3,width,height);

        top+=abstand*0.3;

        LB_Abgriff.setBounds(left,top+=abstand,width,height);
        TF_Abgriff.setBounds(left,top+=abstand/1.5,width,height);
        sl_Abgriff.setBounds(left,top+=abstand,width,(int)(height));

//			LB_Hyperbol.setBounds(left,top+=abstand,width,height);
//			CB_Hyperbol.setBounds(left,top+=abstand,width,height);

        top+=abstand*2.8;


        /**
         * Reaktion auf die nderung der Eingabefelder
         */
        TF_VariableA_Wert.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (!TF_VariableA_Wert.hasFocus()) return;
                eingabewerteEinlesen();
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
            }
        }
        );



        sl_VariableA_Wert.addChangeListener(
        new ChangeListener() {
            public void stateChanged(ChangeEvent  e) {
                if (!sl_VariableA_Wert.hasFocus()) return;
                String Beschriftung1;
                VariableA_Wert = sl_VariableA_Wert.getValue()/Genauigkeit;
                Beschriftung1 = df2.format(VariableA_Wert);
                TF_VariableA_Wert.setText(Beschriftung1);
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();

            }
        }
        );



        TF_VariableB_Wert.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (!TF_VariableB_Wert.hasFocus()) return;
                eingabewerteEinlesen();

                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();

            }
        }
        );

        sl_VariableB_Wert.addChangeListener(
        new ChangeListener() {
            public void stateChanged(ChangeEvent  e) {
                if (!sl_VariableB_Wert.hasFocus()) return;
                String Beschriftung1;
                VariableB_Wert = sl_VariableB_Wert.getValue()/Genauigkeit;
                Beschriftung1 = df2.format(VariableB_Wert);
                TF_VariableB_Wert.setText(Beschriftung1);
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        TF_VariableC_Wert.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (!TF_VariableC_Wert.hasFocus()) return;
                eingabewerteEinlesen();
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();

            }
        }
        );



        sl_VariableC_Wert.addChangeListener(
        new ChangeListener() {
            public void stateChanged(ChangeEvent  e) {
                if (!sl_VariableC_Wert.hasFocus()) return;
                String Beschriftung1;
                VariableC_Wert = sl_VariableC_Wert.getValue()/Genauigkeit;
                Beschriftung1 = df2.format(VariableC_Wert);
                TF_VariableC_Wert.setText(Beschriftung1);
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
            }
        }
        );


        TF_Abgriff.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (!TF_Abgriff.hasFocus()) return;
                eingabewerteEinlesen();

                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        sl_Abgriff.addChangeListener(
        new ChangeListener() {
            public void stateChanged(ChangeEvent  e) {
                if (!sl_Abgriff.hasFocus()) return;
                String Beschriftung1;
                Abgriff_Wert = sl_Abgriff.getValue()/Genauigkeit;
                Beschriftung1 = df2.format(Abgriff_Wert);
                TF_Abgriff.setText(Beschriftung1);

                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();

            }
        }
        );

        // Gre des Eingabebereichs zulassen
        innerContent.setPreferredSize(new Dimension(left*2+width,20));

        // Widgets auf dem Panel plazieren
        innerContent.add(LB_VariableA_Wert);
        innerContent.add(TF_VariableA_Wert);
        innerContent.add(sl_VariableA_Wert);

        innerContent.add(LB_VariableB_Wert);
        innerContent.add(TF_VariableB_Wert);
        innerContent.add(sl_VariableB_Wert);

        innerContent.add(LB_VariableC_Wert);
        innerContent.add(TF_VariableC_Wert);
        innerContent.add(sl_VariableC_Wert);

        innerContent.add(LB_Abgriff);
        innerContent.add(TF_Abgriff);
        innerContent.add(sl_Abgriff);

        innerContent.add(LB_Hyperbol);
        innerContent.add(CB_Hyperbol);

//			innerContent.add(CB_Skalierung_auto);
//			innerContent.add(CB_Skalierung_fix);
    }


    /**
     * Methode delete dient dazu eine Eingabe aus dem Speicher aufzulsen
     *
     * @param Fenster	Fenster auf dem die Elemente plaziert sind
     */
    public void delete(JFrame Fenster) {
        // Eingabefelder freigeben
        innerContent.remove(LB_VariableA_Wert);
        innerContent.remove(TF_VariableA_Wert);
        innerContent.remove(sl_VariableA_Wert);

        innerContent.remove(LB_VariableB_Wert);
        innerContent.remove(TF_VariableB_Wert);
        innerContent.remove(sl_VariableB_Wert);

        innerContent.remove(LB_VariableC_Wert);
        innerContent.remove(TF_VariableC_Wert);
        innerContent.remove(sl_VariableC_Wert);

        innerContent.remove(LB_Abgriff);
        innerContent.remove(TF_Abgriff);
        innerContent.remove(sl_Abgriff);

        innerContent.remove(LB_Hyperbol);
        innerContent.remove(CB_Hyperbol);

//			innerContent.remove(CB_Skalierung_auto);
//			innerContent.remove(CB_Skalierung_fix);

        // Referenzen lschen
        LB_VariableA_Wert = null;
        LB_VariableB_Wert = null;
        LB_VariableC_Wert = null;
        LB_Abgriff = null;

        TF_VariableA_Wert = null;
        TF_VariableB_Wert = null;
        TF_VariableC_Wert = null;
        TF_Abgriff = null;

        sl_VariableA_Wert = null;
        sl_VariableB_Wert = null;
        sl_VariableC_Wert = null;
        sl_Abgriff = null;

        // selbst auflsen
        Fenster.getContentPane().remove(innerContent);
        innerContent = null;
        Zeichenbereich1 = null;
        Zeichenbereich2 = null;
    }


    /**
     * setzt den Amplituden-Wert von aussen
     *
     * @param wert	Neuer Amplituden-Wert
     */
    public void setAmplitude_Wert(double wert) {
        VariableA_Wert = wert;
        String Beschriftung = df4.format(VariableA_Wert);
        TF_VariableA_Wert.setText(Beschriftung);
        sl_VariableA_Wert.setValue( (int) (VariableA_Wert*Genauigkeit) );
        if (Zeichenbereich1 != null) Zeichenbereich1.Dorepaint();
    }

    /**
     * setzt den Kreisfrequenz-Wert von aussen
     *
     * @param wert	Neuer Kreisfrequenz-Wert
     */
    public void setKreisfrequenz_Wert(int wert) {
        VariableB_Wert = wert;
        String Beschriftung = df4.format(VariableB_Wert);
        TF_VariableB_Wert.setText(Beschriftung);
        sl_VariableB_Wert.setValue( (int) (VariableB_Wert * Genauigkeit) );
    }

    /**
     * setzt den Phasenwinkel-Wert von aussen
     *
     * @param wert	Neuer Phasenwinkel-Wert
     */
    public void setPhasenwinkel_Wert(int wert) {
        VariableC_Wert = wert;
        String Beschriftung = df4.format(VariableC_Wert);
        TF_VariableC_Wert.setText(Beschriftung);
        sl_VariableC_Wert.setValue( (int) (VariableC_Wert*Genauigkeit) );
    }


    /**
     * liefert den Wert der Amplitude
     *
     * @return derzeitige Amplitude
     */
    public double getAmplitude_Wert() {
        return VariableA_Wert ;
    }

    /**
     * liefert den Wert der Kreisfrequenz
     *
     * @return derzeitige Kreisfrequenz
     */
    public double getKreisfrequenz_Wert() {
        // begrenzen auf 250, zwecks Zahlenberlauf
        //	if (Kreisfrequenz_Wert > 250) return 250;
        return VariableB_Wert;
    }
    /**
     * liefert den Wert des Phasenwinkels
     *
     * @return derzeitiger Phasenwinkel
     */
    public double getPhasenwinkel_Wert() {
        // begrenzen auf 250, zwecks Zahlenberlauf
        //	if (Phasenwinkel_Wert > 250) return 250;
        return VariableC_Wert;
    }


    /**
     * berechnet und liefert den YFaktor
     * zur Anpassung der Skalierung
     */
    public double YFaktor(boolean isNormaled) {
        if (!isNormaled)
            YFaktor = 1;
        else {
//			if (Amplitude_Wert * Kreisfrequenz_Wert <= 3)
            YFaktor = 1;
            /**			if (Amplitude_Wert * Kreisfrequenz_Wert >3 && Amplitude_Wert * Kreisfrequenz_Wert <= 6)
            				YFaktor = 0.6; //0.6
            			if (Amplitude_Wert * Kreisfrequenz_Wert >6 && Amplitude_Wert * Kreisfrequenz_Wert <= 12)
            				YFaktor = 0.6; // 0.3
            			if (Amplitude_Wert * Kreisfrequenz_Wert > 12)
            				YFaktor = 0.6; //0.15
            */
        }
        return YFaktor;
    }


    /**
     * setzt die Zeichenbereiche
     *
     * @param z	Zeichenbereich
     */
    public void setZeichenbereich(Zeichenbereich_Funktion3 z) {
        if (Zeichenbereich1==null)
            Zeichenbereich1=z;
        else
            Zeichenbereich2=z;
    }


    /**
     * liefert den Abgriff
     *
     * @return derzeitiger Abgriff
     */
    public double getAbgriff() {
        return	Abgriff_Wert;
    }

    /**
     * setzt den Abgriff
     *
     * @param x	Neuer Abgriff
     */
    public void setAbgriff(double x) {
        // intern genauen Wert verwenden
        Abgriff_Wert = x; //*100d;
//		Abgriff_Wert_Intern = Abgriff_Wert;
        if(Abgriff_Wert > -3.90 && Abgriff_Wert < 3.90) {
            sl_Abgriff.setValue( (int)(Genauigkeit*Abgriff_Wert) );
            String Beschriftung1;
            Beschriftung1 = df2.format(Abgriff_Wert); // / 100d
            TF_Abgriff.setText(Beschriftung1);
        } else if (Abgriff_Wert >3.90) {
            sl_Abgriff.setValue( (int)(Genauigkeit*3.90) );
            String Beschriftung1;
            Beschriftung1 = df2.format(3.90); // / 100d
            TF_Abgriff.setText(Beschriftung1);
            Abgriff_Wert = 3.90;
        } else {
            sl_Abgriff.setValue( (int)(Genauigkeit*-3.90) );
            String Beschriftung1;
            Beschriftung1 = df2.format(-3.90); // / 100d
            TF_Abgriff.setText(Beschriftung1);
            Abgriff_Wert = -3.90;
        }
        if (Zeichenbereich1 != null) Zeichenbereich1.Dorepaint();
        if (Zeichenbereich2 != null) Zeichenbereich2.Dorepaint();
    }


    /**
     * leifert den Zustand der Skalierung fix/auto
     *
     * @return Skalierungsart
     */
    public boolean getFixedSkalierung() {
        return CB_Skalierung_auto.getState();
    }


    /**
     * leifert den Art der Sinusfunktion
     *
     * @return Art der Sinusfunktion
     */
    public int getFunkArt() {
        return CB_Hyperbol.getSelectedIndex();
    }

    /**
     * setzt den Zustand ob verschoben wird
     *
     * @param s	true wenn gerade verschoben wird
     */
    /**	public void setIsDragging(boolean s)
    		{
    		IsDragging = s;
    		}


    	/**
    	 * fgt die Eingabeleiste auf einem Fenster ein
    	 *
    	 * @param Fenster	Fenster auf dem die Leiste eingefgt werden soll
    	 */
    public void addToFrame(JFrame Fenster) {
        Fenster.getContentPane().add(innerContent, BorderLayout.WEST);
    }


    /**
     * bernimmt alle Werte fr die Vorwrtzberechnung
     */
    private void eingabewerteEinlesen() {
        // VariableA Wert
        {
            String Hilf = TF_VariableA_Wert.getText();
            VariableA_Wert = Double.parseDouble(Hilf.replace(',','.'));
            // ungltige Werte nicht zulassen
            if (VariableA_Wert > 2.5 ) {
                VariableA_Wert = 2.5;
                TF_VariableA_Wert.setText("2.50");
            }

            else if (VariableA_Wert<-2.5) {
                VariableA_Wert = -2.5;
                TF_VariableA_Wert.setText("-2.50");
            }

            sl_VariableA_Wert.setValue( (int)(Genauigkeit*VariableA_Wert) );
        }

        // VariableB Wert
        {
            String Hilf = TF_VariableB_Wert.getText();
            VariableB_Wert = Double.parseDouble(Hilf.replace(',','.'));
            // ungltige Werte nicht zulassen
            if (VariableB_Wert > 5.0 ) {
                VariableB_Wert = 5.0;
                TF_VariableB_Wert.setText("5.0");
            }

            else if (VariableB_Wert<-5.0) {
                VariableB_Wert = -5.0;
                TF_VariableB_Wert.setText("-5.0");
            }

            sl_VariableB_Wert.setValue( (int)(Genauigkeit*VariableB_Wert) );
        }

        // VariableC Wert
        {
            String Hilf = TF_VariableC_Wert.getText();
            VariableC_Wert = Double.parseDouble(Hilf.replace(',','.'));
            // ungltige Werte nicht zulassen
            if (VariableC_Wert > 3.0 ) {
                VariableC_Wert = 3.0;
                TF_VariableC_Wert.setText("3.0");
            }

            else if (VariableC_Wert<-3.0) {
                VariableC_Wert = -3.0;
                TF_VariableC_Wert.setText("-3.0");
            }

            sl_VariableC_Wert.setValue( (int)(Genauigkeit*VariableC_Wert) );
        }

//				 Abgriff
        {
            String Hilf = TF_Abgriff.getText();
            Abgriff_Wert = Double.parseDouble(Hilf.replace(',','.'));
            // ungltige Werte nicht zulassen
            if (Abgriff_Wert < -3.90 ) {
                Abgriff_Wert = -3.90;
                TF_Abgriff.setText("-3.90");
            } else if (Abgriff_Wert > 3.90) {
                Abgriff_Wert = 3.90;
                TF_Abgriff.setText("3.90");
            }

            sl_Abgriff.setValue( (int) (Genauigkeit * Abgriff_Wert) );
        }

    }
}




