package Parmeterdarstellung;


//	import java.io.*;

/**
 * Klasse Skalierung
 * bernimmt die Berechnungen fr die Anzeige der 2.Funktion
 * @author Pascal Klipstein
 */
public class Skalierung_Funktion2 {
    // Gre des Zeichenbereichs
    private int Width;
    private int Height;

    //Randbreite
    private int Rand = 20;

    // Breite der Grafik
    private double Breite = 4;

    // bestimmt ob die Darstellung	normiert ist
    private boolean isNormaled;

    // berechnete Werte fr Zeichenbereich
    private double von;
    private double bis;
    private double bereich_werte;
    private int bereich_grafik_X;
    private int bereich_grafik_Y;


    // Umfrechnungsfaktoren fr die Skalierung
    private double Skalierungs_Faktor_X;
    private double Skalierungs_Faktor_Y;
    private double Achsen_Verschiebung_X;

    private double Max_Wert;
    private double Kreisfrequenz;
    private double Amplitude;
    private double Phasenwinkel;
    private double Variable;

    // Nullpunktoffset
    private int Offset_X;
    private int Offset_Y;

    // Referenz auf die Eingaben
    private ParameterEingabe_Funktion2 parameterEingabeS = null;


    /**
     * Konstruktor
     * bernimmt die Parameter fr die Klasse
     * Referenz auf Eingaben und ob Normierte Darstellung
     *
     * @param PE 	Referenz auf das zugehrige Eingabefeld
     */
    public Skalierung_Funktion2(ParameterEingabe_Funktion2 PE, boolean Normaled) {
        // Werte in den internen Variablen ablegen
        parameterEingabeS = PE;
        isNormaled = Normaled;

        // Standardmig Skalierung = 0, so muss sie spter neu berechnet werden
        Skalierungs_Faktor_X = 0;
        Skalierungs_Faktor_Y = 0;
    }


    /**
     * Verlangt zwingend neue Berechnung, mit neuer Skalierung
     *
     * @param x	Breite des Zeichenbereiches
     * @param y	Hhe des Zeichenbereiches
     */
    public void ForceRechnen(int x, int y) {
        // Werte auf 0 setzen, damit sie neu berechnet werden
        Skalierungs_Faktor_X = 0;
        Skalierungs_Faktor_Y = 0;
        // jetzt neue Daten berechnen
        Rechnen(x, y);
    }


    /**
     * Berechnet neue interne Werte
     *
     * @param x	Breite des Zeichenbereiches
     * @param y	Hhe des Zeichenbereiches
     */
    public void Rechnen(int x, int y) {
        Width = x;
        Height = y;

        bereich_grafik_X = Width - Rand * 4 ;
        bereich_grafik_Y = Height - Rand * 4 ;

        // Unterscheidung bei normierter Darstellung
        if (!isNormaled) {
            // nicht normiert
            // Funktionswerte bernehmen
            Variable = parameterEingabeS.getVariable_Wert()*parameterEingabeS.YFaktor(isNormaled);
            Amplitude = parameterEingabeS.getAmplitude_Wert()*parameterEingabeS.YFaktor(isNormaled);//*parameterEingabeS.YFaktor();
            Kreisfrequenz = parameterEingabeS.getKreisfrequenz_Wert()*parameterEingabeS.YFaktor(isNormaled);
            Phasenwinkel = parameterEingabeS.getPhasenwinkel_Wert()*parameterEingabeS.YFaktor(isNormaled);

        } else {
            // normiert
            // Ableitung
            Variable = parameterEingabeS.getVariable_Wert()*parameterEingabeS.YFaktor(isNormaled);
            Amplitude = parameterEingabeS.getAmplitude_Wert()*parameterEingabeS.YFaktor(isNormaled);//*parameterEingabeS.getKreisfrequenz_Wert()*parameterEingabeS.YFaktor();
            Kreisfrequenz = parameterEingabeS.getKreisfrequenz_Wert()*parameterEingabeS.YFaktor(isNormaled);
            Phasenwinkel = parameterEingabeS.getPhasenwinkel_Wert()*parameterEingabeS.YFaktor(isNormaled);//+Math.PI/2;

        }


        // die Y-Achse ist um den Mittelwert verschoben, so steht er immer in der Mitte
        Achsen_Verschiebung_X = 0;

        // Breite links und rechts vom Mittelwert ergeben Zeichengrenzen
        von =  - Breite;
        bis =  + Breite;

        // Bereich ausrechnen
        bereich_werte = (bis - von);

        // X-Skalierung neu berechnen
        if (Skalierungs_Faktor_X==0 ||  parameterEingabeS.getFixedSkalierung()==true) {
            Skalierungs_Faktor_X = bereich_grafik_X / bereich_werte ;
        } else {
            // von und bis mssen entsprechend der fixen Skalierung neu berechnet werden!
            double bereich_werte_neu = bereich_grafik_X / Skalierungs_Faktor_X;
            double Breite_neu = bereich_werte_neu;// / ( 2d*Amplitude);
            von =  - Breite_neu;
            bis =  + Breite_neu;
        }

        // Y-Skalierung neu berechnen
        if ( Skalierungs_Faktor_Y==0 ||  parameterEingabeS.getFixedSkalierung()==true) {
//			Max_Wert =  (parameterEingabeS.getAmplitude_Wert() ); //parameterEingabeS.getKreisfrequenz_Wert() * //2.1 * 1d /
//			if (parameterEingabeS.getFixedSkalierung()==true)

            if (parameterEingabeS.getAmplitude_Wert() <= 3)
                Max_Wert = 5;
            if (parameterEingabeS.getAmplitude_Wert() >3 && parameterEingabeS.getAmplitude_Wert() * parameterEingabeS.getKreisfrequenz_Wert() <= 6)
                Max_Wert = 5;
            if (parameterEingabeS.getAmplitude_Wert() *parameterEingabeS.getKreisfrequenz_Wert() >6 && parameterEingabeS.getAmplitude_Wert ()* parameterEingabeS.getKreisfrequenz_Wert() <= 12)
                Max_Wert = 5;
            if (parameterEingabeS.getAmplitude_Wert() * parameterEingabeS.getKreisfrequenz_Wert() > 12)
                Max_Wert = 5;

            Skalierungs_Faktor_Y = bereich_grafik_Y /2/3;

        } else {
            Max_Wert =5;
            /**
            				// von und bis mssen entsprechend der fixen Skalierung neu berechnet werden!
            				double bereich_werte_neu = bereich_grafik_Y /2/ Skalierungs_Faktor_Y;
            				double Hhe_neu = bereich_werte_neu / ( 2d*Kreisfrequenz*Amplitude);
            				von = Kreisfrequenz*Amplitude - Hhe_neu;
            				bis = Kreisfrequenz*Amplitude + Hhe_neu;
            */
        }

        // Die Offsets geben den Abstand zum Ursprung an
        Offset_X = Width / 2;
        //Offset_Y = Height - 2*Rand;
        Offset_Y = Height/2 +Rand /2 ;
    }

    /**
     * liefert die breite
     *
     * @return Breites des Zeichenbereiches in Pixel
     */
    public int getWidth() {
        return Width;
    }

    /**
     * liefert die hhe
     *
     * @return Hhe des Zeichenbereiches in Pixel
     */
    public int getHeight() {
        return Height;
    }


    /**
     * liefert Position der Y-Achse
     *
     * @return X-Position der Y-Achse in Pixel
     */
    public int getPosYAchse() {
        // Position berechnen
        int Interner_Wert = (int) (Offset_X + Achsen_Verschiebung_X * Skalierungs_Faktor_X);
        // prfen ob ausserhalb und bei Bedarf begrenzen
        if (Interner_Wert > Width-3*Rand) Interner_Wert = Width-3*Rand;
        if (Interner_Wert < 3*Rand) Interner_Wert = 3*Rand;

        return Interner_Wert;
    }


    /**
     * Zeigt an ob Y-Achse versetzt
     *
     * @return 0 wenn nicht versetzt, -1 wenn links versetzt, 1 wenn rechts versetzt
     */
    public int getIfVersetzteYAchse() {
        // Position berechnen
        int Interner_Wert = (int) (Offset_X + Achsen_Verschiebung_X * Skalierungs_Faktor_X);
        // prfen ob ausserhalb und bei Bedarf begrenzen
        if (Interner_Wert > Width-3*Rand) return 1;
        if (Interner_Wert < 3*Rand) return -1;
        // sonst Standartrckgabe, als Kennzeichung fr nicht verschoben
        return 0;
    }

    /**
     * liefert Position der X-Achse
     *
     * @return Y-Position der X-Achse in Pixel
     */
    public int getPosXAchse() {
        return Offset_Y;
    }


    /**
     * liefert die Randbreite
     *
     * @return Breite des Randes in Pixel
     */
    public int getRand() {
        return Rand;
    }


    /**
     * liefert den Abstand der Beschriftungen auf der Achse
     *
     * @return Abstand der Beschriftungen auf der X Achse
     */
    public double getBeschriftungAbstandX() {
        double returnWert;

        returnWert = 35.0/Skalierungs_Faktor_X;

        if (returnWert <= 0.001) return  0.001;
        if (returnWert <= 0.002) return  0.002;
        if (returnWert <= 0.005) return  0.005;
        if (returnWert <= 0.01) return  0.01;
        if (returnWert <= 0.02) return  0.02;
        if (returnWert <= 0.05) return  0.05;
        if (returnWert <= 0.1) return  0.1;
        if (returnWert <= 0.2) return  0.2;
        if (returnWert <= 0.5) return  0.5;
        if (returnWert <= 1) return  1;
        if (returnWert <= 2) return  2;
        if (returnWert <= 5) return  5;
        if (returnWert <= 10) return  10;
        if (returnWert <= 20) return  20;
        if (returnWert <= 50) return  50;

        return returnWert;
    }

    /**
     * liefert den Abstand der Beschriftungen auf der Achse
     *
     * @return Abstand der Beschriftungen auf der Y Achse
     */
    public double getBeschriftungAbstandY() {
        double int_wert = 18/Skalierungs_Faktor_Y/parameterEingabeS.YFaktor(!isNormaled || isNormaled);
        if (int_wert <= 0.001) return 0.001;
        if (int_wert <= 0.002) return 0.002;
        if (int_wert <= 0.005) return 0.005;
        if (int_wert <= 0.01) return 0.01;
        if (int_wert <= 0.02) return 0.02;
        if (int_wert <= 0.05) return 0.05;
        if (int_wert <= 0.10) return 0.10;
        if (int_wert <= 0.20) return 0.20;
        if (int_wert <= 0.50) return 0.50;
        if (int_wert <= 1.00) return 1.00;
        if (int_wert <= 2.00) return 2.00;
        if (int_wert <= 5.00) return 5.00;
        if (int_wert <= 10.00) return 10.00;


        return int_wert;
    }

    /**
     * Liefert den Skalierungsfaktor in X Richtung
     *
     * @return Skalierungsfaktor in X Richtung
     */
    public double getSkalierungs_Faktor_X() {
        return Skalierungs_Faktor_X;
    }

    /**
     * Liefert den Skalierungsfaktor in Y Richtung
     *
     * @return Skalierungsfaktor in Y Richtung
     */
    public double getSkalierungs_Faktor_Y() {
        return Skalierungs_Faktor_Y;
    }


    /**
     * liefert die linke Begrenzung
     *
     * @return Position (Untergrenze) ab der die Kurve dargestellt wird
     */
    public double getVon() {
        return von;
    }

    /**
     * liefert die rechte Begrenzung
     *
     * @return Position (Obergrenze) ab der die Kurve dargestellt wird
     */
    public double getTextBis() {
        return bis;
    }


    /**
     * liefert die linke TextBegrenzung
     *
     * @return Position (Untergrenze) ab der Text dargestellt wird
     */
    public double getTextVon() {
        return von;
    }


    /**
     * liefert die rechte TextBegrenzung
     *
     * @return Position (Obergrenze) ab der Text dargestellt wird
     */
    public double getBis() {
        return bis;
    }


    /**
     * liefert die Y-Textposition zum Y Wert
     *
     * @param value		gewnschte Position des Textes
     *
     * @return zugehriger skalierter Y Wert
     */
    public double getYAchseTextY(double value) {
        return Offset_Y -value* Skalierungs_Faktor_Y;
    }

    /**
     * liefert die X-Textposition zum X Wert
     *
     * @param value		gewnschte Position des Textes
     *
     * @return zugehriger skalierter X Wert
     */
    public double getXAchseTextX(double value) {
        return Offset_X +(value+Achsen_Verschiebung_X)* Skalierungs_Faktor_X;
    }

    /**
     * liefert den X Sinus Wert
     *
     * @param value		gewnschte Position der Kurve (mathematisch)
     *
     * @return zugehriger skalierter X Wert
     */
    public double getSinusWertX(double value) {
        return Offset_X + (value) * Skalierungs_Faktor_X;
    }

    public double getCosinusWertX(double value) {
        return Offset_X + (value) * Skalierungs_Faktor_X;
    }
    /**
     * liefert den Y Sinus Wert
     *
     * @param value		gewnschte Position der Kurve (mathematisch)
     *
     * @return zugehriger skalierter Y Wert (Zeichenbereich)
     */


    public double getSinusWertY(double value) {
        double return_wert;
        //double fi = 1d / (Math.sqrt(2d * Math.PI) * Amplitude ) * Math.exp(-1d/2d* (value-Kreisfrequenz)/Amplitude*((double)value-Kreisfrequenz)/(double)Amplitude);
        return_wert =  Offset_Y - Amplitude* Math.sin(Kreisfrequenz*value+Phasenwinkel) * Skalierungs_Faktor_Y; //
        if (return_wert < Rand) return_wert = -1;
        return return_wert;
    }

    public double getCosinusWertY(double value) {
        double return_wert;
        //double fi = 1d / (Math.sqrt(2d * Math.PI) * Amplitude ) * Math.exp(-1d/2d* (value-Kreisfrequenz)/Amplitude*((double)value-Kreisfrequenz)/(double)Amplitude);
        return_wert =  Offset_Y - Variable*value*value* Skalierungs_Faktor_Y; //
        if (return_wert < Rand) return_wert = -1;
        return return_wert;
    }



    /**
     * liefert maximalen Funktionswert
     *
     * @return Maximaler Funktionswert
     */
    public double getMaxWert() {
        return Max_Wert;
    }


    /**
     * liefert Realen Funktionswert zu einem Wert in der Darstellung
     *
     * @param x 	Wert in der Darstellung
     *
     * @return realer (mathematischer) Funktionswert
     */
    public double getRealXWert(int x) {
        double hilf = ((double)x - (double)Offset_X) / Skalierungs_Faktor_X - Achsen_Verschiebung_X;

//			if (isNormaled)
//				return hilf *parameterEingabe.getStandardabweichung() + parameterEingabe.getRealMittelwert();
//				else
        return hilf ;
    }

    public double getWertY(double value) {
        double return_wert;
        //double fi = 1d / (Math.sqrt(2d * Math.PI) * Amplitude ) * Math.exp(-1d/2d* (value-Kreisfrequenz)/Amplitude*((double)value-Kreisfrequenz)/(double)Amplitude);
        return_wert =  Offset_Y -Amplitude*Math.sin(Kreisfrequenz*value+Phasenwinkel)  * Skalierungs_Faktor_Y;
//		if (return_wert < Rand) return_wert = -1;
        return return_wert;
    }

    public double getWertX(double value) {
        double return_wert;
        //double fi = 1d / (Math.sqrt(2d * Math.PI) * Amplitude ) * Math.exp(-1d/2d* (value-Kreisfrequenz)/Amplitude*((double)value-Kreisfrequenz)/(double)Amplitude);
        return_wert =  Offset_X +(Variable*value*value) * Skalierungs_Faktor_X; //
//		if (return_wert < Rand) return_wert = -1;
        return return_wert;
    }

    public double getWertY1(double value) {
        double return_wert;
        //double fi = 1d / (Math.sqrt(2d * Math.PI) * Amplitude ) * Math.exp(-1d/2d* (value-Kreisfrequenz)/Amplitude*((double)value-Kreisfrequenz)/(double)Amplitude);
        return_wert =   Amplitude*Math.sin(Kreisfrequenz*value+Phasenwinkel) ;
//		if (return_wert < Rand) return_wert = -1;
        return return_wert;
    }

    public double getWertX1(double value) {
        double return_wert;
        //double fi = 1d / (Math.sqrt(2d * Math.PI) * Amplitude ) * Math.exp(-1d/2d* (value-Kreisfrequenz)/Amplitude*((double)value-Kreisfrequenz)/(double)Amplitude);
        return_wert =  Variable*value*value ; //
//		if (return_wert < Rand) return_wert = -1;
        return return_wert;
    }
}

