package Parmeterdarstellung;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JToolBar;

/**
 * Klasse Toolbar
 * Stellt die Button Leiste zur Verfgung
 * Whlt Aufgrund der Buttons eine entsprechende Funktion
 * @author Pascal Klipstein 15/11/2007
 */

public class Toolbar {
    /**
     * Toolbar
     */
    private JToolBar toolBar = null;

    /**
     * die verschiedenen Buttons
     */
    private JButton BT_close = null;
    private JButton BT_Funktion1 = null;
    private JButton BT_Funktion2 = null;
    private JButton BT_Funktion3 = null;


    /**
     * In diesem Panel liegen die Buttons
     */
    private JPanel panel = null;

    /**
     * Referenz auf das bergeordnete Hauptfenster
     */
    private JFrame Hauptfenster = null;
    private JPanel HauptFensterMitte = null;

    /**
     * Referenzen auf die verschiedenen Eingabebereiche
     */
    private ParameterEingabe_Funktion1 parameterEingabe_Funktion1  = null;
    private ParameterEingabe_Funktion2 parameterEingabe_Funktion2  = null;
    private ParameterEingabe_Funktion3 parameterEingabe_Funktion3  = null;


    /**
     * Referenzen auf die verschiedenen Zeichenbereiche
     */
    private Zeichenbereich_Funktion1 Zeichenbereich11=null;
    private Zeichenbereich_Funktion1 Zeichenbereich12=null;
    private Zeichenbereich_Funktion2 Zeichenbereich21=null;
    private Zeichenbereich_Funktion2 Zeichenbereich22=null;
    private Zeichenbereich_Funktion3 Zeichenbereich31=null;
    private Zeichenbereich_Funktion3 Zeichenbereich32=null;


    /**
     * Konstruktor
     * erzeugt die Toolbar
     *
     * @param HF 		Fenster auf dem die Toolbar eingefgt werden soll
     * @param IsApplet 	true falls Anwendung als Applet luft
     */
    public Toolbar ( final JFrame HF  , final boolean IsApplet  ) {
        // Referenz intern sichern
        Hauptfenster = HF;

        // In den Verschiedenen Regionen des Hauptfensters Panels ablegen
        HauptFensterMitte = new JPanel();
        Hauptfenster.getContentPane().add(HauptFensterMitte,BorderLayout.CENTER );

        // Layout Manager fr dien Mittelteil
        BoxLayout boxLayout =  new BoxLayout(HauptFensterMitte, BoxLayout.Y_AXIS);
        HauptFensterMitte.setLayout(boxLayout);

        // Buttons erzeugen
        BT_close = new JButton("Close");
        // Standartsymbole sind nicht gedrckt
        BT_Funktion1 = new JButton(Parameter.getsymbolUnPressedLogo(0));
        BT_Funktion2 = new JButton(Parameter.getsymbolUnPressedLogo(1));
        BT_Funktion3 = new JButton(Parameter.getsymbolUnPressedLogo(2));

        // Tool Tips
        BT_close.setToolTipText("Close");
        BT_Funktion1.setToolTipText("Funktion 1");
        BT_Funktion2.setToolTipText("Funktion 2");
        BT_Funktion3.setToolTipText("Funktion 3");


        // Aktionen der Buttons
        BT_close.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (!IsApplet)
                    System.exit(0);
                else
                    Hauptfenster.setVisible(false);
            }
        }
        );

        BT_Funktion1.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                panel.setVisible( false );
                remouveVerteilungen();
                addSinus();
                panel.setVisible( true );
            }
        }
        );

        BT_Funktion2.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                panel.setVisible( false );
                remouveVerteilungen();
                addCosinus();
                panel.setVisible( true );
            }
        }
        );
        BT_Funktion3.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                panel.setVisible( false );
                remouveVerteilungen();
                addPolynom();
                panel.setVisible( true );
            }
        }
        );


        // ToolBar selbst erzeugen
        toolBar = new JToolBar();

        // Buttons auf die ToolBar legen
        //toolBar.add(BT_close);
        toolBar.add(BT_Funktion1);
        toolBar.add(BT_Funktion2);
        toolBar.add(BT_Funktion3);

    }


    /**
     * Setzt die gewnschte Darstellungsart auf der Toolbar
     *
     * @param nr der Funktion
     */
    public void setFunktionsart(int nr) {
        panel.setVisible( false );
        // bisherige Verteilungen entfernen
        remouveVerteilungen();
        // neue auswhlen
        switch (nr) {
        case 1:
            addCosinus();
            break;
        case 2:
            addPolynom();
            break;

        default:
            addSinus();
            break;
        }
        panel.setVisible( true );
    }



    /**
     * frgt die Toolbar zum Fenster hinzu
     */
    public void addToFrame() {
        // Panel im Norden des Hauptfensters fr die Buttonleiste plazieren
        panel = new JPanel();
        Hauptfenster.getContentPane().add(panel, BorderLayout.NORTH);

        // Layout bestimmen
        BoxLayout boxLayout =  new BoxLayout(panel, BoxLayout.X_AXIS);
        panel.setLayout(boxLayout);

        // Panel hinzufgen
        panel.add(toolBar);

        // standartmig Standartabweichung laden
        addSinus();
    }



    /**
     * Veranlasst ein Neuzeichenen der Zeichenbereiche
     */
    public void doRepaint() {
        if ( Zeichenbereich11 != null ) Zeichenbereich11.Dorepaint();
        if ( Zeichenbereich12 != null ) Zeichenbereich12.Dorepaint();
        if ( Zeichenbereich21 != null ) Zeichenbereich21.Dorepaint();
        if ( Zeichenbereich22 != null ) Zeichenbereich22.Dorepaint();
        if ( Zeichenbereich31 != null ) Zeichenbereich31.Dorepaint();
        if ( Zeichenbereich32 != null ) Zeichenbereich32.Dorepaint();

    }



    /**
     * entfernt alle Zeichenbereiche vom Fenster
     */
    private void remouveVerteilungen() {
        if (Zeichenbereich11 != null) HauptFensterMitte.remove(Zeichenbereich11);
        if (Zeichenbereich12 != null) HauptFensterMitte.remove(Zeichenbereich12);
        if (Zeichenbereich21 != null) HauptFensterMitte.remove(Zeichenbereich21);
        if (Zeichenbereich22 != null) HauptFensterMitte.remove(Zeichenbereich22);
        if (Zeichenbereich31 != null) HauptFensterMitte.remove(Zeichenbereich31);
        if (Zeichenbereich32 != null) HauptFensterMitte.remove(Zeichenbereich32);


        if (Zeichenbereich11 != null) Zeichenbereich11.delete();
        if (Zeichenbereich12 != null) Zeichenbereich12.delete();
        if (Zeichenbereich21 != null) Zeichenbereich21.delete();
        if (Zeichenbereich22 != null) Zeichenbereich22.delete();
        if (Zeichenbereich31 != null) Zeichenbereich31.delete();
        if (Zeichenbereich32 != null) Zeichenbereich32.delete();

        if (parameterEingabe_Funktion1 != null) parameterEingabe_Funktion1.delete(Hauptfenster);
        if (parameterEingabe_Funktion2 != null) parameterEingabe_Funktion2.delete(Hauptfenster);
        if (parameterEingabe_Funktion3 != null) parameterEingabe_Funktion3.delete(Hauptfenster);

        Zeichenbereich11 	= null;
        Zeichenbereich12 	= null;
        Zeichenbereich21 	= null;
        Zeichenbereich22 	= null;
        Zeichenbereich31 	= null;
        Zeichenbereich32 	= null;

        parameterEingabe_Funktion1	= null;
        parameterEingabe_Funktion2	= null;
        parameterEingabe_Funktion3	= null;
    }


    /**
     * frgt die Ein und Ausgabebereiche fr Standardabweichung dem Fenster hinzu
     */
    private void addSinus() {
        BT_Funktion1.setIcon(Parameter.getsymbolPressedLogo(0));
        BT_Funktion2.setIcon(Parameter.getsymbolUnPressedLogo(1));
        BT_Funktion3.setIcon(Parameter.getsymbolUnPressedLogo(2));

        Zeichenbereich11=null;
        Zeichenbereich12=null;
        parameterEingabe_Funktion1=null;

        // Eingabe Anfgen
        parameterEingabe_Funktion1 = new ParameterEingabe_Funktion1();
        parameterEingabe_Funktion1.addToFrame(Hauptfenster);

        Zeichenbereich11 = new Zeichenbereich_Funktion1(parameterEingabe_Funktion1, false);
        Zeichenbereich12 = new Zeichenbereich_Funktion1(parameterEingabe_Funktion1, true);



        HauptFensterMitte.add(Zeichenbereich11);
        HauptFensterMitte.add(Zeichenbereich12);

        // Men aktualisieren
        Parameter.setMenueFunktionsart(0);
    }


    /**
     * frgt die Ein und Ausgabebereiche fr T-Verteilung dem Fenster hinzu
     */
    private void addCosinus() {
        BT_Funktion1.setIcon(Parameter.getsymbolUnPressedLogo(0));
        BT_Funktion2.setIcon(Parameter.getsymbolPressedLogo(1));
        BT_Funktion3.setIcon(Parameter.getsymbolUnPressedLogo(2));

        Zeichenbereich21=null;
        Zeichenbereich22=null;
        parameterEingabe_Funktion2=null;

        // Eingabe Anfgen
        parameterEingabe_Funktion2 = new ParameterEingabe_Funktion2();
        parameterEingabe_Funktion2.addToFrame(Hauptfenster);

        Zeichenbereich21 = new Zeichenbereich_Funktion2(parameterEingabe_Funktion2, false);
        Zeichenbereich22 = new Zeichenbereich_Funktion2(parameterEingabe_Funktion2, true);



        HauptFensterMitte.add(Zeichenbereich21);
        HauptFensterMitte.add(Zeichenbereich22);
        // Men aktualisieren
        Parameter.setMenueFunktionsart(1);
    }


    /**
     * frgt die Ein und Ausgabebereiche fr ChiQuad-Verteilung dem Fenster hinzu
     */
    private void addPolynom() {
        BT_Funktion1.setIcon(Parameter.getsymbolUnPressedLogo(0));
        BT_Funktion2.setIcon(Parameter.getsymbolUnPressedLogo(1));
        BT_Funktion3.setIcon(Parameter.getsymbolPressedLogo(2));

        Zeichenbereich31=null;
        Zeichenbereich32=null;
        parameterEingabe_Funktion3=null;

        // Eingabe Anfgen
        parameterEingabe_Funktion3 = new ParameterEingabe_Funktion3();
        parameterEingabe_Funktion3.addToFrame(Hauptfenster);

        Zeichenbereich31 = new Zeichenbereich_Funktion3(parameterEingabe_Funktion3, false);
        Zeichenbereich32 = new Zeichenbereich_Funktion3(parameterEingabe_Funktion3, true);



        HauptFensterMitte.add(Zeichenbereich31);
        HauptFensterMitte.add(Zeichenbereich32);

        // Men aktualisieren
        Parameter.setMenueFunktionsart(2);
    }
}