package Parmeterdarstellung;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
//	import java.awt.geom.*;
import java.text.*;
//	import java.io.*;

/**
 * Klasse Zeichenbereich
 * Erzeugt den eigentlichen Zeichenbereich auf dem die Grafik dargestellt wird
 * @author Pascal Klipstein  15/11/2007
 * 	 */
public class Zeichenbereich_Funktion3 extends JPanel {
    /**
     *
     */
    private static final long serialVersionUID = 1L;
    // Pfeilgren
    private int Pfeil_laenge = 12;
    private int Pfeil_breite = 3;

    // Referenz auf die Eingabeparameter
    private ParameterEingabe_Funktion3 parameterEingabeS = null;

    // fr das Verschieben der Vertrauensbereiche
    private double Klick_Tolleranz = 0.1;

    // erlaubt Verschieben
    private boolean CanDrag = false;

    // Referenz auf die Skalierungsklasse
    private Skalierung_Funktion3 skalierung = null;

    // bestimmt ob dieser Zeichenbereich normiert dargestellt werden soll
    private boolean IsNormaled = false;

    // bestimmt, ob der Abgriff innerhalb des Zeichenbereichs liegt
    boolean untererPfeilVerwendet = false;
    boolean obererPfeilVerwendet = false;

    double value;

    /**
     * Konstruktor
     * erzeugt neuen Zeichenbereich
     *
     * @param w 	Referenz auf die Eingaben
     */
    public Zeichenbereich_Funktion3(ParameterEingabe_Funktion3 w, boolean isNormaled) {
        // Parameter bernehmen und sichern
        parameterEingabeS = w;
        parameterEingabeS.setZeichenbereich(this);
        IsNormaled = isNormaled;

        // Mausaktionen verwenden
        addMouseListener(new MyMouseListener());
        addMouseMotionListener(new MyMouseMotionListener());

        // neue Skalierungsberechnung erzeugen
        skalierung = new Skalierung_Funktion3(parameterEingabeS, IsNormaled);
    }


    /**
     * lscht den Zeichenbereich
     * und gibt interne Referenzen frei
     */
    public void delete() {
        parameterEingabeS = null;
        skalierung = null;
    }


    /**
     * veranlasst ein neuzeichnen der Visualisierung
     */
    public void Dorepaint() {
        this.repaint();
    }

    /**
     * erzwingt eine Neuberechnung der Skalierung
     */
    public void DoRecalc() {
        skalierung.ForceRechnen(getWidth(), getHeight());
        this.repaint();
    }


    /**
     * Neuzeichnen der Grafik erforderlich
     *
     * @param g 	Graphics Objekt auf die Zeichenflche
     */
    protected void paintComponent( Graphics g) {
        // Referzenz fr 2D Grafik
        Graphics2D g2d = (Graphics2D) g;
        // bergeordnetes Zeichen aktivieren
        super.paintComponent(g);
        // Skalierung aktualisieren
        skalierung.Rechnen(getWidth(), getHeight());
        // einzelne Bereiche neu Zeichnen
        PrintBackground(g);
        PrintAbgriff(g);
        PrintAchsen(g);
        PrintSinusKurve(g);
        PrintFigure (g);

        // bei Normierter Darstellung entsprechende Einblendung
        if (IsNormaled) {
            Stroke OldStoke=g2d.getStroke();
            g2d.setColor(Color.black);
//				g.drawString("Kurve in Parameterdarstellung", 3*skalierung.getRand()/2, 2*skalierung.getRand());
            g2d.setStroke(OldStoke);
        } else

        {
            Font font = new Font ("Arial", Font.PLAIN, 13);
            g.setFont(font);
            g2d.setColor(Color.blue);
            g.drawString("x = at", 3*skalierung.getRand()/2, 2*skalierung.getRand());
            g2d.setColor(Color.red);
            g.drawString("y = bt + ct", 3*skalierung.getRand()/2, 3*skalierung.getRand());
        }
    }


    /**
     * Zeichnet x-Abgriff
     *
     * @param g 	Graphics Objekt auf die Zeichenflche
     */
    private void PrintAbgriff (Graphics g) {
        // Referzenz fr 2D Grafik
        Graphics2D g2d = (Graphics2D) g;

        // Abgriff blau darstellen
        g2d.setColor(Color.ORANGE);

        // dafr einen anderen Stift verwenden
        Stroke OldStoke=g2d.getStroke();

        double lauf;
        int Punkt_x, Punkt_y, Wert_y;

        // x-Abgriff holen
        lauf=parameterEingabeS.getAbgriff();

        // Umrechnen in Grafikkoordinaten
        Punkt_x = (int) skalierung.getSinusWertX(lauf);
//			if (skalierung.getSinusWertY(lauf)<=skalierung.getCosinusWertY(lauf))
//				Wert_y = (int)skalierung.getSinusWertY(lauf);
//			else
        Wert_y = (int)skalierung.getHeight()-2*skalierung.getRand();//(int)skalierung.getCosinusWertY(lauf);
        Punkt_y = Wert_y;
        // Sicherstellen dass darstellbar, sonst Pfeil ausgeben
        if(!IsNormaled && Punkt_x >2*skalierung.getRand()&& Punkt_x < skalierung.getWidth()-2*skalierung.getRand()) {
            if (Punkt_x < skalierung.getWidth()-2*skalierung.getRand()&& Punkt_y > 2*skalierung.getRand()&& Punkt_y < skalierung.getHeight()-2*skalierung.getRand()) {
                if (!IsNormaled) {
                    g2d.setStroke(new BasicStroke(3,BasicStroke.CAP_ROUND, BasicStroke.JOIN_MITER));
                    g.drawLine(Punkt_x, Punkt_y-8, Punkt_x, skalierung.getPosXAchse()+ skalierung.getHeight()/2-2*skalierung.getRand());
                    g2d.setStroke(OldStoke);
                }
            } else {
                g2d.setStroke(new BasicStroke(3,BasicStroke.CAP_ROUND, BasicStroke.JOIN_MITER));
                g.drawLine(Punkt_x, 2*skalierung.getRand()-8, Punkt_x, skalierung.getPosXAchse()+ skalierung.getHeight()/2-2*skalierung.getRand());
                g2d.setStroke(OldStoke);

            }
        }
        // alten Stift wieder einstellen
        g2d.setStroke(OldStoke);

    }


    /**
     * Zeichnet den eigentlichen Verlauf der Kurve
     *
     * @param g 	Graphics Objekt auf die Zeichenflche
     */
    private void PrintSinusKurve (Graphics g) {
        // Referzenz fr 2D Grafik
        Graphics2D g2d = (Graphics2D) g;
        if (!IsNormaled) {
            // Mit Rot Zeichnen
            g2d.setColor(Color.RED);
            g2d.setStroke(new BasicStroke(3,BasicStroke.CAP_ROUND, BasicStroke.JOIN_MITER));
            // Sichtbaren Bereich durchlaufen
            for (double lauf=skalierung.getVon(); lauf < skalierung.getBis(); lauf+=1d/skalierung.getSkalierungs_Faktor_X()) {
                // Koordinaten umrechnen
                int Punkt_x = (int) skalierung.getSinusWertX(lauf);
                int Punkt_y = (int) skalierung.getSinusWertY(lauf);
                if (Punkt_y>0&&Punkt_y<skalierung.getHeight()-skalierung.getRand())
                    g.drawLine(Punkt_x, Punkt_y, Punkt_x, Punkt_y);
            }

            // Mit Blau Zeichnen
            g2d.setColor(Color.BLUE);
            g2d.setStroke(new BasicStroke(3,BasicStroke.CAP_ROUND, BasicStroke.JOIN_MITER));
//			 Sichtbaren Bereich durchlaufen
            for (double lauf=skalierung.getVon(); lauf < skalierung.getBis(); lauf+=1d/skalierung.getSkalierungs_Faktor_X()) {
                // Koordinaten umrechnen
                int Punkt_x = (int) skalierung.getCosinusWertX(lauf);
                int Punkt_y = (int) skalierung.getCosinusWertY(lauf);
                if (Punkt_y>0&&Punkt_y<skalierung.getHeight()-skalierung.getRand())
                    g.drawLine(Punkt_x, Punkt_y, Punkt_x, Punkt_y);
            }
        }

    }

    /**
     * Zeichnet die Achsen
     *
     * @param g 	Graphics Objekt auf die Zeichenflche
     */
    private void PrintAchsen (Graphics g) {
        // Referzenz fr 2D Grafik
        Graphics2D g2d = (Graphics2D) g;
        //if (!IsNormaled)
        {
            // Falls die Y-Achse nicht durch x=0 geht, dies mit Zeichen deutlichmachen
            if (skalierung.getIfVersetzteYAchse()<0) {
                g2d.setColor(Color.BLACK);
                g.drawString("//", (int)(skalierung.getRand()), skalierung.getPosXAchse()+5);
            }
            if (skalierung.getIfVersetzteYAchse()>0) {
                g2d.setColor(Color.BLACK);
                g.drawString("//", (int)(skalierung.getWidth()-skalierung.getRand()), skalierung.getPosXAchse()+5);
            }

            // X-Achse
            g2d.setColor(Color.BLACK);
            g.drawLine(2*skalierung.getRand(), (int)(1*skalierung.getPosXAchse()), skalierung.getWidth()-2*skalierung.getRand(), (int)(1*skalierung.getPosXAchse()));

            // Y-Achse
            g.drawLine(skalierung.getPosYAchse(), 2*skalierung.getRand(), skalierung.getPosYAchse(), skalierung.getHeight()-2*skalierung.getRand());

            // Pfeile an die Achsen
            for (int i=Pfeil_laenge; i>=0; i--) {
                // Oben
                g.drawLine(skalierung.getPosYAchse() - Pfeil_breite, 2*skalierung.getRand(), skalierung.getPosYAchse(), 2*skalierung.getRand()+i-Pfeil_laenge);
                g.drawLine(skalierung.getPosYAchse() + Pfeil_breite, 2*skalierung.getRand(), skalierung.getPosYAchse(), 2*skalierung.getRand()+i-Pfeil_laenge);

                //Rechts
                g.drawLine(skalierung.getWidth()-2*skalierung.getRand(), (int)(1*skalierung.getPosXAchse()-Pfeil_breite), skalierung.getWidth()-2*skalierung.getRand()-i+Pfeil_laenge, (int)(1*skalierung.getPosXAchse()));
                g.drawLine(skalierung.getWidth()-2*skalierung.getRand(), (int)(1*skalierung.getPosXAchse()+Pfeil_breite), skalierung.getWidth()-2*skalierung.getRand()-i+Pfeil_laenge, (int)(1*skalierung.getPosXAchse()));
            }

            // Beschriftungen
            Font Old_font = g.getFont();
            Font font = new Font ("Arial", Font.PLAIN, 13);
            g.setFont(font);
            // X - Achse
            if (!IsNormaled) {
                g.drawString("t", skalierung.getWidth()-2*skalierung.getRand()+5, (int)(1*skalierung.getPosXAchse()+13));
                g.drawString("x         y", skalierung.getPosYAchse()-28, skalierung.getRand()*2);

                //			 Y - Achse
//				g.drawString("y", skalierung.getPosYAchse()-28, skalierung.getRand()*2);
            } else {
                g.drawString("Kurve in Parameterdarstellung", 3*skalierung.getRand()/2, 2*skalierung.getRand());
                g.drawString("y", skalierung.getPosYAchse()-28, skalierung.getRand()*2);
                g.drawString("x", skalierung.getWidth()-2*skalierung.getRand()+5, (int)(1*skalierung.getPosXAchse()+13));
            }
            if (IsNormaled) {
                //	g.drawString("y", skalierung.getPosYAchse()-28, skalierung.getRand()*2);
            }//g.drawString("\u03C6(u)", skalierung.getPosYAchse()-28, skalierung.getRand()*2);
            //		else
//				g.drawString("y", skalierung.getPosYAchse()-28, skalierung.getRand()*2);
            //g.drawString("\u03C6(x)", skalierung.getPosYAchse()-28, skalierung.getRand()*2);

            g.setFont(Old_font);




            // Achsenbeschriftung
            // X - Achsen Beschriftung von 0 .. oo
            for (double lauf=0; lauf <= skalierung.getTextBis()  ; lauf+=skalierung.getBeschriftungAbstandX()) {

                // Formatierung der Achsenbeschriftung
                DecimalFormat df = new DecimalFormat( "0.0" );

                if (skalierung.getBeschriftungAbstandX() >= 10) df = new DecimalFormat( "0" );
                if (skalierung.getBeschriftungAbstandX() <= 1) df = new DecimalFormat( "0.0" );
                if (skalierung.getBeschriftungAbstandX() <= 0.1) df = new DecimalFormat( "0.00" );

                String Beschriftung = df.format(lauf);

                // Platzbedarf fr Schrift ausrechnen
                FontMetrics fm = getFontMetrics(getFont());
                int Beschriftung_Width = fm.stringWidth(Beschriftung);
                int Beschriftung_Height = fm.getHeight();

                // X und Y - Koordinate fr Textausgabe
                int Punkt_x_Text = (int) (skalierung.getXAchseTextX(lauf) - (double)Beschriftung_Width/2d );
                int Punkt_y_Text = (int) (skalierung.getPosXAchse() +  Beschriftung_Height ) ;

                // X - Koordinate fr die Markierungen (ohne Textgrenkorrektur)
                int Punkt_x_Markierung = (int) (skalierung.getXAchseTextX(lauf));

                if (Punkt_x_Markierung>2*skalierung.getRand() && Punkt_x_Markierung<skalierung.getWidth()-2*skalierung.getRand()) {
                    if(lauf!=0) {
                        // Text ausgeben
                        g.drawString(Beschriftung , Punkt_x_Text, (int)(1.0*Punkt_y_Text));

                        // Kleine Markierungen anbringen, wo der Text steht
                        g.drawLine(Punkt_x_Markierung, (int)(1*skalierung.getPosXAchse()-2), Punkt_x_Markierung, (int)(1*skalierung.getPosXAchse()+3));
                    }
                }
            }

            // X - Achsen Beschriftung von -oo .. 0
            for (double lauf=-skalierung.getBeschriftungAbstandX(); lauf > skalierung.getTextVon()  ; lauf-=skalierung.getBeschriftungAbstandX()) {

                // Formatierung der Achsenbeschriftung
                DecimalFormat df = new DecimalFormat( "0.0" );

                if (skalierung.getBeschriftungAbstandX() >= 10) df = new DecimalFormat( "0" );
                if (skalierung.getBeschriftungAbstandX() <= 1) df = new DecimalFormat( "0.0" );
                if (skalierung.getBeschriftungAbstandX() <= 0.1) df = new DecimalFormat( "0.00" );


                String Beschriftung = df.format(lauf);

                // Platzbedarf fr Schrift ausrechnen
                FontMetrics fm = getFontMetrics(getFont());
                int Beschriftung_Width = fm.stringWidth(Beschriftung);
                int Beschriftung_Height = fm.getHeight();

                // X und Y - Koordinate fr Textausgabe
                int Punkt_x_Text = (int) (skalierung.getXAchseTextX(lauf) - (double)Beschriftung_Width/2d );
                int Punkt_y_Text = (int) (skalierung.getPosXAchse() +  Beschriftung_Height) ;

                // X - Koordinate fr die Markierungen (ohne Textgrenkorrektur)
                int Punkt_x_Markierung = (int) (skalierung.getXAchseTextX(lauf));

                if (Punkt_x_Markierung>2*skalierung.getRand() && Punkt_x_Markierung<skalierung.getWidth()-2*skalierung.getRand()) {
                    // Text ausgeben
                    g.drawString(Beschriftung , Punkt_x_Text, (int)(1*Punkt_y_Text));

                    // Kleine Markierungen anbringen, wo der Text steht
                    g.drawLine(Punkt_x_Markierung, (int)(1*skalierung.getPosXAchse()-2), Punkt_x_Markierung, (int)(1*skalierung.getPosXAchse()+3));
                }
            }

            // Y - Achsen Beschriftung von 0 .. oo
            for (double lauf=0; lauf <= 3.2 ; lauf+=skalierung.getBeschriftungAbstandY()) {

                // Formatierung der Achsenbeschriftung
                DecimalFormat df = new DecimalFormat( "0.0" );
                String Beschriftung = df.format(lauf);

                // Platzbedarf fr Schrift ausrechnen
                FontMetrics fm = getFontMetrics(getFont());
                int Beschriftung_Width = fm.stringWidth(Beschriftung);
                int Beschriftung_Height = fm.getHeight();

                // X und Y - Koordinate fr Textausgabe
                int Punkt_x_Text = (int) (skalierung.getPosYAchse()-4 - Beschriftung_Width);
                int Punkt_y_Text = (int) (skalierung.getYAchseTextY(lauf) +  (double)Beschriftung_Height / 2d -2  ) ;

                // Y - Koordinate fr die Markierungen (ohne Textgrenkorrektur)
                int Punkt_y_Markierung = (int) (skalierung.getYAchseTextY(lauf));

                // Text ausgeben
                g.drawString(Beschriftung , Punkt_x_Text, Punkt_y_Text);

                // Kleine Markierungen anbringen, wo der Text steht
                g.drawLine(skalierung.getPosYAchse()-3, Punkt_y_Markierung, skalierung.getPosYAchse()+2 ,Punkt_y_Markierung);
            }

            // Y - Achsen Beschriftung von -oo .. 0
            for (double lauf=0; lauf > -3.0  ; lauf-=skalierung.getBeschriftungAbstandY()) {

                // Formatierung der Achsenbeschriftung
                DecimalFormat df = new DecimalFormat( "0.0" );
                String Beschriftung = df.format(lauf);

                // Platzbedarf fr Schrift ausrechnen
                FontMetrics fm = getFontMetrics(getFont());
                int Beschriftung_Width = fm.stringWidth(Beschriftung);
                int Beschriftung_Height = fm.getHeight();

                // X und Y - Koordinate fr Textausgabe
                int Punkt_x_Text = (int) (skalierung.getPosYAchse()-4 - Beschriftung_Width);
                int Punkt_y_Text = (int) (skalierung.getYAchseTextY(lauf) +  (double)Beschriftung_Height / 2d -2  ) ;

                // Y - Koordinate fr die Markierungen (ohne Textgrenkorrektur)
                int Punkt_y_Markierung = (int) (skalierung.getYAchseTextY(lauf));

                // Text ausgeben
                g.drawString(Beschriftung , Punkt_x_Text, Punkt_y_Text);

                // Kleine Markierungen anbringen, wo der Text steht
                g.drawLine(skalierung.getPosYAchse()-3, Punkt_y_Markierung, skalierung.getPosYAchse()+2 ,Punkt_y_Markierung);
            }
        }
    }

    private void PrintFigure (Graphics g) {

        double akt, WertX1, WertY1;
        akt=parameterEingabeS.getAbgriff();
        WertX1 =(skalierung.getWertX1(akt)*skalierung.getSkalierungs_Faktor_X());
        WertY1 =(skalierung.getWertY1(akt)*skalierung.getSkalierungs_Faktor_Y());

//			 Referzenz fr 2D Grafik
        Graphics2D g2d = (Graphics2D) g;
        Font bold = new Font ("Arial",Font.BOLD,12);

        if (IsNormaled) {


            // Sichtbaren Bereich durchlaufen
            for (double lauf=skalierung.getVon(); lauf < skalierung.getBis(); lauf+=0.3d/skalierung.getSkalierungs_Faktor_X()) {
                // Koordinaten umrechnen
                int Punkt_x1 = (int)(skalierung.getWertY(lauf));
                int Punkt_x2 = (int)(skalierung.getWertY(lauf));
                double Punkt_y1 = skalierung.getWertX(lauf);
                double Punkt_y2 = skalierung.getWertX(lauf);
                if (Punkt_x2>(skalierung.getRand())&& Punkt_x1<(skalierung.getHeight()-skalierung.getRand())
                        && Punkt_y2>skalierung.getRand() && Punkt_y1<(skalierung.getWidth()-skalierung.getRand())) {
//					 Mit Grn Zeichnen
                    g2d.setColor(Color.GREEN);
                    g2d.setStroke(new BasicStroke(3,BasicStroke.CAP_ROUND, BasicStroke.JOIN_MITER));
                    g.drawLine((int)( Punkt_y2) ,Punkt_x2,(int)(Punkt_y1), Punkt_x1);
                }
            }

            g2d.setColor(Color.BLUE);
            g2d.setStroke(new BasicStroke(3,BasicStroke.CAP_ROUND, BasicStroke.JOIN_MITER));

            if (skalierung.getWertX(akt)>skalierung.getRand() && skalierung.getWertX(akt)<(skalierung.getWidth()-skalierung.getRand())) {
                g.drawLine(skalierung.getPosYAchse(), skalierung.getPosXAchse(), (int)(skalierung.getPosYAchse()+WertX1), skalierung.getPosXAchse());
                g.setFont(bold);
                g.drawString("" +Math.round(skalierung.getWertX1(akt)*100)/100.,(int)(skalierung.getPosYAchse()+WertX1)+10,skalierung.getPosXAchse()-2);
            } else if (WertX1>0)
                g.drawLine(skalierung.getPosYAchse(), skalierung.getPosXAchse(), (int)(skalierung.getWidth()-skalierung.getRand()), skalierung.getPosXAchse());
            else
                g.drawLine(skalierung.getPosYAchse(), skalierung.getPosXAchse(), skalierung.getRand(), skalierung.getPosXAchse());


            g2d.setColor(Color.RED);
            g2d.setStroke(new BasicStroke(3,BasicStroke.CAP_ROUND, BasicStroke.JOIN_MITER));

            if (skalierung.getWertY(akt)>skalierung.getRand() && skalierung.getWertY(akt)<(skalierung.getHeight()-skalierung.getRand())) {
                g.drawLine((int)(skalierung.getPosYAchse()+WertX1), skalierung.getPosXAchse(),  (int)(skalierung.getPosYAchse()+WertX1),(int)(skalierung.getPosXAchse()-WertY1));
                g.setFont(bold);
                g.drawString("" +Math.round(skalierung.getWertY1(akt)*100)/100.,(int)(skalierung.getPosYAchse()+WertX1+2),(int)(skalierung.getPosXAchse()-WertY1)-2);
            } else if (WertY1>0 && skalierung.getWertX(akt)>skalierung.getRand() && skalierung.getWertX(akt)<(skalierung.getWidth()-skalierung.getRand()))
                g.drawLine((int)(skalierung.getPosYAchse()+WertX1), skalierung.getPosXAchse(),  (int)(skalierung.getPosYAchse()+WertX1),(int)(skalierung.getRand()));
            else if (WertY1<0 && skalierung.getWertX(akt)>skalierung.getRand() && skalierung.getWertX(akt)<(skalierung.getWidth()-skalierung.getRand()))
                g.drawLine((int)(skalierung.getPosYAchse()+WertX1), skalierung.getPosXAchse(),  (int)(skalierung.getPosYAchse()+WertX1),(int)(skalierung.getHeight()-skalierung.getRand()));

        }
    }

    /**
     * Hintergund wei darstellen
     *
     * @param g 	Graphics Objekt auf die Zeichenflche
     */
    private void PrintBackground (Graphics g) {
        //double Y_Achsen_Verschiebung = parameterEingabe.getMittelwert();
        //if (IsNormaled) Y_Achsen_Verschiebung=0;

        // Referzenz fr 2D Grafik
        Graphics2D g2d = (Graphics2D) g;

        // Rahmen
        Color Farbe = new Color(0xffdcdc00);
        g2d.setColor(Farbe);
        g2d.setColor(Color.WHITE);
        g2d.fill(new Rectangle(skalierung.getRand(),skalierung.getRand(),skalierung.getWidth()-skalierung.getRand()*2,skalierung.getHeight()-skalierung.getRand()*2));

    }

    public void setuntererPfeilVerwendet(boolean wert) {
        untererPfeilVerwendet = wert;
    }

    public boolean getuntererPfeilVerwendet() {
        return untererPfeilVerwendet ;
    }

    public void setobererPfeilVerwendet(boolean wert) {
        obererPfeilVerwendet = wert;
    }

    public boolean getobererPfeilVerwendet() {
        return obererPfeilVerwendet ;
    }


    //************************************ M o u s e L i s t e n e r ******************************************
    class MyMouseListener extends MouseAdapter {

        /**
         * Methode wird aufgerufen, falls Maustaste gedrckt wurde
         *
         * @param evt 	MouseEvent
         */
        public void mousePressed(MouseEvent evt) {
            if (!IsNormaled) {
                // Mausposition holen
                int posX = evt.getX();
//				int posY = evt.getY();
                // aus Mauskoordinaten Orginalwert errechnen
                skalierung.Rechnen(getWidth(), getHeight());
                double Calculated_X_Value = skalierung.getRealXWert(posX);

                // Tolleranz bercksichtigen
                Klick_Tolleranz = 0.1d; //* parameterEingabeS.getAbgriff();

                // Gltiger Bereich?
                if (
                    Calculated_X_Value >= parameterEingabeS.getAbgriff() - Klick_Tolleranz
                    &&
                    Calculated_X_Value <= parameterEingabeS.getAbgriff() + Klick_Tolleranz
                ) {
                    // Hier auf jeden Fall in einem Bereich in dem Reagiert wird!
                    CanDrag = true;
                }
            }
        }

        /**
         * Methode wird aufgerufen, falls die "Maus" das Koordinatensystem verlassen hat, d.h.
         * im Ausgabemen, darf nun keine Mausposition mehr angezeigt werden.
         *
         * @param evt 	MouseEvent
         */
        public void mouseExited(MouseEvent evt) {
            if (CanDrag&&!IsNormaled) {
                CanDrag = false;
            }
            setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        }

        /**
         * Methode wird aufgerufen, falls die Maustaste losgelassen wurde, d.h.
         * ein Punkt wurde verschoben bzw. aus dem Koordinatensystem gezogen und
         * wird gelscht.
         *
         * @param evt 	MouseEvent
         */
        public void mouseReleased(MouseEvent evt) {
            // nur wenn verschoben wird
            if (CanDrag&&!IsNormaled) {
                // ende Verschiebung
                CanDrag = false;
                // derzeige Mausposition
                int posX = evt.getX();
                // wert zurckrechnen
                skalierung.Rechnen(getWidth(), getHeight());
                double Calculated_X_Value = skalierung.getRealXWert(posX);

                {
                    // Untergrenze
                    parameterEingabeS.setAbgriff(Calculated_X_Value);
                }
            }
        }

    }

    //************************************ M o u s e L i s t e n e r ******************************************
    class MyMouseMotionListener extends MouseMotionAdapter {

        /**
         * Methode wird aufgerufen, falls Maus bewegt wurde.
         * Maus Cursor wird angepasst
         *
         * @param evt 	MouseEvent
         */
        public void mouseMoved(MouseEvent evt) {
            if (CanDrag != true&& !IsNormaled) {
                // derzeige Mausposition
                int posX = evt.getX();
                // Wert zurckrechnen
                skalierung.Rechnen(getWidth(), getHeight());
                double Calculated_X_Value = skalierung.getRealXWert(posX);

                Klick_Tolleranz = 0.1d;  //* parameterEingabe.getStandardabweichung();

                if (
                    Calculated_X_Value >= parameterEingabeS.getAbgriff() - Klick_Tolleranz
                    &&
                    Calculated_X_Value <= parameterEingabeS.getAbgriff() + Klick_Tolleranz
                ) {

                    // Auf jeden Fall im interresanten Bereich

                    if (Calculated_X_Value <= parameterEingabeS.getAbgriff() + Klick_Tolleranz) {
                        // Unter/Obergrenzen
                        setCursor(new java.awt.Cursor(java.awt.Cursor.W_RESIZE_CURSOR  ));
                    } else {
                        if (Calculated_X_Value >= parameterEingabeS.getAbgriff() - Klick_Tolleranz) {
                            // Unter/Obergrenzen
                            setCursor(new java.awt.Cursor(java.awt.Cursor.W_RESIZE_CURSOR  ));
                        } else {
                            // Mittelbereich
                            setCursor(new java.awt.Cursor(java.awt.Cursor.MOVE_CURSOR   ));
                        }
                    }


                } else {
                    // Wenn nicht, normalen Cursor einstellen
                    setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR   ));
                }


            }
        }

        /**
         * Methode wird aufgerufen, falls Maus mit gedrckter Maustaste bewegt wurde.
         *
         * @param evt 	MouseEvent
         */
        public void mouseDragged(MouseEvent evt) {
            // nur wenn verschoben wird
            if (CanDrag == true) {
                // Mausposition holen
                int posX = evt.getX();
                // Orginalwert zurckrechnen
                skalierung.Rechnen(getWidth(), getHeight());
                double Calculated_X_Value = skalierung.getRealXWert(posX);

                {
                    // Untergrenze
                    parameterEingabeS.setAbgriff(Calculated_X_Value);
                }
            }
        }
    }
}



