package KiP_v3;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.SystemColor;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;

/**
 * Die Klasse <b>DlgAbout</b> erzeugt ein Info-Dialogfeld.
 * <p>
 * Dieses Dialogfeld dient lediglich dem Zweck dem Anwender eine kurze Information
 * ber dieses Applet zu geben
 * </p>
 */
public class DlgAbout extends JFrame {

    /**
     * Fr was auch immer man das braucht
     */
    private static final long serialVersionUID = 1L;

    /**
     * Dialogfenster "Info"
     */
    private JDialog dlgAbout;

    /**
     * Eventhandler fr GUI-Elemente
     */
    private Adapter adapter = new Adapter();

    /**
     * Flag welches kennzeichnet ob Dialogfenster im Vordergrund bleiben soll.
     */
    private boolean closing = false;


    /**
     * Schriftart Dialog, Pitch 12, Standard
     */
    private Font f_big =  new Font("Dialog", Font.PLAIN, 12);



    /**
     * Dialogfenster wird erzeugt
     */
    public DlgAbout() {
        dlgAbout = new JDialog (this,"Info", false);
        //Layout des Dialogfeldes wird auf "Null-Layout" festegelegt.
        dlgAbout.getContentPane().setLayout(null);
        dlgAbout.getContentPane().setBackground(SystemColor.control);
    }

    /**
     * Es wird das Dialogfenster "Info" in der Bildschirmmitte geffnet.
     *
     * Es werden folgende Widget-Elemente erzeugt, initialisiert und platziert:
     * <ul>
     * 	<li>CanvasLogo: Auf diesem Canvas wird Logo gezeichnet, welches dem Dialogfeld hinzugefgt wird.</li>
     * 	<li>4 Labels: = 4 Zeilen des Dialogfeldes, auf welchen die Informationen ausgegeben werden.</li>
     * 	<li>Button "schlieen": Mit Hilfe dieses Buttons kann das Dialogfenster geschlossen werden.</li>
     * </ul>
     * <br>
     * Nachdem alle GUI-Elemente erzeugt und initialisert wurden, wird das Dialogfenster in der
     * Bildschirmmitte geffnet.
     *
     */
//Alles was unter "?" steht
    public void showInfoDlg() {
        //Logo
        JLabel labelIcon = new JLabel();
        labelIcon.setBounds(12,45,86,75);
        dlgAbout.getContentPane().add(labelIcon);

        //Logo welches hinzugefgt werden soll, wird aus der Klasse StartStreuellipsen
        //geholt.
        if (Polarkoordinaten.getIconLogo() != null)
            labelIcon.setIcon(Polarkoordinaten.getIconLogo());


        //4 Labels um die Informationen darzustellen
        JLabel labelZeile1 = new JLabel();
        //JLabel labelZeile2 = new JLabel();
        JLabel labelZeile3 = new JLabel();
        JLabel labelZeile4 = new JLabel();
        //JLabel labelZeile5 = new JLabel();
        //JLabel labelZeile6 = new JLabel();

        labelZeile1.setText("Kurven in Polarkoordinaten");
        labelZeile1.setFont(f_big);
        labelZeile1.setBounds(120,40,320,15);
        dlgAbout.getContentPane().add(labelZeile1);


        labelZeile3.setText("Studienarbeit - Florian Pahling");
        labelZeile3.setFont(f_big);
        labelZeile3.setBounds(120,80,320,15);
        dlgAbout.getContentPane().add(labelZeile3);

        labelZeile4.setText("HTW Aalen - E/TI (WS07/08)");
        labelZeile4.setFont(f_big);
        labelZeile4.setBounds(120,95,320,15);
        dlgAbout.getContentPane().add(labelZeile4);

        JButton buttonClose = new JButton ();
        buttonClose.setText("Schlieen");
        buttonClose.setMnemonic(KeyEvent.VK_S);
        buttonClose.setBackground(SystemColor.control);
        buttonClose.setFont(f_big);
        buttonClose.addActionListener(adapter);
        buttonClose.setBounds(130,140,100,25);
        buttonClose.setToolTipText("<html>Klicken Sie hier,<br>um das Dialogfenster zu schlieen.</html>");
        dlgAbout.getContentPane().add(buttonClose);

        //Dialog in Bildschirmmitte positionieren
        dlgAbout.setSize(360,250);
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        dlgAbout.setLocation( (screenSize.width-dlgAbout.getSize().width)/2,
                              (screenSize.height-dlgAbout.getSize().height)/2);
        dlgAbout.setVisible(true);

        dlgAbout.addWindowListener(new DialogListener());
        dlgAbout.repaint();
    }

    /**
     * Adapterklasse: Eventhandler fr Button "schlieen".
     */
    class Adapter implements ActionListener {

        /**
         * Methode wird aufgerufen, falls mit der Maus auf Button
         * "Schlieen" geklickt wurde.
         */
        public void actionPerformed(ActionEvent e) {
            closing = true;
            dlgAbout.setVisible(false);
        }
    }


    /**
     *  Die Klasse <b>DialogListener</b> setzt das Dialogfenster
     *  wieder in den Vordergrund, falls es minimiert oder
     * 	von einem anderen Task berdeckt werden sollte und
     *  nicht geschlossen werden soll.
     */
    class DialogListener extends WindowAdapter {

        /**
         * Methode wird aufgerufen, falls das Dialogfenster den Focus verloren hat.
         */
        public void windowDeactivated(WindowEvent e) {
            if (!closing)
                dlgAbout.setVisible(true);
        }
    }
}

