package KiP_v3;

import java.awt.BorderLayout;
import java.awt.Checkbox;
import java.awt.CheckboxGroup;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.text.DecimalFormat;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.JTextField;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;


/**
 * Die Klasse Eingabe_Funktion verwaltet die
 * Ein- und Ausgabewerte der Polarkoordinaten
 * @author Florian Pahling 17/03/2008
 */

public class Eingabe_Funktion03 extends JPanel {

    /**
     * Fr was auch immer man das braucht
     */
    private static final long serialVersionUID = 1L;

    // Ledt die Genauigkeit fest
    private double Genauigkeit = 100;

    // Formatierung der Anzeigen
    DecimalFormat df1 = new DecimalFormat( "0" );
    DecimalFormat df2 = new DecimalFormat( "0.00" );

    // Referenzen auf die Zeichenbereiche
    private Zeichnen_Funktion03 Zeichenbereich1 = null;
    private Zeichnen_Funktion03 Zeichenbereich2 = null;

    // Bereich der in ParameterEingabe verwaltet wird
    private JPanel innerContent = null;

    /**
     * Gruppe von Elementen erstellen:
     * Beschriftung, Eingabefeld & Scrollbalken fr Mittelwert
     * Beschriftung, Eingabefeld & Scrollbalken fr Standardabweichung
     * Beschriftung, Eingabefeld & Scrollbalken fr Obergrenze
     * Beschriftung, Eingabefeld & Scrollbalken fr Untergrenze
     * Beschriftung & ComboBox fr Grenzenauswahl
     * RadioButtons fr Grenzenauswahl
    */

    // Labels
    private JLabel LB_Par_A = null;
    private JLabel LB_Par_B = null;
    //private JLabel LB_Par_C = null;
    //private JLabel LB_Par_D = null;
    private JLabel LB_Winkel = null;
    private JLabel LB_Bild = null;

    // Textfelder
    private JTextField TF_Par_A = null;
    private JTextField TF_Par_B = null;
    //private JTextField TF_Par_C = null;
    //private JTextField TF_Par_D = null;
    private JTextField TF_Winkel = null;

    // Slidder (Scrollbalken)
    private JSlider sl_Par_A = null;
    private JSlider sl_Par_B = null;
    //private JSlider sl_Par_C = null;
    //private JSlider sl_Par_D = null;
    private JSlider sl_Winkel = null;

    // Check Boxen
    private CheckboxGroup group = new CheckboxGroup();
    private Checkbox CB_Winkelma = null;
    private Checkbox CB_Bogenma = null;

    // befindet sich die Grafik bei Drag & Drop?
    private boolean IsDragging = false;

    // Interne Variablen
    private double Par_B_Wert = 0.06;
    private double Par_A_Wert = 2;
    //private double Par_D_Wert = 2;
    //private double Par_C_Wert = 2;
    private double Winkel_Wert = 0;

    /**
     * Konstruktor erzeugt die Eingabefelder
     */
    public Eingabe_Funktion03() {
        String Beschriftung;

        // wir legen alle Elemente auf ein Panel
        innerContent = new JPanel();


        // wir verwenden keinen Layoutmanager
        innerContent.setLayout(null);

        // Erzeugung der Text-Eingabefelder, mit dem jeweiligen Wert und
        // lassen maximal 10 Zeichen zu

        Beschriftung = df2.format(Par_A_Wert);
        TF_Par_A = new JTextField(Beschriftung,10);

        Beschriftung = df2.format(Par_B_Wert);
        TF_Par_B = new JTextField(Beschriftung,10);

        //Beschriftung = df2.format(Par_C_Wert);
        //TF_Par_C = new JTextField(Beschriftung,10);

        //Beschriftung = df2.format(Par_D_Wert);
        //TF_Par_D = new JTextField(Beschriftung,10);

        Beschriftung = df1.format(Winkel_Wert);
        TF_Winkel = new JTextField(Beschriftung,10);

        // wir erzeugen die Berschriftungslabels
        LB_Par_A = new JLabel("Parameter a:");
        LB_Par_B = new JLabel("Parameter b:");
        //LB_Par_C = new JLabel("Parameter c:");
        //LB_Par_D = new JLabel("Parameter d:");
        LB_Winkel = new JLabel("Winkel \u03C6:");
        LB_Bild = new JLabel("");

        // Erzeugung der Schieberegler --> JSlider (min, max, value)
        sl_Par_A = new JSlider(0,500,(int)(Genauigkeit*Par_A_Wert));
        sl_Par_B = new JSlider(-50,50,(int)(Genauigkeit*Par_B_Wert));
        //sl_Par_C = new JSlider(100,2000,(int)(Genauigkeit*Par_C_Wert));
        //sl_Par_D = new JSlider(100,2000,(int)(Genauigkeit*Par_D_Wert));
        sl_Winkel = new JSlider(0,72000,(int)(Genauigkeit*Winkel_Wert));


        // Erzeugung der Check Boxen fr die Skalierungsart
        CB_Bogenma = new Checkbox(" Winkelma in ", group, true);
        CB_Winkelma = new Checkbox(" Bogenma in rad", group, false);

        // Positionierung der Elemente
        int left = 5;
        int width = 120;
        int height = 21;
        int abstand = 26;
        int top = 7 - abstand;

        // Elementbegrenzungen setzen
        LB_Par_A.setBounds(left,top+=abstand,width,height);
        TF_Par_A.setBounds(left,top+=abstand/1.5,width,height);
        sl_Par_A.setBounds(left,top+=abstand,width,(int)(height));

        top+=abstand*0.1;

        LB_Par_B.setBounds(left,top+=abstand,width,height);
        TF_Par_B.setBounds(left,top+=abstand/1.5,width,height);
        sl_Par_B.setBounds(left,top+=abstand,width,(int)(height));

        top+=abstand*0.1;
        top+=69;
        //LB_Par_C.setBounds(left,top+=abstand,width,height);
        //TF_Par_C.setBounds(left,top+=abstand/1.5,width,height);
        //sl_Par_C.setBounds(left,top+=abstand,width,(int)(height));

        top+=abstand*0.1;
        top+=69;
        //LB_Par_D.setBounds(left,top+=abstand,width,height);
        //TF_Par_D.setBounds(left,top+=abstand/1.5,width,height);
        //sl_Par_D.setBounds(left,top+=abstand,width,(int)(height));

        top+=abstand*0.1;

        LB_Winkel.setBounds(left,top+=abstand,width,height);
        TF_Winkel.setBounds(left,top+=abstand/1.5,width,height);
        sl_Winkel.setBounds(left,top+=abstand,width,(int)(height));

        top+=abstand*0.5;

        CB_Bogenma.setBounds(left,top+=2*abstand/3,width,height);
        CB_Winkelma.setBounds(left,top+=2*abstand/3,width,height);

        if (Polarkoordinaten.getFunkBild1()!= null)
            LB_Bild.setIcon(Polarkoordinaten.getFunkBild1());
        LB_Bild.setBounds(left,top+=abstand,241,54);
        /**
        * Reaktion auf die nderung der Eingabefelder
        */

        TF_Par_A.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (!TF_Par_A.hasFocus()) return;
                eingabewerteEinlesen();
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
            }
        }
        );




        sl_Par_A.addChangeListener(
        new ChangeListener() {
            public void stateChanged(ChangeEvent  e) {
                if (!sl_Par_A.hasFocus()) return;
                String Beschriftung1;
                Par_A_Wert = sl_Par_A.getValue()/Genauigkeit;
                Beschriftung1 = df2.format(Par_A_Wert);
                TF_Par_A.setText(Beschriftung1);
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
            }
        }
        );




        TF_Par_B.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (!TF_Par_B.hasFocus()) return;
                eingabewerteEinlesen();
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();

            }
        }
        );



        sl_Par_B.addChangeListener(
        new ChangeListener() {
            public void stateChanged(ChangeEvent  e) {
                if (!sl_Par_B.hasFocus()) return;
                String Beschriftung1;
                Par_B_Wert = sl_Par_B.getValue()/Genauigkeit;
                Beschriftung1 = df2.format(Par_B_Wert);
                TF_Par_B.setText(Beschriftung1);
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
            }
        }
        );





        /*		TF_Par_D.addActionListener(
        							new ActionListener()
        							{
        								public void actionPerformed( ActionEvent e)
        								{
        									if (!TF_Par_D.hasFocus()) return;
        									eingabewerteEinlesen();
        									if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
        									if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
        								}
        							}
        							);




        		sl_Par_D.addChangeListener(
        							new ChangeListener()
        							{
        								public void stateChanged(ChangeEvent  e)
        								{
        									if (!sl_Par_D.hasFocus()) return;
        									String Beschriftung1;
        									Par_D_Wert = sl_Par_D.getValue()/Genauigkeit;
        									Beschriftung1 = df2.format(Par_D_Wert);
        									TF_Par_D.setText(Beschriftung1);
        									if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
        									if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
        								}
        							}
        							);




        		TF_Par_C.addActionListener(
        							new ActionListener()
        							{
        								public void actionPerformed( ActionEvent e)
        								{
        									if (!TF_Par_C.hasFocus()) return;
        									eingabewerteEinlesen();
        									if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
        									if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
        								}
        							}
        							);



        		sl_Par_C.addChangeListener(
        							new ChangeListener()
        							{
        								public void stateChanged(ChangeEvent  e)
        								{
        									if (!sl_Par_C.hasFocus()) return;
        									String Beschriftung1;
        									Par_C_Wert = sl_Par_C.getValue()/Genauigkeit;
        									Beschriftung1 = df2.format(Par_C_Wert);
        									TF_Par_C.setText(Beschriftung1);
        									if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
        									if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
        								}
        							}
        							);
        */


        CB_Bogenma.addItemListener(
        new ItemListener() {
            public void itemStateChanged(ItemEvent e) {
                Object item = e.getItem();
                // nur bei nderung der Sekektion reagieren
                if (ItemEvent.SELECTED == e.getStateChange()) {
                    String Beschriftung1;
                    Winkel_Wert = sl_Winkel.getValue()/Genauigkeit;
                    Beschriftung1 = df1.format(Winkel_Wert);
                    TF_Winkel.setText(Beschriftung1);
                    if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                    if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
                }
            }
        }
        );


        CB_Winkelma.addItemListener(
        new ItemListener() {
            public void itemStateChanged(ItemEvent e) {
                Object item = e.getItem();
                System.out.println("winkel = "+e.getStateChange());
                // nur bei nderung der Sekektion reagieren
                if (ItemEvent.SELECTED == e.getStateChange()) {
                    String Beschriftung1;
                    Winkel_Wert = sl_Winkel.getValue()/Genauigkeit;
                    Beschriftung1 = df2.format((double)(Winkel_Wert/(720/12.57)));
                    TF_Winkel.setText(Beschriftung1);
                    if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                    if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
                }
            }
        }
        );




        TF_Winkel.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (!TF_Winkel.hasFocus()) return;
                eingabewerteEinlesen();
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
            }
        }
        );



        sl_Winkel.addChangeListener(
        new ChangeListener() {
            public void stateChanged(ChangeEvent  e) {
                if (!sl_Winkel.hasFocus()) return;
                String Beschriftung1;
                Winkel_Wert = sl_Winkel.getValue()/Genauigkeit;
                if(getWinkeloderBogenma() == false) {
                    Beschriftung1 = df1.format(Winkel_Wert);
                    TF_Winkel.setText(Beschriftung1);
                } else {
                    Beschriftung1 = df2.format((double)(Winkel_Wert/(720/12.57)));
                    TF_Winkel.setText(Beschriftung1);
                }
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
            }
        }
        );




        // Gre des Eingabebereichs zulassen
        innerContent.setPreferredSize(new Dimension(left*2+width,20));

        // Widgets auf dem Panel plazieren
        innerContent.add(LB_Par_A);
        innerContent.add(TF_Par_A);
        innerContent.add(sl_Par_A);

        innerContent.add(LB_Par_B);
        innerContent.add(TF_Par_B);
        innerContent.add(sl_Par_B);
        /*
        		innerContent.add(LB_Par_C);
        		innerContent.add(TF_Par_C);
        		innerContent.add(sl_Par_C);

        		innerContent.add(LB_Par_D);
        		innerContent.add(TF_Par_D);
        		innerContent.add(sl_Par_D);
        */
        innerContent.add(CB_Winkelma);
        innerContent.add(CB_Bogenma);

        innerContent.add(LB_Winkel);
        innerContent.add(TF_Winkel);
        innerContent.add(sl_Winkel);

        innerContent.add(LB_Bild);
    }


    /**
     * Methode delete dient dazu eine Eingabe aus dem Speicher aufzulsen
     *
     * @param Fenster	Fenster auf dem die Elemente plaziert sind
     */
    public void delete(JFrame Fenster) {
        // Eingabefelder freigeben
        innerContent.remove(LB_Par_A);
        innerContent.remove(TF_Par_A);
        innerContent.remove(sl_Par_A);

        innerContent.remove(LB_Par_B);
        innerContent.remove(TF_Par_B);
        innerContent.remove(sl_Par_B);
        /*
        		innerContent.remove(LB_Par_C);
        		innerContent.remove(TF_Par_C);
        		innerContent.remove(sl_Par_C);

        		innerContent.remove(LB_Par_D);
        		innerContent.remove(TF_Par_D);
        		innerContent.remove(sl_Par_D);
        */
        innerContent.remove(CB_Winkelma);
        innerContent.remove(CB_Bogenma);

        innerContent.remove(LB_Winkel);
        innerContent.remove(TF_Winkel);
        innerContent.remove(sl_Winkel);

        innerContent.remove(LB_Bild);

        // Referenzen lschen
        LB_Par_A = null;
        LB_Par_B = null;
        //LB_Par_C = null;
        //LB_Par_D = null;
        LB_Winkel = null;
        LB_Bild = null;

        TF_Par_A = null;
        TF_Par_B = null;
        //TF_Par_C = null;
        //TF_Par_D = null;
        TF_Winkel = null;

        sl_Par_A = null;
        sl_Par_B = null;
        //sl_Par_C = null;
        //sl_Par_D = null;
        sl_Winkel = null;

        // selbst auflsen
        Fenster.getContentPane().remove(innerContent);
        innerContent = null;
        Zeichenbereich1 = null;
        Zeichenbereich2 = null;


    }


    /**
     * setzt den Paramter A von aussen
     *
     * @param wert	Neues A
     */
    public void set_Par_A(double wert) {
        Par_A_Wert = wert;
        String Beschriftung = df2.format(Par_A_Wert);
        TF_Par_A.setText(Beschriftung);
        //sB_Mittelwert.setValue( (int) (Mittelwert_Wert * Genauigkeit) );
        sl_Par_A.setValue( (int) (Par_A_Wert * Genauigkeit) );
    }

    /**
     * setzt den Paramter B von aussen
     *
     * @param wert	Neues B
     */
    public void set_Par_B(double wert) {
        Par_B_Wert = wert;
        String Beschriftung = df2.format(Par_B_Wert);
        TF_Par_B.setText(Beschriftung);
        //sB_Standardabweichung.setValue( (int) (Standardabweichung_Wert*Genauigkeit) );
        sl_Par_B.setValue( (int) (Par_B_Wert*Genauigkeit) );
    }

    /**
     * setzt den Paramter C von aussen
     *
     * @param wert	Neues C
     */
    /*	public void set_Par_C(double wert)
    		{
    		Par_C_Wert =  wert;
    		String Beschriftung = df2.format(Par_C_Wert);
    		TF_Par_C.setText(Beschriftung);
    		//sB_Obergrenze.setValue( (int) (Obergrenze_Wert*Genauigkeit) );
    		sl_Par_C.setValue( (int) (Par_C_Wert*Genauigkeit) );
    		}
    */
    /**
     * setzt den Paramter D von aussen
     *
     * @param wert	Neues D
     */
    /*	public void set_Par_D(double wert)
    		{
    		Par_D_Wert =  wert;
    		String Beschriftung = df2.format(Par_D_Wert);
    		TF_Par_D.setText(Beschriftung);
    		//sB_Untergrenze.setValue( (int) (Untergrenze_Wert*Genauigkeit) );
    		sl_Par_D.setValue( (int) (Par_D_Wert*Genauigkeit) );
    		}
    */



    /**
     * setzt den Abgriff
     *
     * @param x	Neuer Abgriff
     */
    public void set_Winkel(double x) {
        // intern genauen Wert verwenden
        Winkel_Wert = (int) x; // *100d;
        if(Winkel_Wert > 720)
            Winkel_Wert = 720;
//		Abgriff_Wert_Intern = Abgriff_Wert;
        sl_Winkel.setValue( (int) (Winkel_Wert*Genauigkeit) );
        String Beschriftung1;
        if(getWinkeloderBogenma() == false) {
            Beschriftung1 = df1.format(Winkel_Wert); //  / 100d
            TF_Winkel.setText(Beschriftung1);
        } else {
            Beschriftung1 = df2.format(Winkel_Wert/(720/12.57)); //  / 100d
            TF_Winkel.setText(Beschriftung1);
        }
        if (Zeichenbereich1 != null) Zeichenbereich1.Dorepaint();
        if (Zeichenbereich2 != null) Zeichenbereich2.Dorepaint();
    }

    /**
     * liefert den Parameter A
     *
     * @return derzeitige Wert von A
     */
    public double get_Par_A() {
        return Par_A_Wert;
    }

    /**
     * liefert den Parameter B
     *
     * @return derzeitige Wert von B
     */
    public double get_Par_B() {
        return Par_B_Wert;
    }

    /**
     * liefert den Parameter C
     *
     * @return derzeitige Wert von C
     */
    /*	public	double get_Par_C()
    		{
    			return Par_C_Wert;
    		}
    */
    /**
     * liefert den Parameter D
     *
     * @return derzeitige Wert von D
     */
    /*	public	double get_Par_D()
    		{
    			return Par_D_Wert;
    		}
    */
    /**
     * liefert den Winkel
     *
     * @return derzeitige Wert von Winkel
     */
    public	double get_Winkel() {
        return Winkel_Wert;
    }


    /**
     * setzt die Zeichenbereiche
     *
     * @param z	Zeichenbereich
     */
    public void setZeichenbereich(Zeichnen_Funktion03 z) {
        if (Zeichenbereich1==null)
            Zeichenbereich1=z;
        else
            Zeichenbereich2=z;
    }


    /**
     * leifert die Beschriftung Grad oder Rad
     *
     * @return Beschriftungsart
     */
    public boolean getWinkeloderBogenma() {
        return CB_Winkelma.getState();
    }

    /**
     * setzt den Zustand ob verschoben wird
     *
     * @param s	true wenn gerade verschoben wird
     */
    public void setIsDragging(boolean s) {
        IsDragging = s;
    }

    /**
     * fgt die Eingabeleiste auf einem Fenster ein
     *
     * @param Fenster	Fenster auf dem die Leiste eingefgt werden soll
     */
    public void addToFrame(JFrame Fenster) {
        Fenster.getContentPane().add(innerContent, BorderLayout.WEST);
    }


    /**
     * bernimmt alle Werte fr die Vorwrtzberechnung
     */
    private void eingabewerteEinlesen() {
        // Parameter A
        {
            String Hilf = TF_Par_A.getText();
            Par_A_Wert = Double.parseDouble(Hilf.replace(',','.'));
            // ungltige Werte nicht zulassen
            if (Par_A_Wert <= 0) {
                Par_A_Wert = 0;
                TF_Par_A.setText("0,00");
            }
            if( Par_A_Wert > 5) {
                Par_A_Wert = 5;
                TF_Par_A.setText("5,00");
            }
            sl_Par_A.setValue( (int)(Genauigkeit*Par_A_Wert) );
        }

        // Parameter B
        {
            String Hilf = TF_Par_B.getText();
            Par_B_Wert = Double.parseDouble(Hilf.replace(',','.'));
            sl_Par_B.setValue( (int)(Genauigkeit*Par_B_Wert) );
            // ungltige Werte nicht zulassen
            if (Par_B_Wert <= -0.5) {
                Par_B_Wert = -0.5;
                TF_Par_B.setText("-0,50");
            }
            if( Par_B_Wert > 0.5) {
                Par_B_Wert = 0.5;
                TF_Par_B.setText("0,50");
            }
            sl_Par_B.setValue( (int)(Genauigkeit*Par_B_Wert) );
        }

        // Parameter C
        /*		{
        			String Hilf = TF_Par_C.getText();
        			Par_C_Wert = Double.parseDouble(Hilf.replace(',','.'));
        			sl_Par_C.setValue( (int)(Genauigkeit*Par_C_Wert) );
        			// ungltige Werte nicht zulassen
        			if (Par_C_Wert <= 1)
        			{
        			Par_C_Wert = 1;
        			TF_Par_C.setText("1,00");
        			}
        			if( Par_C_Wert > 20)
        			{
        				Par_C_Wert = 20;
        				TF_Par_C.setText("20,00");
        			}
        			sl_Par_C.setValue( (int)(Genauigkeit*Par_C_Wert) );
        		}

        		// Paramter D
        		{
        			String Hilf = TF_Par_D.getText();
        			Par_D_Wert = Double.parseDouble(Hilf.replace(',','.'));
        			sl_Par_D.setValue( (int)(Genauigkeit*Par_D_Wert) );
        			// ungltige Werte nicht zulassen
        			if (Par_D_Wert <= 1)
        				{
        				Par_D_Wert = 1;
        				TF_Par_D.setText("1,00");
        				}
        			if( Par_D_Wert > 20)
        			{
        				Par_D_Wert = 20;
        				TF_Par_D.setText("20,00");
        			}
        			sl_Par_D.setValue( (int)(Genauigkeit*Par_D_Wert) );
        		}
        */
        // Winkel
        {
            if(getWinkeloderBogenma() == false) {
                String Hilf = TF_Winkel.getText();
                Winkel_Wert = (int) Double.parseDouble(Hilf.replace(',','.'));
                // ungltige Werte nicht zulassen
                if (Winkel_Wert <= 0) {
                    Winkel_Wert = 0;
                    TF_Winkel.setText("0");
                }
                if (Winkel_Wert > 720) {
                    Winkel_Wert = 720;
                    TF_Winkel.setText("720");
                }
                sl_Winkel.setValue( (int)(Genauigkeit*Winkel_Wert) );
            } else {
                String Hilf = TF_Winkel.getText();
                Winkel_Wert = (Double.parseDouble(Hilf.replace(',','.'))*(720/12.57));
                sl_Winkel.setValue( (int) (Genauigkeit*Winkel_Wert) );
                // ungltige Werte nicht zulassen
                if (Winkel_Wert <= 0) {
                    Winkel_Wert = 0;
                    TF_Winkel.setText("0");
                }
                if (Winkel_Wert > 720) {
                    Winkel_Wert = 720;
                    TF_Winkel.setText("12.57");
                }
                sl_Winkel.setValue((int) (Genauigkeit*Winkel_Wert));
            }
        }
    }
}



