package KiP_v3;



/**
 * Klasse Skalierung
 * bernimmt die Berechnungen fr die Anzeige der Funktion01
 * @author Florian Pahling 17/03/2008
 */
public class Skalierung_Funktion02 {

    // Gre des Zeichenbereichs
    private int Width;
    private int Height;

    //Randbreite
    private int Rand = 20;

    // Breite der Grafik
    private double Breite = 4;

    // bestimmt ob die Darstellung	normiert ist
    private boolean isNormaled;

    // berechnete Werte fr Zeichenbereich
    private double von;
    private double bis;
    private double bereich_werte;
    private int bereich_grafik_X;
    private int bereich_grafik_Y;

    // Umfrechnungsfaktoren fr die Skalierung
    private double Skalierungs_Faktor_X;
    private double Skalierungs_Faktor_Y;
    private double Achsen_Verschiebung_X;
    private double Achsen_Verschiebung_Y;

    private double Max_Wert;
    private double Par_A;
    private double Par_B;
    private double Par_C;
    //private double Par_D;

    // Nullpunktoffset
    private int Offset_X;
    private int Offset_Y;

    // Referenz auf die Eingaben
    private Eingabe_Funktion02 parameterEingabe = null;


    /**
     * Konstruktor
     * bernimmt die Parameter fr die Klasse
     * Referenz auf Eingaben und ob Normierte Darstellung
     *
     * @param PE 	Referenz auf das zugehrige Eingabefeld
     */
    public Skalierung_Funktion02(Eingabe_Funktion02 PE, boolean Normaled) {
        // Werte in den internen Variablen ablegen
        parameterEingabe = PE;
        isNormaled = Normaled;

        // Standardmig Skalierung = 0, so muss sie spter neu berechnet werden
        Skalierungs_Faktor_X =0;
        Skalierungs_Faktor_Y =0;
    }


    /**
     * Verlangt zwingend neue Berechnung, mit neuer Skalierung
     *
     * @param x	Breite des Zeichenbereiches
     * @param y	Hhe des Zeichenbereiches
     */
    public void ForceRechnen(int x, int y) {
        // Werte auf 0 setzen, damit sie neu berechnet werden
        Skalierungs_Faktor_X = 0;
        Skalierungs_Faktor_Y = 0;
        // jetzt neue Daten berechnen
        Rechnen(x, y);
    }


    /**
     * Berechnet neue interne Werte
     *
     * @param x	Breite des Zeichenbereiches
     * @param y	Hhe des Zeichenbereiches
     */
    public void Rechnen(int x, int y) {
        Width = x;
        Height = y;

        bereich_grafik_X = Width - Rand * 4 ;
        bereich_grafik_Y = Height - Rand * 4 ;

        // Unterscheidung bei normierter Darstellung
        if (!isNormaled) {
            // nicht normiert
            // Werte ausrechnen
            Par_A = parameterEingabe.get_Par_A();
            Par_B = parameterEingabe.get_Par_B();
            Par_C = parameterEingabe.get_Par_C();
            //Par_D = parameterEingabe02.get_Par_D();
        }


        // Breite links und rechts vom Winkel ergeben Zeichengrenzen
        von =  -Breite;
        bis =  Breite;

        // Bereich ausrechnen
        bereich_werte = bis - von;

        // X-Skalierung neu berechnen
        {
            Skalierungs_Faktor_X = bereich_grafik_X / bereich_werte;
        }

        // Y-Skalierung neu berechnen
        {
            Max_Wert = 1.1 * 0.5d * Par_A;
            Skalierungs_Faktor_Y = bereich_grafik_Y / Max_Wert;
        }

        // Die Offsets geben den Abstand zum Ursprung an
        Offset_X = Width / 2;
        Offset_Y = Height / 2;
    }

    /**
     * liefert die breite
     *
     * @return Breites des Zeichenbereiches in Pixel
     */
    public int getWidth() {
        //System.out.println("Width: "+Width);
        return Width;
    }

    /**
     * liefert die hhe
     *
     * @return Hhe des Zeichenbereiches in Pixel
     */
    public int getHeight() {
        return Height;
    }


    /**
     * liefert Position der Y-Achse
     *
     * @return X-Position der Y-Achse in Pixel
     */
    public int getPosYAchse() {
        // Position berechnen
        int Interner_Wert = (int) (Offset_X + Achsen_Verschiebung_X * Skalierungs_Faktor_X);
        // prfen ob ausserhalb und bei Bedarf begrenzen
        if (Interner_Wert > Width-3*Rand) Interner_Wert = Width-3*Rand;
        if (Interner_Wert < 3*Rand) Interner_Wert = 3*Rand;

        return Interner_Wert;
    }

    /**
     * liefert Position der X-Achse
     *
     * @return Y-Position der X-Achse in Pixel
     */
    public int getPosXAchse() {
        // Position berechnen
        int Interner_Wert = (int) (Offset_Y+ Achsen_Verschiebung_Y * Skalierungs_Faktor_Y);
        // prfen ob ausserhalb und bei Bedarf begrenzen
        if (Interner_Wert > Width-3*Rand) Interner_Wert = Width-3*Rand;
        if (Interner_Wert < 3*Rand) Interner_Wert = 3*Rand;

        return Interner_Wert;
    }


    /**
     * liefert die Randbreite
     *
     * @return Breite des Randes in Pixel
     */
    public int getRand() {
        return Rand;
    }


    /**
     * liefert den Abstand der Beschriftungen auf der Achse
     *
     * @return Abstand der Beschriftungen auf der X Achse
     */
    public double getBeschriftungAbstandX() {
        double returnWert;

        returnWert = 40.0/Skalierungs_Faktor_X;

        if (returnWert <= 0.001) return  0.001;
        if (returnWert <= 0.002) return  0.002;
        if (returnWert <= 0.005) return  0.005;
        if (returnWert <= 0.01) return  0.01;
        if (returnWert <= 0.02) return  0.02;
        if (returnWert <= 0.05) return  0.05;
        if (returnWert <= 0.1) return  0.1;
        if (returnWert <= 0.2) return  0.2;
        if (returnWert <= 0.5) return  0.5;
        if (returnWert <= 1) return  1;
        if (returnWert <= 2) return  2;
        if (returnWert <= 5) return  5;
        if (returnWert <= 10) return  10;
        if (returnWert <= 20) return  20;
        if (returnWert <= 50) return  50;

        return returnWert;
    }

    /**
     * liefert den Abstand der Beschriftungen auf der Achse
     *
     * @return Abstand der Beschriftungen auf der Y Achse
     */
    public double getBeschriftungAbstandY() {
        double int_wert = 18/Skalierungs_Faktor_Y;
        if (int_wert <= 0.001) return  0.001;
        if (int_wert <= 0.002) return  0.002;
        if (int_wert <= 0.005) return  0.005;
        if (int_wert <= 0.01) return  0.01;
        if (int_wert <= 0.02) return  0.02;
        if (int_wert <= 0.05) return  0.05;
        if (int_wert <= 0.1) return  0.1;
        if (int_wert <= 0.2) return  0.2;
        if (int_wert <= 0.5) return  0.5;
        if (int_wert <= 1) return  1;
        if (int_wert <= 2) return  2;
        if (int_wert <= 5) return  5;
        if (int_wert <= 10) return  10;
        if (int_wert <= 20) return  20;
        if (int_wert <= 50) return  50;


        return int_wert;
    }

    /**
     * Liefert den Skalierungsfaktor in X Richtung
     *
     * @return Skalierungsfaktor in X Richtung
     */
    public double getSkalierungs_Faktor_X() {
        return Skalierungs_Faktor_X;
    }

    /**
     * Liefert den Skalierungsfaktor in Y Richtung
     *
     * @return Skalierungsfaktor in Y Richtung
     */
    public double getSkalierungs_Faktor_Y() {
        return Skalierungs_Faktor_Y;
    }


    /**
     * liefert die linke Begrenzung
     *
     * @return Position (Untergrenze) ab der die Kurve dargestellt wird
     */
    public double getVon() {
        return von;
    }

    /**
     * liefert die rechte Begrenzung
     *
     * @return Position (Obergrenze) ab der die Kurve dargestellt wird
     */
    public double getTextBis() {
        return bis-bereich_werte/100.0;
    }


    /**
     * liefert die linke TextBegrenzung
     *
     * @return Position (Untergrenze) ab der Text dargestellt wird
     */
    public double getTextVon() {
        return von;
    }


    /**
     * liefert die rechte TextBegrenzung
     *
     * @return Position (Obergrenze) ab der Text dargestellt wird
     */
    public double getBis() {
        return bis;
    }


    /**
     * liefert die Y-Textposition zum Y Wert
     *
     * @param value		gewnschte Position des Textes
     *
     * @return zugehriger skalierter Y Wert
     */
    public double getYAchseTextY(double value) {
        return Offset_Y + value * Skalierungs_Faktor_Y;
    }


    /**
     * liefert die X-Textposition zum X Wert
     *
     * @param value		gewnschte Position des Textes
     *
     * @return zugehriger skalierter X Wert
     */
    public double getXAchseTextX(double value) {
        return Offset_X  + value * Skalierungs_Faktor_X;
    }


    /**
     * liefert den X Wert
     *
     * @param value		gewnschte Position der Kurve (mathematisch)
     *
     * @return zugehriger skalierter X Wert
     */

    public double getWertX(double value) {
        return value * ((double)(Width-130)/(double)(719));
    }

    /**
     * liefert den Y Wert
     *
     * @param value		gewnschte Position der Kurve (mathematisch)
     *
     * @return zugehriger skalierter Y Wert (Zeichenbereich)
     */
    public double getWertY(double value) {
        value = value -50;
        value = 2 * Math.PI * (value / 360);
        double Wert = (Par_A / (1 - Par_B * Math.cos(((value) + (2 * Math.PI * (Par_C / 360))))));//*0.1*Skalierungs_Faktor_X;
        return Wert*10;
    }

    /**
     * liefert den Radius
     *
     * @param value
     *
     * @return zugehriger Radius
     */
    public double getRadiusWert(double value) {
        value = 2 * Math.PI * (value / 360);
        double Wert = (Par_A / (1 - Par_B * Math.cos(((value) + (2 * Math.PI * (Par_C / 360))))));
        return Wert;
    }

    /**
     * liefert den Radius
     *
     * @param value
     *
     * @return zugehriger Radius
     */
    public double getRadiusWert_func02(double value) {
        double Wert = (Par_A / (1 - Par_B * Math.cos(((value) + (2 * Math.PI * (Par_C / 360))))));
        return Wert;
    }

    /**
     * liefert den Radius
     *
     * @param value
     *
     * @return zugehriger Radius falls y = unendlich ist
     */
    public double getRadiusWert_y(double value) {
        value = 2 * Math.PI * (value / 360);
        double Wert = (Par_A / (1 - Par_B * Math.cos(((value) + (2 * Math.PI * ((Par_C -1 )/ 360))))));
        return Wert;
    }

    /**
     * liefert die Skalierung fr die Kurve
     *
     * @return Offset
     */
    public int getOffset_Y() {
        return Height/2;
    }

    /**
     * liefert die Skalierung fr die Kurve
     *
     * @return Offset
     */
    public int getOffset_X() {
        return (34 - (int)(Width-362)/14);
    }

    /**
     * liefert unendlichen Wert
     *
     * @return unendlich
     */
    public double unendlich(double x) {
        x = (2 / (1 - Math.cos(x)));
        return x;
    }
}