package KiP_v3;

import java.awt.BorderLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.DecimalFormat;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JToolBar;

/**
 * Klasse ToolBar
 * Stellt die Button Leiste zur Verfgung
 * Whlt Aufgrund der Buttons eine entsprechende Verteilung
 * @author Florian Pahling 17/03/2008
 */
public class ToolBar {

    // Formatierung der Anzeigen
    DecimalFormat df1 = new DecimalFormat( "" );

    /**
     * ToolBar
     */
    private JToolBar toolBar = null;

    /**
     * die verschiedenen Buttons
     */
    private JButton BT_close = null;
    private JButton BT_Func01 = null;
    private JButton BT_Func02 = null;
    private JButton BT_Func03 = null;
//	private JButton BT_about = null;
    /**
     * In diesem Panel liegen die Buttons
     */
    private JPanel panel = null;

    /**
     * Referenz auf das bergeordnete Hauptfenster
     */
    private JFrame Hauptfenster = null;
    private JPanel HauptFensterMitte = null;

    /**
     * Referenzen auf die verschiedenen Eingabebereiche
     */
    private Eingabe_Funktion01 parameterEingabe_func01  = null;
    private Eingabe_Funktion02 parameterEingabe_func02  = null;
    private Eingabe_Funktion03 parameterEingabe_func03  = null;


    /**
     * Referenzen auf die verschiedenen Zeichenbereiche
     */
    private Zeichnen_Funktion01 zeichenbereich_func01_1=null;
    private Zeichnen_Funktion01 zeichenbereich_func01_2=null;

    private Zeichnen_Funktion02 zeichenbereich_func02_1=null;
    private Zeichnen_Funktion02 zeichenbereich_func02_2=null;

    private Zeichnen_Funktion03 zeichenbereich_func03_1=null;
    private Zeichnen_Funktion03 zeichenbereich_func03_2=null;



    /**
     * Konstruktor
     * erzeugt die Toolbar
     *
     * @param HF 		Fenster auf dem die Toolbar eingefgt werden soll
     * @param IsApplet 	true falls Anwendung als Applet luft
     */
    public ToolBar ( final JFrame HF  , final boolean IsApplet  ) {
        // Referenz intern sichern
        Hauptfenster = HF;

        // In den Verschiedenen Regionen des Hauptfensters Panels ablegen
        HauptFensterMitte = new JPanel();
        Hauptfenster.getContentPane().add(HauptFensterMitte,BorderLayout.CENTER );

        // Layout Manager fr dien Mittelteil
        BoxLayout boxLayout =  new BoxLayout(HauptFensterMitte, BoxLayout.Y_AXIS);
        HauptFensterMitte.setLayout(boxLayout);

        // Buttons erzeugen
        BT_close = new JButton("");
        // Standartsymbole sind nicht gedrckt
        BT_Func01 = new JButton("");
        BT_Func02 = new JButton("");
        BT_Func03 = new JButton("");
//		BT_about = new JButton(" About ");

        // Tool Tips
        BT_close.setFont(new Font("Arial", Font.BOLD, 12));
        BT_close.setToolTipText("Beenden");
        BT_Func01.setFont(new Font("Arial", Font.BOLD, 12));
        BT_Func01.setToolTipText("r(\u03C6) = a+b\u05BCcos(c\u05BC\u03C6+d)");
        BT_Func02.setFont(new Font("Arial", Font.BOLD, 12));
        BT_Func02.setToolTipText("r(\u03C6) = a / (1-b\u05BCcos(\u03C6+c))");
        BT_Func03.setFont(new Font("Arial", Font.BOLD, 12));
        BT_Func03.setToolTipText("r(\u03C6) = a\u05BCe^(b\u05BC\u03C6)");
//		BT_about.setFont(new Font("Arial", Font.BOLD, 12));
//		BT_about.setToolTipText("About");

        // Aktionen der Buttons
        BT_close.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (!IsApplet)
                    System.exit(0);
                else
                    Hauptfenster.setVisible(false);
            }
        }
        );

        BT_Func01.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                panel.setVisible( false );
                remouveVerteilungen();
                add_func01();
                panel.setVisible( true );
            }
        }
        );

        BT_Func02.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                panel.setVisible( false );
                remouveVerteilungen();
                add_func02();
                panel.setVisible( true );
            }
        }
        );
        BT_Func03.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                panel.setVisible( false );
                remouveVerteilungen();
                add_func03();
                panel.setVisible( true );
            }
        }
        );
//		BT_about.addActionListener(
//					new ActionListener()
//					{
//
//					    	public void actionPerformed( ActionEvent e )
//					      	{
//					      		DlgAbout dlgabout = new DlgAbout();
//					      		dlgabout.showInfoDlg();
//					      	}
//				}
//				);


        // ToolBar selbst erzeugen
        toolBar = new JToolBar();

        // Buttons auf die ToolBar legen
        toolBar.add(BT_Func01);
        toolBar.add(BT_Func02);
        toolBar.add(BT_Func03);
        toolBar.add(BT_close);
//		toolBar.add(BT_about);
    }


    /**
     * Setzt die gewnschte Darstellungsart auf der Toolbar
     *
     * @param nr der Funktion
     */
    public void setFunktionsart(int nr) {
        panel.setVisible( false );
        // bisherige Verteilungen entfernen
        remouveVerteilungen();
        // neue auswhlen
        switch (nr) {
        case 1:
            add_func02();
            break;
        case 2:
            add_func03();
            break;

        default:
            add_func01();
            break;
        }
        panel.setVisible( true );
    }



    /**
     * frgt die Toolbar zum Fenster hinzu
     */
    public void addToFrame() {
        // Panel im Norden des Hauptfensters fr die Buttonleiste plazieren
        panel = new JPanel();
        Hauptfenster.getContentPane().add(panel, BorderLayout.NORTH);

        // Layout bestimmen
        BoxLayout boxLayout =  new BoxLayout(panel, BoxLayout.X_AXIS);
        panel.setLayout(boxLayout);

        // Panel hinzufgen
        panel.add(toolBar);

        // standartmig Funktion01 laden
        add_func01();
    }



    /**
     * Veranlasst ein neuzeichenen der Zeichenbereiche
     */
    public void doRepaint() {
        if ( zeichenbereich_func01_1 != null ) zeichenbereich_func01_1.Dorepaint();
        if ( zeichenbereich_func01_2 != null ) zeichenbereich_func01_2.Dorepaint();

        if ( zeichenbereich_func02_1 != null ) zeichenbereich_func02_1.Dorepaint();
        if ( zeichenbereich_func02_2 != null ) zeichenbereich_func02_2.Dorepaint();

        if ( zeichenbereich_func03_1 != null ) zeichenbereich_func03_1.Dorepaint();
        if ( zeichenbereich_func03_2 != null ) zeichenbereich_func03_2.Dorepaint();
    }



    /**
     * entfernt alle Zeichenbereiche vom Fenster
     */
    private void remouveVerteilungen() {
        if (zeichenbereich_func01_1 != null) HauptFensterMitte.remove(zeichenbereich_func01_1);
        if (zeichenbereich_func01_2 != null) HauptFensterMitte.remove(zeichenbereich_func01_2);

        if (zeichenbereich_func02_1 != null) HauptFensterMitte.remove(zeichenbereich_func02_1);
        if (zeichenbereich_func02_2 != null) HauptFensterMitte.remove(zeichenbereich_func02_2);

        if (zeichenbereich_func03_1 != null) HauptFensterMitte.remove(zeichenbereich_func03_1);
        if (zeichenbereich_func03_2 != null) HauptFensterMitte.remove(zeichenbereich_func03_2);


        if (zeichenbereich_func01_1 != null) zeichenbereich_func01_1.delete();
        if (zeichenbereich_func01_2 != null) zeichenbereich_func01_2.delete();

        if (zeichenbereich_func02_1 != null) zeichenbereich_func02_1.delete();
        if (zeichenbereich_func02_2 != null) zeichenbereich_func02_2.delete();

        if (zeichenbereich_func03_1 != null) zeichenbereich_func03_1.delete();
        if (zeichenbereich_func03_2 != null) zeichenbereich_func03_2.delete();


        if (parameterEingabe_func01 != null) parameterEingabe_func01.delete(Hauptfenster);
        if (parameterEingabe_func02 != null) parameterEingabe_func02.delete(Hauptfenster);
        if (parameterEingabe_func03 != null) parameterEingabe_func03.delete(Hauptfenster);

        zeichenbereich_func01_1 	= null;
        zeichenbereich_func01_2 	= null;

        zeichenbereich_func02_1 	= null;
        zeichenbereich_func02_2 	= null;

        zeichenbereich_func03_1 	= null;
        zeichenbereich_func03_2 	= null;

        parameterEingabe_func01	= null;
        parameterEingabe_func02	= null;
        parameterEingabe_func03	= null;
    }


    /**
     * frgt die Ein und Ausgabebereiche fr Funktion01 dem Fenster hinzu
     */
    private void add_func01() {
        BT_close.setIcon(Polarkoordinaten.getsymbolClose());
        BT_Func01.setIcon(Polarkoordinaten.getsymbolPressedLogo(0));
        BT_Func02.setIcon(Polarkoordinaten.getsymbolUnPressedLogo(1));
        BT_Func03.setIcon(Polarkoordinaten.getsymbolUnPressedLogo(2));
//		BT_about.setIcon(Polarkoordinaten.getsymbolAbout());

        zeichenbereich_func01_1=null;
        zeichenbereich_func01_2=null;
        parameterEingabe_func01=null;

        // Eingabe Anfgen
        parameterEingabe_func01 = new Eingabe_Funktion01();
        parameterEingabe_func01.addToFrame(Hauptfenster);

        zeichenbereich_func01_1 = new Zeichnen_Funktion01(parameterEingabe_func01, false);
        zeichenbereich_func01_2 = new Zeichnen_Funktion01(parameterEingabe_func01, true);

        HauptFensterMitte.add(zeichenbereich_func01_1);
        HauptFensterMitte.add(zeichenbereich_func01_2);

        // Men aktualisieren
        Polarkoordinaten.setMenueFunktionsart(0);
    }


    /**
     * frgt die Ein und Ausgabebereiche fr Funktion02 dem Fenster hinzu
     */
    private void add_func02() {
        BT_close.setIcon(Polarkoordinaten.getsymbolClose());
        BT_Func01.setIcon(Polarkoordinaten.getsymbolUnPressedLogo(0));
        BT_Func02.setIcon(Polarkoordinaten.getsymbolPressedLogo(1));
        BT_Func03.setIcon(Polarkoordinaten.getsymbolUnPressedLogo(2));
//		BT_about.setIcon(Polarkoordinaten.getsymbolAbout());

        zeichenbereich_func02_1=null;
        zeichenbereich_func02_2=null;
        parameterEingabe_func02=null;

        // Eingabe Anfgen
        parameterEingabe_func02 = new Eingabe_Funktion02();
        parameterEingabe_func02.addToFrame(Hauptfenster);

        zeichenbereich_func02_1 = new Zeichnen_Funktion02(parameterEingabe_func02, false);
        zeichenbereich_func02_2 = new Zeichnen_Funktion02(parameterEingabe_func02, true);

        HauptFensterMitte.add(zeichenbereich_func02_1);
        HauptFensterMitte.add(zeichenbereich_func02_2);

        // Men aktualisieren
        Polarkoordinaten.setMenueFunktionsart(1);
    }


    /**
     * frgt die Ein und Ausgabebereiche fr Funktion03 dem Fenster hinzu
     */
    private void add_func03() {
        BT_close.setIcon(Polarkoordinaten.getsymbolClose());
        BT_Func01.setIcon(Polarkoordinaten.getsymbolUnPressedLogo(0));
        BT_Func02.setIcon(Polarkoordinaten.getsymbolUnPressedLogo(1));
        BT_Func03.setIcon(Polarkoordinaten.getsymbolPressedLogo(2));
//		BT_about.setIcon(Polarkoordinaten.getsymbolAbout());

        zeichenbereich_func03_1=null;
        zeichenbereich_func03_2=null;
        parameterEingabe_func03=null;

        // Eingabe Anfgen
        parameterEingabe_func03 = new Eingabe_Funktion03();
        parameterEingabe_func03.addToFrame(Hauptfenster);

        zeichenbereich_func03_1 = new Zeichnen_Funktion03(parameterEingabe_func03, false);
        zeichenbereich_func03_2 = new Zeichnen_Funktion03(parameterEingabe_func03, true);

        HauptFensterMitte.add(zeichenbereich_func03_1);
        HauptFensterMitte.add(zeichenbereich_func03_2);

        // Men aktualisieren
        Polarkoordinaten.setMenueFunktionsart(2);
    }
}
