package KiP_v3;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.SystemColor;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionAdapter;
import java.text.DecimalFormat;

import javax.swing.JPanel;


/**
 * Klasse Zeichenbereich
 * Erzeugt den eigentlichen Zeichenbereich auf dem die Grafik dargestellt wird
 * @author Florian Pahling 17/03/2008
 */
public class Zeichnen_Funktion02 extends JPanel {
    /**
     * Fr was auch immer man das braucht
     */
    private static final long serialVersionUID = 1L;

    // Bild fr die Funktion
    // private Image img = null;

    // Trick 17 ;-) Fr Dorepaint
    int x=1;

    // Formatierung der Anzeigen
    DecimalFormat df1 = new DecimalFormat( "0" );
    DecimalFormat df2 = new DecimalFormat( "0.00" );
    DecimalFormat df3 = new DecimalFormat( "0" );
    DecimalFormat df4 = new DecimalFormat( "0.000" );

    // Pfeilgren
    private int Pfeil_laenge = 12;
    private int Pfeil_breite = 3;

    // Referenz auf die Eingabeparameter
    private Eingabe_Funktion02 parameterEingabe = null;

    // Referenz auf die Skalierungsklasse
    private Skalierung_Funktion02 skalierung = null;

    // bestimmt ob dieser Zeichenbereich normiert dargestellt werden soll
    private boolean IsNormaled = false;

    // Klick-Toleranz fr MouseDragging
    private double Klick_Tolleranz = 0.1;

    // erlaubt das Verschieben des Abgriffs
    private boolean CanDrag = false;


    /**
     * erzwingt eine Neuberechnung der Skalierung
     */
    public void DoRecalc() {
        skalierung.ForceRechnen(getWidth(), getHeight());
        this.repaint();
    }


    /**
     * Konstruktor
     * erzeugt neuen Zeichenbereich
     *
     * @param w 	Referenz auf die Eingaben
     */
    public Zeichnen_Funktion02(Eingabe_Funktion02 w, boolean isNormaled) {
        // Parameter bernehmen und sichern
        parameterEingabe = w;
        parameterEingabe.setZeichenbereich(this);
        IsNormaled = isNormaled;

        // neue Skalierungsberechnung erzeugen
        skalierung = new Skalierung_Funktion02(parameterEingabe, IsNormaled);
    }


    /**
     * lscht den Zeichenbereich
     * und gibt interne Referenzen frei
     */
    public void delete() {
        parameterEingabe = null;
        skalierung = null;
    }


    /**
     * veranlasst ein neuzeichnen der Visualisierung
     */
    public void Dorepaint() {
        this.repaint();
    }





    /**
     * Neuzeichnen der Grafik erforderlich
     *
     * @param A 	Graphics Objekt auf die Zeichenflche
     */
    protected void paintComponent( Graphics A) {
        // Referzenz fr 2D Grafik
        //Graphics2D g2d = (Graphics2D) A;

        // bergeordnetes Zeichen aktivieren
        super.paintComponent(A);

        // Skalierung aktualisieren
        skalierung.Rechnen(getWidth(), getHeight());

        // Hintergund der Zeichenflche wei darstellen
        PrintBackground(A);

        // bei Normierter Darstellung entsprechende Einbelendung
        if(!IsNormaled) {
            PrintFunktion01(A);
            AchsePol(A);

            // Mausaktionen verwenden
            addMouseListener(new MyMouseListener());
            addMouseMotionListener(new MyMouseMotionListener());
        } else {
            PrintFunktion02(A);
            AchseKar(A);

            // neue Skalierungsberechnung erzeugen
            skalierung = new Skalierung_Funktion02(parameterEingabe, !IsNormaled);
        }
        if(x==1) {
            Dorepaint();
            x++;
        }
    }


    /**
     * Zeichnet den eigentlichen Verlauf der Kurve
     *
     * @param g 	Graphics Objekt auf die Zeichenflche
     */
    private void PrintFunktion01 (Graphics A) {
        // Referzenz fr 2D Grafik
        Graphics2D g2d = (Graphics2D) A;

        // Mit Rot Zeichnen
        g2d.setColor(Color.RED);
        g2d.setStroke(new BasicStroke(1,BasicStroke.CAP_ROUND, BasicStroke.JOIN_MITER));

        for (double lauf = 50; lauf <= (771); lauf+=0.1) {

            // Koordinaten umrechnen
            int Punkt_y = (int) skalierung.getWertY(lauf) + skalierung.getOffset_Y();
            Punkt_y = ((skalierung.getHeight()/2)-(Punkt_y-(skalierung.getHeight()/2)));
            int Punkt_x = (int) skalierung.getWertX(lauf) + skalierung.getOffset_X();

            // Kurve zeichnen
            if(Punkt_y > skalierung.getRand() && Punkt_y < (skalierung.getHeight()-skalierung.getRand()))
                A.drawLine(Punkt_x, Punkt_y, Punkt_x, Punkt_y);
        }

        int Punkt_x = (int) skalierung.getWertX(parameterEingabe.get_Winkel()+50) + skalierung.getOffset_X();
        int Punkt_y = (int) skalierung.getWertY(parameterEingabe.get_Winkel()+50) + skalierung.getOffset_Y();
        Punkt_y = ((skalierung.getHeight()/2)-(Punkt_y-(skalierung.getHeight()/2)));


        if(skalierung.getRadiusWert(parameterEingabe.get_Winkel()) < 0) {
            // Mit Rot Zeichnen
            g2d.setColor(Color.RED);
            A.drawString("Negativer Radius nicht definiert" ,60, skalierung.getHeight()-30);
        }
        // Mit Blau Zeichnen
        g2d.setColor(Color.BLUE);
        g2d.setStroke(new BasicStroke(2,BasicStroke.CAP_ROUND, BasicStroke.JOIN_MITER));


        // Schriftzug
        if(Punkt_y > skalierung.getRand() && Punkt_y < (skalierung.getHeight()-skalierung.getRand())) {
            // Mit Blau Zeichnen
            g2d.setColor(Color.BLUE);
            A.drawString("" + df2.format( (double) skalierung.getRadiusWert(parameterEingabe.get_Winkel())) ,Punkt_x+10 ,Punkt_y);
        }
        // Linie selber
        if(Punkt_y > skalierung.getRand() && Punkt_y < (skalierung.getHeight()-skalierung.getRand()))
            A.drawLine(Punkt_x, skalierung.getHeight()/2, Punkt_x, Punkt_y);
        else {
            if(Punkt_y < 50) {
                A.drawLine(Punkt_x, skalierung.getHeight()/2, Punkt_x, skalierung.getRand());
            } else
                A.drawLine(Punkt_x, skalierung.getHeight()/2, Punkt_x, (skalierung.getHeight()-skalierung.getRand()));
        }

        // Mit Grn Zeichnen
        g2d.setColor(Color.GREEN);
        g2d.setStroke(new BasicStroke(2,BasicStroke.CAP_ROUND, BasicStroke.JOIN_MITER));

        // Zeichnet den Winkel in Grn
        A.drawLine(50, skalierung.getHeight()/2, Punkt_x, skalierung.getHeight()/2);
//		Dorepaint();
    }



    private void PrintFunktion02 (Graphics A) {
        // Faktor fr untere Funktion
        double Faktor = 0.5;

        // Referzenz fr 2D Grafik
        Graphics2D g2d = (Graphics2D) A;

        // Weier Hintergrund wo der Text steht
        // g2d.setColor(Color.WHITE);
        // A.fillRect(20, 20, 170, 50);

        g2d.setColor(Color.BLACK);
        g2d.setStroke(new BasicStroke(1,BasicStroke.CAP_ROUND, BasicStroke.JOIN_MITER));

        // Werte Anzeigen lassen
        double Wert_R = skalierung.getRadiusWert(parameterEingabe.get_Winkel());
        double winkel = parameterEingabe.get_Winkel();

        if(parameterEingabe.getWinkeloderBogenma() == false ) {
            A.drawString("mit \u03C6 = " +df3.format(winkel)  , 3*skalierung.getRand()/2, 3*skalierung.getRand());
        } else {
            winkel = winkel / (720/12.57);
            A.drawString("mit \u03C6 = " +df2.format( (double) winkel ) , 3*skalierung.getRand()/2, 3*skalierung.getRand());
        }

        A.drawString("                     a" , 3*skalierung.getRand()/2, 2*skalierung.getRand()-9);
        A.drawString("           _____________" , 3*skalierung.getRand()/2, 2*skalierung.getRand()-8);
        A.drawString("r(\u03C6) =                            = " +df2.format( (double) Wert_R ) , 3*skalierung.getRand()/2, 2*skalierung.getRand());
        A.drawString("            1 - b\u05BCcos(\u03C6+c)   " , 3*skalierung.getRand()/2, 5+2*skalierung.getRand());

        // Zeichnet den Verlauf der Kurve in Rot
        g2d.setColor(Color.RED);
        g2d.setStroke(new BasicStroke(1,BasicStroke.CAP_ROUND, BasicStroke.JOIN_MITER));

        for (double value = 0; value <= 12.57; value+=0.001d) {
            double Wert_r = skalierung.getRadiusWert_func02(value);
            double Winkel = value;

            if(Wert_r >= 0) {
                double x = (Wert_r * Math.cos(Winkel))*skalierung.getRand() * Faktor;
                double y = -(Wert_r * Math.sin(Winkel))*skalierung.getRand() * Faktor;

                int Punkt_x = (int) x + (skalierung.getWidth()/2);
                int Punkt_y = (int) y + (skalierung.getHeight()/2);

                A.drawLine(Punkt_x, Punkt_y, Punkt_x, Punkt_y);
            }
        }

        double value = parameterEingabe.get_Winkel();
        double Wert_r = skalierung.getRadiusWert(value);
        double Winkel = 2 * Math.PI * (value / 360);

        double x = (Wert_r * Math.cos(Winkel))*skalierung.getRand() * Faktor;
        double y = -(Wert_r * Math.sin(Winkel))*skalierung.getRand() * Faktor;

        int Punkt_x = (int) x + (skalierung.getWidth()/2);
        int Punkt_y = (int) y + (skalierung.getHeight()/2);


        if(Wert_R == skalierung.unendlich(0)) {
            value = parameterEingabe.get_Winkel()+1;
            Wert_r = skalierung.getRadiusWert(value);
            Winkel = 2 * Math.PI * (value / 360);

            x = (Wert_r * Math.cos(Winkel))*skalierung.getRand() * Faktor;
            Punkt_x = (int) x + (skalierung.getWidth()/2);

            value = parameterEingabe.get_Winkel();
            Wert_r = skalierung.getRadiusWert_y(value);
            Winkel = 2 * Math.PI * (value / 360);

            y = -(Wert_r * Math.sin(Winkel))*skalierung.getRand() * Faktor;
            Punkt_y = (int) y + (skalierung.getHeight()/2);
        }

        if(Wert_R >= 0) {
            g2d.setColor(Color.BLUE);
            g2d.setStroke(new BasicStroke(2,BasicStroke.CAP_ROUND, BasicStroke.JOIN_MITER));

            // Zeichnet die Linie
            A.drawLine(Punkt_x, Punkt_y, skalierung.getWidth()/2, skalierung.getHeight()/2);

            // Schriftzug
            A.drawString("" + df2.format( (double) skalierung.getRadiusWert(parameterEingabe.get_Winkel())) ,Punkt_x+10 ,Punkt_y);
        }

        g2d.setColor(SystemColor.control);
        A.fillRect(0, 0, skalierung.getWidth(), 20);
        A.fillRect(0, 0, 20, skalierung.getHeight());
        A.fillRect(skalierung.getWidth()-20, 0, 20, skalierung.getHeight());
        A.fillRect(0, skalierung.getHeight()-20, skalierung.getWidth(), 20);
    }


    private void AchsePol (Graphics A) {

        // Referzenz fr 2D Grafik
        Graphics2D g2d = (Graphics2D) A;

        // X-Achse
        g2d.setColor(Color.BLACK);
        g2d.setStroke(new BasicStroke(1,BasicStroke.CAP_ROUND, BasicStroke.JOIN_MITER));

        A.drawLine(skalierung.getWidth()-30, skalierung.getHeight()/2, 50-3, skalierung.getHeight()/2);

        // Y-Achse
        A.drawLine(50, skalierung.getHeight()-30, 50, 30);

        // Pfeile an die Achsen
        for (int i=Pfeil_laenge; i>=0; i--) {
            // Oben
            A.drawLine(50 - Pfeil_breite, 40, 50, 40+i-Pfeil_laenge);
            A.drawLine(50 + Pfeil_breite, 40, 50, 40+i-Pfeil_laenge);

            //Rechts
            A.drawLine(skalierung.getWidth()-40, skalierung.getHeight()/2-Pfeil_breite, skalierung.getWidth()-40-i+Pfeil_laenge, skalierung.getHeight()/2);
            A.drawLine(skalierung.getWidth()-40, skalierung.getHeight()/2+Pfeil_breite, skalierung.getWidth()-40-i+Pfeil_laenge, skalierung.getHeight()/2);
        }

        // Beschriftungen
        Font Old_font = A.getFont();
        Font font = new Font ("Arial", Font.PLAIN, 13);
        A.setFont(font);

        // X - Achse
        A.drawString("\u03C6", skalierung.getWidth()-40+5, skalierung.getHeight()/2+13);

        // Y - Achse
        A.drawString("r(\u03C6)", 50+8, 40);

        A.setFont(Old_font);


        // Achsenbeschriftung
        // X - Achsen Beschriftung von oo .. oo
        {


            // Platzbedarf fr Schrift ausrechnen
            FontMetrics fm = getFontMetrics(getFont());
            int Beschriftung_Height = fm.getHeight();

            for(int i=0; i <= 8; i++) {

                int X_Wert = ((int) skalierung.getWertX(90*i))+50;
                if(parameterEingabe.getWinkeloderBogenma()) {
                    switch(i) {
                    case 0:
                        A.drawString("0",(X_Wert + 5), skalierung.getHeight()/2 + Beschriftung_Height);
                        break;
                    case 1:
                        A.drawString(" ",(X_Wert), skalierung.getHeight()/2 + Beschriftung_Height);
                        A.drawLine(X_Wert, skalierung.getHeight()/2-2, X_Wert, skalierung.getHeight()/2+3);
                        break;
                    case 2:
                        A.drawString("\u03c0 ",(X_Wert), skalierung.getHeight()/2 + Beschriftung_Height);
                        A.drawLine(X_Wert, skalierung.getHeight()/2-2, X_Wert, skalierung.getHeight()/2+3);
                        break;
                    case 3:
                        A.drawString(" ",(X_Wert), skalierung.getHeight()/2 + Beschriftung_Height);
                        A.drawLine(X_Wert, skalierung.getHeight()/2-2, X_Wert, skalierung.getHeight()/2+3);
                        break;
                    case 4:
                        A.drawString("2 \u03c0 ",(X_Wert), skalierung.getHeight()/2 + Beschriftung_Height);
                        A.drawLine(X_Wert, skalierung.getHeight()/2-2, X_Wert, skalierung.getHeight()/2+3);
                        break;
                    case 5:
                        A.drawString("  ",(X_Wert), skalierung.getHeight()/2 + Beschriftung_Height);
                        A.drawLine(X_Wert, skalierung.getHeight()/2-2, X_Wert, skalierung.getHeight()/2+3);
                        break;
                    case 6:
                        A.drawString("3 \u03c0 ",(X_Wert), skalierung.getHeight()/2 + Beschriftung_Height);
                        A.drawLine(X_Wert, skalierung.getHeight()/2-2, X_Wert, skalierung.getHeight()/2+3);
                        break;
                    case 7:
                        A.drawString(" ",(X_Wert), skalierung.getHeight()/2 + Beschriftung_Height);
                        A.drawLine(X_Wert, skalierung.getHeight()/2-2, X_Wert, skalierung.getHeight()/2+3);
                        break;
                    case 8:
                        A.drawString("4 \u03c0 ",skalierung.getWidth()-80, skalierung.getHeight()/2 + Beschriftung_Height);
                        A.drawLine(skalierung.getWidth()-80, skalierung.getHeight()/2-2, skalierung.getWidth()-80, skalierung.getHeight()/2+3);
                        break;
                    }
                } else {
                    switch(i) {
                    case 0:
                        A.drawString("0",(X_Wert + 5), skalierung.getHeight()/2 + Beschriftung_Height);
                        break;
                    case 1:
                        A.drawString("90",(X_Wert), skalierung.getHeight()/2 + Beschriftung_Height);
                        A.drawLine(X_Wert, skalierung.getHeight()/2-2, X_Wert, skalierung.getHeight()/2+3);
                        break;
                    case 2:
                        A.drawString("180",(X_Wert), skalierung.getHeight()/2 + Beschriftung_Height);
                        A.drawLine(X_Wert, skalierung.getHeight()/2-2, X_Wert, skalierung.getHeight()/2+3);
                        break;
                    case 3:
                        A.drawString("270",(X_Wert), skalierung.getHeight()/2 + Beschriftung_Height);
                        A.drawLine(X_Wert, skalierung.getHeight()/2-2, X_Wert, skalierung.getHeight()/2+3);
                        break;
                    case 4:
                        A.drawString("360",(X_Wert), skalierung.getHeight()/2 + Beschriftung_Height);
                        A.drawLine(X_Wert, skalierung.getHeight()/2-2, X_Wert, skalierung.getHeight()/2+3);
                        break;
                    case 5:
                        A.drawString("450",(X_Wert), skalierung.getHeight()/2 + Beschriftung_Height);
                        A.drawLine(X_Wert, skalierung.getHeight()/2-2, X_Wert, skalierung.getHeight()/2+3);
                        break;
                    case 6:
                        A.drawString("540",(X_Wert), skalierung.getHeight()/2 + Beschriftung_Height);
                        A.drawLine(X_Wert, skalierung.getHeight()/2-2, X_Wert, skalierung.getHeight()/2+3);
                        break;
                    case 7:
                        A.drawString("630",(X_Wert), skalierung.getHeight()/2 + Beschriftung_Height);
                        A.drawLine(X_Wert, skalierung.getHeight()/2-2, X_Wert, skalierung.getHeight()/2+3);
                        break;
                    case 8:
                        A.drawString("720",skalierung.getWidth()-80, skalierung.getHeight()/2 + Beschriftung_Height);
                        A.drawLine(skalierung.getWidth()-80, skalierung.getHeight()/2-2, skalierung.getWidth()-80, skalierung.getHeight()/2+3);
                        break;
                    }
                }
            }
        }


        // Y - Achsen Beschriftung

        // Kleine Markierungen und den Text anbringen
        int Punkt_pos5 = (int) 50 + skalierung.getOffset_Y();
        Punkt_pos5 = ((skalierung.getHeight()/2)-(Punkt_pos5-(skalierung.getHeight()/2)));
        A.drawLine(50-3, Punkt_pos5, 50+2 ,Punkt_pos5);
        A.drawString("5 ", 40, Punkt_pos5+5);

        if(skalierung.getHeight() > 290) {
            int Punkt_pos10 = (int) 100 + skalierung.getOffset_Y();
            Punkt_pos10 = ((skalierung.getHeight()/2)-(Punkt_pos10-(skalierung.getHeight()/2)));
            A.drawLine(50-3, Punkt_pos10, 50+2 ,Punkt_pos10);
            A.drawString("10 ", 35, Punkt_pos10+5);
        }

        int Punkt_neg5 = (int) 50 + skalierung.getOffset_Y();
        Punkt_neg5 = ((skalierung.getHeight()/2)-(Punkt_neg5-(skalierung.getHeight()/2)));
        A.drawLine(50-3, Punkt_neg5+100, 50+2 ,Punkt_neg5+100);
        A.drawString("-5 ", 35, Punkt_neg5+100+5);

        if(skalierung.getHeight() > 290) {
            int Punkt_neg10 = (int) 100 + skalierung.getOffset_Y();
            Punkt_neg10 = ((skalierung.getHeight()/2)-(Punkt_neg10-(skalierung.getHeight()/2)));
            A.drawLine(50-3, Punkt_neg10+200, 50+2 ,Punkt_neg10+200);
            A.drawString("-10 ", 30, Punkt_neg10+200+5);
        }
    }



    private void AchseKar (Graphics A) {

        // Referzenz fr 2D Grafik
        Graphics2D g2d = (Graphics2D) A;

        // X-Achse
        g2d.setColor(Color.BLACK);
        g2d.setStroke(new BasicStroke(1,BasicStroke.CAP_ROUND, BasicStroke.JOIN_MITER));

        A.drawLine(skalierung.getWidth()-10-skalierung.getRand(), skalierung.getHeight()/2, 10+skalierung.getRand(), skalierung.getHeight()/2);

        // Y-Achse
        A.drawLine(skalierung.getPosYAchse(), skalierung.getHeight()-10-skalierung.getRand(), skalierung.getPosYAchse(), 10+skalierung.getRand());


        // Pfeile an die Achsen
        for (int i=Pfeil_laenge; i>=0; i--) {
            // Oben
            A.drawLine(skalierung.getPosYAchse() - Pfeil_breite, 40, skalierung.getPosYAchse(), 40+i-Pfeil_laenge);
            A.drawLine(skalierung.getPosYAchse() + Pfeil_breite, 40, skalierung.getPosYAchse(), 40+i-Pfeil_laenge);

            //Rechts
            A.drawLine(skalierung.getWidth()-40, skalierung.getHeight()/2-Pfeil_breite, skalierung.getWidth()-40-i+Pfeil_laenge, skalierung.getHeight()/2);
            A.drawLine(skalierung.getWidth()-40, skalierung.getHeight()/2+Pfeil_breite, skalierung.getWidth()-40-i+Pfeil_laenge, skalierung.getHeight()/2);
        }

        // Beschriftungen
        Font Old_font = A.getFont();
        Font font = new Font ("Arial", Font.PLAIN, 13);
        A.setFont(font);

        A.setFont(Old_font);

        int hlfte_y = (skalierung.getHeight()/2);
        int hlfte_x = (skalierung.getWidth()/2);

        // X - Achse
        A.drawString("x", skalierung.getWidth()-40+5, skalierung.getHeight()/2+13);

        // Kleine Markierungen und den Text anbringen
        int Punktx_pos5 = hlfte_y - (int) 50 + skalierung.getOffset_Y();
        Punktx_pos5 = hlfte_x + ((skalierung.getHeight()/2)-(Punktx_pos5-(skalierung.getHeight()/2)));
        A.drawLine(Punktx_pos5, hlfte_y+2 ,Punktx_pos5, hlfte_y-2);
        A.drawString("5 ", Punktx_pos5, hlfte_y-5);

        int Punktx_pos10 = hlfte_y - (int) 100 + skalierung.getOffset_Y();
        Punktx_pos10 = hlfte_x + ((skalierung.getHeight()/2)-(Punktx_pos10-(skalierung.getHeight()/2)));
        A.drawLine(Punktx_pos10, hlfte_y+2 ,Punktx_pos10, hlfte_y-2);
        A.drawString("10 ", Punktx_pos10-5, hlfte_y-5);

        int Punktx_pos15 = hlfte_y - (int) 150 + skalierung.getOffset_Y();
        Punktx_pos15 = hlfte_x + ((skalierung.getHeight()/2)-(Punktx_pos15-(skalierung.getHeight()/2)));
        A.drawLine(Punktx_pos15, hlfte_y+2 ,Punktx_pos15, hlfte_y-2);
        A.drawString("15 ", Punktx_pos15-5, hlfte_y-5);

        if(skalierung.getWidth() >= 500) {
            int Punktx_pos20 = hlfte_y - (int) 200 + skalierung.getOffset_Y();
            Punktx_pos20 = hlfte_x + ((skalierung.getHeight()/2)-(Punktx_pos20-(skalierung.getHeight()/2)));
            A.drawLine(Punktx_pos20, hlfte_y+2 ,Punktx_pos20, hlfte_y-2);
            A.drawString("20 ", Punktx_pos20-5, hlfte_y-5);
        }

        if(skalierung.getWidth() >= 600) {
            int Punktx_pos25 = hlfte_y - (int) 250 + skalierung.getOffset_Y();
            Punktx_pos25 = hlfte_x + ((skalierung.getHeight()/2)-(Punktx_pos25-(skalierung.getHeight()/2)));
            A.drawLine(Punktx_pos25, hlfte_y+2 ,Punktx_pos25, hlfte_y-2);
            A.drawString("25 ", Punktx_pos25-5, hlfte_y-5);
        }

        int Punktx_neg5 = hlfte_y - (int) 50 + skalierung.getOffset_Y();
        Punktx_neg5 = hlfte_x - ((skalierung.getHeight()/2)-(Punktx_neg5-(skalierung.getHeight()/2)));
        A.drawLine(Punktx_neg5, hlfte_y+2 ,Punktx_neg5, hlfte_y-2);
        A.drawString("-5 ", Punktx_neg5-5, hlfte_y-5);

        int Punktx_neg10 = hlfte_y - (int) 100 + skalierung.getOffset_Y();
        Punktx_neg10 = hlfte_x - ((skalierung.getHeight()/2)-(Punktx_neg10-(skalierung.getHeight()/2)));
        A.drawLine(Punktx_neg10, hlfte_y+2 ,Punktx_neg10, hlfte_y-2);
        A.drawString("-10 ", Punktx_neg10-10, hlfte_y-5);

        int Punktx_neg15 = hlfte_y - (int) 150 + skalierung.getOffset_Y();
        Punktx_neg15 = hlfte_x - ((skalierung.getHeight()/2)-(Punktx_neg15-(skalierung.getHeight()/2)));
        A.drawLine(Punktx_neg15, hlfte_y+2 ,Punktx_neg15, hlfte_y-2);
        A.drawString("-15 ", Punktx_neg15-10, hlfte_y-5);

        if(skalierung.getWidth() >= 500) {
            int Punktx_neg20 = hlfte_y - (int) 200 + skalierung.getOffset_Y();
            Punktx_neg20 = hlfte_x - ((skalierung.getHeight()/2)-(Punktx_neg20-(skalierung.getHeight()/2)));
            A.drawLine(Punktx_neg20, hlfte_y+2 ,Punktx_neg20, hlfte_y-2);
            A.drawString("-20 ", Punktx_neg20-10, hlfte_y-5);
        }

        if(skalierung.getWidth() >= 600) {
            int Punktx_neg25 = hlfte_y - (int) 250 + skalierung.getOffset_Y();
            Punktx_neg25 = hlfte_x - ((skalierung.getHeight()/2)-(Punktx_neg25-(skalierung.getHeight()/2)));
            A.drawLine(Punktx_neg25, hlfte_y+2 ,Punktx_neg25, hlfte_y-2);
            A.drawString("-25 ", Punktx_neg25-10, hlfte_y-5);
        }

        // Y - Achse
        A.drawString("y", skalierung.getPosYAchse() + 8, skalierung.getRand()*2);

        // Kleine Markierungen und den Text anbringen

        int Punkt_pos5 = (int) 50 + skalierung.getOffset_Y();
        Punkt_pos5 = ((skalierung.getHeight()/2)-(Punkt_pos5-(skalierung.getHeight()/2)));
        A.drawLine(hlfte_x-3, Punkt_pos5, hlfte_x+2 ,Punkt_pos5);
        A.drawString("5 ", hlfte_x-10, Punkt_pos5+5);

        if(skalierung.getHeight() > 290) {
            int Punkt_pos10 = (int) 100 + skalierung.getOffset_Y();
            Punkt_pos10 = ((skalierung.getHeight()/2)-(Punkt_pos10-(skalierung.getHeight()/2)));
            A.drawLine(hlfte_x-3, Punkt_pos10, hlfte_x+2 ,Punkt_pos10);
            A.drawString("10 ", hlfte_x-15, Punkt_pos10+5);
        }

        int Punkt_neg5 = (int) 50 + skalierung.getOffset_Y();
        Punkt_neg5 = ((skalierung.getHeight()/2)-(Punkt_neg5-(skalierung.getHeight()/2)));
        A.drawLine(hlfte_x-3, Punkt_neg5+100, hlfte_x+2 ,Punkt_neg5+100);
        A.drawString("-5 ", hlfte_x-15, Punkt_neg5+100+5);

        if(skalierung.getHeight() > 290) {
            int Punkt_neg10 = (int) 100 + skalierung.getOffset_Y();
            Punkt_neg10 = ((skalierung.getHeight()/2)-(Punkt_neg10-(skalierung.getHeight()/2)));
            A.drawLine(hlfte_x-3, Punkt_neg10+200, hlfte_x+2 ,Punkt_neg10+200);
            A.drawString("-10 ", hlfte_x-20, Punkt_neg10+200+5);
        }
//			Dorepaint();
    }


    /**
     * Hintergund weilich darstellen
     *
     * @param A 	Graphics Objekt auf die Zeichenflche
     */
    private void PrintBackground (Graphics A) {
        // Referzenz fr 2D Grafik
        Graphics2D g2d = (Graphics2D) A;

        // Rahmen
//		Color Farbe = new Color(0xffdcdc00);
//		g2d.setColor(Farbe);
        g2d.setColor(Color.WHITE);
        g2d.fill(new Rectangle(skalierung.getRand(),skalierung.getRand(),skalierung.getWidth()-skalierung.getRand()*2,skalierung.getHeight()-skalierung.getRand()*2));

    }


//	************************************************************* ******************************************
//  M o u s e L i s t e n e r
//************************************************************* ******************************************
    class MyMouseListener extends MouseAdapter {

        /**
        * Methode wird aufgerufen, falls Maustaste gedrckt wurde
        *
        * @param evt 	MouseEvent
        */
        public void mousePressed(MouseEvent evt) {
            // Mausposition holen
            int posX = evt.getX();
            int Punkt_x = (int) skalierung.getWertX(parameterEingabe.get_Winkel()+50) + skalierung.getOffset_X();
            //int posY = evt.getY();

            // aus Mauskoordinaten Orginalwert errechnen
            skalierung.Rechnen(getWidth(), getHeight());
            double Calculated_X_Value = (posX);

            // Tolleranz bercksichtigen
            Klick_Tolleranz = 1d ; // * parameterEingabe.getStandardabweichung();

            // Gltiger Bereich?
            if (
                Calculated_X_Value >= Punkt_x - Klick_Tolleranz
                &&
                Calculated_X_Value <= Punkt_x + Klick_Tolleranz
            ) {

                // Hier auf jeden Fall in einem Bereich in dem reagiert wird!
                CanDrag = true;
            }
        }

        /**
        * Methode wird aufgerufen, falls die "Maus" das Koordinatensystem verlassen hat, d.h.
        * im Ausgabemen, darf nun keine Mausposition mehr angezeigt werden.
        *
        * @param evt 	MouseEvent
        */
        public void mouseExited(MouseEvent evt) {

            if (CanDrag) {
                if (CanDrag) {
                    CanDrag = false;
                    parameterEingabe.setIsDragging(false);
                }
                setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
            }
        }

        /**
        * Methode wird aufgerufen, falls die Maustaste losgelassen wurde, d.h.
        * ein Punkt wurde verschoben bzw. aus dem Koordinatensystem gezogen und
        * wird gelscht.
        *
        * @param evt 	MouseEvent
        */
        public void mouseReleased(MouseEvent evt) {
            // nur wenn verschoben wird
            if (CanDrag) {
                // ende Verschiebung
                CanDrag = false;
                parameterEingabe.setIsDragging(false);

                // derzeige Mausposition
                int Punkt_x = (int) parameterEingabe.get_Winkel();

                skalierung.Rechnen(getWidth(), getHeight());

                // Untergrenze
                parameterEingabe.set_Winkel(Punkt_x);


            }
        }

    }

//	************************************************************* ******************************************
//  M o u s e L i s t e n e r
//************************************************************* ******************************************
    class MyMouseMotionListener extends MouseMotionAdapter {

        /**
        * Methode wird aufgerufen, falls Maus bewegt wurde.
        * Maus Cursor wird angepasst
        *
        * @param evt 	MouseEvent
        */
        public void mouseMoved(MouseEvent evt) {
            if (CanDrag != true) {

                // derzeige Mausposition
                int posX = evt.getX();
                int Punkt_x = (int) skalierung.getWertX(parameterEingabe.get_Winkel()+50) + skalierung.getOffset_X();

                // Wert zurckrechnen
                skalierung.Rechnen(getWidth(), getHeight());
                double Calculated_X_Value = (posX);

                Klick_Tolleranz = 1d ; //0.1d * parameterEingabeE.getAbgriff()

                // Mauszeiger ber Abgrifflinie -> Zeiger ndern
                if (
                    Calculated_X_Value >= Punkt_x - Klick_Tolleranz
                    &&
                    Calculated_X_Value <= Punkt_x + Klick_Tolleranz
                ) {
                    setCursor(new java.awt.Cursor(java.awt.Cursor.W_RESIZE_CURSOR  ));
                } else {	// Wenn nicht, normalen Cursor einstellen
                    setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR   ));
                }
            }
        }

        /**
        * Methode wird aufgerufen, falls Maus mit gedrckter Maustaste bewegt wurde.
        *
        * @param evt 	MouseEvent
        */
        public void mouseDragged(MouseEvent evt) {
            // nur wenn verschoben wird
            if (CanDrag == true) {
                int korrektur = 50;
                double posX = evt.getX()-50;
                if(skalierung.getWidth() >= 800)
                    korrektur = 13;
                if(skalierung.getWidth() <= 450)
                    korrektur = 70;
                posX = posX * (720 / ((skalierung.getWidth() / 1.15)-korrektur));
                // Untergrenze

                if( posX <= 0 ) posX = 0;
                parameterEingabe.set_Winkel((int) posX);

            }
        }
    }
}