import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.net.*;
import javax.imageio.ImageIO;
import java.io.IOException;

public class AboutDlg extends JDialog implements ActionListener {
    /**
     * Erfllt eigentlich keinen Zweck, aber Eclipse will,
     * da diese erstellt wird.
     */
    private static final long serialVersionUID = 7140274278636407151L;

    // Titel des Applets.

    private static final String TITEL = "Richtungsfeld einer Differentialgleichung";

    // Name des Entwicklers.

    private static final String ENTWICKLER = "Sebastian Jkel";

    // Semester der Studienarbeit.

    private static final String SEMESTER = "WS 2009/10";

    // Schriftart Dialog, Pitch 12, Standard.

    private static final Font f_big =  new Font("Dialog", Font.PLAIN, 12);

    // Schriftart Dialog, Pitch 12, Fett.

    private static final Font f_thik =  new Font("Dialog", Font.BOLD, 12);

    // Icon des Applets

    private ImageIcon iconLogo;

    /**
     * JLabels, in denen verschiedene Information angezeigt
     * wird, unter anderem auch das iconLogo.
     */
    private JLabel appletLabel, nameLabel, studiengangLabel, semesterLabel, iconLabel;

    /**
     * JButton zum Schlieen des Dialogs.
     */
    private JButton CloseButton;


    /**
     * Ruft initGUI() auf, um Dialogelemente anzuordnen, Dialog
     * ist (ber Superkonstruktor) modal und hat Titel.
     * @param owner Das Besitzerframe des Dialogs
     * @param imagePath Pfad zu den Bilddateien
     */
    public AboutDlg(JFrame owner, String imagePath) {
        super(owner, "ber...", true);

        try {
            //iconLogo = new ImageIcon(new URL(imagePath+"logo.png"));
			iconLogo = new ImageIcon(ImageIO.read(AboutDlg.class.getResourceAsStream("/images/logo.png")));
        } catch(IOException IOE) {
        }

        initGUI();
    }

    /**
     * Ordnet die JTextLabels, das Icon und den Button
     * auf dem Dialog an.
     */
    private void initGUI() {
        try {
            this.getContentPane().setLayout(null);
            {
                iconLabel = new JLabel();
                iconLabel.setBounds(15,42,90,70);
                if (iconLogo != null) iconLabel.setIcon(iconLogo);
                this.getContentPane().add(iconLabel);
            }
            {
                appletLabel = new JLabel();
                appletLabel.setFont(f_thik);
                appletLabel.setText(TITEL);
                appletLabel.setBounds(120,48,320,15);
                this.getContentPane().add(appletLabel);
            }
            {
                nameLabel = new JLabel();
                nameLabel.setFont(f_big);
                nameLabel.setText("Studienarbeit - "+ENTWICKLER);
                nameLabel.setBounds(120,73,320,15);
                this.getContentPane().add(nameLabel);
            }
            {
                studiengangLabel = new JLabel();
                studiengangLabel.setFont(f_big);
                studiengangLabel.setText("Elektronik und Informationstechnik");
                studiengangLabel.setBounds(120,88,320,15);
                this.getContentPane().add(studiengangLabel);
            }
            {
                semesterLabel = new JLabel();
                semesterLabel.setFont(f_big);
                semesterLabel.setText("Hochschule Aalen ("+SEMESTER+")");
                semesterLabel.setBounds(120,103,320,15);
                this.getContentPane().add(semesterLabel);
            }
            {
                CloseButton = new JButton ();
                CloseButton.setText("Schlieen");
                CloseButton.setFocusable(false);
                CloseButton.setFont(f_big);
                CloseButton.addActionListener(this);
                CloseButton.setBounds(155,150,100,25);
                CloseButton.setToolTipText("Hier klicken, um das Dialogfenster zu schlieen.");
                this.getContentPane().add(CloseButton);
            }
            this.setSize(400,240);
            this.setResizable(false);

            // Dialog in der Mitte des Bildschirms positionieren.
            Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
            this.setLocation((screenSize.width - getSize().width) / 2,
                             (screenSize.height - getSize().height) / 2);
        } catch(Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * Einzige mgliche Aktion in diesem Dialog: Schlieen.
     * @param event
     */
    public void actionPerformed(ActionEvent event) {
        this.setVisible(false);
    }

}
