import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.applet.AppletContext;
import java.net.URL;
import javax.imageio.ImageIO;
import java.io.IOException;


public class StartApplet extends javax.swing.JApplet implements ActionListener {
    /**
     * Erfllt eigentlich keinen Zweck, aber Eclipse will,
     * da diese erstellt wird.
     */
    private static final long serialVersionUID = 4000550514095889858L;

    /**
     * Ordner, in welchem die Bilder fr die Icons sind.
     */
    private static final String IMAGEFOLDER = "/images/";

    /**
     * Pfad zur Hilfedatei.
     */
    private static final String HELPFILE = "../html/anleitung.html";

    /**
     * Hintergrundfarbe, damit sich das Applet in die Hintergrundfarbe der
     * Homepage "einschmiegt", mu je Seite angepasst werden.
     */
    private static final Color BGCOLOR = new Color(235, 238, 247);

    /**
     * Font fr den Schriftzug 'Applet starten'
     */
    private static final Font SCHRIFT = new Font("Sans Serif", Font.BOLD, 14);

    /**
     * Frame in welchem das Applet ausgefhrt wird
     */
    private JFrame app_frame = null;

    /**
     * Button "Start", um den Frame in welchem das Applet
     * abluft zu erzeugen und das Haupt-Applet zu starten.
     */
    private JButton buttonStart;

    /**
     * Wird spter bentigt, um die Hilfedatei zu ffnen.
     */
    private AppletContext appContext;

    /**
     * Stammverzeichnis oder URL der Icon-Dateien; mu an
     * WuerfelFrame bergeben werden.
     */
    private String imageBase;

    /**
     * Stammverzeichnis oder URL der HTML-Hilfsdatei; mu an
     * WuerfelFrame bergeben werden.
     */
    private String helpFile;

    /**
     * Malt den Button mit dem logo.png als Icon;
     * kommt der Mauszeiger ins Innere des Buttons,
     * verndert sich dieser. Mit Druck auf den
     * Button startet das eigentliche Applet im
     * Fenster app_frame.
     */
    public void init() {
        try {
            // bergabeparameter vorbereiten
            imageBase = IMAGEFOLDER;
            helpFile = HELPFILE;
            appContext = this.getAppletContext();

            getContentPane().setLayout(null);
            getContentPane().setBackground(BGCOLOR);

            buttonStart = new JButton("Applet starten");
            //buttonStart.setIcon(new ImageIcon(new URL(imageBase+"logo.png")));
			
			try{
				buttonStart.setIcon(new ImageIcon(ImageIO.read(StartApplet.class.getResourceAsStream("/images/logo.png"))));
			}catch(IOException IOE){
			}			
			
            buttonStart.setIconTextGap(20);
            buttonStart.setBackground(BGCOLOR);
            buttonStart.setFont(SCHRIFT);
            buttonStart.setHorizontalAlignment(SwingConstants.LEFT);
            buttonStart.setBounds(10, 10, 250, 100);

            // Listener vorbereiten
            buttonStart.addActionListener(this);
            buttonStart.addMouseListener(new MouseAdapter() {
                public void mouseEntered(MouseEvent evt) {
                    setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
                }

                public void mouseExited(MouseEvent evt) {
                    setCursor(new java.awt.Cursor(
                                  java.awt.Cursor.DEFAULT_CURSOR));
                }
            });

            getContentPane().add(buttonStart);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * Mit Druck auf den Button (einzige mgliche action
     * in dieser Klasse) startet das eigentliche Applet im
     * Fenster app_frame.
     */
    public void actionPerformed(ActionEvent event) {
        app_frame = new EasyFrame(imageBase, helpFile, appContext);
        app_frame.setVisible(true);
    }
}
