/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

import java.util.concurrent.locks.LockSupport;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.text.DecimalFormat;

/*
 * SW_Design.java
 *
 * Created on 16.04.2009, 11:18:08
 */

/**
 *
 * @author Mathias Hartner
 */

public class SW_Design extends JFrame {
    /*** Globale Variablen ***/

    boolean autoscale = false;      //Variable um zu prüfen, ob automatisch skaliert werden soll
    double g_Fall;                  //Fallbeschleunigung
    double g_Erde = 9.81;           //Fallbeschleunigung auf der Erde
    double g_Mars = 3.71;           //Fallbeschleunigung auf dem Mars
    double g_Mond = 1.62;           //Fallbeschleunigung auf dem Mond
    double g_Jupiter = 24.79;       //Fallbeschleunigung auf dem Jupiter
    double g_Venus = 8.87;          //Fallbeschleunigung auf der Venus
    double t;                       //Zeitschritt
    int winkel;                     //Abwurfwinkel
    int height;                     //Abwurfhöhe
    int speed;                      //Abwurfgeschwindigkeit
    double v0;                      //Abwurfgeschwindigkeit
    double x,y;                     //X- und Y-Werte in Abhängigkeit von der Zeit
    double vx,vy;                   //Geschwindigkeit in X- und Y-Richtung
    double tw;                      //Wurfzeit
    int delay;                      //Wartezeit für den Thread

    /*** Setzen der Schrift und des Formates ***/

    Font font = new Font("Tahoma",Font.BOLD,12);
    Font minifont = new Font("Tahoma",Font.BOLD,9);
    Font microfont = new Font("Tahoma",Font.PLAIN,9);
    DecimalFormat f = new DecimalFormat("#0.000");  //Formatierung der Berechnungswerte
    DecimalFormat f2 = new DecimalFormat("#0");     //Formatierung der Achsenbeschriftung
    DecimalFormat ft = new DecimalFormat("#0.00");  //Formatierung für die t-Achse
    DecimalFormat f3 = new DecimalFormat("#0.0");   //Formatierung für die x-Achse
    DecimalFormat f4 = new DecimalFormat("#0.0");   //Formatierung für die y-Achse
    DecimalFormat f5 = new DecimalFormat("#0.0");   //Formatierung für die vx-Achse
    DecimalFormat f6 = new DecimalFormat("#0.0");   //Formatierung für die vy-Achse

    /*** Festlegung von Farbe, Schrift und Linienstärke der Parabel und der Bemaßung ***/

    Font font2 = new Font("Tahoma",Font.BOLD,11);
    Color graphcolor = new Color(100,200,100);
    Color xylabel_color = new Color(0,0,0);
    BasicStroke stroke2pixel = new BasicStroke(2);
    BasicStroke stroke1pixel = new BasicStroke(1);

    /*** Variablen für die Bemaßung in der X/Y-Darstellung ***/

    double faktor = 0;              //Faktor mit dem die X/Y-Werte multipliziert werden
    double incfaktor = 0;           //Faktor mit dem inkrementiert wird
    double xyfaktor = 0;            //Faktor für die Bemaßung der X/Y-Achse

    /*** Variablen für die Bemaßung in der Zeit-Darstellung ***/

    double tfaktor = 0;             //Zeit-Faktor mit dem multipliziert wird
    double xfaktor = 0;             //Faktor für die x(t)-Darstellung
    double inc_faktor_x = 0;        //Faktor mit dem inkrementiert wird
    double xt_faktor = 0;           //Faktor für die Bemaßung der x/t-Achse
    double yfaktor = 0;             //Faktor für die y(t)-Darstellung
    double inc_faktor_y = 0;        //Faktor mit dem inkrementiert wird
    double yt_faktor = 0;           //Faktor für die Bemaßung der y/t-Achse
    double vxfaktor = 0;            //Faktor für die vx(t)-Darstellung
    double inc_faktor_vx = 0;       //Faktor mit dem inkrementiert wird
    double vxt_faktor = 0;          //Faktor für die Bemaßung der vx/t-Achse
    double vyfaktor = 0;            //Faktor für die vy(t)-Darstellung
    double inc_faktor_vy = 0;       //Faktor mit dem inkrementiert wird
    double vyt_faktor = 0;          //Faktor für die Bemaßung der vy/t-Achse
    double xy_faktor = 0;           //Faktor für die Bemaßung der t-Achsen
    double inc_faktor = 0;          //Faktor mit dem bei den t-Achsen inkrementiert wird

    /*** Variablen für die Doppelpufferung ***/

    private Graphics gfx; //Grafik-Puffer
    private BufferedImage bufferedimage; //Screenshot
    Point location;

    /* Creates new form SW_Design */

    public SW_Design() {
        initComponents();

        winkel = jSlider1.getValue();
        height = jSlider2.getValue();
        speed = jSlider3.getValue();

        Erde.setSelected(true);
        g_Fall = g_Erde;
        jLabel2.setText("Abwurfwinkel: "+winkel+"°");
        jLabel3.setText("Abwurfhöhe: "+height+" m");
        jLabel4.setText("Abwurfgeschw.: "+speed+" m/s");
        jLabel11.setText(f.format(t)+" s");

        /*** Hinzufügen des ChangeListeners ***/

        jSlider1.addChangeListener(new SliderListener());
        jSlider2.addChangeListener(new SliderListener());
        jSlider3.addChangeListener(new SliderListener());
        jTabbedPane1.addChangeListener(new TabListener());

        /*** Hinzufügen des ActionListeners ***/

        Erde.addActionListener(new RadioButtonListener());
        Mars.addActionListener(new RadioButtonListener());
        Mond.addActionListener(new RadioButtonListener());
        Jupiter.addActionListener(new RadioButtonListener());
        Venus.addActionListener(new RadioButtonListener());

        /*** Hinzufügen der Window-EventListener ***/

        this.addWindowListener(new windowlistener());
        this.addComponentListener(new componentlistener());
        this.addWindowFocusListener(new focuslistener());
    }

    @Override
    public void update(Graphics g) {
        paint(g);
    }

    @Override
    public void paint(Graphics g) {
		Color oriColor = g.getColor();
		paintImpl(g);
        gfx = g.create(); //Hier besser als getGraphics(), da es weniger "flackert"

        /*** Nur das Capture machen, wenn BufferedImage "null" ist ***/

        if (bufferedimage == null) {
			/*
            location = this.getLocationOnScreen();

            try {
                bufferedimage = new Robot().createScreenCapture(new Rectangle(location.x,location.y,845,465));
            } catch (AWTException ex) {
                //...
            }
			*/
			bufferedimage = new BufferedImage(845, 465, BufferedImage.TYPE_INT_RGB);
			Graphics imgGraphics = bufferedimage.createGraphics();
			imgGraphics.setColor(oriColor);
			paintImpl(imgGraphics);
        }
    }
	
	public void paintImpl(Graphics g) {
        super.paint(g);
        drawCoords(g);
        drawGraph((Graphics2D) g);
	}

    public void drawCoords(Graphics g) {
        if (jTabbedPane1.getSelectedIndex()==0) {
            /*** X/Y-Darstellung ***/

            Polygon polygonX = new Polygon();
            Polygon polygonY = new Polygon();
            g.fillRect(75,89,3,336);
            g.fillRect(75,425,712,3);
            g.setFont(font);
            polygonX.addPoint(787,420);
            polygonX.addPoint(787,432);
            polygonX.addPoint(793,426);
            polygonY.addPoint(70,89);
            polygonY.addPoint(83,89);
            polygonY.addPoint(76,82);
            g.fillPolygon(polygonX);
            g.fillPolygon(polygonY);
            g.drawString("y",48,96);
            g.drawString("x",781,445);
            g.setFont(microfont);
            g.drawString("[m]",55,96);
            g.drawString("[m]",788,445);
        } else {
            /*** x(t)/y(t)-Darstellung ***/

            Polygon polygonT1 = new Polygon();
            Polygon polygonT2 = new Polygon();
            Polygon polygonX = new Polygon();
            Polygon polygonY = new Polygon();
            g.fillRect(72,84,3,182);
            g.fillRect(72,266,320,3);
            g.fillRect(472,84,3,182);
            g.fillRect(472,266,320,3);
            g.setFont(font);
            polygonT1.addPoint(392,261);
            polygonT1.addPoint(392,273);
            polygonT1.addPoint(398,267);
            polygonT2.addPoint(792,261);
            polygonT2.addPoint(792,273);
            polygonT2.addPoint(798,267);
            polygonX.addPoint(67,84);
            polygonX.addPoint(80,84);
            polygonX.addPoint(73,77);
            polygonY.addPoint(467,84);
            polygonY.addPoint(480,84);
            polygonY.addPoint(473,77);
            g.fillPolygon(polygonT1);
            g.fillPolygon(polygonT2);
            g.fillPolygon(polygonX);
            g.fillPolygon(polygonY);
            g.drawString("x",45,91);
            g.drawString("y",445,91);
            g.drawString("t",387,286);
            g.drawString("t",787,286);
            g.setFont(microfont);
            g.drawString("[m]",52,91);
            g.drawString("[m]",452,91);
            g.drawString("[s]",394,286);
            g.drawString("[s]",794,286);
            g.setFont(font);

            /*** vx(t)/vy(t)-Darstellung ***/

            Polygon polygonT3 = new Polygon();
            Polygon polygonT4 = new Polygon();
            Polygon polygonVX = new Polygon();
            Polygon polygonVY = new Polygon();
            g.fillRect(72,339,3,182);
            g.fillRect(72,521,320,3);
            g.fillRect(472,339,3,185);
            g.fillRect(472,440,320,3);
            g.drawString("v",33,346);
            g.drawString("v",433,346);
            g.setFont(minifont);
            g.drawString("x",39,348);
            g.drawString("y",439,348);
            g.setFont(microfont);
            g.drawString("[m/s]",45,346);
            g.drawString("[m/s]",445,346);
            g.setFont(font);
            polygonT3.addPoint(392,516);
            polygonT3.addPoint(392,528);
            polygonT3.addPoint(398,522);
            polygonT4.addPoint(792,435);
            polygonT4.addPoint(792,447);
            polygonT4.addPoint(798,441);
            polygonVX.addPoint(67,339);
            polygonVX.addPoint(80,339);
            polygonVX.addPoint(73,332);
            polygonVY.addPoint(467,339);
            polygonVY.addPoint(480,339);
            polygonVY.addPoint(473,332);
            g.fillPolygon(polygonT3);
            g.fillPolygon(polygonT4);
            g.fillPolygon(polygonVX);
            g.fillPolygon(polygonVY);
            g.drawString("t",387,541);
            g.drawString("t",787,460);
            g.setFont(microfont);
            g.drawString("[s]",394,541);
            g.drawString("[s]",794,460);
        }
    }

    public void drawGraph(Graphics2D g) {
        if (jTabbedPane1.getSelectedIndex()==0) {
            double W,Hmax,alpha,vmin,vmax;
            v0 = speed;

            /*** Sinus und Cosinus des Abwurfwinkels ins Bogenmaß umgerechnet ***/

            double sinx = Math.sin(winkel*Math.PI/180);
            double cosx = Math.cos(winkel*Math.PI/180);

            /*** Wurfzeit ***/

            tw = ((v0*sinx)+Math.sqrt(v0*v0*sinx*sinx+2*g_Fall*height))/g_Fall;
            jLabel7.setText("Wurfzeit: "+f.format(tw)+" s");
            jLabel11.setText(f.format(tw)+" s");

            /*** Wurfweite ***/

            W = (v0*cosx)*tw;
            jLabel5.setText("Wurfweite: "+f.format(W)+" m");

            /*** Maximale Höhe ***/

            Hmax = height+(v0*v0*sinx*sinx)/(2*g_Fall);
            jLabel6.setText("Maximale Höhe: "+f.format(Hmax)+" m");

            /*** Auftreffwinkel ***/

            if (v0 == 0) {
                alpha = 90;
            } else if (winkel == 0 && height == 0) {
                alpha = 90;
            } else {
                alpha = ((-Math.atan((v0*sinx-g_Fall*tw)/(v0*cosx)))*180)/Math.PI;
            }
            jLabel8.setText("Auftreffwinkel: "+f.format(alpha)+"°");

            /*** Auftreffgeschwindigkeit ***/

            vmax = Math.sqrt((v0*v0)-(2*v0*g_Fall*tw*sinx)+(g_Fall*g_Fall*tw*tw));
            jLabel9.setText("Auftreffgeschw.: "+f.format(vmax)+" m/s");

            /*** Minimale Geschwindigkeit ***/

            vmin = v0*cosx;
            jLabel10.setText("Min. Geschw.: "+f.format(vmin)+" m/s");

            double xstart = 76;                 //X-Startpunkt
            double ystart = 426;                //Y-Startpunkt
            double xold;                        //Alter X-Startpunkt
            double yold;                        //Alter Y-Startpunkt
            double MaxPixelX = 688;             //Maximale Länge (in Pixel) in X-Richtung
            double MaxPixelY = 315;             //Maximale Länge (in Pixel) in Y-Richtung
            xold = xstart;
            yold = ystart;

            /*** Setzen der Faktoren in Abhängigkeit der Wurfweite ***/

            if (autoscale == true) {
                if (W<=2.5) {
                    faktor = MaxPixelX/2.5;
                    incfaktor = 0.25;
                    xyfaktor = incfaktor*faktor;
                } else if (W>2.5 && W<=5) {
                    faktor = MaxPixelX/5;
                    incfaktor = 0.5;
                    xyfaktor = incfaktor*faktor;
                } else if (W>5 && W<=25) {
                    faktor = MaxPixelX/25;
                    incfaktor = 1;
                    xyfaktor = incfaktor*faktor;
                } else if (W>25 && W<=50) {
                    faktor = MaxPixelX/50;
                    incfaktor = 5;
                    xyfaktor = incfaktor*faktor;
                } else if (W>50 && W<=100) {
                    faktor = MaxPixelX/100;
                    incfaktor = 10;
                    xyfaktor = incfaktor*faktor;
                } else if (W>100 && W<=250) {
                    faktor = MaxPixelX/250;
                    incfaktor = 25;
                    xyfaktor = incfaktor*faktor;
                } else if (W>250 && W<=500) {
                    faktor = MaxPixelX/500;
                    incfaktor = 50;
                    xyfaktor = incfaktor*faktor;
                } else if (W>500 && W<=1000) {
                    faktor = MaxPixelX/1000;
                    incfaktor = 100;
                    xyfaktor = incfaktor*faktor;
                } else if (W>1000 && W<=2500) {
                    faktor = MaxPixelX/2500;
                    incfaktor = 250;
                    xyfaktor = incfaktor*faktor;
                } else if (W>2500 && W<=5000) {
                    faktor = MaxPixelX/5000;
                    incfaktor = 500;
                    xyfaktor = incfaktor*faktor;
                } else if (W>5000 && W<=7500) {
                    faktor = MaxPixelX/7500;
                    incfaktor = 750;
                    xyfaktor = incfaktor*faktor;
                } else {
                    //...
                }

                /*** Setzen der Faktoren in Abhängigkeit der maximalen Höhe ***/

                if ((Hmax*faktor)>MaxPixelY) {
                    if (Hmax<=2.5) {
                        faktor = MaxPixelY/Hmax;
                        incfaktor = 0.25;
                        xyfaktor = incfaktor*faktor;
                    } else if (Hmax>2.5 && Hmax<=4) {
                        faktor = MaxPixelY/Hmax;
                        incfaktor = 0.5;
                        xyfaktor = incfaktor*faktor;
                    } else if (Hmax>4 && Hmax<=15) {
                        faktor = MaxPixelY/Hmax;
                        incfaktor = 1;
                        xyfaktor = incfaktor*faktor;
                    } else if (Hmax>15 && Hmax<=50) {
                        faktor = MaxPixelY/Hmax;
                        incfaktor = 5;
                        xyfaktor = incfaktor*faktor;
                    } else if (Hmax>50 && Hmax<=100) {
                        faktor = MaxPixelY/Hmax;
                        incfaktor = 10;
                        xyfaktor = incfaktor*faktor;
                    } else if (Hmax>100 && Hmax<=250) {
                        faktor = MaxPixelY/Hmax;
                        incfaktor = 25;
                        xyfaktor = incfaktor*faktor;
                    } else if (Hmax>250 && Hmax<=500) {
                        faktor = MaxPixelY/Hmax;
                        incfaktor = 50;
                        xyfaktor = incfaktor*faktor;
                    } else if (Hmax>500 && Hmax<=1000) {
                        faktor = MaxPixelY/Hmax;
                        incfaktor = 100;
                        xyfaktor = incfaktor*faktor;
                    } else if (Hmax>1000 && Hmax<=2500) {
                        faktor = MaxPixelY/Hmax;
                        incfaktor = 250;
                        xyfaktor = incfaktor*faktor;
                    } else if (Hmax>2500 && Hmax<=5000) {
                        faktor = MaxPixelY/Hmax;
                        incfaktor = 500;
                        xyfaktor = incfaktor*faktor;
                    } else {
                        //...
                    }
                }

                if (W<=5 && Hmax<=4) {
                    f2 = new DecimalFormat("#0.00");
                } else {
                    f2 = new DecimalFormat("#0");
                }
                autoscale = false; //autoscale auf "false" setzen, sodass erst bei erneutem Drücken
            }                      //des "AutoScale-Buttons" die Schleife wieder durchlaufen wird
            else {
                if ((faktor==0) && (incfaktor==0) && (xyfaktor==0)) {
                    faktor = MaxPixelX/25;
                    incfaktor = 1;
                    xyfaktor = incfaktor*faktor;
                }
            }

            /*** Setzen der Bemaßungs-Schrift ***/

            g.setFont(font2);

            double ix = 0; //ix auf 0 setzen

            /*** Beschriftung der X-Achse ***/

            for (double i=0; i<=MaxPixelX+5; i+=xyfaktor) {
                g.setColor(Color.GRAY); //Farbe der Striche setzen
                g.drawLine((int) (76+i),422,(int) (76+i),430); //Striche
                g.setColor(xylabel_color); //Farbe der Zahlen setzen

                if (ix<10) {
                    if (W<=5 && Hmax<=4 && faktor>=MaxPixelX/5) {
                        g.drawString(f2.format(ix),(int) (67+i),445); //Weite von 0 bis 5 m
                    } else {
                        if (faktor>=MaxPixelX/5) {
                            g.drawString(f2.format(ix),(int) (67+i),445); //Weite von 0 bis 5 m
                        } else {
                            g.drawString(f2.format(ix),(int) (74+i),445); //Weite von 5 bis 9 m
                        }
                    }
                } else if (ix>=10 && ix<100) {
                    g.drawString(f2.format(ix),(int) (70+i),445); //Weite von 10 bis 99 m
                } else if (ix>=100 && ix<1000) {
                    g.drawString(f2.format(ix),(int) (66+i),445); //Weite von 100 bis 999 m
                } else {
                    g.drawString(f2.format(ix),(int) (62+i),445); //Weite von 1000 bis ... m
                }
                ix+=incfaktor;
            }

            double iy = 0; //iy auf 0 setzen

            /*** Beschriftung der Y-Achse ***/

            for (double j=0; j<=MaxPixelY+5; j+=xyfaktor) {
                g.setColor(Color.GRAY); //Farbe der Striche setzen
                g.drawLine(72,(int) (426-j),80,(int) (426-j)); //Striche
                g.setColor(xylabel_color); //Ab hier die Farbe für die Zahlen

                if (iy!=0 && iy<10) {
                    if (W<=5 && Hmax<=4 && faktor>=MaxPixelX/5) {
                        g.drawString(f2.format(iy),43,(int) (430-j)); //Höhe von 0. bis 5 m
                    } else {
                        if (faktor>=MaxPixelX/5) {
                            g.drawString(f2.format(iy),43,(int) (430-j)); //Höhe von 0. bis 5 m
                        } else {
                            g.drawString(f2.format(iy),60,(int) (430-j)); //Höhe von 5. bis 9. m
                        }
                    }
                } else if (iy!=0 && iy>=10 && iy<100) {
                    g.drawString(f2.format(iy),53,(int) (430-j)); //Höhe von 10 bis 99 m
                } else if (iy!=0 && iy>=100 && iy<1000) {
                    g.drawString(f2.format(iy),46,(int) (430-j)); //Höhe von 100 bis 999 m
                } else if (iy!=0 && iy>=1000) {
                    g.drawString(f2.format(iy),39,(int) (430-j)); //Höhe von 1000 bis ... m
                }
                iy+=incfaktor;
            }

            /*** Setzen der Parabelfarbe und der Linienstärke ***/

            g.setColor(graphcolor);
            g.setStroke(stroke2pixel);
            g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);

            double inc; //Inkrementierungsvariable

            if (tw<=0.1) {
                inc = 0.0001;
            } else if (tw>0.1 && tw<=1) {
                inc = 0.001;
            } else if (tw>1 && tw<=2) {
                inc = 0.0025;
            } else if (tw>2 && tw<=5) {
                inc = 0.005;
            } else if (tw>5 && tw<=10) {
                inc = 0.01;
            } else {
                inc = 0.05;
            }

            /*** Zeichnen der Wurfparabel ***/

            ystart = 426 - (height*faktor); //Um die Linie vom Ursprung zur Abwurfhöhe zu verhindern

            for (t=0; t<=tw; t+=inc) {
                x = (v0*t*cosx);
                y = (height + (v0*t*sinx)-((g_Fall/2)*t*t));
                g.drawLine((int) xstart,(int) ystart,(int) (xold + x*faktor),(int) (yold - y*faktor));
                xstart = xold + x*faktor;
                ystart = yold - y*faktor;
            }
        } else {
            /*** Sinus und Cosinus des Abwurfwinkels ins Bogenmaß umgerechnet ***/

            double sinx = Math.sin(winkel*Math.PI/180);
            double cosx = Math.cos(winkel*Math.PI/180);
            v0 = speed;

            double Hmax;                //Maximale Höhe
            double t1start = 73;        //T1-Startpunkt
            double xstart = 267;        //X-Startpunkt
            double t2start = 473;       //T2-Startpunkt
            double ystart = 267;        //Y-Startpunkt
            double t3start = 73;        //T3-Startpunkt
            double vxstart = 522;       //VX-Startpunkt
            double t4start = 473;       //T4-Startpunkt
            double vystart = 441;       //VY-Startpunkt
            double xold,t1old;          //Alter X/T1-Startpunkt
            double yold,t2old;          //Alter Y/T2-Startpunkt
            double vxold,t3old;         //Alter VX/T3-Startpunkt
            double vyold,t4old;         //Alter VY/T4-Startpunkt
            double MaxPixelX = 290;     //Maximale Länge (in Pixel) in X-Richtung
            double MaxPixelY = 162;     //Maximale Länge (in Pixel) in Y-Richtung
            xold = xstart;
            t1old = t1start;
            yold = ystart;
            t2old = t2start;
            vxold = vxstart;
            t3old = t3start;
            vyold = vystart;
            t4old = t4start;

            /*** Wurfzeit ***/

            tw = ((v0*sinx)+Math.sqrt(v0*v0*sinx*sinx+2*g_Fall*height))/g_Fall;

            /*** Geschwindigkeit in X-Richtung ***/

            vx = v0*cosx; //Zeitunabhängig

            /*** Geschwindigkeit in Y-Richtung ***/

            vy = v0*sinx - g_Fall*tw;

            /*** X-Wert in Abhängigkeit von der Wurfzeit ***/

            x = (v0*tw*cosx);

            /*** Maximale Höhe ***/

            Hmax = height+(v0*v0*sinx*sinx)/(2*g_Fall);

            /*** Setzen der Faktoren in Abhängigkeit der Wurfzeit ***/

            if (autoscale == true) {
                if (tw<=0.002) {
                    tfaktor = MaxPixelX/0.002;
                    inc_faktor = 0.001;
                    xy_faktor = inc_faktor*tfaktor;
                } else if (tw>0.002 && tw<=0.01) {
                    tfaktor = MaxPixelX/0.01;
                    inc_faktor = 0.002;
                    xy_faktor = inc_faktor*tfaktor;
                } else if (tw>0.01 && tw<=0.1) {
                    tfaktor = MaxPixelX/0.1;
                    inc_faktor = 0.01;
                    xy_faktor = inc_faktor*tfaktor;
                } else if (tw>0.1 && tw<=0.5) {
                    tfaktor = MaxPixelX/0.5;
                    inc_faktor = 0.05;
                    xy_faktor = inc_faktor*tfaktor;
                } else if (tw>0.5 && tw<=1) {
                    tfaktor = MaxPixelX/1;
                    inc_faktor = 0.2;
                    xy_faktor = inc_faktor*tfaktor;
                } else if (tw>1 && tw<=2) {
                    tfaktor = MaxPixelX/2;
                    inc_faktor = 0.25;
                    xy_faktor = inc_faktor*tfaktor;
                } else if (tw>2 && tw<=5) {
                    tfaktor = MaxPixelX/5;
                    inc_faktor = 1;
                    xy_faktor = inc_faktor*tfaktor;
                } else if (tw>5 && tw<=10) {
                    tfaktor = MaxPixelX/10;
                    inc_faktor = 2;
                    xy_faktor = inc_faktor*tfaktor;
                } else if (tw>10 && tw<=20) {
                    tfaktor = MaxPixelX/20;
                    inc_faktor = 2.5;
                    xy_faktor = inc_faktor*tfaktor;
                } else if (tw>20 && tw<=40) {
                    tfaktor = MaxPixelX/40;
                    inc_faktor = 5;
                    xy_faktor = inc_faktor*tfaktor;
                } else if (tw>40 && tw<=80) {
                    tfaktor = MaxPixelX/80;
                    inc_faktor = 10;
                    xy_faktor = inc_faktor*tfaktor;
                } else if (tw>80 && tw<=125) {
                    tfaktor = MaxPixelX/125;
                    inc_faktor = 20;
                    xy_faktor = inc_faktor*tfaktor;
                }

                /*** Setzen des Formates ***/

                if (tw<=0.01) {
                    ft = new DecimalFormat("#0.000");
                } else {
                    ft = new DecimalFormat("#0.00");
                }
            } else {
                if ((tfaktor==0) && (inc_faktor==0) && (xy_faktor==0)) {
                    tfaktor = MaxPixelX/5;
                    inc_faktor = 0.5;
                    xy_faktor = inc_faktor*tfaktor;
                }
            }

            /*** Setzen der Bemaßungs-Schrift ***/

            g.setFont(font2);

            double it = 0; //it auf 0 setzen

            /*** Beschriftung der t-Achse für alle 4 Schaubilder ***/

            for (double i=0; i<=MaxPixelX+5; i+=xy_faktor) {
                g.setColor(Color.GRAY); //Farbe der Striche setzen

                /*** Striche x(t)-Schaubild ***/
                g.drawLine((int) (73+i),263,(int) (73+i),271);

                /*** Striche y(t)-Schaubild ***/
                g.drawLine((int) (473+i),263,(int) (473+i),271);

                /*** Striche vx(t)-Schaubild ***/
                g.drawLine((int) (73+i),518,(int) (73+i),526);

                /*** Striche vy(t)-Schaubild ***/
                g.drawLine((int) (473+i),437,(int) (473+i),445);

                g.setColor(xylabel_color); //Farbe der Zahlen setzen

                if (it<10) {
                    /*** x(t)-Schaubild ***/
                    g.drawString(ft.format(it),(int) (64+i),286); //Wurfzeit von 0 bis 9.9 s

                    /*** y(t)-Schaubild ***/
                    g.drawString(ft.format(it),(int) (464+i),286); //Wurfzeit von 0 bis 9.9 s

                    /*** vx(t)-Schaubild ***/
                    g.drawString(ft.format(it),(int) (64+i),541); //Wurfzeit von 0 bis 9.9 s

                    /*** vy(t)-Schaubild ***/
                    if (it != 0) {
                        g.drawString(ft.format(it),(int) (464+i),460); //Wurfzeit von 0. bis 9.9 s
                    }
                } else if (it>=10 && it<100) {
                    /*** x(t)-Schaubild ***/
                    g.drawString(ft.format(it),(int) (57+i),286); //Wurfzeit von 10 bis 99.9 s

                    /*** y(t)-Schaubild ***/
                    g.drawString(ft.format(it),(int) (457+i),286); //Wurfzeit von 10 bis 99.9 s

                    /*** vx(t)-Schaubild ***/
                    g.drawString(ft.format(it),(int) (57+i),541); //Wurfzeit von 10 bis 99.9 s

                    /*** vy(t)-Schaubild ***/
                    g.drawString(ft.format(it),(int) (457+i),460); //Wurfzeit von 10 bis 99.9 s
                } else if (it>=100 && it<1000) {
                    /*** x(t)-Schaubild ***/
                    g.drawString(ft.format(it),(int) (50+i),286); //Wurfzeit von 100 bis 999.9 s

                    /*** y(t)-Schaubild ***/
                    g.drawString(ft.format(it),(int) (450+i),286); //Wurfzeit von 100 bis 999.9 s

                    /*** vx(t)-Schaubild ***/
                    g.drawString(ft.format(it),(int) (50+i),541); //Wurfzeit von 100 bis 999.9 s

                    /*** vy(t)-Schaubild ***/
                    g.drawString(ft.format(it),(int) (450+i),460); //Wurfzeit von 100 bis 999.9 s
                }
                it+=inc_faktor;
            }

            /*** Setzen der Faktoren in Abhängigkeit von x ***/

            if (autoscale == true) {
                if (x<=0.01) {
                    xfaktor = MaxPixelY/0.01;
                    inc_faktor_x = 0.001;
                    xt_faktor = inc_faktor_x*xfaktor;
                } else if (x>0.01 && x<=0.1) {
                    xfaktor = MaxPixelY/0.1;
                    inc_faktor_x = 0.01;
                    xt_faktor = inc_faktor_x*xfaktor;
                } else if (x>0.1 && x<=0.5) {
                    xfaktor = MaxPixelY/0.5;
                    inc_faktor_x = 0.05;
                    xt_faktor = inc_faktor_x*xfaktor;
                } else if (x>0.5 && x<=1) {
                    xfaktor = MaxPixelY/1;
                    inc_faktor_x = 0.1;
                    xt_faktor = inc_faktor_x*xfaktor;
                } else if (x>1 && x<=2.5) {
                    xfaktor = MaxPixelY/2.5;
                    inc_faktor_x = 0.25;
                    xt_faktor = inc_faktor_x*xfaktor;
                } else if (x>2.5 && x<=5) {
                    xfaktor = MaxPixelY/5;
                    inc_faktor_x = 0.5;
                    xt_faktor = inc_faktor_x*xfaktor;
                } else if (x>5 && x<=10) {
                    xfaktor = MaxPixelY/10;
                    inc_faktor_x = 1;
                    xt_faktor = inc_faktor_x*xfaktor;
                } else if (x>10 && x<=25) {
                    xfaktor = MaxPixelY/25;
                    inc_faktor_x = 2.5;
                    xt_faktor = inc_faktor_x*xfaktor;
                } else if (x>25 && x<=50) {
                    xfaktor = MaxPixelY/50;
                    inc_faktor_x = 5;
                    xt_faktor = inc_faktor_x*xfaktor;
                } else if (x>50 && x<=100) {
                    xfaktor = MaxPixelY/100;
                    inc_faktor_x = 10;
                    xt_faktor = inc_faktor_x*xfaktor;
                } else if (x>100 && x<=250) {
                    xfaktor = MaxPixelY/250;
                    inc_faktor_x = 25;
                    xt_faktor = inc_faktor_x*xfaktor;
                } else if (x>250 && x<=500) {
                    xfaktor = MaxPixelY/500;
                    inc_faktor_x = 50;
                    xt_faktor = inc_faktor_x*xfaktor;
                } else if (x>500 && x<=1000) {
                    xfaktor = MaxPixelY/1000;
                    inc_faktor_x = 100;
                    xt_faktor = inc_faktor_x*xfaktor;
                } else if (x>1000 && x<=2500) {
                    xfaktor = MaxPixelY/2500;
                    inc_faktor_x = 250;
                    xt_faktor = inc_faktor_x*xfaktor;
                } else if (x>2500 && x<=5000) {
                    xfaktor = MaxPixelY/5000;
                    inc_faktor_x = 500;
                    xt_faktor = inc_faktor_x*xfaktor;
                } else if (x>5000 && x<=7500) {
                    xfaktor = MaxPixelY/7500;
                    inc_faktor_x = 750;
                    xt_faktor = inc_faktor_x*xfaktor;
                } else {
                    xfaktor = tfaktor;
                }

                /*** Setzen des Formates ***/

                if (x<=0.01) {
                    f3 = new DecimalFormat("#0.000");
                } else if (x>0.01 && x<=2.5) {
                    f3 = new DecimalFormat("#0.00");
                } else if (x>2.5 && x<=25) {
                    f3 = new DecimalFormat("#0.0");
                } else {
                    f3 = new DecimalFormat("#0");
                }
            } else {
                if ((xfaktor==0) && (inc_faktor_x==0) && (xt_faktor==0)) {
                    xfaktor = MaxPixelY/25;
                    inc_faktor_x = 2.5;
                    xt_faktor = inc_faktor_x*xfaktor;
                }
            }

            /*** Beschriftung der x-Achse ***/

            double ix = 0; //ix auf 0 setzen

            for (double j=0; j<=MaxPixelY+5; j+=xt_faktor) {
                g.setColor(Color.GRAY); //Farbe der Striche setzen
                g.drawLine(69,(int) (267-j),77,(int) (267-j)); //Striche
                g.setColor(xylabel_color); //Farbe der Zahlen setzen

                if (ix!=0 && ix<10) {
                    if (xfaktor>=MaxPixelY/0.01) {
                        g.drawString(f3.format(ix),32,(int) (271-j)); //x von 0 bis 0.01 m
                    } else if (xfaktor>=MaxPixelY/2.5) {
                        g.drawString(f3.format(ix),39,(int) (271-j)); //x von 0.01 bis 2.5 m
                    } else if (xfaktor>=MaxPixelY/25) {
                        g.drawString(f3.format(ix),46,(int) (271-j)); //x von 2.5 bis 25 m
                    } else {
                        g.drawString(f3.format(ix),56,(int) (271-j)); //x von 25. bis ... m
                    }
                } else if (ix!=0 && ix>=10 && ix<100) {
                    if (xfaktor>=MaxPixelY/25) {
                        g.drawString(f3.format(ix),39,(int) (271-j)); //x von 10 bis 25 m
                    } else {
                        g.drawString(f3.format(ix),49,(int) (271-j)); //x von 25. bis 99 m
                    }
                } else if (ix!=0 && ix>=100 && ix<1000) {
                    g.drawString(f3.format(ix),42,(int) (271-j)); //x von 100 bis 999 m
                } else if (ix!=0 && ix>=1000 && ix<10000) {
                    g.drawString(f3.format(ix),35,(int) (271-j)); //x von 1000 bis 9999 m
                }
                ix+=inc_faktor_x;
            }

            /*** Setzen der Parabelfarbe und der Linienstärke ***/

            g.setColor(graphcolor);
            g.setStroke(stroke2pixel);
            g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);

            /*** Zeichnen der x(t)-Parabel ***/

            g.drawLine((int) t1start,(int) xstart,(int) (t1start+tw*tfaktor),(int) (xstart-x*xfaktor));

            g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_OFF); //Antialiasing wieder aus

            /*** Setzen der Faktoren in Abhängigkeit von y ***/

            if (autoscale == true) {
                if (Hmax<=0.001) {
                    yfaktor = MaxPixelY/0.001;
                    inc_faktor_y = 0.0001;
                    yt_faktor = inc_faktor_y*yfaktor;
                } else if (Hmax>0.001 && Hmax<=0.01) {
                    yfaktor = MaxPixelY/0.01;
                    inc_faktor_y = 0.001;
                    yt_faktor = inc_faktor_y*yfaktor;
                } else if (Hmax>0.01 && Hmax<=0.05) {
                    yfaktor = MaxPixelY/0.05;
                    inc_faktor_y = 0.01;
                    yt_faktor = inc_faktor_y*yfaktor;
                } else if (Hmax>0.05 && Hmax<=0.2) {
                    yfaktor = MaxPixelY/0.2;
                    inc_faktor_y = 0.02;
                    yt_faktor = inc_faktor_y*yfaktor;
                } else if (Hmax>0.2 && Hmax<=1) {
                    yfaktor = MaxPixelY/1;
                    inc_faktor_y = 0.1;
                    yt_faktor = inc_faktor_y*yfaktor;
                } else if (Hmax>1 && Hmax<=5) {
                    yfaktor = MaxPixelY/5;
                    inc_faktor_y = 1;
                    yt_faktor = inc_faktor_y*yfaktor;
                } else if (Hmax>5 && Hmax<=15) {
                    yfaktor = MaxPixelY/15;
                    inc_faktor_y = 2.5;
                    yt_faktor = inc_faktor_y*yfaktor;
                } else if (Hmax>15 && Hmax<=50) {
                    yfaktor = MaxPixelY/50;
                    inc_faktor_y = 5;
                    yt_faktor = inc_faktor_y*yfaktor;
                } else if (Hmax>50 && Hmax<=100) {
                    yfaktor = MaxPixelY/100;
                    inc_faktor_y = 10;
                    yt_faktor = inc_faktor_y*yfaktor;
                } else if (Hmax>100 && Hmax<=250) {
                    yfaktor = MaxPixelY/250;
                    inc_faktor_y = 25;
                    yt_faktor = inc_faktor_y*yfaktor;
                } else if (Hmax>250 && Hmax<=500) {
                    yfaktor = MaxPixelY/500;
                    inc_faktor_y = 50;
                    yt_faktor = inc_faktor_y*yfaktor;
                } else if (Hmax>500 && Hmax<=1000) {
                    yfaktor = MaxPixelY/1000;
                    inc_faktor_y = 100;
                    yt_faktor = inc_faktor_y*yfaktor;
                } else if (Hmax>1000 && Hmax<=2500) {
                    yfaktor = MaxPixelY/2500;
                    inc_faktor_y = 250;
                    yt_faktor = inc_faktor_y*yfaktor;
                } else if (Hmax>2500 && Hmax<=5000) {
                    yfaktor = MaxPixelY/5000;
                    inc_faktor_y = 500;
                    yt_faktor = inc_faktor_y*yfaktor;
                } else {
                    yfaktor = tfaktor;
                }

                /*** Setzen des Formates ***/

                if (Hmax<=0.001) {
                    f4 = new DecimalFormat("#0.0000");
                } else if (Hmax>0.001 && Hmax<=0.05) {
                    f4 = new DecimalFormat("#0.000");
                } else if (Hmax>0.05 && Hmax<=1) {
                    f4 = new DecimalFormat("#0.00");
                } else if (Hmax>1 && Hmax<=15) {
                    f4 = new DecimalFormat("#0.0");
                } else {
                    f4 = new DecimalFormat("#0");
                }
            } else {
                if ((yfaktor==0) && (inc_faktor_y==0) && (yt_faktor==0)) {
                    yfaktor = MaxPixelY/5;
                    inc_faktor_y = 1;
                    yt_faktor = inc_faktor_y*yfaktor;
                }
            }

            /*** Beschriftung der y-Achse ***/

            double iy = 0; //iy auf 0 setzen
            g.setStroke(stroke1pixel);

            for (double j=0; j<=MaxPixelY+5; j+=yt_faktor) {
                g.setColor(Color.GRAY); //Farbe der Striche setzen
                g.drawLine(469,(int) (267-j),477,(int) (267-j)); //Striche
                g.setColor(xylabel_color); //Farbe der Zahlen setzen

                if (iy!=0 && iy<10) {
                    if (yfaktor>=MaxPixelY/0.001) {
                        g.drawString(f4.format(iy),425,(int) (271-j)); //y von 0 bis 0.001 m
                    } else if (yfaktor>=MaxPixelY/0.05) {
                        g.drawString(f4.format(iy),432,(int) (271-j)); //y von 0.001 bis 0.05 m
                    } else if (yfaktor>=MaxPixelY/1) {
                        g.drawString(f4.format(iy),439,(int) (271-j)); //y von 0.05 bis 1 m
                    } else if (yfaktor>=MaxPixelY/15) {
                        g.drawString(f4.format(iy),446,(int) (271-j)); //y von 1 bis 25 m
                    } else {
                        g.drawString(f4.format(iy),456,(int) (271-j)); //y von 25. bis ... m
                    }
                } else if (iy!=0 && iy>=10 && iy<100) {
                    if (yfaktor>=MaxPixelY/25) {
                        g.drawString(f4.format(iy),439,(int) (271-j)); //y von 10 bis 25 m
                    } else {
                        g.drawString(f4.format(iy),449,(int) (271-j)); //y von 25. bis 99 m
                    }
                } else if (iy!=0 && iy>=100 && iy<1000) {
                    g.drawString(f4.format(iy),442,(int) (271-j)); //y von 100 bis 999 m
                } else if (iy!=0 && iy>=1000 && iy<10000) {
                    g.drawString(f4.format(iy),435,(int) (271-j)); //y von 1000 bis 9999 m
                }
                iy+=inc_faktor_y;
            }

            /*** Setzen der Parabelfarbe und der Linienstärke ***/

            g.setColor(graphcolor);
            g.setStroke(stroke2pixel);
            g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);

            /*** Zeichnen der y(t)-Parabel ***/

            double inc;

            if (tw<=0.1) {
                inc = 0.0001;
            } else if (tw>0.1 && tw<=1) {
                inc = 0.001;
            } else if (tw>1 && tw<=2) {
                inc = 0.0025;
            } else if (tw>2 && tw<=5) {
                inc = 0.005;
            } else if (tw>5 && tw<=10) {
                inc = 0.01;
            } else {
                inc = 0.05;
            }

            if (v0 == 0 && height != 0) {
                g.drawLine((int) t2start,(int) ystart,(int) t2start,(int) (ystart - MaxPixelY));
            } else if (winkel == 0 && height == 0) {
                g.drawLine((int) t2start,(int) ystart,(int) t2start,(int) ystart);
            } else if (v0 == 0 && height == 0) {
                g.drawLine((int) t2start,(int) ystart,(int) t2start,(int) ystart);
            } else {
                ystart = 267 - (height*yfaktor); //Um die Linie vom Ursprung zur Abwurfhöhe zu verhindern

                for (t=0; t<=tw; t+=inc) {
                    y = (height + (v0*t*sinx)-((g_Fall/2)*t*t));
                    g.drawLine((int) t2start,(int) ystart,(int) (t2old + t*tfaktor),(int) (yold - y*yfaktor));
                    t2start = t2old + t*tfaktor;
                    ystart = yold - y*yfaktor;
                }
            }

            g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_OFF); //Antialiasing wieder aus

            /*** Setzen der Faktoren in Abhängigkeit von vx ***/

            if (autoscale == true) {
                if (vx<=0.01) {
                    vxfaktor = MaxPixelY/0.01;
                    inc_faktor_vx = 0.001;
                    vxt_faktor = inc_faktor_vx*vxfaktor;
                } else if (vx>0.01 && vx<=0.1) {
                    vxfaktor = MaxPixelY/0.1;
                    inc_faktor_vx = 0.01;
                    vxt_faktor = inc_faktor_vx*vxfaktor;
                } else if (vx>0.1 && vx<=1) {
                    vxfaktor = MaxPixelY/1;
                    inc_faktor_vx = 0.1;
                    vxt_faktor = inc_faktor_vx*vxfaktor;
                } else if (vx>1 && vx<=5) {
                    vxfaktor = MaxPixelY/5;
                    inc_faktor_vx = 0.5;
                    vxt_faktor = inc_faktor_vx*vxfaktor;
                } else if (vx>5 && vx<=15) {
                    vxfaktor = MaxPixelY/15;
                    inc_faktor_vx = 2.5;
                    vxt_faktor = inc_faktor_vx*vxfaktor;
                } else if (vx>15 && vx<=50) {
                    vxfaktor = MaxPixelY/50;
                    inc_faktor_vx = 5;
                    vxt_faktor = inc_faktor_vx*vxfaktor;
                } else if (vx>50 && vx<=100) {
                    vxfaktor = MaxPixelY/100;
                    inc_faktor_vx = 10;
                    vxt_faktor = inc_faktor_vx*vxfaktor;
                }

                /*** Setzen des Formates ***/

                if (vx<=0.01) {
                    f5 = new DecimalFormat("#0.000");
                } else if (vx>0.01 && vx<=0.1) {
                    f5 = new DecimalFormat("#0.00");
                } else if (vx>0.1 && vx<=15) {
                    f5 = new DecimalFormat("#0.0");
                } else {
                    f5 = new DecimalFormat("#0");
                }
            } else {
                if ((vxfaktor==0) && (inc_faktor_vx==0) && (vxt_faktor==0)) {
                    vxfaktor = MaxPixelY/15;
                    inc_faktor_vx = 2.5;
                    vxt_faktor = inc_faktor_vx*vxfaktor;
                }
            }

            /*** Beschriftung der vx-Achse ***/

            double ivx = 0; //ivx auf 0 setzen
            g.setStroke(stroke1pixel);

            for (double j=0; j<=MaxPixelY+5; j+=vxt_faktor) {
                g.setColor(Color.GRAY); //Farbe der Striche setzen
                g.drawLine(69,(int) (522-j),77,(int) (522-j)); //Striche
                g.setColor(xylabel_color); //Farbe der Zahlen setzen

                if (ivx!=0 && ivx<10) {
                    if (vxfaktor>=MaxPixelY/0.01) {
                        g.drawString(f5.format(ivx),32,(int) (526-j)); //vx von 0 bis 0.01 m/s
                    } else if (vxfaktor>=MaxPixelY/0.1) {
                        g.drawString(f5.format(ivx),39,(int) (526-j)); //vx von 0.01 bis 0.1 m/s
                    } else if (vxfaktor>=MaxPixelY/15) {
                        g.drawString(f5.format(ivx),46,(int) (526-j)); //vx von 0.1 bis 15 m/s
                    } else {
                        g.drawString(f5.format(ivx),56,(int) (526-j)); //vx von 15 bis ... m/s
                    }
                } else if (ivx!=0 && ivx>=10 && ivx<100) {
                    if (vxfaktor>=MaxPixelY/15) {
                        g.drawString(f5.format(ivx),39,(int) (526-j)); //vx von 10 bis 15 m/s
                    } else {
                        g.drawString(f5.format(ivx),49,(int) (526-j)); //vx von 15. bis 99 m/s
                    }
                } else if (ivx!=0 && ivx>=100) {
                    g.drawString(f5.format(ivx),42,(int) (526-j)); //vx 100 m/s
                }
                ivx+=inc_faktor_vx;
            }

            /*** Setzen der Parabelfarbe und der Linienstärke ***/

            g.setColor(graphcolor);
            g.setStroke(stroke2pixel);
            g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);

            /*** Zeichnen der vx(t)-Parabel ***/

            g.drawLine((int) t3start,(int) (vxstart - (vx*vxfaktor)),(int) (t3old + tw*tfaktor),(int) (vxstart - (vx*vxfaktor)));

            g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_OFF); //Antialiasing wieder aus

            /*** Setzen der Faktoren in Abhängigkeit von vy ***/

            if (autoscale == true) {
                if (vy<=-100) {
                    vyfaktor = (MaxPixelY/-100)*0.5;
                    inc_faktor_vy = -25;
                    vyt_faktor = inc_faktor_vy*vyfaktor;
                } else if (vy>-100 && vy<=-50) {
                    vyfaktor = (MaxPixelY/-100)*0.5;
                    inc_faktor_vy = -25;
                    vyt_faktor = inc_faktor_vy*vyfaktor;
                } else if (vy>-50 && vy<=-10) {
                    vyfaktor = (MaxPixelY/-50)*0.5;
                    inc_faktor_vy = -10;
                    vyt_faktor = inc_faktor_vy*vyfaktor;
                } else if (vy>-10 && vy<=-5) {
                    vyfaktor = (MaxPixelY/-10)*0.5;
                    inc_faktor_vy = -2.5;
                    vyt_faktor = inc_faktor_vy*vyfaktor;
                } else if (vy>-5 && vy<=-1) {
                    vyfaktor = (MaxPixelY/-5)*0.5;
                    inc_faktor_vy = -1;
                    vyt_faktor = inc_faktor_vy*vyfaktor;
                } else if (vy>-1 && vy<=-0.1) {
                    vyfaktor = (MaxPixelY/-1)*0.5;
                    inc_faktor_vy = -0.2;
                    vyt_faktor = inc_faktor_vy*vyfaktor;
                } else if (vy>-0.1 && vy<=0) {
                    vyfaktor = (MaxPixelY/-0.1)*0.5;
                    inc_faktor_vy = -0.02;
                    vyt_faktor = inc_faktor_vy*vyfaktor;
                } else {
                    vyfaktor = tfaktor;
                }

                /*** Setzen des Formates ***/

                if (vy>-10 && vy<=-0.1) {
                    f6 = new DecimalFormat("#0.0");
                } else if (vy>-0.1 && vy<=0) {
                    f6 = new DecimalFormat("#0.00");
                } else {
                    f6 = new DecimalFormat("#0");
                }
                autoscale = false; //autoscale auf "false" setzen, sodass erst bei erneutem Drücken
            }                      //des "AutoScale-Buttons" die Schleife wieder durchlaufen wird
            else {
                if ((vyfaktor==0) && (inc_faktor_vy==0) && (vyt_faktor==0)) {
                    vyfaktor = (MaxPixelY/-10)*0.5;
                    inc_faktor_vy = -2.5;
                    vyt_faktor = inc_faktor_vy*vyfaktor;
                }
            }

            /*** Beschriftung der vy-Achse ***/

            double ivyn = 0; //ivyn auf 0 setzen
            g.setStroke(stroke1pixel);

            /*** Beschriftung der negativen Werte von vy(t) ***/

            for (double j=0; j<=(MaxPixelY*0.5); j+=vyt_faktor) {
                g.setColor(Color.GRAY); //Farbe der Striche setzen
                g.drawLine(469,(int) (441+j),477,(int) (441+j)); //Striche
                g.setColor(xylabel_color); //Farbe der Zahlen setzen

                if (ivyn == 0) {
                    if (vyfaktor<=((MaxPixelY/-0.1)*0.5)) {
                        g.drawString(f6.format(ivyn),439,(int) (445+j)); //Positionierung von 0.00
                    } else if (vyfaktor<=((MaxPixelY/-10)*0.5)) {
                        g.drawString(f6.format(ivyn),446,(int) (445+j)); //Positionierung von 0.0
                    } else {
                        g.drawString(f6.format(ivyn),456,(int) (445+j)); //Positionierung von 0
                    }
                } else if (ivyn>-10 && ivyn<0) {
                    if (vyfaktor<=((MaxPixelY/-0.1)*0.5)) {
                        g.drawString(f6.format(ivyn),434,(int) (445+j)); //vy von -0.1. bis 0 m/s
                    } else if (vyfaktor<=((MaxPixelY/-10)*0.5)) {
                        g.drawString(f6.format(ivyn),441,(int) (445+j)); //vy von -15. bis -0.1 m/s
                    } else {
                        g.drawString(f6.format(ivyn),451,(int) (445+j)); //vy von -15 bis ... m/s
                    }
                } else if (ivyn>-100 && ivyn<=-10) {
                    if (vyfaktor<=((MaxPixelY/-10)*0.5)) {
                        g.drawString(f6.format(ivyn),434,(int) (445+j)); //vy von -15. bis -99. m/s
                    } else {
                        g.drawString(f6.format(ivyn),444,(int) (445+j)); //vy von -15. bis -99. m/s
                    }
                } else if (ivyn<=-100) {
                    g.drawString(f6.format(ivyn),437,(int) (445+j)); //vy von -100 m/s bis ... m/s
                }
                ivyn+=inc_faktor_vy;
            }

            double ivyp = 0; //ivyp auf 0 setzen

            /*** Beschriftung der positiven Werte von vy(t) ***/

            for (double j=0; j<=(MaxPixelY*0.5); j+=vyt_faktor) {
                g.setColor(Color.GRAY); //Farbe der Striche setzen
                g.drawLine(469,(int) (441-j),477,(int) (441-j)); //Striche
                g.setColor(xylabel_color); //Farbe der Zahlen setzen

                if (ivyp>0 && ivyp<10) {
                    if (vyfaktor<=((MaxPixelY/-0.1)*0.5)) {
                        g.drawString(f6.format(ivyp),439,(int) (445-j)); //vy von 0.01. bis 0 m/s
                    } else if (vyfaktor<=((MaxPixelY/-10)*0.5)) {
                        g.drawString(f6.format(ivyp),446,(int) (445-j)); //vy von 0.1 bis 10 m/s
                    } else {
                        g.drawString(f6.format(ivyp),456,(int) (445-j)); //vy von 0 bis ... m/s
                    }
                } else if (ivyp>=10 && ivyp<100) {
                    if (vyfaktor<=((MaxPixelY/-10)*0.5)) {
                        g.drawString(f6.format(ivyp),439,(int) (445-j)); //vy von 15. bis 99 m/s
                    } else {
                        g.drawString(f6.format(ivyp),449,(int) (445-j)); //vy von 15. bis 99 m/s
                    }
                } else if (ivyp>=100) {
                    g.drawString(f6.format(ivyp),442,(int) (445-j)); //vy 100 m/s
                }
                ivyp-=inc_faktor_vy; //Hier "-" um die positiven Werte zu erzeugen
            }

            /*** Setzen der Parabelfarbe ***/

            g.setColor(graphcolor);
            g.setStroke(stroke2pixel);
            g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);

            /*** Zeichnen der vy(t)-Parabel ***/

            if (height == 0) {
                vystart = 441 - (vy*vyfaktor); //Um die Linie vom Ursprung zum 1. Wert zu verhindern
            } else {
                vystart = 441 + (v0*sinx*vyfaktor);
            }
            g.drawLine((int) t4start,(int) vystart,(int) (t4old + tw*tfaktor),(int) (vyold + vy*vyfaktor));
        }
    }

    class focuslistener implements WindowFocusListener {
        public void windowGainedFocus(WindowEvent e) {
            repaint();
        }

        public void windowLostFocus(WindowEvent e) {
            repaint();
        }
    }

    class componentlistener implements ComponentListener {
        public void componentMoved(ComponentEvent e) {
            repaint();
        }

        public void componentResized(ComponentEvent e) {
            repaint();
        }

        public void componentShown(ComponentEvent e) {
            repaint();
        }

        public void componentHidden(ComponentEvent e) {
            repaint();
        }
    }

    class windowlistener implements WindowListener {
        public void windowClosed(WindowEvent e) {

        }

        public void windowActivated(WindowEvent e) {

        }

        public void windowClosing(WindowEvent e) {
            //System.exit(0);
        }

        public void windowDeactivated(WindowEvent e) {

        }

        public void windowDeiconified(WindowEvent e) {

        }

        public void windowIconified(WindowEvent e) {

        }

        public void windowOpened(WindowEvent e) {

        }
    }

    class SliderListener implements ChangeListener {
        public void stateChanged(ChangeEvent e) {
            winkel = jSlider1.getValue();
            height = jSlider2.getValue();
            speed = jSlider3.getValue();

            if (e.getSource()==jSlider1 && jSlider1.getValueIsAdjusting()) {
                jLabel2.setText("Abwurfwinkel: "+winkel+"°");
                bufferedimage = null;
                repaint();
            } else if (e.getSource()==jSlider2 && jSlider2.getValueIsAdjusting()) {
                jLabel3.setText("Abwurfhöhe: "+height+" m");
                bufferedimage = null;
                repaint();
            } else if (e.getSource()==jSlider3 && jSlider3.getValueIsAdjusting()) {
                jLabel4.setText("Abwurfgeschw.: "+speed+" m/s");
                bufferedimage = null;
                repaint();
            }
            //wird hier repaint() aufgerufen, wird paint 2 mal durchlaufen, wegen StateChange
        }
    }

    class TabListener implements ChangeListener {
        public void stateChanged(ChangeEvent e) {
            if (jTabbedPane1.getSelectedIndex()==0) {
                bufferedimage = null;
                repaint();
            } else {
                repaint();
            }
        }
    }

    class RadioButtonListener implements ActionListener {
        public void actionPerformed(ActionEvent e) {
            if (e.getSource()==Erde) {
                g_Fall = g_Erde;
                Erde.setSelected(true);
                Mars.setSelected(false);
                Mond.setSelected(false);
                Jupiter.setSelected(false);
                Venus.setSelected(false);
                bufferedimage = null;
                repaint();
            } else if (e.getSource()==Mars) {
                g_Fall = g_Mars;
                Mars.setSelected(true);
                Erde.setSelected(false);
                Mond.setSelected(false);
                Jupiter.setSelected(false);
                Venus.setSelected(false);
                bufferedimage = null;
                repaint();
            } else if (e.getSource()==Mond) {
                g_Fall = g_Mond;
                Mond.setSelected(true);
                Erde.setSelected(false);
                Mars.setSelected(false);
                Jupiter.setSelected(false);
                Venus.setSelected(false);
                bufferedimage = null;
                repaint();
            } else if (e.getSource()==Jupiter) {
                g_Fall = g_Jupiter;
                Jupiter.setSelected(true);
                Erde.setSelected(false);
                Mars.setSelected(false);
                Mond.setSelected(false);
                Venus.setSelected(false);
                bufferedimage = null;
                repaint();
            } else if (e.getSource()==Venus) {
                g_Fall = g_Venus;
                Venus.setSelected(true);
                Erde.setSelected(false);
                Mars.setSelected(false);
                Mond.setSelected(false);
                Jupiter.setSelected(false);
                bufferedimage = null;
                repaint();
            } else {
                Erde.setSelected(true);
                bufferedimage = null;
                repaint();
            }
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        Erde = new javax.swing.JRadioButton();
        Mars = new javax.swing.JRadioButton();
        Jupiter = new javax.swing.JRadioButton();
        jLabel1 = new javax.swing.JLabel();
        jSlider1 = new javax.swing.JSlider();
        jLabel2 = new javax.swing.JLabel();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel1 = new javax.swing.JPanel();
        jPanel5 = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        jPanel6 = new javax.swing.JPanel();
        jPanel7 = new javax.swing.JPanel();
        jLabel11 = new javax.swing.JLabel();
        jStartButton = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jSlider2 = new javax.swing.JSlider();
        jLabel4 = new javax.swing.JLabel();
        jSlider3 = new javax.swing.JSlider();
        jSeparator1 = new javax.swing.JSeparator();
        Mond = new javax.swing.JRadioButton();
        Venus = new javax.swing.JRadioButton();
        jAutoScaleButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Schiefer Wurf");
        setBackground(new java.awt.Color(204, 204, 204));
        setResizable(false);

        Erde.setText("Erde (g = 9,81)");

        Mars.setText("Mars (g = 3,71)");

        Jupiter.setText("Jupiter (g = 24,79)");

        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel1.setText("Fallbeschleunigung:");

        jSlider1.setMajorTickSpacing(15);
        jSlider1.setMaximum(90);
        jSlider1.setMinorTickSpacing(1);
        jSlider1.setPaintLabels(true);
        jSlider1.setPaintTicks(true);
        jSlider1.setSnapToTicks(true);
        jSlider1.setToolTipText("Abwurfwinkel in Grad");
        jSlider1.setValue(45);
        jSlider1.setOpaque(false);

        jLabel2.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel2.setText("Abwurfwinkel:");

        jTabbedPane1.setDebugGraphicsOptions(javax.swing.DebugGraphics.BUFFERED_OPTION);
        jTabbedPane1.setDoubleBuffered(true);

        jPanel1.setBackground(new java.awt.Color(204, 204, 204));
        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(""));
        jPanel1.setPreferredSize(new java.awt.Dimension(450, 100));

        jPanel5.setBackground(new java.awt.Color(200, 221, 242));
        jPanel5.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jPanel5.setPreferredSize(new java.awt.Dimension(543, 75));

        jLabel5.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel5.setText("Wurfweite:");
        jLabel5.setPreferredSize(new java.awt.Dimension(155, 14));

        jLabel6.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel6.setText("Maximale Höhe:");
        jLabel6.setPreferredSize(new java.awt.Dimension(190, 14));

        jLabel7.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel7.setText("Wurfzeit:");
        jLabel7.setPreferredSize(new java.awt.Dimension(155, 14));

        jLabel8.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel8.setText("Auftreffwinkel:");
        jLabel8.setPreferredSize(new java.awt.Dimension(155, 14));

        jLabel9.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel9.setText("Auftreffgeschw.:");
        jLabel9.setPreferredSize(new java.awt.Dimension(190, 14));

        jLabel10.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel10.setText("Min. Geschw.:");
        jLabel10.setPreferredSize(new java.awt.Dimension(155, 14));

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                      .addContainerGap()
                      .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                .addGroup(jPanel5Layout.createSequentialGroup()
                                          .addComponent(jLabel5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                          .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                          .addComponent(jLabel6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                          .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                          .addComponent(jLabel7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addGroup(jPanel5Layout.createSequentialGroup()
                                          .addComponent(jLabel8, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                          .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                          .addComponent(jLabel9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                          .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                          .addComponent(jLabel10, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                      .addContainerGap(17, Short.MAX_VALUE))
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                      .addContainerGap()
                      .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                .addComponent(jLabel5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(jLabel6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(jLabel7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                      .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 21, Short.MAX_VALUE)
                      .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                .addComponent(jLabel8, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(jLabel9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(jLabel10, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                      .addContainerGap())
        );

        jPanel6.setBackground(new java.awt.Color(255, 255, 255));
        jPanel6.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        javax.swing.GroupLayout jPanel6Layout = new javax.swing.GroupLayout(jPanel6);
        jPanel6.setLayout(jPanel6Layout);
        jPanel6Layout.setHorizontalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 761, Short.MAX_VALUE)
        );
        jPanel6Layout.setVerticalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 391, Short.MAX_VALUE)
        );

        jPanel7.setBackground(new java.awt.Color(0, 0, 0));
        jPanel7.setPreferredSize(new java.awt.Dimension(135, 35));

        jLabel11.setFont(new java.awt.Font("Tahoma", 0, 25));
        jLabel11.setForeground(new java.awt.Color(255, 0, 0));
        jLabel11.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel11.setText("0,000 s");
        jLabel11.setToolTipText("Zeitanzeige der Animation");
        jLabel11.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jLabel11.setDoubleBuffered(true);
        jLabel11.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jLabel11.setPreferredSize(new java.awt.Dimension(135, 35));

        javax.swing.GroupLayout jPanel7Layout = new javax.swing.GroupLayout(jPanel7);
        jPanel7.setLayout(jPanel7Layout);
        jPanel7Layout.setHorizontalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel7Layout.createSequentialGroup()
                      .addGap(0, 0, 0)
                      .addComponent(jLabel11, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                      .addGap(0, 0, 0))
        );
        jPanel7Layout.setVerticalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel7Layout.createSequentialGroup()
                      .addGap(0, 0, 0)
                      .addComponent(jLabel11, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jStartButton.setFont(new java.awt.Font("Tahoma", 1, 11));
        jStartButton.setText("Ball werfen");
        jStartButton.setToolTipText("Animation starten");
        jStartButton.setPreferredSize(new java.awt.Dimension(99, 23));
        jStartButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jStartButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                      .addContainerGap()
                      .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                .addGroup(jPanel1Layout.createSequentialGroup()
                                          .addComponent(jPanel5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                          .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 87, Short.MAX_VALUE)
                                          .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                  .addComponent(jPanel7, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                  .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                                                          .addComponent(jStartButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                          .addGap(18, 18, 18))))
                                .addComponent(jPanel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                      .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                      .addContainerGap()
                      .addComponent(jPanel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                      .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                      .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                .addComponent(jPanel5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel1Layout.createSequentialGroup()
                                          .addComponent(jPanel7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                          .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                          .addComponent(jStartButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                      .addContainerGap())
        );

        jTabbedPane1.addTab("X/Y-Darstellung", jPanel1);

        jPanel2.setBackground(new java.awt.Color(204, 204, 204));

        jPanel3.setBackground(new java.awt.Color(255, 255, 255));
        jPanel3.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel3.setPreferredSize(new java.awt.Dimension(636, 235));

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 777, Short.MAX_VALUE)
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 231, Short.MAX_VALUE)
        );

        jPanel4.setBackground(new java.awt.Color(255, 255, 255));
        jPanel4.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel4.setPreferredSize(new java.awt.Dimension(636, 235));

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 777, Short.MAX_VALUE)
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 231, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                      .addContainerGap()
                      .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                .addComponent(jPanel3, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 781, Short.MAX_VALUE)
                                .addComponent(jPanel4, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 781, Short.MAX_VALUE))
                      .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                      .addContainerGap()
                      .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                      .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 22, Short.MAX_VALUE)
                      .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                      .addContainerGap())
        );

        jTabbedPane1.addTab("Zeitdarstellung", jPanel2);

        jLabel3.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel3.setText("Abwurfhöhe:");

        jSlider2.setMajorTickSpacing(20);
        jSlider2.setMinorTickSpacing(1);
        jSlider2.setPaintLabels(true);
        jSlider2.setPaintTicks(true);
        jSlider2.setSnapToTicks(true);
        jSlider2.setToolTipText("Abwurfhöhe in Meter");
        jSlider2.setValue(0);

        jLabel4.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel4.setText("Abwurfgeschw.:");

        jSlider3.setMajorTickSpacing(20);
        jSlider3.setMinorTickSpacing(1);
        jSlider3.setPaintLabels(true);
        jSlider3.setPaintTicks(true);
        jSlider3.setSnapToTicks(true);
        jSlider3.setToolTipText("Abwurfgeschwindigkeit in m/s");
        jSlider3.setValue(10);

        jSeparator1.setOrientation(javax.swing.SwingConstants.VERTICAL);
        jSeparator1.setPreferredSize(new java.awt.Dimension(1, 0));

        Mond.setText("Mond (g = 1,62)");

        Venus.setText("Venus (g = 8,87)");

        jAutoScaleButton.setFont(new java.awt.Font("Tahoma", 1, 11));
        jAutoScaleButton.setText("Auto. Skalierung");
        jAutoScaleButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jAutoScaleButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                      .addContainerGap()
                      .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 806, Short.MAX_VALUE)
                                .addGroup(layout.createSequentialGroup()
                                          .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                  .addComponent(jSlider1, javax.swing.GroupLayout.PREFERRED_SIZE, 175, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                  .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 175, javax.swing.GroupLayout.PREFERRED_SIZE))
                                          .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                          .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                  .addComponent(jLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 175, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                  .addComponent(jSlider2, javax.swing.GroupLayout.PREFERRED_SIZE, 175, javax.swing.GroupLayout.PREFERRED_SIZE))
                                          .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                          .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                  .addComponent(jLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, 175, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                  .addComponent(jSlider3, javax.swing.GroupLayout.PREFERRED_SIZE, 175, javax.swing.GroupLayout.PREFERRED_SIZE))
                                          .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                          .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                          .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                  .addGroup(layout.createSequentialGroup()
                                                          .addGap(2, 2, 2)
                                                          .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                                  .addGroup(layout.createSequentialGroup()
                                                                          .addComponent(Mars)
                                                                          .addGap(15, 15, 15)
                                                                          .addComponent(jAutoScaleButton))
                                                                  .addGroup(layout.createSequentialGroup()
                                                                          .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                                                  .addComponent(Jupiter)
                                                                                  .addComponent(Erde))
                                                                          .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                                          .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                                                  .addComponent(Mond)
                                                                                  .addComponent(Venus)))))
                                                  .addGroup(layout.createSequentialGroup()
                                                          .addGap(6, 6, 6)
                                                          .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 118, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                          .addGap(0, 0, 0)))
                      .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                      .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 542, Short.MAX_VALUE)
                      .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                      .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                          .addGroup(layout.createSequentialGroup()
                                                  .addComponent(jLabel1)
                                                  .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                  .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                                          .addComponent(Erde)
                                                          .addComponent(Mond))
                                                  .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                  .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                                          .addComponent(Jupiter)
                                                          .addComponent(Venus))
                                                  .addGap(0, 0, 0)
                                                  .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                                          .addComponent(Mars)
                                                          .addComponent(jAutoScaleButton)))
                                          .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 96, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addGroup(layout.createSequentialGroup()
                                          .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                                  .addComponent(jLabel2)
                                                  .addComponent(jLabel3)
                                                  .addComponent(jLabel4))
                                          .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                          .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                                  .addComponent(jSlider1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                  .addComponent(jSlider2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                  .addComponent(jSlider3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                          .addGap(8, 8, 8)))
                      .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jStartButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jStartButtonActionPerformed

        if (tw<=0.1) {
            delay = 1000000;
        } else {
            delay = 10000000;
        }

        Animation thread = new Animation(gfx);
        thread.setPriority(10);                 //Priorität auf Maximum stellen
        thread.start();                         //Thread starten
        jTabbedPane1.setEnabledAt(1,false);     //Tabindex 1 deaktivieren
        jStartButton.setEnabled(false);         //"Werfen-Button" deaktivieren
        jSlider1.setEnabled(false);             //Slider 1 deaktivieren
        jSlider2.setEnabled(false);             //Slider 2 deaktivieren
        jSlider3.setEnabled(false);             //Slider 3 deaktivieren
        Erde.setEnabled(false);                 //RadioButton "Erde" deaktivieren
        Jupiter.setEnabled(false);              //RadioButton "Jupiter" deaktivieren
        Mars.setEnabled(false);                 //RadioButton "Mars" deaktivieren
        Mond.setEnabled(false);                 //RadioButton "Mond" deaktivieren
        Venus.setEnabled(false);                //RadioButton "Venus" deaktivieren
        jAutoScaleButton.setEnabled(false);     //AutoScaleButton deaktivieren
    }//GEN-LAST:event_jStartButtonActionPerformed

    private void jAutoScaleButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jAutoScaleButtonActionPerformed
        autoscale = true;

        if (jTabbedPane1.getSelectedIndex()==0) {
            bufferedimage = null;
        }
        repaint();
    }//GEN-LAST:event_jAutoScaleButtonActionPerformed

    /**
    * @param args the command line arguments
    */

    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new SW_Design().setVisible(true);
            }
        });
    }

    class Animation extends Thread {
        double inc,xold,yold,cosx,sinx;                 //Variablen, die im neuen Thread berechnet werden
        double xstart = 71;                             //X-Startpunkt
        double ystart = 421;                            //Y-Startpunkt
        private Graphics2D g;                           //Grafikobjekt
        long starttime,endtime;                         //Start- und Endzeit der Zeitmessung
        double deltatime;                               //(Startzeit - Endzeit) = Deltazeit

        /*** Konstruktor für die Klasse Animation ***/

        public Animation(Graphics GFX) {
            this.g = (Graphics2D) GFX;                  //Grafikobjekt übergeben
            sinx = Math.sin(winkel*Math.PI/180);
            cosx = Math.cos(winkel*Math.PI/180);
            xold = xstart;
            yold = ystart;
            t = 0;
            g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON); //Antialiasing aktivieren
        }

        @Override
        public void run() {
            ystart = 426 - (height*faktor);

            do {
                /*** Kugel zeichnen und Position berechnen ***/

                starttime = System.nanoTime();                  //Startzeit
                x = (v0*t*cosx);
                y = (height + (v0*t*sinx)-((g_Fall/2)*t*t));
                xstart = xold + x*faktor;                       //Neuen X-Punkt berechnen
                ystart = yold - y*faktor;                       //Neuen Y-Punkt berechnen
                g.setColor(Color.BLUE);                         //Farbe der Kugel setzen
                g.fillOval((int) xstart,(int) ystart,11,11);    //Kugel zeichnen

                /*** Aktuelle Wurfzeit auf der Zeitanzeige ausgeben ***/

                jLabel11.setText(f.format(t)+" s");

                LockSupport.parkNanos(delay);                   //Thread für eine gewisse Zeit (in Nanosekunden) anhalten

                /*** Kugel löschen ***/

                g.drawImage(bufferedimage,0,0,jPanel6);         //Screencapture auf Darstellungsebene (Panel) ausgeben

                endtime = System.nanoTime();                    //Endzeit
                deltatime = (endtime-starttime)/1000000000.0;   //Deltatime in Sekunden umgerechnet
                inc = deltatime;
                t+=inc;
            } while(t<=tw);

            jLabel11.setText(f.format(tw)+" s");                //Endgültige Zeit anzeigen
            jStartButton.setEnabled(true);                      //"Werfen-Button" wieder aktivieren
            jTabbedPane1.setEnabledAt(1,true);                  //Tabindex 1 wieder aktivieren
            jSlider1.setEnabled(true);                          //Slider 1 wieder aktivieren
            jSlider2.setEnabled(true);                          //Slider 2 wieder aktivieren
            jSlider3.setEnabled(true);                          //Slider 3 wieder aktivieren
            Erde.setEnabled(true);                              //RadioButton "Erde" wieder aktivieren
            Jupiter.setEnabled(true);                           //RadioButton "Jupiter" wieder aktivieren
            Mars.setEnabled(true);                              //RadioButton "Mars" wieder aktivieren
            Mond.setEnabled(true);                              //RadioButton "Mond" wieder aktivieren
            Venus.setEnabled(true);                             //RadioButton "Venus" wieder aktivieren
            jAutoScaleButton.setEnabled(true);                  //AutoScaleButton wieder aktivieren
            repaint();
        }
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JRadioButton Erde;
    private javax.swing.JRadioButton Jupiter;
    private javax.swing.JRadioButton Mars;
    private javax.swing.JRadioButton Mond;
    private javax.swing.JRadioButton Venus;
    private javax.swing.JButton jAutoScaleButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSlider jSlider1;
    private javax.swing.JSlider jSlider2;
    private javax.swing.JSlider jSlider3;
    private javax.swing.JButton jStartButton;
    private javax.swing.JTabbedPane jTabbedPane1;
    // End of variables declaration//GEN-END:variables
}