
package source;

import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;

import javax.swing.ImageIcon;
import javax.swing.JApplet;
import javax.swing.JFrame;
import javax.swing.UIManager;

import javax.imageio.ImageIO;
import java.io.IOException;

/**
 * <b>Klasse Ableitung</b>
 * Enthlt Einstiegspunkt fr das Java-Programm
 * Erzeugt das Hauptfenster
 * @author Denis Schneider
 */

public class Ableitung extends javax.swing.JFrame {

    /**
     * automatisch generierte UID
     */
    private static final long serialVersionUID = 1L;

    /**
     * Hauptfenster
     */
    private static JFrame Hauptfenster;

    /**
     * Thread welcher das Fenster nach festgelegter Zeit neu zeichnet
     */
    private static RepaintThread thread;

    /**
     * legt fest ob Applet oder nicht
     */
    private static boolean IsApplet = true;

    /**
     * Zeiger auf Logos
     */
    private static ImageIcon iconLogo = null;
    private static ImageIcon symbolPressedLogo[];
    private static ImageIcon symbolUnPressedLogo[];

    /**
     * Iconleiste
     */
    private static Toolbar toolbar  = null;

    /**
     * Menleiste
     */
    private static Menuleiste Menuleiste = null;

    /**
     * Standard Fenstergre
     */
    private static final int groesseHauptfenster_X = 830;

    /**
     * Referenz auf das Applet
     */
    private static JApplet applet = null;

    //---------------------------------------------------------------------------

    /**
     * liefert Zeiger auf Logo
     */
    public static ImageIcon getIconLogo() {
        return iconLogo;
    }

    /**
     * liefert Zeiger auf gedrcktes Symbol
     */
    public static ImageIcon getsymbolPressedLogo(int nr) {
        return symbolPressedLogo[nr];
    }

    /**
     * liefert Zeiger auf nicht gedrcktes Symbol
     */
    public static ImageIcon getsymbolUnPressedLogo(int nr) {
        return symbolUnPressedLogo[nr];
    }

    /**
     * Einsprungspunkt fr Java Programme
     *
     * @param args Argumente (werden nicht bercksichtigt)
     */
    public static void main( String args[] ) {
        // kein Applet
        IsApplet = false;

        // Icon Arrays anlegen
        symbolPressedLogo = new ImageIcon[9];
        symbolUnPressedLogo = new ImageIcon[9];

        // Icons laden
		
		try{
			// iconLogo laden
			iconLogo 				= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/Logo3-farbe.gif")));
			
			symbolPressedLogo[0] 	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/sinaktiv.png")));
			symbolUnPressedLogo[0]	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/sininaktiv.png")));
			symbolPressedLogo[1] 	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/cosaktiv.png")));
			symbolUnPressedLogo[1] 	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/cosinaktiv.png")));
			symbolPressedLogo[2] 	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/sinhaktiv.png")));
			symbolUnPressedLogo[2] 	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/sinhinaktiv.png")));
			symbolPressedLogo[3] 	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/coshaktiv.png")));
			symbolUnPressedLogo[3] 	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/coshinaktiv.png")));
			symbolPressedLogo[4] 	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/e-Funktionaktiv.png")));
			symbolUnPressedLogo[4] 	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/e-Funktioninaktiv.png")));
			symbolPressedLogo[5] 	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/1xaktiv.png")));
			symbolUnPressedLogo[5] 	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/1xinaktiv.png")));
			symbolPressedLogo[6] 	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/x2aktiv.png")));
			symbolUnPressedLogo[6] 	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/x2inaktiv.png")));
			symbolPressedLogo[7] 	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/x3aktiv.png")));
			symbolUnPressedLogo[7] 	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/x3inaktiv.png")));
			symbolPressedLogo[8] 	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/x4aktiv.png")));
			symbolUnPressedLogo[8] 	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/x4inaktiv.png")));
			
		}catch(IOException ioe){
			javax.swing.JOptionPane.showMessageDialog(null, ioe.getStackTrace());
		}

        // starten
        Haupt_Programm();
    }

    /**
     * Einsprungspunkt fr Java Applets
     *
     * @param a Referenz des Applets
     */
    public static void main1(JApplet a) {
        // Logo kommt vom Applet

		iconLogo = StartApplet.getIconLogo();
        symbolPressedLogo = StartApplet.getsymbolPressedLogo();
        symbolUnPressedLogo = StartApplet.getsymbolUnPressedLogo();
		
        // iconLogo laden
        //iconLogo = new ImageIcon(Ableitung.class.getResourceAsStream(("/images/Logo3-farbe.gif")));

        // Icon Arrays anlegen
        symbolPressedLogo = new ImageIcon[9];
        symbolUnPressedLogo = new ImageIcon[9];
		
		

        try{
			// iconLogo laden
			iconLogo 				= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/Logo3-farbe.gif")));
			
			symbolPressedLogo[0] 	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/sinaktiv.png")));
			symbolUnPressedLogo[0]	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/sininaktiv.png")));
			symbolPressedLogo[1] 	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/cosaktiv.png")));
			symbolUnPressedLogo[1] 	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/cosinaktiv.png")));
			symbolPressedLogo[2] 	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/sinhaktiv.png")));
			symbolUnPressedLogo[2] 	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/sinhinaktiv.png")));
			symbolPressedLogo[3] 	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/coshaktiv.png")));
			symbolUnPressedLogo[3] 	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/coshinaktiv.png")));
			symbolPressedLogo[4] 	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/e-Funktionaktiv.png")));
			symbolUnPressedLogo[4] 	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/e-Funktioninaktiv.png")));
			symbolPressedLogo[5] 	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/1xaktiv.png")));
			symbolUnPressedLogo[5] 	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/1xinaktiv.png")));
			symbolPressedLogo[6] 	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/x2aktiv.png")));
			symbolUnPressedLogo[6] 	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/x2inaktiv.png")));
			symbolPressedLogo[7] 	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/x3aktiv.png")));
			symbolUnPressedLogo[7] 	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/x3inaktiv.png")));
			symbolPressedLogo[8] 	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/x4aktiv.png")));
			symbolUnPressedLogo[8] 	= new ImageIcon(ImageIO.read(Ableitung.class.getResourceAsStream("/images/x4inaktiv.png")));
			
			
			
		}catch(IOException ioe){
			//StackTraceElement[] trace = ioe.getStackTrace();
			//javax.swing.JOptionPane.showMessageDialog(null, trace[0].toString());
		}


        applet = a;

        // starten
        Haupt_Programm();
    }

    /**
     * eigentlicher Einsprungspunkt fr's Programm
     */
    private static void Haupt_Programm(  ) {
        // versuchen Look & Feel einzustellen
        try {
            UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
        } catch ( Exception e ) {
            e.printStackTrace();
        }

        // Hauptfenster erzeugen
        Hauptfenster = new JFrame( "Taylor-Entwicklung von Funktionen" );

        // Java Programme sofort beenden
        if (!IsApplet) Hauptfenster.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );

        // Tool Bar erzeugen und zum Fenster hinzufgen
        toolbar = new Toolbar(Hauptfenster, IsApplet);
        toolbar.addToFrame();

        //Menu erzeugen
        Menuleiste = new Menuleiste(Hauptfenster, IsApplet, applet);

        // Gre vom Hauptfenster festlegen
        Hauptfenster.setSize( groesseHauptfenster_X  , groesseHauptfenster_X *10/12);

        // Minimale Gre des Hauptfensters festlegen
        Hauptfenster. setMinimumSize(new java.awt.Dimension(403, 257));

        // Hauptfenster in Bildschirmmitte positionieren
        Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
        int xPos = dim.width/2 - Hauptfenster.getWidth()/2;
        int yPos = dim.height/2 - Hauptfenster.getHeight()/2;
        Hauptfenster.setLocation(xPos, yPos);

        // bei Grennderung neu zeichnen
        Hauptfenster.addComponentListener(
            new ComponentAdapter()

        {
            public void componentResized( ComponentEvent event ) {
                if ( event.getID() == 	ComponentEvent.COMPONENT_RESIZED ) {
                    if (toolbar != null ) toolbar.doRepaint();
                }
            }
        }
        );

        // repaint Thread erzeugen und starten
        thread= new RepaintThread();
        thread.start();

        // Hauptfenster anzeigen
        Hauptfenster.setVisible( true );
    }

    /**
     * Setzt die gewnschte Darstellungsart auf der Toolbar
     *
     * @param nr Nummer der Funktion
     */
    public static void setToolbarFunktionsart(int nr) {
        if (toolbar != null) toolbar.setFunktionsart(nr);
    }

    /**
     * Setzt die gewnschte Darstellungsart im Men
     *
     * @param nr Nummer der Funktion
     */
    public static void setMenueFunktionsart(int nr) {
        if (Menuleiste != null) Menuleiste.setFunktionsart(nr);
    }


    //*************** T H R E A D ************************************************
    static class RepaintThread extends Thread {
        public void run () {
            while (!isInterrupted()) {
                if (toolbar != null ) toolbar.doRepaint();

                try {
                    //Prozess schlft fr 5s.
                    Thread.sleep(60000);
                    if (Hauptfenster.isVisible() == false) {
                        thread.interrupt();
                    }

                } catch(InterruptedException e) {
                    thread.interrupt();
                }
            }
        }
    }
}

