
package source;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.DecimalFormat;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.JTextField;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
 * Die Klasse ParameterEingabe verwaltet die
 * Ein- und Ausgabewerte der 1/X-Funktion
 *
 * @author Denis Schneider
 */

public class ParameterEingabe1X {
    //Variablen
    String a0, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14;

    // Referenz auf die Skalierungsklassen
    private Skalierung1X skalierung = null;

    // Legt die Genauigkeit fest
    private double Genauigkeit = 100;

    // Formatierung der Anzeigen
    DecimalFormat df2 = new DecimalFormat( "0.00" );
    DecimalFormat df4 = new DecimalFormat( "0.0000" );
    DecimalFormat df1 = new DecimalFormat( "0" );
    DecimalFormat df6 = new DecimalFormat( "0.000000" );
    DecimalFormat dfE = new DecimalFormat( "0.000E00" );

    // Referenzen auf die Zeichenbereiche
    private Zeichenbereich1X Zeichenbereich1 = null;
    private Zeichenbereich1X Zeichenbereich2 = null;

    private boolean IsNormaled = false;

    // Bereich der in ParameterEingabe verwaltet wird
    private JPanel innerContent = null;

    // Gruppe von Elementen erstellen:
    // Beschriftung, Eingabefeld & Scrollbalken fr Abgriff
    // Beschriftung, Eingabefeld & Scrollbalken fr Anzahl der Koeffizienten

    //Labels
    private JLabel LB_Abgriff = null;
    private JLabel LB_AnzahlKoeff = null;
    private JLabel LB_W = null;
    private JLabel LB_0 = null;		//Beschriftungslabels
    private JLabel LB_1 = null;
    private JLabel LB_2 = null;
    private JLabel LB_3 = null;
    private JLabel LB_4 = null;
    private JLabel LB_5 = null;
    private JLabel LB_6 = null;
    private JLabel LB_7 = null;
    private JLabel LB_8 = null;
    private JLabel LB_9 = null;
    private JLabel LB_10 = null;
    private JLabel LB_11 = null;
    private JLabel LB_12 = null;
    private JLabel LB_13 = null;
    private JLabel LB_14 = null;
    private JLabel LB_a0 = null;	//Werte-Labels
    private JLabel LB_a1 = null;
    private JLabel LB_a2 = null;
    private JLabel LB_a3 = null;
    private JLabel LB_a4 = null;
    private JLabel LB_a5 = null;
    private JLabel LB_a6 = null;
    private JLabel LB_a7 = null;
    private JLabel LB_a8 = null;
    private JLabel LB_a9 = null;
    private JLabel LB_a10 = null;
    private JLabel LB_a11 = null;
    private JLabel LB_a12 = null;
    private JLabel LB_a13 = null;
    private JLabel LB_a14 = null;

    // Textfelder
    private JTextField TF_Abgriff = null;
    private JTextField TF_AnzahlKoeff = null;

    // Slider (Scrollbalken)
    private JSlider sl_Abgriff = null;
    private JSlider sl_AnzahlKoeff = null;

    // Interne Variablen
    private double Abgriff_Wert = 1;
    private double AnzahlKoeff_Wert = 0;


    /**
     * Konstruktor erzeugt die Eingabefelder
     */
    public ParameterEingabe1X () {
        // neue Skalierungsberechnung erzeugen
        skalierung = new Skalierung1X(this, IsNormaled);

        String Beschriftung;
        // wir legen alle Elemente auf ein Panel
        innerContent = new JPanel();
        // wir verwenden keinen Layoutmanager
        innerContent.setLayout(null);

        // Erzeugung der Text-Eingabefelder, mit dem jeweiligen Wert und
        // lassen maximal 10 Zeichen zu
        Beschriftung = df2.format(Abgriff_Wert);
        TF_Abgriff = new JTextField(Beschriftung,10);

        Beschriftung = df1.format(AnzahlKoeff_Wert);
        TF_AnzahlKoeff = new JTextField(Beschriftung,10);




        // wir erzeugen die Berschriftungslabels
        LB_Abgriff = new JLabel("Entwicklungspunkt:");
        LB_AnzahlKoeff = new JLabel("Hchste Potenz:");

        LB_W = new JLabel("<html>Werte der<p/Koeffizienten:</html>");
        LB_0 = new JLabel("a0: ", JLabel.CENTER);
        LB_1 = new JLabel("a1: ", JLabel.CENTER);
        LB_2 = new JLabel("a2: ", JLabel.CENTER);
        LB_3 = new JLabel("a3: ", JLabel.CENTER);
        LB_4 = new JLabel("a4: ", JLabel.CENTER);
        LB_5 = new JLabel("a5: ", JLabel.CENTER);
        LB_6 = new JLabel("a6: ", JLabel.CENTER);
        LB_7 = new JLabel("a7: ", JLabel.CENTER);
        LB_8 = new JLabel("a8: ", JLabel.CENTER);
        LB_9 = new JLabel("a9: ", JLabel.CENTER);
        LB_10 = new JLabel("a10: ", JLabel.CENTER);
        LB_11 = new JLabel("a11: ", JLabel.CENTER);
        LB_12 = new JLabel("a12: ", JLabel.CENTER);
        LB_13 = new JLabel("a13: ", JLabel.CENTER);
        LB_14 = new JLabel("a14: ", JLabel.CENTER);
        LB_a0 = new JLabel("", JLabel.RIGHT);		//rechtsbndig
        LB_a1 = new JLabel("", JLabel.RIGHT);
        LB_a2 = new JLabel("", JLabel.RIGHT);
        LB_a3 = new JLabel("", JLabel.RIGHT);
        LB_a4 = new JLabel("", JLabel.RIGHT);
        LB_a5 = new JLabel("", JLabel.RIGHT);
        LB_a6 = new JLabel("", JLabel.RIGHT);
        LB_a7 = new JLabel("", JLabel.RIGHT);
        LB_a8 = new JLabel("", JLabel.RIGHT);
        LB_a9 = new JLabel("", JLabel.RIGHT);
        LB_a10 = new JLabel("", JLabel.RIGHT);
        LB_a11 = new JLabel("", JLabel.RIGHT);
        LB_a12 = new JLabel("", JLabel.RIGHT);
        LB_a13 = new JLabel("", JLabel.RIGHT);
        LB_a14 = new JLabel("", JLabel.RIGHT);

        // Erzeugung der Schieberegler --> JSlider (min, max, value)
        sl_Abgriff = new JSlider(-398,398,(int)(Genauigkeit*Abgriff_Wert));
        sl_AnzahlKoeff = new JSlider(0,14,(int)(AnzahlKoeff_Wert));

        // Positionierung der Elemente
        int left = 5;
        int width = 120;
        int height = 21;
        int abstand = 26;
        int top = 7 - abstand;

        // Elementbegrenzungen setzen

        top+=abstand*0.3;
        LB_Abgriff.setBounds(left,top+=abstand,width,height);
        TF_Abgriff.setBounds(left,top+=abstand/1.5,width,height);
        sl_Abgriff.setBounds(left,top+=abstand,width,(int)(height));

        top+=abstand*0.3;
        LB_AnzahlKoeff.setBounds(left,top+=abstand,width,height);
        TF_AnzahlKoeff.setBounds(left,top+=abstand/1.5,width,height);
        sl_AnzahlKoeff.setBounds(left,top+=abstand,width,(int)(height));

        top+=abstand*0.5;
        LB_W.setBounds(left,top+=abstand,width,2*height);

        top+=abstand*0.6;
        LB_0.setBounds(left,top+=abstand,width/3,height);
        LB_a0.setBounds(left+width/3,top,width/2,height);
        LB_1.setBounds(left,top+=abstand,width/3,height);
        LB_a1.setBounds(left+width/3,top,width/2,height);
        LB_2.setBounds(left,top+=abstand,width/3,height);
        LB_a2.setBounds(left+width/3,top,width/2,height);
        LB_3.setBounds(left,top+=abstand,width/3,height);
        LB_a3.setBounds(left+width/3,top,width/2,height);
        LB_4.setBounds(left,top+=abstand,width/3,height);
        LB_a4.setBounds(left+width/3,top,width/2,height);
        LB_5.setBounds(left,top+=abstand,width/3,height);
        LB_a5.setBounds(left+width/3,top,width/2,height);
        LB_6.setBounds(left,top+=abstand,width/3,height);
        LB_a6.setBounds(left+width/3,top,width/2,height);
        LB_7.setBounds(left,top+=abstand,width/3,height);
        LB_a7.setBounds(left+width/3,top,width/2,height);
        LB_8.setBounds(left,top+=abstand,width/3,height);
        LB_a8.setBounds(left+width/3,top,width/2,height);
        LB_9.setBounds(left,top+=abstand,width/3,height);
        LB_a9.setBounds(left+width/3,top,width/2,height);
        LB_10.setBounds(left,top+=abstand,width/3,height);
        LB_a10.setBounds(left+width/3,top,width/2,height);
        LB_11.setBounds(left,top+=abstand,width/3,height);
        LB_a11.setBounds(left+width/3,top,width/2,height);
        LB_12.setBounds(left,top+=abstand,width/3,height);
        LB_a12.setBounds(left+width/3,top,width/2,height);
        LB_13.setBounds(left,top+=abstand,width/3,height);
        LB_a13.setBounds(left+width/3,top,width/2,height);
        LB_14.setBounds(left,top+=abstand,width/3,height);
        LB_a14.setBounds(left+width/3,top,width/2,height);

        /**
         * Reaktion auf die nderung der Eingabefelder
         */

        TF_Abgriff.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (!TF_Abgriff.hasFocus()) return;
                eingabewerteEinlesen();
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        sl_Abgriff.addChangeListener(
        new ChangeListener() {
            public void stateChanged(ChangeEvent  e) {
                if (!sl_Abgriff.hasFocus()) return;
                String Beschriftung1;
                Abgriff_Wert = sl_Abgriff.getValue()/Genauigkeit;
                Beschriftung1 = df2.format(Abgriff_Wert);
                TF_Abgriff.setText(Beschriftung1);
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        TF_AnzahlKoeff.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (!TF_AnzahlKoeff.hasFocus()) return;
                eingabewerteEinlesen();
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        sl_AnzahlKoeff.addChangeListener(
        new ChangeListener() {
            public void stateChanged(ChangeEvent  e) {
                if (!sl_AnzahlKoeff.hasFocus()) return;
                String Beschriftung1;
                AnzahlKoeff_Wert = sl_AnzahlKoeff.getValue();
                Beschriftung1 = df1.format(AnzahlKoeff_Wert);
                TF_AnzahlKoeff.setText(Beschriftung1);
                if (Zeichenbereich1!=null) Zeichenbereich1.Dorepaint();
                if (Zeichenbereich2!=null) Zeichenbereich2.Dorepaint();
            }
        }
        );

        // Gre des Eingabebereichs zulassen
        innerContent.setPreferredSize(new Dimension(left*2+width,20));

        // Widgets auf dem Panel plazieren

        innerContent.add(LB_Abgriff);
        innerContent.add(TF_Abgriff);
        innerContent.add(sl_Abgriff);

        innerContent.add(LB_AnzahlKoeff);
        innerContent.add(TF_AnzahlKoeff);
        innerContent.add(sl_AnzahlKoeff);

        innerContent.add(LB_W);

        innerContent.add(LB_0);
        innerContent.add(LB_1);
        innerContent.add(LB_2);
        innerContent.add(LB_3);
        innerContent.add(LB_4);
        innerContent.add(LB_5);
        innerContent.add(LB_6);
        innerContent.add(LB_7);
        innerContent.add(LB_8);
        innerContent.add(LB_9);
        innerContent.add(LB_10);
        innerContent.add(LB_11);
        innerContent.add(LB_12);
        innerContent.add(LB_13);
        innerContent.add(LB_14);
        innerContent.add(LB_a0);
        innerContent.add(LB_a1);
        innerContent.add(LB_a2);
        innerContent.add(LB_a3);
        innerContent.add(LB_a4);
        innerContent.add(LB_a5);
        innerContent.add(LB_a6);
        innerContent.add(LB_a7);
        innerContent.add(LB_a8);
        innerContent.add(LB_a9);
        innerContent.add(LB_a10);
        innerContent.add(LB_a11);
        innerContent.add(LB_a12);
        innerContent.add(LB_a13);
        innerContent.add(LB_a14);

    }

    /**
     * Methode delete dient dazu eine Eingabe aus dem Speicher aufzulsen
     *
     * @param Fenster	Fenster auf dem die Elemente plaziert sind
     */
    public void delete(JFrame Fenster) {
        // Eingabefelder freigeben
        innerContent.remove(LB_Abgriff);
        innerContent.remove(TF_Abgriff);
        innerContent.remove(sl_Abgriff);

        innerContent.remove(LB_AnzahlKoeff);
        innerContent.remove(TF_AnzahlKoeff);
        innerContent.remove(sl_AnzahlKoeff);

        innerContent.remove(LB_W);

        innerContent.remove(LB_0);
        innerContent.remove(LB_1);
        innerContent.remove(LB_2);
        innerContent.remove(LB_3);
        innerContent.remove(LB_4);
        innerContent.remove(LB_5);
        innerContent.remove(LB_6);
        innerContent.remove(LB_7);
        innerContent.remove(LB_8);
        innerContent.remove(LB_9);
        innerContent.remove(LB_10);
        innerContent.remove(LB_11);
        innerContent.remove(LB_12);
        innerContent.remove(LB_13);
        innerContent.remove(LB_14);
        innerContent.remove(LB_a0);
        innerContent.remove(LB_a1);
        innerContent.remove(LB_a2);
        innerContent.remove(LB_a3);
        innerContent.remove(LB_a4);
        innerContent.remove(LB_a5);
        innerContent.remove(LB_a6);
        innerContent.remove(LB_a7);
        innerContent.remove(LB_a8);
        innerContent.remove(LB_a9);
        innerContent.remove(LB_a10);
        innerContent.remove(LB_a11);
        innerContent.remove(LB_a12);
        innerContent.remove(LB_a13);
        innerContent.remove(LB_a14);

        // Referenzen lschen
        LB_Abgriff = null;
        LB_AnzahlKoeff = null;
        LB_W = null;
        LB_0 = null;
        LB_1 = null;
        LB_2 = null;
        LB_3 = null;
        LB_4 = null;
        LB_5 = null;
        LB_6 = null;
        LB_7 = null;
        LB_8 = null;
        LB_9 = null;
        LB_10 = null;
        LB_11 = null;
        LB_12 = null;
        LB_13 = null;
        LB_14 = null;
        LB_a0 = null;
        LB_a1 = null;
        LB_a2 = null;
        LB_a3 = null;
        LB_a4 = null;
        LB_a5 = null;
        LB_a6 = null;
        LB_a7 = null;
        LB_a8 = null;
        LB_a9 = null;
        LB_a10 = null;
        LB_a11 = null;
        LB_a12 = null;
        LB_a13 = null;
        LB_a14 = null;


        TF_Abgriff = null;
        TF_AnzahlKoeff = null;

        sl_Abgriff = null;
        sl_AnzahlKoeff = null;

        // selbst auflsen
        Fenster.getContentPane().remove(innerContent);
        innerContent = null;
        Zeichenbereich1 = null;
        Zeichenbereich2 = null;
    }




    /**
     * setzt die Zeichenbereiche
     *
     * @param z	Zeichenbereich
     */
    public void setZeichenbereich(Zeichenbereich1X z) {
        if (Zeichenbereich1==null)
            Zeichenbereich1=z;
        else
            Zeichenbereich2=z;
    }

    /**
     * liefert den Abgriff
     *
     * @return derzeitiger Abgriff
     */
    public double getAbgriff() {
        return	Abgriff_Wert;
    }

    /**
     * liefert die Anzahl der Koeffizienten
     *
     * @return Anzahl der Koeffizienten
     */
    public double getAnzahlKoeff() {
        return AnzahlKoeff_Wert;
    }

    /**
     * setzt den Abgriff
     *
     * @param x	Neuer Abgriff
     */
    public void setAbgriff(double x) {
        // Abfangen unzulssiger Werte
        // intern genauen Wert verwenden
        Abgriff_Wert = x;
        if (Abgriff_Wert > -3.98 && Abgriff_Wert < 3.98) {
            sl_Abgriff.setValue( (int)(Genauigkeit*Abgriff_Wert) );
            String Beschriftung1;
            Beschriftung1 = df2.format(Abgriff_Wert);
            TF_Abgriff.setText(Beschriftung1);

        } else if (Abgriff_Wert > 3.98) {
            sl_Abgriff.setValue( (int)(Genauigkeit*3.98) );
            String Beschriftung1;
            Beschriftung1 = df2.format(3.98);
            TF_Abgriff.setText(Beschriftung1);
            Abgriff_Wert = 3.98;
        } else {
            sl_Abgriff.setValue( (int)(Genauigkeit*-3.98) );
            String Beschriftung1;
            Beschriftung1 = df2.format(-3.98);
            TF_Abgriff.setText(Beschriftung1);
            Abgriff_Wert = -3.98;
        }
        if (Zeichenbereich1 != null) Zeichenbereich1.Dorepaint();
        if (Zeichenbereich2 != null) Zeichenbereich2.Dorepaint();
    }

    /**
     * setzt die Anzahl der Koeffizienten
     *
     * @param x	Neue Anzahl
     */
    public void setAnzahlKoeff(double x) {
        // Abfangen unzulssiger Werte
        // intern genauen Wert verwenden
        AnzahlKoeff_Wert = x;
        if (AnzahlKoeff_Wert > 0 && AnzahlKoeff_Wert < 14) {
            sl_AnzahlKoeff.setValue( (int)( AnzahlKoeff_Wert) );
            String Beschriftung1;
            Beschriftung1 = df1.format(AnzahlKoeff_Wert);
            TF_AnzahlKoeff.setText(Beschriftung1);
        } else if (AnzahlKoeff_Wert > 14) {
            sl_AnzahlKoeff.setValue((int) (14) );
            String Beschriftung1;
            Beschriftung1 = df1.format(14);
            TF_AnzahlKoeff.setText(Beschriftung1);
            AnzahlKoeff_Wert = 14;
        } else {
            sl_AnzahlKoeff.setValue( (int)(0) );
            String Beschriftung1;
            Beschriftung1 = df1.format(0);
            TF_AnzahlKoeff.setText(Beschriftung1);
            AnzahlKoeff_Wert = 0;
        }
        if (Zeichenbereich1 != null) Zeichenbereich1.Dorepaint();
        if (Zeichenbereich2 != null) Zeichenbereich2.Dorepaint();
    }

    /**
     * fgt die Eingabeleiste auf einem Fenster ein
     *
     * @param Fenster	Fenster auf dem die Leiste eingefgt werden soll
     */
    public void addToFrame(JFrame Fenster) {
        Fenster.getContentPane().add(innerContent, BorderLayout.WEST);
    }

    /**
     * bernimmt alle Werte bei der Texteingabe
     */
    private void eingabewerteEinlesen() {
        // Abgriff
        {
            String Hilf = TF_Abgriff.getText();
            Abgriff_Wert = Double.parseDouble(Hilf.replace(',','.'));
            // ungltige Werte nicht zulassen
            if (Abgriff_Wert < -3.98 ) {
                Abgriff_Wert = -3.98;
                TF_Abgriff.setText("-3,98");
            }
            if (Abgriff_Wert > 3.98 ) {
                Abgriff_Wert = 3.98;
                TF_Abgriff.setText("3,98");
            }
            sl_Abgriff.setValue( (int) (Genauigkeit * Abgriff_Wert) );
        }

        // Anzahl der Koeffizienten
        {
            String Hilf = TF_AnzahlKoeff.getText();
            AnzahlKoeff_Wert = Double.parseDouble(Hilf);
            // ungltige Werte nicht zulassen
            if (AnzahlKoeff_Wert < 0 ) {
                AnzahlKoeff_Wert = 0;
                TF_AnzahlKoeff.setText("0");
            }
            if (AnzahlKoeff_Wert > 14 ) {
                AnzahlKoeff_Wert = 14;
                TF_AnzahlKoeff.setText("14");
            }
            sl_AnzahlKoeff.setValue( (int) ( AnzahlKoeff_Wert) );
        }
    }

    /**
     * Die Funktion KoeffizientenAusgeben
     * gibt die Werte der Koeffizienten aus
     *
     */
    public void KoeffizientenAusgeben() {
        skalierung.KoeffRechnen();

        //zu groe Werte in Exopenentenform darstellen
        if (skalierung.a0 <= 99 && skalierung.a0 >= -99) {
            a0 = df6.format(skalierung.a0);
        } else {
            a0= dfE.format(skalierung.a0);
        }

        if (skalierung.a1 <= 99 && skalierung.a1 >= -99) {
            a1 = df6.format(skalierung.a1);
        } else {
            a1= dfE.format(skalierung.a1);
        }

        if (skalierung.a2 <= 99 && skalierung.a2 >= -99) {
            a2 = df6.format(skalierung.a2);
        } else {
            a2= dfE.format(skalierung.a2);
        }

        if (skalierung.a3 <= 99 && skalierung.a3 >= -99) {
            a3 = df6.format(skalierung.a3);
        } else {
            a3= dfE.format(skalierung.a3);
        }

        if (skalierung.a4 <= 99 && skalierung.a4 >= -99) {
            a4 = df6.format(skalierung.a4);
        } else {
            a4= dfE.format(skalierung.a4);
        }

        if (skalierung.a5 <= 99 && skalierung.a5 >= -99) {
            a5 = df6.format(skalierung.a5);
        } else {
            a5= dfE.format(skalierung.a5);
        }

        if (skalierung.a6 <= 99 && skalierung.a6 >= -99) {
            a6 = df6.format(skalierung.a6);
        } else {
            a6= dfE.format(skalierung.a6);
        }

        if (skalierung.a7 <= 99 && skalierung.a7 >= -99) {
            a7 = df6.format(skalierung.a7);
        } else {
            a7= dfE.format(skalierung.a7);
        }

        if (skalierung.a8 <= 99 && skalierung.a8 >= -99) {
            a8 = df6.format(skalierung.a8);
        } else {
            a8= dfE.format(skalierung.a8);
        }

        if (skalierung.a9 <= 99 && skalierung.a9 >= -99) {
            a9 = df6.format(skalierung.a9);
        } else {
            a9= dfE.format(skalierung.a9);
        }

        if (skalierung.a10 <= 99 && skalierung.a10 >= -99) {
            a10 = df6.format(skalierung.a10);
        } else {
            a10= dfE.format(skalierung.a10);
        }

        if (skalierung.a11 <= 99 && skalierung.a11 >= -99) {
            a11 = df6.format(skalierung.a11);
        } else {
            a11= dfE.format(skalierung.a11);
        }

        if (skalierung.a12 <= 99 && skalierung.a12 >= -99) {
            a12 = df6.format(skalierung.a12);
        } else {
            a12= dfE.format(skalierung.a12);
        }

        if (skalierung.a13 <= 99 && skalierung.a13 >= -99) {
            a13 = df6.format(skalierung.a13);
        } else {
            a13= dfE.format(skalierung.a13);
        }

        if (skalierung.a14 <= 99 && skalierung.a14 >= -99) {
            a14 = df6.format(skalierung.a14);
        } else {
            a14= dfE.format(skalierung.a14);
        }


        if (AnzahlKoeff_Wert == 0) {
            LB_a0.setText(a0);
            LB_a1.setText("");
            LB_a2.setText("");
            LB_a3.setText("");
            LB_a4.setText("");
            LB_a5.setText("");
            LB_a6.setText("");
            LB_a7.setText("");
            LB_a8.setText("");
            LB_a9.setText("");
            LB_a10.setText("");
            LB_a11.setText("");
            LB_a12.setText("");
            LB_a13.setText("");
            LB_a14.setText("");
        } else if (AnzahlKoeff_Wert == 1) {
            LB_a0.setText(a0);
            LB_a1.setText(a1);
            LB_a2.setText("");
            LB_a3.setText("");
            LB_a4.setText("");
            LB_a5.setText("");
            LB_a6.setText("");
            LB_a7.setText("");
            LB_a8.setText("");
            LB_a9.setText("");
            LB_a10.setText("");
            LB_a11.setText("");
            LB_a12.setText("");
            LB_a13.setText("");
            LB_a14.setText("");
        } else if (AnzahlKoeff_Wert == 2) {
            LB_a0.setText(a0);
            LB_a1.setText(a1);
            LB_a2.setText(a2);
            LB_a3.setText("");
            LB_a4.setText("");
            LB_a5.setText("");
            LB_a6.setText("");
            LB_a7.setText("");
            LB_a8.setText("");
            LB_a9.setText("");
            LB_a10.setText("");
            LB_a11.setText("");
            LB_a12.setText("");
            LB_a13.setText("");
            LB_a14.setText("");
        } else if (AnzahlKoeff_Wert == 3) {
            LB_a0.setText(a0);
            LB_a1.setText(a1);
            LB_a2.setText(a2);
            LB_a3.setText(a3);
            LB_a4.setText("");
            LB_a5.setText("");
            LB_a6.setText("");
            LB_a7.setText("");
            LB_a8.setText("");
            LB_a9.setText("");
            LB_a10.setText("");
            LB_a11.setText("");
            LB_a12.setText("");
            LB_a13.setText("");
            LB_a14.setText("");
        } else if (AnzahlKoeff_Wert == 4) {
            LB_a0.setText(a0);
            LB_a1.setText(a1);
            LB_a2.setText(a2);
            LB_a3.setText(a3);
            LB_a4.setText(a4);
            LB_a5.setText("");
            LB_a6.setText("");
            LB_a7.setText("");
            LB_a8.setText("");
            LB_a9.setText("");
            LB_a10.setText("");
            LB_a11.setText("");
            LB_a12.setText("");
            LB_a13.setText("");
            LB_a14.setText("");
        } else if (AnzahlKoeff_Wert == 5) {
            LB_a0.setText(a0);
            LB_a1.setText(a1);
            LB_a2.setText(a2);
            LB_a3.setText(a3);
            LB_a4.setText(a4);
            LB_a5.setText(a5);
            LB_a6.setText("");
            LB_a7.setText("");
            LB_a8.setText("");
            LB_a9.setText("");
            LB_a10.setText("");
            LB_a11.setText("");
            LB_a12.setText("");
            LB_a13.setText("");
            LB_a14.setText("");
        } else if (AnzahlKoeff_Wert == 6) {
            LB_a0.setText(a0);
            LB_a1.setText(a1);
            LB_a2.setText(a2);
            LB_a3.setText(a3);
            LB_a4.setText(a4);
            LB_a5.setText(a5);
            LB_a6.setText(a6);
            LB_a7.setText("");
            LB_a8.setText("");
            LB_a9.setText("");
            LB_a10.setText("");
            LB_a11.setText("");
            LB_a12.setText("");
            LB_a13.setText("");
            LB_a14.setText("");
        } else if (AnzahlKoeff_Wert == 7) {
            LB_a0.setText(a0);
            LB_a1.setText(a1);
            LB_a2.setText(a2);
            LB_a3.setText(a3);
            LB_a4.setText(a4);
            LB_a5.setText(a5);
            LB_a6.setText(a6);
            LB_a7.setText(a7);
            LB_a8.setText("");
            LB_a9.setText("");
            LB_a10.setText("");
            LB_a11.setText("");
            LB_a12.setText("");
            LB_a13.setText("");
            LB_a14.setText("");
        } else if (AnzahlKoeff_Wert == 8) {
            LB_a0.setText(a0);
            LB_a1.setText(a1);
            LB_a2.setText(a2);
            LB_a3.setText(a3);
            LB_a4.setText(a4);
            LB_a5.setText(a5);
            LB_a6.setText(a6);
            LB_a7.setText(a7);
            LB_a8.setText(a8);
            LB_a9.setText("");
            LB_a10.setText("");
            LB_a11.setText("");
            LB_a12.setText("");
            LB_a13.setText("");
            LB_a14.setText("");
        } else if (AnzahlKoeff_Wert == 9) {
            LB_a0.setText(a0);
            LB_a1.setText(a1);
            LB_a2.setText(a2);
            LB_a3.setText(a3);
            LB_a4.setText(a4);
            LB_a5.setText(a5);
            LB_a6.setText(a6);
            LB_a7.setText(a7);
            LB_a8.setText(a8);
            LB_a9.setText(a9);
            LB_a10.setText("");
            LB_a11.setText("");
            LB_a12.setText("");
            LB_a13.setText("");
            LB_a14.setText("");
        } else if (AnzahlKoeff_Wert == 10) {
            LB_a0.setText(a0);
            LB_a1.setText(a1);
            LB_a2.setText(a2);
            LB_a3.setText(a3);
            LB_a4.setText(a4);
            LB_a5.setText(a5);
            LB_a6.setText(a6);
            LB_a7.setText(a7);
            LB_a8.setText(a8);
            LB_a9.setText(a9);
            LB_a10.setText(a10);
            LB_a11.setText("");
            LB_a12.setText("");
            LB_a13.setText("");
            LB_a14.setText("");
        } else if (AnzahlKoeff_Wert == 11) {
            LB_a0.setText(a0);
            LB_a1.setText(a1);
            LB_a2.setText(a2);
            LB_a3.setText(a3);
            LB_a4.setText(a4);
            LB_a5.setText(a5);
            LB_a6.setText(a6);
            LB_a7.setText(a7);
            LB_a8.setText(a8);
            LB_a9.setText(a9);
            LB_a10.setText(a10);
            LB_a11.setText(a11);
            LB_a12.setText("");
            LB_a13.setText("");
            LB_a14.setText("");
        } else if (AnzahlKoeff_Wert == 12) {
            LB_a0.setText(a0);
            LB_a1.setText(a1);
            LB_a2.setText(a2);
            LB_a3.setText(a3);
            LB_a4.setText(a4);
            LB_a5.setText(a5);
            LB_a6.setText(a6);
            LB_a7.setText(a7);
            LB_a8.setText(a8);
            LB_a9.setText(a9);
            LB_a10.setText(a10);
            LB_a11.setText(a11);
            LB_a12.setText(a12);
            LB_a13.setText("");
            LB_a14.setText("");
        } else if (AnzahlKoeff_Wert == 13) {
            LB_a0.setText(a0);
            LB_a1.setText(a1);
            LB_a2.setText(a2);
            LB_a3.setText(a3);
            LB_a4.setText(a4);
            LB_a5.setText(a5);
            LB_a6.setText(a6);
            LB_a7.setText(a7);
            LB_a8.setText(a8);
            LB_a9.setText(a9);
            LB_a10.setText(a10);
            LB_a11.setText(a11);
            LB_a12.setText(a12);
            LB_a13.setText(a13);
            LB_a14.setText("");
        } else if (AnzahlKoeff_Wert == 14) {
            LB_a0.setText(a0);
            LB_a1.setText(a1);
            LB_a2.setText(a2);
            LB_a3.setText(a3);
            LB_a4.setText(a4);
            LB_a5.setText(a5);
            LB_a6.setText(a6);
            LB_a7.setText(a7);
            LB_a8.setText(a8);
            LB_a9.setText(a9);
            LB_a10.setText(a10);
            LB_a11.setText(a11);
            LB_a12.setText(a12);
            LB_a13.setText(a13);
            LB_a14.setText(a14);
        }
    }
}
