
package source;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JToolBar;


/**
 * Klasse Toolbar
 * Stellt die Button-Leiste zur Verfgung
 * Whlt Aufgrund der Buttons eine entsprechende Funktion
 * @author Denis Schneider
 */

public class Toolbar {
    /**
     * Toolbar
     */
    private JToolBar toolBar = null;

    /**
     * die verschiedenen Buttons
     */
    private JButton BT_close = null;
    private JButton BT_Sinus = null;
    private JButton BT_Cosinus = null;
    private JButton BT_SinusH = null;
    private JButton BT_CosinusH = null;
    private JButton BT_EFunk = null;
    private JButton BT_1XFunk = null;
    private JButton BT_X2 = null;
    private JButton BT_X3 = null;
    private JButton BT_X4 = null;
    /**
     * In diesem Panel liegen die Buttons
     */
    private JPanel panel = null;

    /**
     * Referenz auf das bergeordnete Hauptfenster
     */
    private JFrame Hauptfenster = null;
    private JPanel HauptFensterMitte = null;

    /**
     * Referenzen auf die verschiedenen Eingabebereiche
     */
    private ParameterEingabeSinus parameterEingabeS  = null;
    private ParameterEingabeCosinus parameterEingabeC  = null;
    private ParameterEingabeSinusH parameterEingabeSH  = null;
    private ParameterEingabeCosinusH parameterEingabeCH  = null;
    private ParameterEingabeEFunktion parameterEingabeE  = null;
    private ParameterEingabe1X parameterEingabe1X  = null;
    private ParameterEingabeX2 parameterEingabeX2  = null;
    private ParameterEingabeX3 parameterEingabeX3  = null;
    private ParameterEingabeX4 parameterEingabeX4  = null;

    /**
     * Referenzen auf die verschiedenen Zeichenbereiche
     */
    private ZeichenbereichSinus ZeichenbereichS1=null;
    private ZeichenbereichSinus ZeichenbereichS2=null;
    private ZeichenbereichCosinus ZeichenbereichC1=null;
    private ZeichenbereichCosinus ZeichenbereichC2=null;
    private ZeichenbereichSinusH ZeichenbereichSH1=null;
    private ZeichenbereichSinusH ZeichenbereichSH2=null;
    private ZeichenbereichCosinusH ZeichenbereichCH1=null;
    private ZeichenbereichCosinusH ZeichenbereichCH2=null;
    private ZeichenbereichEFunk ZeichenbereichE1=null;
    private ZeichenbereichEFunk ZeichenbereichE2=null;
    private Zeichenbereich1X Zeichenbereich1X1=null;
    private Zeichenbereich1X Zeichenbereich1X2=null;
    private ZeichenbereichX2 ZeichenbereichX21=null;
    private ZeichenbereichX2 ZeichenbereichX22=null;
    private ZeichenbereichX3 ZeichenbereichX31=null;
    private ZeichenbereichX3 ZeichenbereichX32=null;
    private ZeichenbereichX4 ZeichenbereichX41=null;
    private ZeichenbereichX4 ZeichenbereichX42=null;

    /**
     * Konstruktor
     * erzeugt die Toolbar
     *
     * @param HF 		Fenster auf dem die Toolbar eingefgt werden soll
     * @param IsApplet 	true falls Anwendung als Applet luft
     */
    public Toolbar ( final JFrame HF  , final boolean IsApplet  ) {
        // Referenz intern sichern
        Hauptfenster = HF;

        // In den verschiedenen Regionen des Hauptfensters Panels ablegen
        HauptFensterMitte = new JPanel();
        Hauptfenster.getContentPane().add(HauptFensterMitte,BorderLayout.CENTER );

        // Layout Manager fr dien Mittelteil
        BoxLayout boxLayout =  new BoxLayout(HauptFensterMitte, BoxLayout.Y_AXIS);
        HauptFensterMitte.setLayout(boxLayout);

        // Buttons erzeugen
        BT_close = new JButton("Close");
        // Standardsymbole sind nicht gedrckt
        BT_Sinus = new JButton(Ableitung.getsymbolUnPressedLogo(0));
        BT_Cosinus = new JButton(Ableitung.getsymbolUnPressedLogo(1));
        BT_SinusH = new JButton(Ableitung.getsymbolUnPressedLogo(2));
        BT_CosinusH = new JButton(Ableitung.getsymbolUnPressedLogo(3));
        BT_EFunk = new JButton(Ableitung.getsymbolUnPressedLogo(4));
        BT_1XFunk = new JButton(Ableitung.getsymbolUnPressedLogo(5));
        BT_X2 = new JButton(Ableitung.getsymbolUnPressedLogo(6));
        BT_X3 = new JButton(Ableitung.getsymbolUnPressedLogo(7));
        BT_X4 = new JButton(Ableitung.getsymbolUnPressedLogo(8));

        // Tool Tips
        BT_close.setToolTipText("Close");
        BT_Sinus.setToolTipText("Sinus-Funktion");
        BT_Cosinus.setToolTipText("Cosinus-Funktion");
        BT_SinusH.setToolTipText("Sinus-hyperbolicus-Funktion");
        BT_CosinusH.setToolTipText("Cosinus-hyperbolicus-Funktion");
        BT_EFunk.setToolTipText("Exponential-Funktion");
        BT_1XFunk.setToolTipText("1/x Funktion");
        BT_X2.setToolTipText("x^2 Funktion");
        BT_X3.setToolTipText("x^3 Funktion");
        BT_X4.setToolTipText("x^4 Funktion");

        // Aktionen der Buttons
        BT_close.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (!IsApplet)
                    System.exit(0);
                else
                    Hauptfenster.setVisible(false);
            }
        }
        );

        BT_Sinus.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                panel.setVisible( false );
                remouveVerteilungen();
                addSinus();
                panel.setVisible( true );
            }
        }
        );

        BT_Cosinus.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                panel.setVisible( false );
                remouveVerteilungen();
                addCosinus();
                panel.setVisible( true );
            }
        }
        );
        BT_SinusH.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                panel.setVisible( false );
                remouveVerteilungen();
                addSinusH();
                panel.setVisible( true );
            }
        }
        );
        BT_CosinusH.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                panel.setVisible( false );
                remouveVerteilungen();
                addCosinusH();
                panel.setVisible( true );
            }
        }
        );
        BT_EFunk.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                panel.setVisible( false );
                remouveVerteilungen();
                addEFunk();
                panel.setVisible( true );
            }
        }
        );
        BT_1XFunk.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                panel.setVisible( false );
                remouveVerteilungen();
                add1XFunk();
                panel.setVisible( true );
            }
        }
        );
        BT_X2.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                panel.setVisible( false );
                remouveVerteilungen();
                addX2();
                panel.setVisible( true );
            }
        }
        );
        BT_X3.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                panel.setVisible( false );
                remouveVerteilungen();
                addX3();
                panel.setVisible( true );
            }
        }
        );
        BT_X4.addActionListener(
        new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                panel.setVisible( false );
                remouveVerteilungen();
                addX4();
                panel.setVisible( true );
            }
        }
        );

        // ToolBar selbst erzeugen
        toolBar = new JToolBar();

//		//Rahmen erzeugen
//		BT_Sinus.setBorder(new EtchedBorder(Color.black, Color.gray));
//		BT_Cosinus.setBorder(new EtchedBorder());
//		BT_SinusH.setBorder(new EtchedBorder());
//		BT_CosinusH.setBorder(new EtchedBorder());
//		BT_EFunk.setBorder(new EtchedBorder());
//		BT_1XFunk.setBorder(new EtchedBorder());
//		BT_X2.setBorder(new EtchedBorder());
//		BT_X3.setBorder(new EtchedBorder());
//		BT_X4.setBorder(new EtchedBorder());
//

        // Buttons auf die ToolBar legen
        //toolBar.add(BT_close);
        toolBar.add(BT_Sinus);
        toolBar.add(BT_Cosinus);
        toolBar.add(BT_SinusH);
        toolBar.add(BT_CosinusH);
        toolBar.add(BT_EFunk);
        toolBar.add(BT_1XFunk);
        toolBar.add(BT_X2);
        toolBar.add(BT_X3);
        toolBar.add(BT_X4);
    }

    /**
     * Setzt die gewnschte Darstellungsart auf der Toolbar
     *
     * @param nr der Funktion
     */
    public void setFunktionsart(int nr) {
        panel.setVisible( false );
        // bisherige Verteilungen entfernen
        remouveVerteilungen();
        // neue auswhlen
        switch (nr) {
        case 1:
            addCosinus();
            break;
        case 2:
            addSinusH();
            break;
        case 3:
            addCosinusH();
            break;
        case 4:
            addEFunk();
            break;
        case 5:
            add1XFunk();
            break;
        case 6:
            addX2();
            break;
        case 7:
            addX3();
            break;
        case 8:
            addX4();
            break;


        default:
            addSinus();
            break;
        }
        panel.setVisible( true );
    }

    /**
     * frgt die Toolbar zum Fenster hinzu
     */
    public void addToFrame() {
        // Panel im Norden des Hauptfensters fr die Buttonleiste plazieren
        panel = new JPanel();
        Hauptfenster.getContentPane().add(panel, BorderLayout.NORTH);

        // Layout bestimmen
        BoxLayout boxLayout =  new BoxLayout(panel, BoxLayout.X_AXIS);
        panel.setLayout(boxLayout);

        // Panel hinzufgen
        panel.add(toolBar);

        // standardmig Sinusfunktion laden
        addSinus();
    }

    /**
     * Veranlasst ein Neuzeichnen der Zeichenbereiche
     */
    public void doRepaint() {
        if ( ZeichenbereichS1 != null ) ZeichenbereichS1.Dorepaint();
        if ( ZeichenbereichS2 != null ) ZeichenbereichS2.Dorepaint();
        if ( ZeichenbereichC1 != null ) ZeichenbereichC1.Dorepaint();
        if ( ZeichenbereichC2 != null ) ZeichenbereichC2.Dorepaint();
        if ( ZeichenbereichSH1 != null ) ZeichenbereichSH1.Dorepaint();
        if ( ZeichenbereichSH2 != null ) ZeichenbereichSH2.Dorepaint();
        if ( ZeichenbereichCH1 != null ) ZeichenbereichCH1.Dorepaint();
        if ( ZeichenbereichCH2 != null ) ZeichenbereichCH2.Dorepaint();
        if ( ZeichenbereichE1 != null ) ZeichenbereichE1.Dorepaint();
        if ( ZeichenbereichE2 != null ) ZeichenbereichE2.Dorepaint();
        if ( Zeichenbereich1X1 != null ) Zeichenbereich1X1.Dorepaint();
        if ( Zeichenbereich1X2 != null ) Zeichenbereich1X2.Dorepaint();
        if ( ZeichenbereichX21 != null ) ZeichenbereichX21.Dorepaint();
        if ( ZeichenbereichX22 != null ) ZeichenbereichX22.Dorepaint();
        if ( ZeichenbereichX31 != null ) ZeichenbereichX31.Dorepaint();
        if ( ZeichenbereichX32 != null ) ZeichenbereichX32.Dorepaint();
        if ( ZeichenbereichX41 != null ) ZeichenbereichX41.Dorepaint();
        if ( ZeichenbereichX42 != null ) ZeichenbereichX42.Dorepaint();
    }

    /**
     * entfernt alle Zeichenbereiche vom Fenster
     */
    private void remouveVerteilungen() {
        if (ZeichenbereichS1 != null) HauptFensterMitte.remove(ZeichenbereichS1);
        if (ZeichenbereichS2 != null) HauptFensterMitte.remove(ZeichenbereichS2);
        if (ZeichenbereichC1 != null) HauptFensterMitte.remove(ZeichenbereichC1);
        if (ZeichenbereichC2 != null) HauptFensterMitte.remove(ZeichenbereichC2);
        if (ZeichenbereichSH1 != null) HauptFensterMitte.remove(ZeichenbereichSH1);
        if (ZeichenbereichSH2 != null) HauptFensterMitte.remove(ZeichenbereichSH2);
        if (ZeichenbereichCH1 != null) HauptFensterMitte.remove(ZeichenbereichCH1);
        if (ZeichenbereichCH2 != null) HauptFensterMitte.remove(ZeichenbereichCH2);
        if (ZeichenbereichE1 != null) HauptFensterMitte.remove(ZeichenbereichE1);
        if (ZeichenbereichE2 != null) HauptFensterMitte.remove(ZeichenbereichE2);
        if (Zeichenbereich1X1 != null) HauptFensterMitte.remove(Zeichenbereich1X1);
        if (Zeichenbereich1X2 != null) HauptFensterMitte.remove(Zeichenbereich1X2);
        if (ZeichenbereichX21 != null) HauptFensterMitte.remove(ZeichenbereichX21);
        if (ZeichenbereichX22 != null) HauptFensterMitte.remove(ZeichenbereichX22);
        if (ZeichenbereichX31 != null) HauptFensterMitte.remove(ZeichenbereichX31);
        if (ZeichenbereichX32 != null) HauptFensterMitte.remove(ZeichenbereichX32);
        if (ZeichenbereichX41 != null) HauptFensterMitte.remove(ZeichenbereichX41);
        if (ZeichenbereichX42 != null) HauptFensterMitte.remove(ZeichenbereichX42);

        if (ZeichenbereichS1 != null) ZeichenbereichS1.delete();
        if (ZeichenbereichS2 != null) ZeichenbereichS2.delete();
        if (ZeichenbereichC1 != null) ZeichenbereichC1.delete();
        if (ZeichenbereichC2 != null) ZeichenbereichC2.delete();
        if (ZeichenbereichSH1 != null) ZeichenbereichSH1.delete();
        if (ZeichenbereichSH2 != null) ZeichenbereichSH2.delete();
        if (ZeichenbereichCH1 != null) ZeichenbereichCH1.delete();
        if (ZeichenbereichCH2 != null) ZeichenbereichCH2.delete();
        if (ZeichenbereichE1 != null) ZeichenbereichE1.delete();
        if (ZeichenbereichE2 != null) ZeichenbereichE2.delete();
        if (Zeichenbereich1X1 != null) Zeichenbereich1X1.delete();
        if (Zeichenbereich1X2 != null) Zeichenbereich1X2.delete();
        if (ZeichenbereichX21 != null) ZeichenbereichX21.delete();
        if (ZeichenbereichX22 != null) ZeichenbereichX22.delete();
        if (ZeichenbereichX31 != null) ZeichenbereichX31.delete();
        if (ZeichenbereichX32 != null) ZeichenbereichX32.delete();
        if (ZeichenbereichX41 != null) ZeichenbereichX41.delete();
        if (ZeichenbereichX42 != null) ZeichenbereichX42.delete();

        if (parameterEingabeS != null) parameterEingabeS.delete(Hauptfenster);
        if (parameterEingabeC != null) parameterEingabeC.delete(Hauptfenster);
        if (parameterEingabeSH != null) parameterEingabeSH.delete(Hauptfenster);
        if (parameterEingabeCH != null) parameterEingabeCH.delete(Hauptfenster);
        if (parameterEingabeE != null) parameterEingabeE.delete(Hauptfenster);
        if (parameterEingabe1X != null) parameterEingabe1X.delete(Hauptfenster);
        if (parameterEingabeX2 != null) parameterEingabeX2.delete(Hauptfenster);
        if (parameterEingabeX3 != null) parameterEingabeX3.delete(Hauptfenster);
        if (parameterEingabeX4 != null) parameterEingabeX4.delete(Hauptfenster);

        ZeichenbereichS1 	= null;
        ZeichenbereichS2 	= null;
        ZeichenbereichC1 	= null;
        ZeichenbereichC2 	= null;
        ZeichenbereichSH1 	= null;
        ZeichenbereichSH2 	= null;
        ZeichenbereichCH1 	= null;
        ZeichenbereichCH2 	= null;
        ZeichenbereichE1 	= null;
        ZeichenbereichE2 	= null;
        Zeichenbereich1X1 	= null;
        Zeichenbereich1X2 	= null;
        ZeichenbereichX21 	= null;
        ZeichenbereichX22 	= null;
        ZeichenbereichX31 	= null;
        ZeichenbereichX32 	= null;
        ZeichenbereichX41 	= null;
        ZeichenbereichX42 	= null;

        parameterEingabeS	= null;
        parameterEingabeC	= null;
        parameterEingabeSH	= null;
        parameterEingabeCH	= null;
        parameterEingabeE	= null;
        parameterEingabe1X	= null;
        parameterEingabeX2  = null;
        parameterEingabeX3  = null;
        parameterEingabeX4  = null;
    }

    /**
     * fgt die Ein- und Ausgabebereiche fr Sinusfunktion dem Fenster hinzu
     */
    private void addSinus() {
        BT_Sinus.setIcon(Ableitung.getsymbolPressedLogo(0));
        BT_Cosinus.setIcon(Ableitung.getsymbolUnPressedLogo(1));
        BT_SinusH.setIcon(Ableitung.getsymbolUnPressedLogo(2));
        BT_CosinusH.setIcon(Ableitung.getsymbolUnPressedLogo(3));
        BT_EFunk.setIcon(Ableitung.getsymbolUnPressedLogo(4));
        BT_1XFunk.setIcon(Ableitung.getsymbolUnPressedLogo(5));
        BT_X2.setIcon(Ableitung.getsymbolUnPressedLogo(6));
        BT_X3.setIcon(Ableitung.getsymbolUnPressedLogo(7));
        BT_X4.setIcon(Ableitung.getsymbolUnPressedLogo(8));

        ZeichenbereichS1=null;
        ZeichenbereichS2=null;
        parameterEingabeS=null;

        // Eingabe anfgen
        parameterEingabeS = new ParameterEingabeSinus();
        parameterEingabeS.addToFrame(Hauptfenster);

        ZeichenbereichS1 = new ZeichenbereichSinus(parameterEingabeS, false);
        ZeichenbereichS2 = new ZeichenbereichSinus(parameterEingabeS, true);

        HauptFensterMitte.add(ZeichenbereichS1);
        HauptFensterMitte.add(ZeichenbereichS2);

        // Men aktualisieren
        Ableitung.setMenueFunktionsart(0);
    }

    /**
     * fgt die Ein- und Ausgabebereiche fr Cosinusfunktion dem Fenster hinzu
     */
    private void addCosinus() {
        BT_Sinus.setIcon(Ableitung.getsymbolUnPressedLogo(0));
        BT_Cosinus.setIcon(Ableitung.getsymbolPressedLogo(1));
        BT_SinusH.setIcon(Ableitung.getsymbolUnPressedLogo(2));
        BT_CosinusH.setIcon(Ableitung.getsymbolUnPressedLogo(3));
        BT_EFunk.setIcon(Ableitung.getsymbolUnPressedLogo(4));
        BT_1XFunk.setIcon(Ableitung.getsymbolUnPressedLogo(5));
        BT_X2.setIcon(Ableitung.getsymbolUnPressedLogo(6));
        BT_X3.setIcon(Ableitung.getsymbolUnPressedLogo(7));
        BT_X4.setIcon(Ableitung.getsymbolUnPressedLogo(8));

        ZeichenbereichC1=null;
        ZeichenbereichC2=null;
        parameterEingabeC=null;

        // Eingabe anfgen
        parameterEingabeC = new ParameterEingabeCosinus();
        parameterEingabeC.addToFrame(Hauptfenster);

        ZeichenbereichC1 = new ZeichenbereichCosinus(parameterEingabeC, false);
        ZeichenbereichC2 = new ZeichenbereichCosinus(parameterEingabeC, true);

        HauptFensterMitte.add(ZeichenbereichC1);
        HauptFensterMitte.add(ZeichenbereichC2);

        // Men aktualisieren
        Ableitung.setMenueFunktionsart(1);
    }

    /**
     * fgt die Ein- und Ausgabebereiche fr Sinus-hyperbolicus-Funktion dem Fenster hinzu
     */
    private void addSinusH() {
        BT_Sinus.setIcon(Ableitung.getsymbolUnPressedLogo(0));
        BT_Cosinus.setIcon(Ableitung.getsymbolUnPressedLogo(1));
        BT_SinusH.setIcon(Ableitung.getsymbolPressedLogo(2));
        BT_CosinusH.setIcon(Ableitung.getsymbolUnPressedLogo(3));
        BT_EFunk.setIcon(Ableitung.getsymbolUnPressedLogo(4));
        BT_1XFunk.setIcon(Ableitung.getsymbolUnPressedLogo(5));
        BT_X2.setIcon(Ableitung.getsymbolUnPressedLogo(6));
        BT_X3.setIcon(Ableitung.getsymbolUnPressedLogo(7));
        BT_X4.setIcon(Ableitung.getsymbolUnPressedLogo(8));

        ZeichenbereichSH1=null;
        ZeichenbereichSH2=null;
        parameterEingabeSH=null;

        // Eingabe anfgen
        parameterEingabeSH = new ParameterEingabeSinusH();
        parameterEingabeSH.addToFrame(Hauptfenster);

        ZeichenbereichSH1 = new ZeichenbereichSinusH(parameterEingabeSH, false);
        ZeichenbereichSH2 = new ZeichenbereichSinusH(parameterEingabeSH, true);

        HauptFensterMitte.add(ZeichenbereichSH1);
        HauptFensterMitte.add(ZeichenbereichSH2);

        // Men aktualisieren
        Ableitung.setMenueFunktionsart(2);
    }

    /**
     * fgt die Ein- und Ausgabebereiche fr Cosinus-hyperbolicus-Funktion dem Fenster hinzu
     */
    private void addCosinusH() {
        BT_Sinus.setIcon(Ableitung.getsymbolUnPressedLogo(0));
        BT_Cosinus.setIcon(Ableitung.getsymbolUnPressedLogo(1));
        BT_SinusH.setIcon(Ableitung.getsymbolUnPressedLogo(2));
        BT_CosinusH.setIcon(Ableitung.getsymbolPressedLogo(3));
        BT_EFunk.setIcon(Ableitung.getsymbolUnPressedLogo(4));
        BT_1XFunk.setIcon(Ableitung.getsymbolUnPressedLogo(5));
        BT_X2.setIcon(Ableitung.getsymbolUnPressedLogo(6));
        BT_X3.setIcon(Ableitung.getsymbolUnPressedLogo(7));
        BT_X4.setIcon(Ableitung.getsymbolUnPressedLogo(8));

        ZeichenbereichCH1=null;
        ZeichenbereichCH2=null;
        parameterEingabeCH=null;

        // Eingabe anfgen
        parameterEingabeCH = new ParameterEingabeCosinusH();
        parameterEingabeCH.addToFrame(Hauptfenster);

        ZeichenbereichCH1 = new ZeichenbereichCosinusH(parameterEingabeCH, false);
        ZeichenbereichCH2 = new ZeichenbereichCosinusH(parameterEingabeCH, true);

        HauptFensterMitte.add(ZeichenbereichCH1);
        HauptFensterMitte.add(ZeichenbereichCH2);

        // Men aktualisieren
        Ableitung.setMenueFunktionsart(3);
    }



    /**
     * fgt die Ein- und Ausgabebereiche fr E-Funktion dem Fenster hinzu
     */
    private void addEFunk() {
        BT_Sinus.setIcon(Ableitung.getsymbolUnPressedLogo(0));
        BT_Cosinus.setIcon(Ableitung.getsymbolUnPressedLogo(1));
        BT_SinusH.setIcon(Ableitung.getsymbolUnPressedLogo(2));
        BT_CosinusH.setIcon(Ableitung.getsymbolUnPressedLogo(3));
        BT_EFunk.setIcon(Ableitung.getsymbolPressedLogo(4));
        BT_1XFunk.setIcon(Ableitung.getsymbolUnPressedLogo(5));
        BT_X2.setIcon(Ableitung.getsymbolUnPressedLogo(6));
        BT_X3.setIcon(Ableitung.getsymbolUnPressedLogo(7));
        BT_X4.setIcon(Ableitung.getsymbolUnPressedLogo(8));

        ZeichenbereichE1=null;
        ZeichenbereichE2=null;
        parameterEingabeE = null;
        // Eingabe anfgen
        parameterEingabeE = new ParameterEingabeEFunktion();
        parameterEingabeE.addToFrame(Hauptfenster);

        ZeichenbereichE1 = new ZeichenbereichEFunk(parameterEingabeE, false);
        ZeichenbereichE2 = new ZeichenbereichEFunk(parameterEingabeE, true);

        HauptFensterMitte.add(ZeichenbereichE1);
        HauptFensterMitte.add(ZeichenbereichE2);

        // Men aktualisieren
        Ableitung.setMenueFunktionsart(4);
    }

    /**
     * fgt die Ein- und Ausgabebereiche fr 1/X-Funktion dem Fenster hinzu
     */
    private void add1XFunk() {
        BT_Sinus.setIcon(Ableitung.getsymbolUnPressedLogo(0));
        BT_Cosinus.setIcon(Ableitung.getsymbolUnPressedLogo(1));
        BT_SinusH.setIcon(Ableitung.getsymbolUnPressedLogo(2));
        BT_CosinusH.setIcon(Ableitung.getsymbolUnPressedLogo(3));
        BT_EFunk.setIcon(Ableitung.getsymbolUnPressedLogo(4));
        BT_1XFunk.setIcon(Ableitung.getsymbolPressedLogo(5));
        BT_X2.setIcon(Ableitung.getsymbolUnPressedLogo(6));
        BT_X3.setIcon(Ableitung.getsymbolUnPressedLogo(7));
        BT_X4.setIcon(Ableitung.getsymbolUnPressedLogo(8));

        Zeichenbereich1X1=null;
        Zeichenbereich1X2=null;

        parameterEingabe1X = null;
        // Eingabe anfgen
        parameterEingabe1X = new ParameterEingabe1X();
        parameterEingabe1X.addToFrame(Hauptfenster);

        Zeichenbereich1X1 = new Zeichenbereich1X(parameterEingabe1X, false);
        Zeichenbereich1X2 = new Zeichenbereich1X(parameterEingabe1X, true);

        HauptFensterMitte.add(Zeichenbereich1X1);
        HauptFensterMitte.add(Zeichenbereich1X2);
        // Men aktualisieren
        Ableitung.setMenueFunktionsart(5);
    }
    private void addX2() {
        BT_Sinus.setIcon(Ableitung.getsymbolUnPressedLogo(0));
        BT_Cosinus.setIcon(Ableitung.getsymbolUnPressedLogo(1));
        BT_SinusH.setIcon(Ableitung.getsymbolUnPressedLogo(2));
        BT_CosinusH.setIcon(Ableitung.getsymbolUnPressedLogo(3));
        BT_EFunk.setIcon(Ableitung.getsymbolUnPressedLogo(4));
        BT_1XFunk.setIcon(Ableitung.getsymbolUnPressedLogo(5));
        BT_X2.setIcon(Ableitung.getsymbolPressedLogo(6));
        BT_X3.setIcon(Ableitung.getsymbolUnPressedLogo(7));
        BT_X4.setIcon(Ableitung.getsymbolUnPressedLogo(8));

        ZeichenbereichX21=null;
        ZeichenbereichX22=null;

        parameterEingabeX2 = null;
        // Eingabe anfgen
        parameterEingabeX2 = new ParameterEingabeX2();
        parameterEingabeX2.addToFrame(Hauptfenster);

        ZeichenbereichX21 = new ZeichenbereichX2(parameterEingabeX2, false);
        ZeichenbereichX22 = new ZeichenbereichX2(parameterEingabeX2, true);

        HauptFensterMitte.add(ZeichenbereichX21);
        HauptFensterMitte.add(ZeichenbereichX22);
        // Men aktualisieren
        Ableitung.setMenueFunktionsart(6);
    }
    private void addX3() {
        BT_Sinus.setIcon(Ableitung.getsymbolUnPressedLogo(0));
        BT_Cosinus.setIcon(Ableitung.getsymbolUnPressedLogo(1));
        BT_SinusH.setIcon(Ableitung.getsymbolUnPressedLogo(2));
        BT_CosinusH.setIcon(Ableitung.getsymbolUnPressedLogo(3));
        BT_EFunk.setIcon(Ableitung.getsymbolUnPressedLogo(4));
        BT_1XFunk.setIcon(Ableitung.getsymbolUnPressedLogo(5));
        BT_X2.setIcon(Ableitung.getsymbolUnPressedLogo(6));
        BT_X3.setIcon(Ableitung.getsymbolPressedLogo(7));
        BT_X4.setIcon(Ableitung.getsymbolUnPressedLogo(8));

        ZeichenbereichX31=null;
        ZeichenbereichX32=null;

        parameterEingabeX3 = null;
        // Eingabe anfgen
        parameterEingabeX3 = new ParameterEingabeX3();
        parameterEingabeX3.addToFrame(Hauptfenster);

        ZeichenbereichX31 = new ZeichenbereichX3(parameterEingabeX3, false);
        ZeichenbereichX32 = new ZeichenbereichX3(parameterEingabeX3, true);

        HauptFensterMitte.add(ZeichenbereichX31);
        HauptFensterMitte.add(ZeichenbereichX32);
        // Men aktualisieren
        Ableitung.setMenueFunktionsart(7);
    }
    private void addX4() {
        BT_Sinus.setIcon(Ableitung.getsymbolUnPressedLogo(0));
        BT_Cosinus.setIcon(Ableitung.getsymbolUnPressedLogo(1));
        BT_SinusH.setIcon(Ableitung.getsymbolUnPressedLogo(2));
        BT_CosinusH.setIcon(Ableitung.getsymbolUnPressedLogo(3));
        BT_EFunk.setIcon(Ableitung.getsymbolUnPressedLogo(4));
        BT_1XFunk.setIcon(Ableitung.getsymbolUnPressedLogo(5));
        BT_X2.setIcon(Ableitung.getsymbolUnPressedLogo(6));
        BT_X3.setIcon(Ableitung.getsymbolUnPressedLogo(7));
        BT_X4.setIcon(Ableitung.getsymbolPressedLogo(8));

        ZeichenbereichX41=null;
        ZeichenbereichX42=null;

        parameterEingabeX4 = null;
        // Eingabe anfgen
        parameterEingabeX4 = new ParameterEingabeX4();
        parameterEingabeX4.addToFrame(Hauptfenster);

        ZeichenbereichX41 = new ZeichenbereichX4(parameterEingabeX4, false);
        ZeichenbereichX42 = new ZeichenbereichX4(parameterEingabeX4, true);

        HauptFensterMitte.add(ZeichenbereichX41);
        HauptFensterMitte.add(ZeichenbereichX42);
        // Men aktualisieren
        Ableitung.setMenueFunktionsart(8);
    }

}
